"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var fs=require("./graceful-fs.js"),fs__default=_interopDefault(fs),path=require("path"),path__default=_interopDefault(path),fs$1=require("fs"),fs$1__default=_interopDefault(fs$1),util=_interopDefault(require("util")),assert=_interopDefault(require("assert")),events=require("events"),events__default=_interopDefault(events),ts=_interopDefault(require("typescript")),cp=require("child_process"),cp__default=_interopDefault(cp),crypto=require("crypto"),crypto__default=_interopDefault(crypto),module$1=_interopDefault(require("module")),os=require("os"),os__default=_interopDefault(os),url=require("url");function createCommonjsModule(e,t){return e(t={exports:{}},t.exports),t.exports}var symbols=createCommonjsModule(function(e){const t="win32"===process.platform,r="linux"===process.platform,n={bullet:"•",check:"√",cross:"×",ellipsis:"...",heart:"❤",info:"i",line:"─",middot:"·",minus:"－",plus:"＋",question:"?",questionSmall:"﹖",pointer:">",pointerSmall:"»",warning:"‼"},i={ballotCross:"✘",bullet:"•",check:"✔",cross:"✖",ellipsis:"…",heart:"❤",info:"ℹ",line:"─",middot:"·",minus:"－",plus:"＋",question:"?",questionFull:"？",questionSmall:"﹖",pointer:r?"▸":"❯",pointerSmall:r?"‣":"›",warning:"⚠"};e.exports=t?n:i,Reflect.defineProperty(e.exports,"windows",{enumerable:!1,value:n}),Reflect.defineProperty(e.exports,"other",{enumerable:!1,value:i})});const colors={enabled:!0,visible:!0,styles:{},keys:{}},ansi=e=>(e.open=`[${e[0]}m`,e.close=`[${e[1]}m`,e.regex=new RegExp(`\\u001b\\[${e[1]}m`,"g"),e),wrap=(e,t,r)=>{let{open:n,close:i,regex:s}=e;return t=n+(t.includes(i)?t.replace(s,n):t)+i,r?t.replace(/\r?\n/g,`${i}$&${n}`):t},style=(e,t)=>{if(""===e)return"";if(!1===colors.enabled)return e;if(!1===colors.visible)return"";let r=""+e,n=r.includes("\n"),i=t.length;for(;i-- >0;)r=wrap(colors.styles[t[i]],r,n);return r},define=(e,t,r)=>{colors.styles[e]=ansi(t),(colors.keys[r]||(colors.keys[r]=[])).push(e),Reflect.defineProperty(colors,e,{get(){let t=e=>style(e,t.stack);return Reflect.setPrototypeOf(t,colors),t.stack=this.stack?this.stack.concat(e):[e],t}})};define("reset",[0,0],"modifier"),define("bold",[1,22],"modifier"),define("dim",[2,22],"modifier"),define("italic",[3,23],"modifier"),define("underline",[4,24],"modifier"),define("inverse",[7,27],"modifier"),define("hidden",[8,28],"modifier"),define("strikethrough",[9,29],"modifier"),define("black",[30,39],"color"),define("red",[31,39],"color"),define("green",[32,39],"color"),define("yellow",[33,39],"color"),define("blue",[34,39],"color"),define("magenta",[35,39],"color"),define("cyan",[36,39],"color"),define("white",[37,39],"color"),define("gray",[90,39],"color"),define("grey",[90,39],"color"),define("bgBlack",[40,49],"bg"),define("bgRed",[41,49],"bg"),define("bgGreen",[42,49],"bg"),define("bgYellow",[43,49],"bg"),define("bgBlue",[44,49],"bg"),define("bgMagenta",[45,49],"bg"),define("bgCyan",[46,49],"bg"),define("bgWhite",[47,49],"bg"),define("blackBright",[90,39],"bright"),define("redBright",[91,39],"bright"),define("greenBright",[92,39],"bright"),define("yellowBright",[93,39],"bright"),define("blueBright",[94,39],"bright"),define("magentaBright",[95,39],"bright"),define("cyanBright",[96,39],"bright"),define("whiteBright",[97,39],"bright"),define("bgBlackBright",[100,49],"bgBright"),define("bgRedBright",[101,49],"bgBright"),define("bgGreenBright",[102,49],"bgBright"),define("bgYellowBright",[103,49],"bgBright"),define("bgBlueBright",[104,49],"bgBright"),define("bgMagentaBright",[105,49],"bgBright"),define("bgCyanBright",[106,49],"bgBright"),define("bgWhiteBright",[107,49],"bgBright"),colors.ansiRegex=/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/gm,colors.hasAnsi=(e=>e&&"string"==typeof e&&colors.ansiRegex.test(e)),colors.unstyle=(e=>"string"==typeof e?e.replace(colors.ansiRegex,""):e),colors.none=colors.clear=(e=>e),colors.stripColor=colors.unstyle,colors.hasColor=colors.hasAnsi,colors.symbols=symbols;var ansiColors=colors;class NodeLogger{constructor(){this._level="info",this.writeLogQueue=[],this.buildLogFilePath=null}get level(){return this._level}set level(e){"string"==typeof e&&(e=e.toLowerCase().trim(),-1===LOG_LEVELS.indexOf(e)?this.error(`Invalid log level '${ansiColors.bold(e)}' (choose from: ${LOG_LEVELS.map(e=>ansiColors.bold(e)).join(", ")})`):this._level=e)}info(...e){if(this.shouldLog("info")){const t=wordWrap(e,getColumns());this.infoPrefix(t),console.log(t.join("\n"))}this.queueWriteLog("I",e)}infoPrefix(e){if(e.length){const t=new Date,r="["+("0"+t.getMinutes()).slice(-2)+":"+("0"+t.getSeconds()).slice(-2)+"."+Math.floor(t.getMilliseconds()/1e3*10)+"]";e[0]=this.dim(r)+e[0].substr(r.length)}}warn(...e){if(this.shouldLog("warn")){const t=wordWrap(e,getColumns());this.warnPrefix(t),console.warn("\n"+t.join("\n")+"\n")}this.queueWriteLog("W",e)}warnPrefix(e){if(e.length){const t="[ WARN  ]";e[0]=this.bold(ansiColors.yellow(t))+e[0].substr(t.length)}}error(...e){for(let t=0;t<e.length;t++)if(e[t]instanceof Error){const r=e[t];e[t]=r.message,r.stack&&(e[t]+="\n"+r.stack)}if(this.shouldLog("error")){const t=wordWrap(e,getColumns());this.errorPrefix(t),console.error("\n"+t.join("\n")+"\n")}this.queueWriteLog("E",e)}errorPrefix(e){if(e.length){const t="[ ERROR ]";e[0]=this.bold(ansiColors.red(t))+e[0].substr(t.length)}}debug(...e){if(this.shouldLog("debug")){e.push(this.dim(` MEM: ${(process.memoryUsage().rss/1e6).toFixed(1)}MB`));const t=wordWrap(e,getColumns());this.debugPrefix(t),console.log(t.join("\n"))}this.queueWriteLog("D",e)}debugPrefix(e){if(e.length){const t=new Date,r="["+("0"+t.getMinutes()).slice(-2)+":"+("0"+t.getSeconds()).slice(-2)+"."+Math.floor(t.getMilliseconds()/1e3*10)+"]";e[0]=ansiColors.cyan(r)+e[0].substr(r.length)}}timespanStart(e,t,r){const n=[`${e} ${this.dim("...")}`];if(t){if(this.shouldLog("debug")){const t=wordWrap(n,getColumns());this.debugPrefix(t),console.log(t.join("\n")),this.queueWriteLog("D",[`${e} ...`])}}else{const t=wordWrap(n,getColumns());this.infoPrefix(t),console.log(t.join("\n")),this.queueWriteLog("I",[`${e} ...`]),r&&r.push(`${e} ...`)}}timespanFinish(e,t,r,n,i,s,o){let a=e;if(r&&(a=this.color(e,r)),n&&(a=this.bold(a)),a+=" "+this.dim(t),s){if(this.shouldLog("debug")){const e=wordWrap([a],getColumns());this.debugPrefix(e),console.log(e.join("\n"))}this.queueWriteLog("D",[`${e} ${t}`])}else{const r=wordWrap([a],getColumns());this.infoPrefix(r),console.log(r.join("\n")),this.queueWriteLog("I",[`${e} ${t}`]),o&&o.push(`${e} ${t}`)}i&&console.log("")}queueWriteLog(e,t){if(this.buildLogFilePath){const r=new Date,n=("0"+r.getHours()).slice(-2)+":"+("0"+r.getMinutes()).slice(-2)+":"+("0"+r.getSeconds()).slice(-2)+".0"+Math.floor(r.getMilliseconds()/1e3*10)+"  "+("000"+(process.memoryUsage().rss/1e6).toFixed(1)).slice(-6)+"MB  "+e+"  "+t.join(", ");this.writeLogQueue.push(n)}}writeLogs(e){if(this.buildLogFilePath)try{this.queueWriteLog("F",["--------------------------------------"]);const t=this.writeLogQueue.join("\n");if(e)try{fs__default.accessSync(this.buildLogFilePath)}catch(t){e=!1}e?fs__default.appendFileSync(this.buildLogFilePath,t):fs__default.writeFileSync(this.buildLogFilePath,t)}catch(e){}this.writeLogQueue.length=0}color(e,t){return ansiColors[t](e)}red(e){return ansiColors.red(e)}green(e){return ansiColors.green(e)}yellow(e){return ansiColors.yellow(e)}blue(e){return ansiColors.blue(e)}magenta(e){return ansiColors.magenta(e)}cyan(e){return ansiColors.cyan(e)}gray(e){return ansiColors.gray(e)}bold(e){return ansiColors.bold(e)}dim(e){return ansiColors.dim(e)}shouldLog(e){return LOG_LEVELS.indexOf(e)>=LOG_LEVELS.indexOf(this.level)}createTimeSpan(e,t=!1,r){return new CmdTimeSpan(this,e,t,r)}printDiagnostics(e){if(!e||!e.length)return;let t=[""];e.forEach(e=>{t=t.concat(this.printDiagnostic(e))}),console.log(t.join("\n"))}printDiagnostic(e){const t=wordWrap([e.messageText],getColumns());let r="";if(e.header&&"Build Error"!==e.header&&(r+=e.header),e.relFilePath&&(r.length>0&&(r+=": "),r+=ansiColors.cyan(e.relFilePath),"number"==typeof e.lineNumber&&e.lineNumber>-1&&(r+=ansiColors.dim(":"),r+=ansiColors.yellow(`${e.lineNumber}`),"number"==typeof e.columnNumber&&e.columnNumber>-1&&(r+=ansiColors.dim(":"),r+=ansiColors.yellow(`${e.columnNumber}`)))),r.length>0&&t.unshift(INDENT+r),t.push(""),e.lines&&e.lines.length){prepareLines(e.lines).forEach(r=>{if(!isMeaningfulLine(r.text))return;let n=`L${r.lineNumber}:  `;for(;n.length<INDENT.length;)n=" "+n;let i=r.text;r.errorCharStart>-1&&(i=this.highlightError(i,r.errorCharStart,r.errorLength)),n=this.dim(n),"typescript"===e.language||"javascript"===e.language?n+=this.javaScriptSyntaxHighlight(i):"scss"===e.language||"css"===e.language?n+=this.cssSyntaxHighlight(i):n+=i,t.push(n)}),t.push("")}return"error"===e.level?this.errorPrefix(t):"warn"===e.level?this.warnPrefix(t):"debug"===e.level?this.debugPrefix(t):this.infoPrefix(t),t}highlightError(e,t,r){let n=e.length-t+r-1;for(;e.length+INDENT.length>MAX_COLUMNS;)if(t>e.length-t+r&&t>5)e=e.substr(1),t--;else{if(!(n>1))break;e=e.substr(0,e.length-1),n--}const i=[],s=Math.max(e.length,t+r);for(var o=0;o<s;o++){var a=e.charAt(o);o>=t&&o<t+r&&(a=ansiColors.bgRed(""===a?" ":a)),i.push(a)}return i.join("")}javaScriptSyntaxHighlight(e){if(e.trim().startsWith("//"))return this.dim(e);return e.split(" ").map(e=>JS_KEYWORDS.indexOf(e)>-1?ansiColors.cyan(e):e).join(" ")}cssSyntaxHighlight(e){let t=!0;const r=[];for(var n=0;n<e.length;n++){const i=e.charAt(n);";"===i||"{"===i?t=!0:".#,:}@$[]/*".indexOf(i)>-1&&(t=!1),t&&"abcdefghijklmnopqrstuvwxyz-_".indexOf(i.toLowerCase())>-1?r.push(ansiColors.cyan(i)):r.push(i)}return r.join("")}}class CmdTimeSpan{constructor(e,t,r,n){this.debug=r,this.appendTo=n,this.logger=e,this.start=Date.now(),this.logger.timespanStart(t,r,this.appendTo)}finish(e,t,r,n){const i=Date.now()-this.start;let s;if(i>1e3)s="in "+(i/1e3).toFixed(2)+" s";else{s=parseFloat(i.toFixed(3))>0?"in "+i+" ms":"in less than 1 ms"}this.logger.timespanFinish(e,s,t,r,n,this.debug,this.appendTo)}}const LOG_LEVELS=["debug","info","warn","error"];function getColumns(){const e=process.stdout&&process.stdout.columns||80;return Math.max(Math.min(MAX_COLUMNS,e),MIN_COLUMNS)}function wordWrap(e,t){const r=[],n=[];e.forEach(e=>{null===e?n.push("null"):void 0===e?n.push("undefined"):"string"==typeof e?e.replace(/\s/gm," ").split(" ").forEach(e=>{e.trim().length&&n.push(e.trim())}):"number"==typeof e||"boolean"==typeof e||"function"==typeof e?n.push(e.toString()):Array.isArray(e)?n.push(()=>e.toString()):Object(e)===e?n.push(()=>e.toString()):n.push(e.toString())});let i=INDENT;return n.forEach(e=>{r.length>25||("function"==typeof e?(i.trim().length&&r.push(i),r.push(e()),i=INDENT):INDENT.length+e.length>t-1?(i.trim().length&&r.push(i),r.push(INDENT+e),i=INDENT):e.length+i.length>t-1?(r.push(i),i=INDENT+e+" "):i+=e+" ")}),i.trim().length&&r.push(i),r.map(e=>e.trimRight())}function prepareLines(e){const t=JSON.parse(JSON.stringify(e));for(let e=0;e<100;e++){if(!eachLineHasLeadingWhitespace(t))return t;for(let e=0;e<t.length;e++)if(t[e].text=t[e].text.substr(1),t[e].errorCharStart--,!t[e].text.length)return t}return t}function eachLineHasLeadingWhitespace(e){if(!e.length)return!1;for(var t=0;t<e.length;t++){if(!e[t].text||e[t].text.length<1)return!1;const r=e[t].text.charAt(0);if(" "!==r&&"\t"!==r)return!1}return!0}function isMeaningfulLine(e){return!!e&&(e=e.trim()).length>0}const JS_KEYWORDS=["abstract","any","as","break","boolean","case","catch","class","console","const","continue","debugger","declare","default","delete","do","else","enum","export","extends","false","finally","for","from","function","get","if","import","in","implements","Infinity","instanceof","let","module","namespace","NaN","new","number","null","public","private","protected","require","return","static","set","string","super","switch","this","throw","try","true","type","typeof","undefined","var","void","with","while","yield"],INDENT="           ",MIN_COLUMNS=60,MAX_COLUMNS=120;function __awaiter(e,t,r,n){return new(r||(r=Promise))(function(i,s){function o(e){try{u(n.next(e))}catch(e){s(e)}}function a(e){try{u(n.throw(e))}catch(e){s(e)}}function u(e){e.done?i(e.value):new r(function(t){t(e.value)}).then(o,a)}u((n=n.apply(e,t||[])).next())})}function createServer(e,t){if(e.localPrerenderServer)return;const r=require("fs"),n=require("http");e.localPrerenderServer=n.createServer((e,n)=>{const i=getFilePath(t,e.url);r.readFile(i,"utf8",(t,r)=>{t?n.write(`\x3c!--localPrerenderServer, error fetching: ${e.url} : ${t} --\x3e`):n.write(r),n.end()})}),e.localPrerenderServer.listen(PORT)}function getFilePath(e,t){const r=require("path");let n=require("url").parse(t).pathname;return"/"!==n.charAt(0)&&(n="/"+n),n.startsWith(e.baseUrl)&&(n=n.substring(e.baseUrl.length)),r.join(e.dir,n)}function normalizeUrl(e){const t=require("url"),r=t.parse(e);return r.protocol&&r.hostname||(r.protocol="http:",r.host="localhost:"+PORT,e=t.format(r)),e}const PORT=53536;function createContext(e,t,r){const n=require("vm");return patchFetch(e,t,r),patchRaf(r),n.createContext(r)}function patchFetch(e,t,r){r.fetch=function(r,n){const i=require("path"),s=require(i.join(__dirname,"./node-fetch.js"));return createServer(e,t),"string"==typeof r?s.nodeFetch(normalizeUrl(r),n):(r.url=normalizeUrl(r.url),s.nodeFetch(r,n))}}function patchRaf(e){e.requestAnimationFrame||(e.requestAnimationFrame=function(t){return e.setTimeout(function(){t(Date.now())},0)},e.cancelAnimationFrame=function(e){clearTimeout(e)})}function runInContext(e,t,r){require("vm").runInContext(e,t,r)}function createFsWatcher(e,t,r){const n=require("chokidar").watch(t,r);return n.on("change",t=>{e.emit("fileUpdate",t)}).on("add",t=>{e.emit("fileAdd",t)}).on("unlink",t=>{e.emit("fileDelete",t)}).on("addDir",t=>{e.emit("dirAdd",t)}).on("unlinkDir",t=>{e.emit("dirDelete",t)}).on("error",e=>{console.error(e)}),n}function createDom(){let e=null;return{parse(t){e&&e.window.close();const r=require("jsdom"),n={url:t.url,referrer:t.referrer,userAgent:t.userAgent};return t.console&&(n.virtualConsole=new r.VirtualConsole,n.virtualConsole.sendTo(t.console)),polyfillJsDom((e=new r.JSDOM(t.html,n)).window),e.window},serialize:()=>e.serialize(),destroy(){e&&e.window&&e.window.close(),e=null}}}function polyfillJsDom(e){e.Element.prototype.closest||(e.Element.prototype.closest=function(e){let t=this;for(;t;){if(t.matches(e))return t;t=t.parentElement}})}var isWindows="win32"===process.platform,DEBUG=process.env.NODE_DEBUG&&/fs/.test(process.env.NODE_DEBUG);function rethrow(){var e;if(DEBUG){var t=new Error;e=function(e){e&&(t.message=e.message,r(e=t))}}else e=r;return e;function r(e){if(e){if(process.throwDeprecation)throw e;if(!process.noDeprecation){var t="fs: missing callback "+(e.stack||e.message);process.traceDeprecation?console.trace(t):console.error(t)}}}}function maybeCallback(e){return"function"==typeof e?e:rethrow()}var normalize=path__default.normalize;if(isWindows)var nextPartRe=/(.*?)(?:[\/\\]+|$)/g;else nextPartRe=/(.*?)(?:[\/]+|$)/g;if(isWindows)var splitRootRe=/^(?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/][^\\\/]+)?[\\\/]*/;else splitRootRe=/^[\/]*/;var realpathSync=function(e,t){if(e=path__default.resolve(e),t&&Object.prototype.hasOwnProperty.call(t,e))return t[e];var r,n,i,s,o=e,a={},u={};function c(){var t=splitRootRe.exec(e);r=t[0].length,n=t[0],i=t[0],s="",isWindows&&!u[i]&&(fs$1__default.lstatSync(i),u[i]=!0)}for(c();r<e.length;){nextPartRe.lastIndex=r;var h=nextPartRe.exec(e);if(s=n,n+=h[0],i=s+h[1],r=nextPartRe.lastIndex,!(u[i]||t&&t[i]===i)){var p;if(t&&Object.prototype.hasOwnProperty.call(t,i))p=t[i];else{var l=fs$1__default.lstatSync(i);if(!l.isSymbolicLink()){u[i]=!0,t&&(t[i]=i);continue}var f=null;if(!isWindows){var d=l.dev.toString(32)+":"+l.ino.toString(32);a.hasOwnProperty(d)&&(f=a[d])}null===f&&(fs$1__default.statSync(i),f=fs$1__default.readlinkSync(i)),p=path__default.resolve(s,f),t&&(t[i]=p),isWindows||(a[d]=f)}e=path__default.resolve(p,e.slice(r)),c()}}return t&&(t[o]=e),e},realpath=function(e,t,r){if("function"!=typeof r&&(r=maybeCallback(t),t=null),e=path__default.resolve(e),t&&Object.prototype.hasOwnProperty.call(t,e))return process.nextTick(r.bind(null,null,t[e]));var n,i,s,o,a=e,u={},c={};function h(){var t=splitRootRe.exec(e);n=t[0].length,i=t[0],s=t[0],o="",isWindows&&!c[s]?fs$1__default.lstat(s,function(e){if(e)return r(e);c[s]=!0,p()}):process.nextTick(p)}function p(){if(n>=e.length)return t&&(t[a]=e),r(null,e);nextPartRe.lastIndex=n;var u=nextPartRe.exec(e);return o=i,i+=u[0],s=o+u[1],n=nextPartRe.lastIndex,c[s]||t&&t[s]===s?process.nextTick(p):t&&Object.prototype.hasOwnProperty.call(t,s)?d(t[s]):fs$1__default.lstat(s,l)}function l(e,n){if(e)return r(e);if(!n.isSymbolicLink())return c[s]=!0,t&&(t[s]=s),process.nextTick(p);if(!isWindows){var i=n.dev.toString(32)+":"+n.ino.toString(32);if(u.hasOwnProperty(i))return f(null,u[i],s)}fs$1__default.stat(s,function(e){if(e)return r(e);fs$1__default.readlink(s,function(e,t){isWindows||(u[i]=t),f(e,t)})})}function f(e,n,i){if(e)return r(e);var s=path__default.resolve(o,n);t&&(t[i]=s),d(s)}function d(t){e=path__default.resolve(t,e.slice(n)),h()}h()},old={realpathSync:realpathSync,realpath:realpath},fs_realpath=realpath$1;realpath$1.realpath=realpath$1,realpath$1.sync=realpathSync$1,realpath$1.realpathSync=realpathSync$1,realpath$1.monkeypatch=monkeypatch,realpath$1.unmonkeypatch=unmonkeypatch;var origRealpath=fs$1__default.realpath,origRealpathSync=fs$1__default.realpathSync,version=process.version,ok=/^v[0-5]\./.test(version);function newError(e){return e&&"realpath"===e.syscall&&("ELOOP"===e.code||"ENOMEM"===e.code||"ENAMETOOLONG"===e.code)}function realpath$1(e,t,r){if(ok)return origRealpath(e,t,r);"function"==typeof t&&(r=t,t=null),origRealpath(e,t,function(n,i){newError(n)?old.realpath(e,t,r):r(n,i)})}function realpathSync$1(e,t){if(ok)return origRealpathSync(e,t);try{return origRealpathSync(e,t)}catch(r){if(newError(r))return old.realpathSync(e,t);throw r}}function monkeypatch(){fs$1__default.realpath=realpath$1,fs$1__default.realpathSync=realpathSync$1}function unmonkeypatch(){fs$1__default.realpath=origRealpath,fs$1__default.realpathSync=origRealpathSync}var concatMap=function(e,t){for(var r=[],n=0;n<e.length;n++){var i=t(e[n],n);isArray(i)?r.push.apply(r,i):r.push(i)}return r},isArray=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},balancedMatch=balanced;function balanced(e,t,r){e instanceof RegExp&&(e=maybeMatch(e,r)),t instanceof RegExp&&(t=maybeMatch(t,r));var n=range(e,t,r);return n&&{start:n[0],end:n[1],pre:r.slice(0,n[0]),body:r.slice(n[0]+e.length,n[1]),post:r.slice(n[1]+t.length)}}function maybeMatch(e,t){var r=t.match(e);return r?r[0]:null}function range(e,t,r){var n,i,s,o,a,u=r.indexOf(e),c=r.indexOf(t,u+1),h=u;if(u>=0&&c>0){for(n=[],s=r.length;h>=0&&!a;)h==u?(n.push(h),u=r.indexOf(e,h+1)):1==n.length?a=[n.pop(),c]:((i=n.pop())<s&&(s=i,o=c),c=r.indexOf(t,h+1)),h=u<c&&u>=0?u:c;n.length&&(a=[s,o])}return a}balanced.range=range;var braceExpansion=expandTop,escSlash="\0SLASH"+Math.random()+"\0",escOpen="\0OPEN"+Math.random()+"\0",escClose="\0CLOSE"+Math.random()+"\0",escComma="\0COMMA"+Math.random()+"\0",escPeriod="\0PERIOD"+Math.random()+"\0";function numeric(e){return parseInt(e,10)==e?parseInt(e,10):e.charCodeAt(0)}function escapeBraces(e){return e.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod)}function unescapeBraces(e){return e.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".")}function parseCommaParts(e){if(!e)return[""];var t=[],r=balancedMatch("{","}",e);if(!r)return e.split(",");var n=r.pre,i=r.body,s=r.post,o=n.split(",");o[o.length-1]+="{"+i+"}";var a=parseCommaParts(s);return s.length&&(o[o.length-1]+=a.shift(),o.push.apply(o,a)),t.push.apply(t,o),t}function expandTop(e){return e?("{}"===e.substr(0,2)&&(e="\\{\\}"+e.substr(2)),expand(escapeBraces(e),!0).map(unescapeBraces)):[]}function embrace(e){return"{"+e+"}"}function isPadded(e){return/^-?0\d/.test(e)}function lte(e,t){return e<=t}function gte(e,t){return e>=t}function expand(e,t){var r=[],n=balancedMatch("{","}",e);if(!n||/\$$/.test(n.pre))return[e];var i,s=/^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(n.body),o=/^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(n.body),a=s||o,u=n.body.indexOf(",")>=0;if(!a&&!u)return n.post.match(/,.*\}/)?expand(e=n.pre+"{"+n.body+escClose+n.post):[e];if(a)i=n.body.split(/\.\./);else if(1===(i=parseCommaParts(n.body)).length&&1===(i=expand(i[0],!1).map(embrace)).length)return(p=n.post.length?expand(n.post,!1):[""]).map(function(e){return n.pre+i[0]+e});var c,h=n.pre,p=n.post.length?expand(n.post,!1):[""];if(a){var l=numeric(i[0]),f=numeric(i[1]),d=Math.max(i[0].length,i[1].length),m=3==i.length?Math.abs(numeric(i[2])):1,g=lte;f<l&&(m*=-1,g=gte);var y=i.some(isPadded);c=[];for(var v=l;g(v,f);v+=m){var _;if(o)"\\"===(_=String.fromCharCode(v))&&(_="");else if(_=String(v),y){var x=d-_.length;if(x>0){var b=new Array(x+1).join("0");_=v<0?"-"+b+_.slice(1):b+_}}c.push(_)}}else c=concatMap(i,function(e){return expand(e,!1)});for(var E=0;E<c.length;E++)for(var S=0;S<p.length;S++){var A=h+c[E]+p[S];(!t||a||A)&&r.push(A)}return r}var minimatch_1=minimatch;minimatch.Minimatch=Minimatch;var path$1={sep:"/"};try{path$1=path__default}catch(e){}var GLOBSTAR=minimatch.GLOBSTAR=Minimatch.GLOBSTAR={},plTypes={"!":{open:"(?:(?!(?:",close:"))[^/]*?)"},"?":{open:"(?:",close:")?"},"+":{open:"(?:",close:")+"},"*":{open:"(?:",close:")*"},"@":{open:"(?:",close:")"}},qmark="[^/]",star=qmark+"*?",twoStarDot="(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?",twoStarNoDot="(?:(?!(?:\\/|^)\\.).)*?",reSpecials=charSet("().*{}+?[]^$\\!");function charSet(e){return e.split("").reduce(function(e,t){return e[t]=!0,e},{})}var slashSplit=/\/+/;function filter(e,t){return t=t||{},function(r,n,i){return minimatch(r,e,t)}}function ext(e,t){e=e||{},t=t||{};var r={};return Object.keys(t).forEach(function(e){r[e]=t[e]}),Object.keys(e).forEach(function(t){r[t]=e[t]}),r}function minimatch(e,t,r){if("string"!=typeof t)throw new TypeError("glob pattern string required");return r||(r={}),!(!r.nocomment&&"#"===t.charAt(0))&&(""===t.trim()?""===e:new Minimatch(t,r).match(e))}function Minimatch(e,t){if(!(this instanceof Minimatch))return new Minimatch(e,t);if("string"!=typeof e)throw new TypeError("glob pattern string required");t||(t={}),e=e.trim(),"/"!==path$1.sep&&(e=e.split(path$1.sep).join("/")),this.options=t,this.set=[],this.pattern=e,this.regexp=null,this.negate=!1,this.comment=!1,this.empty=!1,this.make()}function make(){if(!this._made){var e=this.pattern,t=this.options;if(t.nocomment||"#"!==e.charAt(0))if(e){this.parseNegate();var r=this.globSet=this.braceExpand();t.debug&&(this.debug=console.error),this.debug(this.pattern,r),r=this.globParts=r.map(function(e){return e.split(slashSplit)}),this.debug(this.pattern,r),r=r.map(function(e,t,r){return e.map(this.parse,this)},this),this.debug(this.pattern,r),r=r.filter(function(e){return-1===e.indexOf(!1)}),this.debug(this.pattern,r),this.set=r}else this.empty=!0;else this.comment=!0}}function parseNegate(){var e=this.pattern,t=!1,r=0;if(!this.options.nonegate){for(var n=0,i=e.length;n<i&&"!"===e.charAt(n);n++)t=!t,r++;r&&(this.pattern=e.substr(r)),this.negate=t}}function braceExpand(e,t){if(t||(t=this instanceof Minimatch?this.options:{}),void 0===(e=void 0===e?this.pattern:e))throw new TypeError("undefined pattern");return t.nobrace||!e.match(/\{.*\}/)?[e]:braceExpansion(e)}minimatch.filter=filter,minimatch.defaults=function(e){if(!e||!Object.keys(e).length)return minimatch;var t=minimatch,r=function(r,n,i){return t.minimatch(r,n,ext(e,i))};return r.Minimatch=function(r,n){return new t.Minimatch(r,ext(e,n))},r},Minimatch.defaults=function(e){return e&&Object.keys(e).length?minimatch.defaults(e).Minimatch:Minimatch},Minimatch.prototype.debug=function(){},Minimatch.prototype.make=make,Minimatch.prototype.parseNegate=parseNegate,minimatch.braceExpand=function(e,t){return braceExpand(e,t)},Minimatch.prototype.braceExpand=braceExpand,Minimatch.prototype.parse=parse;var SUBPARSE={};function parse(e,t){if(e.length>65536)throw new TypeError("pattern is too long");var r=this.options;if(!r.noglobstar&&"**"===e)return GLOBSTAR;if(""===e)return"";var n,i="",s=!!r.nocase,o=!1,a=[],u=[],c=!1,h=-1,p=-1,l="."===e.charAt(0)?"":r.dot?"(?!(?:^|\\/)\\.{1,2}(?:$|\\/))":"(?!\\.)",f=this;function d(){if(n){switch(n){case"*":i+=star,s=!0;break;case"?":i+=qmark,s=!0;break;default:i+="\\"+n}f.debug("clearStateChar %j %j",n,i),n=!1}}for(var m,g=0,y=e.length;g<y&&(m=e.charAt(g));g++)if(this.debug("%s\t%s %s %j",e,g,i,m),o&&reSpecials[m])i+="\\"+m,o=!1;else switch(m){case"/":return!1;case"\\":d(),o=!0;continue;case"?":case"*":case"+":case"@":case"!":if(this.debug("%s\t%s %s %j <-- stateChar",e,g,i,m),c){this.debug("  in class"),"!"===m&&g===p+1&&(m="^"),i+=m;continue}f.debug("call clearStateChar %j",n),d(),n=m,r.noext&&d();continue;case"(":if(c){i+="(";continue}if(!n){i+="\\(";continue}a.push({type:n,start:g-1,reStart:i.length,open:plTypes[n].open,close:plTypes[n].close}),i+="!"===n?"(?:(?!(?:":"(?:",this.debug("plType %j %j",n,i),n=!1;continue;case")":if(c||!a.length){i+="\\)";continue}d(),s=!0;var v=a.pop();i+=v.close,"!"===v.type&&u.push(v),v.reEnd=i.length;continue;case"|":if(c||!a.length||o){i+="\\|",o=!1;continue}d(),i+="|";continue;case"[":if(d(),c){i+="\\"+m;continue}c=!0,p=g,h=i.length,i+=m;continue;case"]":if(g===p+1||!c){i+="\\"+m,o=!1;continue}if(c)var _,x=e.substring(p+1,g);s=!0,c=!1,i+=m;continue;default:d(),o?o=!1:!reSpecials[m]||"^"===m&&c||(i+="\\"),i+=m}for(c&&(x=e.substr(p+1),_=this.parse(x,SUBPARSE),i=i.substr(0,h)+"\\["+_[0],s=s||_[1]),v=a.pop();v;v=a.pop()){var b=i.slice(v.reStart+v.open.length);this.debug("setting tail",i,v),b=b.replace(/((?:\\{2}){0,64})(\\?)\|/g,function(e,t,r){return r||(r="\\"),t+t+r+"|"}),this.debug("tail=%j\n   %s",b,b,v,i);var E="*"===v.type?star:"?"===v.type?qmark:"\\"+v.type;s=!0,i=i.slice(0,v.reStart)+E+"\\("+b}d(),o&&(i+="\\\\");var S=!1;switch(i.charAt(0)){case".":case"[":case"(":S=!0}for(var A=u.length-1;A>-1;A--){var w=u[A],k=i.slice(0,w.reStart),N=i.slice(w.reStart,w.reEnd-8),P=i.slice(w.reEnd-8,w.reEnd),$=i.slice(w.reEnd);P+=$;var C=k.split("(").length-1,I=$;for(g=0;g<C;g++)I=I.replace(/\)[+*?]?/,"");var O="";""===($=I)&&t!==SUBPARSE&&(O="$"),i=k+N+$+O+P}if(""!==i&&s&&(i="(?=.)"+i),S&&(i=l+i),t===SUBPARSE)return[i,s];if(!s)return globUnescape(e);var R=r.nocase?"i":"";try{var T=new RegExp("^"+i+"$",R)}catch(e){return new RegExp("$.")}return T._glob=e,T._src=i,T}function makeRe(){if(this.regexp||!1===this.regexp)return this.regexp;var e=this.set;if(!e.length)return this.regexp=!1,this.regexp;var t=this.options,r=t.noglobstar?star:t.dot?twoStarDot:twoStarNoDot,n=t.nocase?"i":"",i=e.map(function(e){return e.map(function(e){return e===GLOBSTAR?r:"string"==typeof e?regExpEscape(e):e._src}).join("\\/")}).join("|");i="^(?:"+i+")$",this.negate&&(i="^(?!"+i+").*$");try{this.regexp=new RegExp(i,n)}catch(e){this.regexp=!1}return this.regexp}function match(e,t){if(this.debug("match",e,this.pattern),this.comment)return!1;if(this.empty)return""===e;if("/"===e&&t)return!0;var r=this.options;"/"!==path$1.sep&&(e=e.split(path$1.sep).join("/")),e=e.split(slashSplit),this.debug(this.pattern,"split",e);var n,i,s=this.set;for(this.debug(this.pattern,"set",s),i=e.length-1;i>=0&&!(n=e[i]);i--);for(i=0;i<s.length;i++){var o=s[i],a=e;if(r.matchBase&&1===o.length&&(a=[n]),this.matchOne(a,o,t))return!!r.flipNegate||!this.negate}return!r.flipNegate&&this.negate}function globUnescape(e){return e.replace(/\\(.)/g,"$1")}function regExpEscape(e){return e.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}minimatch.makeRe=function(e,t){return new Minimatch(e,t||{}).makeRe()},Minimatch.prototype.makeRe=makeRe,minimatch.match=function(e,t,r){var n=new Minimatch(t,r=r||{});return e=e.filter(function(e){return n.match(e)}),n.options.nonull&&!e.length&&e.push(t),e},Minimatch.prototype.match=match,Minimatch.prototype.matchOne=function(e,t,r){var n=this.options;this.debug("matchOne",{this:this,file:e,pattern:t}),this.debug("matchOne",e.length,t.length);for(var i=0,s=0,o=e.length,a=t.length;i<o&&s<a;i++,s++){this.debug("matchOne loop");var u,c=t[s],h=e[i];if(this.debug(t,c,h),!1===c)return!1;if(c===GLOBSTAR){this.debug("GLOBSTAR",[t,c,h]);var p=i,l=s+1;if(l===a){for(this.debug("** at the end");i<o;i++)if("."===e[i]||".."===e[i]||!n.dot&&"."===e[i].charAt(0))return!1;return!0}for(;p<o;){var f=e[p];if(this.debug("\nglobstar while",e,p,t,l,f),this.matchOne(e.slice(p),t.slice(l),r))return this.debug("globstar found match!",p,o,f),!0;if("."===f||".."===f||!n.dot&&"."===f.charAt(0)){this.debug("dot detected!",e,p,t,l);break}this.debug("globstar swallow a segment, and continue"),p++}return!(!r||(this.debug("\n>>> no match, partial?",e,p,t,l),p!==o))}if("string"==typeof c?(u=n.nocase?h.toLowerCase()===c.toLowerCase():h===c,this.debug("string match",c,h,u)):(u=h.match(c),this.debug("pattern match",c,h,u)),!u)return!1}if(i===o&&s===a)return!0;if(i===o)return r;if(s===a)return i===o-1&&""===e[i];throw new Error("wtf?")};var inherits_browser=createCommonjsModule(function(e){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var r=function(){};r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e}}),inherits=createCommonjsModule(function(e){try{var t=util;if("function"!=typeof t.inherits)throw"";e.exports=t.inherits}catch(t){e.exports=inherits_browser}});function posix(e){return"/"===e.charAt(0)}function win32(e){var t=/^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/.exec(e),r=t[1]||"",n=Boolean(r&&":"!==r.charAt(1));return Boolean(t[2]||n)}var pathIsAbsolute="win32"===process.platform?win32:posix,posix_1=posix,win32_1=win32;pathIsAbsolute.posix=posix_1,pathIsAbsolute.win32=win32_1;var alphasort_1=alphasort,alphasorti_1=alphasorti,setopts_1=setopts,ownProp_1=ownProp,makeAbs_1=makeAbs,finish_1=finish,mark_1=mark,isIgnored_1=isIgnored,childrenIgnored_1=childrenIgnored;function ownProp(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var Minimatch$1=minimatch_1.Minimatch;function alphasorti(e,t){return e.toLowerCase().localeCompare(t.toLowerCase())}function alphasort(e,t){return e.localeCompare(t)}function setupIgnores(e,t){e.ignore=t.ignore||[],Array.isArray(e.ignore)||(e.ignore=[e.ignore]),e.ignore.length&&(e.ignore=e.ignore.map(ignoreMap))}function ignoreMap(e){var t=null;if("/**"===e.slice(-3)){var r=e.replace(/(\/\*\*)+$/,"");t=new Minimatch$1(r,{dot:!0})}return{matcher:new Minimatch$1(e,{dot:!0}),gmatcher:t}}function setopts(e,t,r){if(r||(r={}),r.matchBase&&-1===t.indexOf("/")){if(r.noglobstar)throw new Error("base matching requires globstar");t="**/"+t}e.silent=!!r.silent,e.pattern=t,e.strict=!1!==r.strict,e.realpath=!!r.realpath,e.realpathCache=r.realpathCache||Object.create(null),e.follow=!!r.follow,e.dot=!!r.dot,e.mark=!!r.mark,e.nodir=!!r.nodir,e.nodir&&(e.mark=!0),e.sync=!!r.sync,e.nounique=!!r.nounique,e.nonull=!!r.nonull,e.nosort=!!r.nosort,e.nocase=!!r.nocase,e.stat=!!r.stat,e.noprocess=!!r.noprocess,e.absolute=!!r.absolute,e.maxLength=r.maxLength||1/0,e.cache=r.cache||Object.create(null),e.statCache=r.statCache||Object.create(null),e.symlinks=r.symlinks||Object.create(null),setupIgnores(e,r),e.changedCwd=!1;var n=process.cwd();ownProp(r,"cwd")?(e.cwd=path__default.resolve(r.cwd),e.changedCwd=e.cwd!==n):e.cwd=n,e.root=r.root||path__default.resolve(e.cwd,"/"),e.root=path__default.resolve(e.root),"win32"===process.platform&&(e.root=e.root.replace(/\\/g,"/")),e.cwdAbs=pathIsAbsolute(e.cwd)?e.cwd:makeAbs(e,e.cwd),"win32"===process.platform&&(e.cwdAbs=e.cwdAbs.replace(/\\/g,"/")),e.nomount=!!r.nomount,r.nonegate=!0,r.nocomment=!0,e.minimatch=new Minimatch$1(t,r),e.options=e.minimatch.options}function finish(e){for(var t=e.nounique,r=t?[]:Object.create(null),n=0,i=e.matches.length;n<i;n++){var s=e.matches[n];if(s&&0!==Object.keys(s).length){var o=Object.keys(s);t?r.push.apply(r,o):o.forEach(function(e){r[e]=!0})}else if(e.nonull){var a=e.minimatch.globSet[n];t?r.push(a):r[a]=!0}}if(t||(r=Object.keys(r)),e.nosort||(r=r.sort(e.nocase?alphasorti:alphasort)),e.mark){for(n=0;n<r.length;n++)r[n]=e._mark(r[n]);e.nodir&&(r=r.filter(function(t){var r=!/\/$/.test(t),n=e.cache[t]||e.cache[makeAbs(e,t)];return r&&n&&(r="DIR"!==n&&!Array.isArray(n)),r}))}e.ignore.length&&(r=r.filter(function(t){return!isIgnored(e,t)})),e.found=r}function mark(e,t){var r=makeAbs(e,t),n=e.cache[r],i=t;if(n){var s="DIR"===n||Array.isArray(n),o="/"===t.slice(-1);if(s&&!o?i+="/":!s&&o&&(i=i.slice(0,-1)),i!==t){var a=makeAbs(e,i);e.statCache[a]=e.statCache[r],e.cache[a]=e.cache[r]}}return i}function makeAbs(e,t){var r=t;return r="/"===t.charAt(0)?path__default.join(e.root,t):pathIsAbsolute(t)||""===t?t:e.changedCwd?path__default.resolve(e.cwd,t):path__default.resolve(t),"win32"===process.platform&&(r=r.replace(/\\/g,"/")),r}function isIgnored(e,t){return!!e.ignore.length&&e.ignore.some(function(e){return e.matcher.match(t)||!(!e.gmatcher||!e.gmatcher.match(t))})}function childrenIgnored(e,t){return!!e.ignore.length&&e.ignore.some(function(e){return!(!e.gmatcher||!e.gmatcher.match(t))})}var common={alphasort:alphasort_1,alphasorti:alphasorti_1,setopts:setopts_1,ownProp:ownProp_1,makeAbs:makeAbs_1,finish:finish_1,mark:mark_1,isIgnored:isIgnored_1,childrenIgnored:childrenIgnored_1},sync=globSync;globSync.GlobSync=GlobSync;var setopts$1=common.setopts,ownProp$1=common.ownProp,childrenIgnored$1=common.childrenIgnored,isIgnored$1=common.isIgnored;function globSync(e,t){if("function"==typeof t||3===arguments.length)throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");return new GlobSync(e,t).found}function GlobSync(e,t){if(!e)throw new Error("must provide pattern");if("function"==typeof t||3===arguments.length)throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");if(!(this instanceof GlobSync))return new GlobSync(e,t);if(setopts$1(this,e,t),this.noprocess)return this;var r=this.minimatch.set.length;this.matches=new Array(r);for(var n=0;n<r;n++)this._process(this.minimatch.set[n],n,!1);this._finish()}GlobSync.prototype._finish=function(){if(assert(this instanceof GlobSync),this.realpath){var e=this;this.matches.forEach(function(t,r){var n=e.matches[r]=Object.create(null);for(var i in t)try{i=e._makeAbs(i),n[fs_realpath.realpathSync(i,e.realpathCache)]=!0}catch(t){if("stat"!==t.syscall)throw t;n[e._makeAbs(i)]=!0}})}common.finish(this)},GlobSync.prototype._process=function(e,t,r){assert(this instanceof GlobSync);for(var n,i=0;"string"==typeof e[i];)i++;switch(i){case e.length:return void this._processSimple(e.join("/"),t);case 0:n=null;break;default:n=e.slice(0,i).join("/")}var s,o=e.slice(i);null===n?s=".":pathIsAbsolute(n)||pathIsAbsolute(e.join("/"))?(n&&pathIsAbsolute(n)||(n="/"+n),s=n):s=n;var a=this._makeAbs(s);childrenIgnored$1(this,s)||(o[0]===minimatch_1.GLOBSTAR?this._processGlobStar(n,s,a,o,t,r):this._processReaddir(n,s,a,o,t,r))},GlobSync.prototype._processReaddir=function(e,t,r,n,i,s){var o=this._readdir(r,s);if(o){for(var a=n[0],u=!!this.minimatch.negate,c=a._glob,h=this.dot||"."===c.charAt(0),p=[],l=0;l<o.length;l++){if("."!==(m=o[l]).charAt(0)||h)(u&&!e?!m.match(a):m.match(a))&&p.push(m)}var f=p.length;if(0!==f)if(1!==n.length||this.mark||this.stat){n.shift();for(l=0;l<f;l++){var d;m=p[l];d=e?[e,m]:[m],this._process(d.concat(n),i,s)}}else{this.matches[i]||(this.matches[i]=Object.create(null));for(var l=0;l<f;l++){var m=p[l];e&&(m="/"!==e.slice(-1)?e+"/"+m:e+m),"/"!==m.charAt(0)||this.nomount||(m=path__default.join(this.root,m)),this._emitMatch(i,m)}}}},GlobSync.prototype._emitMatch=function(e,t){if(!isIgnored$1(this,t)){var r=this._makeAbs(t);if(this.mark&&(t=this._mark(t)),this.absolute&&(t=r),!this.matches[e][t]){if(this.nodir){var n=this.cache[r];if("DIR"===n||Array.isArray(n))return}this.matches[e][t]=!0,this.stat&&this._stat(t)}}},GlobSync.prototype._readdirInGlobStar=function(e){if(this.follow)return this._readdir(e,!1);var t,r;try{r=fs$1__default.lstatSync(e)}catch(e){if("ENOENT"===e.code)return null}var n=r&&r.isSymbolicLink();return this.symlinks[e]=n,n||!r||r.isDirectory()?t=this._readdir(e,!1):this.cache[e]="FILE",t},GlobSync.prototype._readdir=function(e,t){if(t&&!ownProp$1(this.symlinks,e))return this._readdirInGlobStar(e);if(ownProp$1(this.cache,e)){var r=this.cache[e];if(!r||"FILE"===r)return null;if(Array.isArray(r))return r}try{return this._readdirEntries(e,fs$1__default.readdirSync(e))}catch(t){return this._readdirError(e,t),null}},GlobSync.prototype._readdirEntries=function(e,t){if(!this.mark&&!this.stat)for(var r=0;r<t.length;r++){var n=t[r];n="/"===e?e+n:e+"/"+n,this.cache[n]=!0}return this.cache[e]=t,t},GlobSync.prototype._readdirError=function(e,t){switch(t.code){case"ENOTSUP":case"ENOTDIR":var r=this._makeAbs(e);if(this.cache[r]="FILE",r===this.cwdAbs){var n=new Error(t.code+" invalid cwd "+this.cwd);throw n.path=this.cwd,n.code=t.code,n}break;case"ENOENT":case"ELOOP":case"ENAMETOOLONG":case"UNKNOWN":this.cache[this._makeAbs(e)]=!1;break;default:if(this.cache[this._makeAbs(e)]=!1,this.strict)throw t;this.silent||console.error("glob error",t)}},GlobSync.prototype._processGlobStar=function(e,t,r,n,i,s){var o=this._readdir(r,s);if(o){var a=n.slice(1),u=e?[e]:[],c=u.concat(a);this._process(c,i,!1);var h=o.length;if(!this.symlinks[r]||!s)for(var p=0;p<h;p++){if("."!==o[p].charAt(0)||this.dot){var l=u.concat(o[p],a);this._process(l,i,!0);var f=u.concat(o[p],n);this._process(f,i,!0)}}}},GlobSync.prototype._processSimple=function(e,t){var r=this._stat(e);if(this.matches[t]||(this.matches[t]=Object.create(null)),r){if(e&&pathIsAbsolute(e)&&!this.nomount){var n=/[\/\\]$/.test(e);"/"===e.charAt(0)?e=path__default.join(this.root,e):(e=path__default.resolve(this.root,e),n&&(e+="/"))}"win32"===process.platform&&(e=e.replace(/\\/g,"/")),this._emitMatch(t,e)}},GlobSync.prototype._stat=function(e){var t=this._makeAbs(e),r="/"===e.slice(-1);if(e.length>this.maxLength)return!1;if(!this.stat&&ownProp$1(this.cache,t)){var n=this.cache[t];if(Array.isArray(n)&&(n="DIR"),!r||"DIR"===n)return n;if(r&&"FILE"===n)return!1}var i=this.statCache[t];if(!i){var s;try{s=fs$1__default.lstatSync(t)}catch(e){if(e&&("ENOENT"===e.code||"ENOTDIR"===e.code))return this.statCache[t]=!1,!1}if(s&&s.isSymbolicLink())try{i=fs$1__default.statSync(t)}catch(e){i=s}else i=s}this.statCache[t]=i;n=!0;return i&&(n=i.isDirectory()?"DIR":"FILE"),this.cache[t]=this.cache[t]||n,(!r||"FILE"!==n)&&n},GlobSync.prototype._mark=function(e){return common.mark(this,e)},GlobSync.prototype._makeAbs=function(e){return common.makeAbs(this,e)};var wrappy_1=wrappy;function wrappy(e,t){if(e&&t)return wrappy(e)(t);if("function"!=typeof e)throw new TypeError("need wrapper function");return Object.keys(e).forEach(function(t){r[t]=e[t]}),r;function r(){for(var t=new Array(arguments.length),r=0;r<t.length;r++)t[r]=arguments[r];var n=e.apply(this,t),i=t[t.length-1];return"function"==typeof n&&n!==i&&Object.keys(i).forEach(function(e){n[e]=i[e]}),n}}var once_1=wrappy_1(once),strict=wrappy_1(onceStrict);function once(e){var t=function(){return t.called?t.value:(t.called=!0,t.value=e.apply(this,arguments))};return t.called=!1,t}function onceStrict(e){var t=function(){if(t.called)throw new Error(t.onceError);return t.called=!0,t.value=e.apply(this,arguments)},r=e.name||"Function wrapped with `once`";return t.onceError=r+" shouldn't be called more than once",t.called=!1,t}once.proto=once(function(){Object.defineProperty(Function.prototype,"once",{value:function(){return once(this)},configurable:!0}),Object.defineProperty(Function.prototype,"onceStrict",{value:function(){return onceStrict(this)},configurable:!0})}),once_1.strict=strict;var reqs=Object.create(null),inflight_1=wrappy_1(inflight);function inflight(e,t){return reqs[e]?(reqs[e].push(t),null):(reqs[e]=[t],makeres(e))}function makeres(e){return once_1(function t(){var r=reqs[e],n=r.length,i=slice(arguments);try{for(var s=0;s<n;s++)r[s].apply(null,i)}finally{r.length>n?(r.splice(0,n),process.nextTick(function(){t.apply(null,i)})):delete reqs[e]}})}function slice(e){for(var t=e.length,r=[],n=0;n<t;n++)r[n]=e[n];return r}var glob_1=glob,EE=events__default.EventEmitter,setopts$2=common.setopts,ownProp$2=common.ownProp,childrenIgnored$2=common.childrenIgnored,isIgnored$2=common.isIgnored;function glob(e,t,r){if("function"==typeof t&&(r=t,t={}),t||(t={}),t.sync){if(r)throw new TypeError("callback provided to sync glob");return sync(e,t)}return new Glob$1(e,t,r)}glob.sync=sync;var GlobSync$1=glob.GlobSync=sync.GlobSync;function extend(e,t){if(null===t||"object"!=typeof t)return e;for(var r=Object.keys(t),n=r.length;n--;)e[r[n]]=t[r[n]];return e}function Glob$1(e,t,r){if("function"==typeof t&&(r=t,t=null),t&&t.sync){if(r)throw new TypeError("callback provided to sync glob");return new GlobSync$1(e,t)}if(!(this instanceof Glob$1))return new Glob$1(e,t,r);setopts$2(this,e,t),this._didRealPath=!1;var n=this.minimatch.set.length;this.matches=new Array(n),"function"==typeof r&&(r=once_1(r),this.on("error",r),this.on("end",function(e){r(null,e)}));var i=this;if(this._processing=0,this._emitQueue=[],this._processQueue=[],this.paused=!1,this.noprocess)return this;if(0===n)return a();for(var s=!0,o=0;o<n;o++)this._process(this.minimatch.set[o],o,!1,a);function a(){--i._processing,i._processing<=0&&(s?process.nextTick(function(){i._finish()}):i._finish())}s=!1}function readdirCb(e,t,r){return function(n,i){n?e._readdirError(t,n,r):e._readdirEntries(t,i,r)}}glob.glob=glob,glob.hasMagic=function(e,t){var r=extend({},t);r.noprocess=!0;var n=new Glob$1(e,r).minimatch.set;if(!e)return!1;if(n.length>1)return!0;for(var i=0;i<n[0].length;i++)if("string"!=typeof n[0][i])return!0;return!1},glob.Glob=Glob$1,inherits(Glob$1,EE),Glob$1.prototype._finish=function(){if(assert(this instanceof Glob$1),!this.aborted){if(this.realpath&&!this._didRealpath)return this._realpath();common.finish(this),this.emit("end",this.found)}},Glob$1.prototype._realpath=function(){if(!this._didRealpath){this._didRealpath=!0;var e=this.matches.length;if(0===e)return this._finish();for(var t=this,r=0;r<this.matches.length;r++)this._realpathSet(r,n)}function n(){0==--e&&t._finish()}},Glob$1.prototype._realpathSet=function(e,t){var r=this.matches[e];if(!r)return t();var n=Object.keys(r),i=this,s=n.length;if(0===s)return t();var o=this.matches[e]=Object.create(null);n.forEach(function(r,n){r=i._makeAbs(r),fs_realpath.realpath(r,i.realpathCache,function(n,a){n?"stat"===n.syscall?o[r]=!0:i.emit("error",n):o[a]=!0,0==--s&&(i.matches[e]=o,t())})})},Glob$1.prototype._mark=function(e){return common.mark(this,e)},Glob$1.prototype._makeAbs=function(e){return common.makeAbs(this,e)},Glob$1.prototype.abort=function(){this.aborted=!0,this.emit("abort")},Glob$1.prototype.pause=function(){this.paused||(this.paused=!0,this.emit("pause"))},Glob$1.prototype.resume=function(){if(this.paused){if(this.emit("resume"),this.paused=!1,this._emitQueue.length){var e=this._emitQueue.slice(0);this._emitQueue.length=0;for(var t=0;t<e.length;t++){var r=e[t];this._emitMatch(r[0],r[1])}}if(this._processQueue.length){var n=this._processQueue.slice(0);this._processQueue.length=0;for(t=0;t<n.length;t++){var i=n[t];this._processing--,this._process(i[0],i[1],i[2],i[3])}}}},Glob$1.prototype._process=function(e,t,r,n){if(assert(this instanceof Glob$1),assert("function"==typeof n),!this.aborted)if(this._processing++,this.paused)this._processQueue.push([e,t,r,n]);else{for(var i,s=0;"string"==typeof e[s];)s++;switch(s){case e.length:return void this._processSimple(e.join("/"),t,n);case 0:i=null;break;default:i=e.slice(0,s).join("/")}var o,a=e.slice(s);null===i?o=".":pathIsAbsolute(i)||pathIsAbsolute(e.join("/"))?(i&&pathIsAbsolute(i)||(i="/"+i),o=i):o=i;var u=this._makeAbs(o);if(childrenIgnored$2(this,o))return n();a[0]===minimatch_1.GLOBSTAR?this._processGlobStar(i,o,u,a,t,r,n):this._processReaddir(i,o,u,a,t,r,n)}},Glob$1.prototype._processReaddir=function(e,t,r,n,i,s,o){var a=this;this._readdir(r,s,function(u,c){return a._processReaddir2(e,t,r,n,i,s,c,o)})},Glob$1.prototype._processReaddir2=function(e,t,r,n,i,s,o,a){if(!o)return a();for(var u=n[0],c=!!this.minimatch.negate,h=u._glob,p=this.dot||"."===h.charAt(0),l=[],f=0;f<o.length;f++){if("."!==(m=o[f]).charAt(0)||p)(c&&!e?!m.match(u):m.match(u))&&l.push(m)}var d=l.length;if(0===d)return a();if(1===n.length&&!this.mark&&!this.stat){this.matches[i]||(this.matches[i]=Object.create(null));for(f=0;f<d;f++){var m=l[f];e&&(m="/"!==e?e+"/"+m:e+m),"/"!==m.charAt(0)||this.nomount||(m=path__default.join(this.root,m)),this._emitMatch(i,m)}return a()}n.shift();for(f=0;f<d;f++){m=l[f];e&&(m="/"!==e?e+"/"+m:e+m),this._process([m].concat(n),i,s,a)}a()},Glob$1.prototype._emitMatch=function(e,t){if(!this.aborted&&!isIgnored$2(this,t))if(this.paused)this._emitQueue.push([e,t]);else{var r=pathIsAbsolute(t)?t:this._makeAbs(t);if(this.mark&&(t=this._mark(t)),this.absolute&&(t=r),!this.matches[e][t]){if(this.nodir){var n=this.cache[r];if("DIR"===n||Array.isArray(n))return}this.matches[e][t]=!0;var i=this.statCache[r];i&&this.emit("stat",t,i),this.emit("match",t)}}},Glob$1.prototype._readdirInGlobStar=function(e,t){if(!this.aborted){if(this.follow)return this._readdir(e,!1,t);var r=this,n=inflight_1("lstat\0"+e,function(n,i){if(n&&"ENOENT"===n.code)return t();var s=i&&i.isSymbolicLink();r.symlinks[e]=s,s||!i||i.isDirectory()?r._readdir(e,!1,t):(r.cache[e]="FILE",t())});n&&fs$1__default.lstat(e,n)}},Glob$1.prototype._readdir=function(e,t,r){if(!this.aborted&&(r=inflight_1("readdir\0"+e+"\0"+t,r))){if(t&&!ownProp$2(this.symlinks,e))return this._readdirInGlobStar(e,r);if(ownProp$2(this.cache,e)){var n=this.cache[e];if(!n||"FILE"===n)return r();if(Array.isArray(n))return r(null,n)}fs$1__default.readdir(e,readdirCb(this,e,r))}},Glob$1.prototype._readdirEntries=function(e,t,r){if(!this.aborted){if(!this.mark&&!this.stat)for(var n=0;n<t.length;n++){var i=t[n];i="/"===e?e+i:e+"/"+i,this.cache[i]=!0}return this.cache[e]=t,r(null,t)}},Glob$1.prototype._readdirError=function(e,t,r){if(!this.aborted){switch(t.code){case"ENOTSUP":case"ENOTDIR":var n=this._makeAbs(e);if(this.cache[n]="FILE",n===this.cwdAbs){var i=new Error(t.code+" invalid cwd "+this.cwd);i.path=this.cwd,i.code=t.code,this.emit("error",i),this.abort()}break;case"ENOENT":case"ELOOP":case"ENAMETOOLONG":case"UNKNOWN":this.cache[this._makeAbs(e)]=!1;break;default:this.cache[this._makeAbs(e)]=!1,this.strict&&(this.emit("error",t),this.abort()),this.silent||console.error("glob error",t)}return r()}},Glob$1.prototype._processGlobStar=function(e,t,r,n,i,s,o){var a=this;this._readdir(r,s,function(u,c){a._processGlobStar2(e,t,r,n,i,s,c,o)})},Glob$1.prototype._processGlobStar2=function(e,t,r,n,i,s,o,a){if(!o)return a();var u=n.slice(1),c=e?[e]:[],h=c.concat(u);this._process(h,i,!1,a);var p=this.symlinks[r],l=o.length;if(p&&s)return a();for(var f=0;f<l;f++){if("."!==o[f].charAt(0)||this.dot){var d=c.concat(o[f],u);this._process(d,i,!0,a);var m=c.concat(o[f],n);this._process(m,i,!0,a)}}a()},Glob$1.prototype._processSimple=function(e,t,r){var n=this;this._stat(e,function(i,s){n._processSimple2(e,t,i,s,r)})},Glob$1.prototype._processSimple2=function(e,t,r,n,i){if(this.matches[t]||(this.matches[t]=Object.create(null)),!n)return i();if(e&&pathIsAbsolute(e)&&!this.nomount){var s=/[\/\\]$/.test(e);"/"===e.charAt(0)?e=path__default.join(this.root,e):(e=path__default.resolve(this.root,e),s&&(e+="/"))}"win32"===process.platform&&(e=e.replace(/\\/g,"/")),this._emitMatch(t,e),i()},Glob$1.prototype._stat=function(e,t){var r=this._makeAbs(e),n="/"===e.slice(-1);if(e.length>this.maxLength)return t();if(!this.stat&&ownProp$2(this.cache,r)){var i=this.cache[r];if(Array.isArray(i)&&(i="DIR"),!n||"DIR"===i)return t(null,i);if(n&&"FILE"===i)return t()}var s=this.statCache[r];if(void 0!==s){if(!1===s)return t(null,s);var o=s.isDirectory()?"DIR":"FILE";return n&&"FILE"===o?t():t(null,o,s)}var a=this,u=inflight_1("stat\0"+r,function(n,i){if(i&&i.isSymbolicLink())return fs$1__default.stat(r,function(n,s){n?a._stat2(e,r,null,i,t):a._stat2(e,r,n,s,t)});a._stat2(e,r,n,i,t)});u&&fs$1__default.lstat(r,u)},Glob$1.prototype._stat2=function(e,t,r,n,i){if(r&&("ENOENT"===r.code||"ENOTDIR"===r.code))return this.statCache[t]=!1,i();var s="/"===e.slice(-1);if(this.statCache[t]=n,"/"===t.slice(-1)&&n&&!n.isDirectory())return i(null,!1,n);var o=!0;return n&&(o=n.isDirectory()?"DIR":"FILE"),this.cache[t]=this.cache[t]||o,s&&"FILE"===o?i():i(null,o,n)};const TASK_CANCELED_MSG="task canceled";function normalizePath(e){if("string"!=typeof e)throw new Error("invalid path to normalize");if(e=e.trim(),EXTENDED_PATH_REGEX.test(e)||NON_ASCII_REGEX.test(e))return e;if("/"===(e=e.replace(SLASH_REGEX,"/")).charAt(e.length-1)){const t=e.indexOf(":");t>-1?t<e.length-2&&(e=e.substring(0,e.length-1)):e.length>1&&(e=e.substring(0,e.length-1))}return e}const EXTENDED_PATH_REGEX=/^\\\\\?\\/,NON_ASCII_REGEX=/[^\x00-\x80]+/,SLASH_REGEX=/\\/g;function loadConfigFile(e,t,r){let n,i="";r&&(r.cwd&&(i=r.cwd()),r.env&&"string"==typeof r.env.PWD&&(i=r.env.PWD));let s=!1;if("string"==typeof t){if(!path.isAbsolute(t))throw new Error(`Stencil configuration file "${t}" must be an absolute path.`);try{const r=e.statSync(t);r.isFile()?s=!0:r.isDirectory()&&(s=null!=(t=getConfigPathFromDirectory(e,t)))}catch(e){}}if(s){const r=requireConfigFile(e,t);if(!r.config)throw new Error(`Invalid Stencil configuration file "${t}". Missing "config" property.`);(n=r.config).configPath=t,t&&(n.rootDir=normalizePath(path.dirname(t)))}else n={rootDir:i};return n.cwd=normalizePath(i),n}function getConfigPathFromDirectory(e,t){for(let r=0;r<CONFIG_FILENAMES.length;r++)try{const n=path.join(t,CONFIG_FILENAMES[r]);if(e.statSync(n).isFile())return n}catch(e){}return null}const CONFIG_FILENAMES=["stencil.config.ts","stencil.config.js"];function requireConfigFile(e,t){let r=e.readFileSync(t);r=convertSourceConfig(r,t),delete require.cache[path.resolve(t)];const n=require.extensions[".js"];require.extensions[".js"]=((e,i)=>{i===t?e._compile(r,i):n(e,i)});const i=require(t);return require.extensions[".js"]=n,i}function convertSourceConfig(e,t){return e=t.endsWith(".ts")?transpileTypedConfig(e,t):e.replace(/export\s+\w+\s+(\w+)/gm,"exports.$1")}function transpileTypedConfig(e,t){const r={fileName:t,compilerOptions:{module:ts.ModuleKind.CommonJS,moduleResolution:ts.ModuleResolutionKind.NodeJs,esModuleInterop:!0,target:ts.ScriptTarget.ES5},reportDiagnostics:!1};return ts.transpileModule(e,r).outputText}class NodeFs{copyFile(e,t){return new Promise((r,n)=>{const i=fs__default.createReadStream(e);i.on("error",n);const s=fs__default.createWriteStream(t);s.on("error",n),s.on("close",r),i.pipe(s)})}createReadStream(e){return fs__default.createReadStream(e)}mkdir(e){return new Promise((t,r)=>{fs__default.mkdir(e,e=>{e?r(e):t()})})}mkdirSync(e){fs__default.mkdirSync(e)}readdir(e){return new Promise((t,r)=>{fs__default.readdir(e,(e,n)=>{e?r(e):t(n)})})}readdirSync(e){return fs__default.readdirSync(e)}readFile(e){return new Promise((t,r)=>{fs__default.readFile(e,"utf8",(e,n)=>{e?r(e):t(n)})})}exists(e){return new Promise(t=>{fs__default.exists(e,t)})}existsSync(e){return fs__default.existsSync(e)}readFileSync(e){return fs__default.readFileSync(e,"utf8")}rmdir(e){return new Promise((t,r)=>{fs__default.rmdir(e,e=>{e?r(e):t()})})}stat(e){return new Promise((t,r)=>{fs__default.stat(e,(e,n)=>{e?r(e):t(n)})})}statSync(e){return fs__default.statSync(e)}unlink(e){return new Promise((t,r)=>{fs__default.unlink(e,e=>{e?r(e):t()})})}writeFile(e,t){return new Promise((r,n)=>{fs__default.writeFile(e,t,{encoding:"utf8"},e=>{e?n(e):r()})})}writeFileSync(e,t){return fs__default.writeFileSync(e,t,{encoding:"utf8"})}}class NodeLazyRequire{constructor(e,t,r){this.semver=e,this.nodeResolveModule=t,this.stencilPackageJson=r,this.moduleData=new Map}ensure(e,t,r){return __awaiter(this,void 0,void 0,function*(){if(!this.stencilPackageJson||!this.stencilPackageJson.lazyDependencies)return Promise.resolve();if(!this.stencilPackageJson.lazyDependencies)return Promise.resolve();const n=[];let i=!1;const s=r.map(e=>__awaiter(this,void 0,void 0,function*(){const r=this.moduleData.get(e);if(r&&r.fromDir&&r.modulePath)return;const s=this.stencilPackageJson.lazyDependencies[e];try{const r=this.nodeResolveModule.resolveModule(t,e),n=yield readPackageJson(r);if(i=!0,this.semver.satisfies(n.version,s))return void this.moduleData.set(e,{fromDir:t,modulePath:path.dirname(r)})}catch(e){}n.push({moduleId:e,requiredVersionRange:s})}));if(yield Promise.all(s),0===n.length)return Promise.resolve();const o=`Please wait while required dependencies are ${i?"updated":"installed"}. This may take a few moments and will only be required for the initial run.`;e.info(e.magenta(o));const a=n.map(e=>e.moduleId),u=e.createTimeSpan(`installing dependenc${a.length>1?"ies":"y"}: ${a.join(", ")}`);try{const r=n.map(e=>{let t=e.moduleId;return e.requiredVersionRange&&(t+="@"+e.requiredVersionRange),t});yield npmInstall(e,t,r),n.forEach(e=>{this.moduleData.set(e.moduleId,{fromDir:t,modulePath:null})}),u.finish("installing dependencies finished")}catch(t){e.error(`lazy require failed: ${t}`)}})}require(e){const t=this.moduleData.get(e);if(!t)throw new Error(`lazy required module has not been ensured: ${e}`);if(!t.modulePath){const r=this.nodeResolveModule.resolveModule(t.fromDir,e);t.modulePath=path.dirname(r),this.moduleData.set(e,t)}return require(t.modulePath)}getModulePath(e){const t=this.moduleData.get(e);if(!t)throw new Error(`lazy required module has not been ensured: ${e}`);if(!t.modulePath){const r=this.nodeResolveModule.resolveModule(t.fromDir,e);t.modulePath=path.dirname(r),this.moduleData.set(e,t)}return t.modulePath}}function npmInstall(e,t,r){return new Promise((n,i)=>{const s=["install",...r,"--no-audit","--save-exact","--save-dev"],o={shell:!0,cwd:t,env:Object.assign({},process.env),stdio:"inherit"};o.env.NODE_ENV="development","debug"===e.level&&s.push("--verbose"),e.debug(`npm ${s.join(" ")}`),e.debug(`npm, cwd: ${t}`);const a=cp.spawn("npm",s,o);let u="";a.stderr&&a.stderr.on("data",e=>{u+=e.toString()}),a.once("exit",t=>{"debug"===e.level&&e.debug(`npm, exit ${t}`),0===t?n():i(`failed to install: ${r.join(", ")}${u?", "+u:""}`)})})}function readPackageJson(e){return new Promise((t,r)=>{fs.readFile(e,"utf8",(e,n)=>{if(e)r(e);else try{t(JSON.parse(n))}catch(e){r(e)}})})}class NodeResolveModule{constructor(){this.resolveModuleCache=new Map}resolveModule(e,t){const r=`${e}:${t}`,n=this.resolveModuleCache.get(r);if(n)return n;if(t.startsWith("@types/"))return this.resolveTypesModule(e,t,r);const i=require("module");e=path__default.resolve(e);const s=path__default.join(e,"noop.js");let o=normalizePath(i._resolveFilename(t,{id:s,filename:s,paths:i._nodeModulePaths(e)}));const a=normalizePath(path__default.parse(e).root);let u;for(;o!==a;)if(o=normalizePath(path__default.dirname(o)),hasAccess(u=path__default.join(o,"package.json")))return this.resolveModuleCache.set(r,u),u;throw new Error(`error loading "${t}" from "${e}"`)}resolveTypesModule(e,t,r){const n=t.split("/"),i=normalizePath(path__default.parse(e).root);let s,o=normalizePath(path__default.join(e,"noop.js"));for(;o!==i;)if(o=normalizePath(path__default.dirname(o)),hasAccess(s=path__default.join(o,"node_modules",n[0],n[1],"package.json")))return this.resolveModuleCache.set(r,s),s;throw new Error(`error loading "${t}" from "${e}"`)}}function hasAccess(e){let t=!1;try{fs__default.accessSync(e),t=!0}catch(e){}return t}var minimalisticAssert=assert$1;function assert$1(e,t){if(!e)throw new Error(t||"Assertion failed")}assert$1.equal=function(e,t,r){if(e!=t)throw new Error(r||"Assertion failed: "+e+" != "+t)};var commonjsGlobal$1="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function unwrapExports$1(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}function createCommonjsModule$1(e,t){return e(t={exports:{}},t.exports),t.exports}var inherits_browser$1=createCommonjsModule$1(function(e){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var r=function(){};r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e}}),inherits$1=createCommonjsModule$1(function(e){try{var t=util;if("function"!=typeof t.inherits)throw"";e.exports=t.inherits}catch(t){e.exports=inherits_browser$1}}),inherits_1=inherits$1;function toArray(e,t){if(Array.isArray(e))return e.slice();if(!e)return[];var r=[];if("string"==typeof e)if(t){if("hex"===t)for((e=e.replace(/[^a-z0-9]+/gi,"")).length%2!=0&&(e="0"+e),n=0;n<e.length;n+=2)r.push(parseInt(e[n]+e[n+1],16))}else for(var n=0;n<e.length;n++){var i=e.charCodeAt(n),s=i>>8,o=255&i;s?r.push(s,o):r.push(o)}else for(n=0;n<e.length;n++)r[n]=0|e[n];return r}var toArray_1=toArray;function toHex(e){for(var t="",r=0;r<e.length;r++)t+=zero2(e[r].toString(16));return t}var toHex_1=toHex;function htonl(e){return(e>>>24|e>>>8&65280|e<<8&16711680|(255&e)<<24)>>>0}var htonl_1=htonl;function toHex32(e,t){for(var r="",n=0;n<e.length;n++){var i=e[n];"little"===t&&(i=htonl(i)),r+=zero8(i.toString(16))}return r}var toHex32_1=toHex32;function zero2(e){return 1===e.length?"0"+e:e}var zero2_1=zero2;function zero8(e){return 7===e.length?"0"+e:6===e.length?"00"+e:5===e.length?"000"+e:4===e.length?"0000"+e:3===e.length?"00000"+e:2===e.length?"000000"+e:1===e.length?"0000000"+e:e}var zero8_1=zero8;function join32(e,t,r,n){var i=r-t;minimalisticAssert(i%4==0);for(var s=new Array(i/4),o=0,a=t;o<s.length;o++,a+=4){var u;u="big"===n?e[a]<<24|e[a+1]<<16|e[a+2]<<8|e[a+3]:e[a+3]<<24|e[a+2]<<16|e[a+1]<<8|e[a],s[o]=u>>>0}return s}var join32_1=join32;function split32(e,t){for(var r=new Array(4*e.length),n=0,i=0;n<e.length;n++,i+=4){var s=e[n];"big"===t?(r[i]=s>>>24,r[i+1]=s>>>16&255,r[i+2]=s>>>8&255,r[i+3]=255&s):(r[i+3]=s>>>24,r[i+2]=s>>>16&255,r[i+1]=s>>>8&255,r[i]=255&s)}return r}var split32_1=split32;function rotr32(e,t){return e>>>t|e<<32-t}var rotr32_1=rotr32;function rotl32(e,t){return e<<t|e>>>32-t}var rotl32_1=rotl32;function sum32(e,t){return e+t>>>0}var sum32_1=sum32;function sum32_3(e,t,r){return e+t+r>>>0}var sum32_3_1=sum32_3;function sum32_4(e,t,r,n){return e+t+r+n>>>0}var sum32_4_1=sum32_4;function sum32_5(e,t,r,n,i){return e+t+r+n+i>>>0}var sum32_5_1=sum32_5;function sum64(e,t,r,n){var i=e[t],s=n+e[t+1]>>>0,o=(s<n?1:0)+r+i;e[t]=o>>>0,e[t+1]=s}var sum64_1=sum64;function sum64_hi(e,t,r,n){return(t+n>>>0<t?1:0)+e+r>>>0}var sum64_hi_1=sum64_hi;function sum64_lo(e,t,r,n){return t+n>>>0}var sum64_lo_1=sum64_lo;function sum64_4_hi(e,t,r,n,i,s,o,a){var u=0,c=t;return u+=(c=c+n>>>0)<t?1:0,u+=(c=c+s>>>0)<s?1:0,e+r+i+o+(u+=(c=c+a>>>0)<a?1:0)>>>0}var sum64_4_hi_1=sum64_4_hi;function sum64_4_lo(e,t,r,n,i,s,o,a){return t+n+s+a>>>0}var sum64_4_lo_1=sum64_4_lo;function sum64_5_hi(e,t,r,n,i,s,o,a,u,c){var h=0,p=t;return h+=(p=p+n>>>0)<t?1:0,h+=(p=p+s>>>0)<s?1:0,h+=(p=p+a>>>0)<a?1:0,e+r+i+o+u+(h+=(p=p+c>>>0)<c?1:0)>>>0}var sum64_5_hi_1=sum64_5_hi;function sum64_5_lo(e,t,r,n,i,s,o,a,u,c){return t+n+s+a+c>>>0}var sum64_5_lo_1=sum64_5_lo;function rotr64_hi(e,t,r){return(t<<32-r|e>>>r)>>>0}var rotr64_hi_1=rotr64_hi;function rotr64_lo(e,t,r){return(e<<32-r|t>>>r)>>>0}var rotr64_lo_1=rotr64_lo;function shr64_hi(e,t,r){return e>>>r}var shr64_hi_1=shr64_hi;function shr64_lo(e,t,r){return(e<<32-r|t>>>r)>>>0}var shr64_lo_1=shr64_lo,utils={inherits:inherits_1,toArray:toArray_1,toHex:toHex_1,htonl:htonl_1,toHex32:toHex32_1,zero2:zero2_1,zero8:zero8_1,join32:join32_1,split32:split32_1,rotr32:rotr32_1,rotl32:rotl32_1,sum32:sum32_1,sum32_3:sum32_3_1,sum32_4:sum32_4_1,sum32_5:sum32_5_1,sum64:sum64_1,sum64_hi:sum64_hi_1,sum64_lo:sum64_lo_1,sum64_4_hi:sum64_4_hi_1,sum64_4_lo:sum64_4_lo_1,sum64_5_hi:sum64_5_hi_1,sum64_5_lo:sum64_5_lo_1,rotr64_hi:rotr64_hi_1,rotr64_lo:rotr64_lo_1,shr64_hi:shr64_hi_1,shr64_lo:shr64_lo_1};function BlockHash(){this.pending=null,this.pendingTotal=0,this.blockSize=this.constructor.blockSize,this.outSize=this.constructor.outSize,this.hmacStrength=this.constructor.hmacStrength,this.padLength=this.constructor.padLength/8,this.endian="big",this._delta8=this.blockSize/8,this._delta32=this.blockSize/32}var BlockHash_1=BlockHash;BlockHash.prototype.update=function(e,t){if(e=utils.toArray(e,t),this.pending?this.pending=this.pending.concat(e):this.pending=e,this.pendingTotal+=e.length,this.pending.length>=this._delta8){var r=(e=this.pending).length%this._delta8;this.pending=e.slice(e.length-r,e.length),0===this.pending.length&&(this.pending=null),e=utils.join32(e,0,e.length-r,this.endian);for(var n=0;n<e.length;n+=this._delta32)this._update(e,n,n+this._delta32)}return this},BlockHash.prototype.digest=function(e){return this.update(this._pad()),minimalisticAssert(null===this.pending),this._digest(e)},BlockHash.prototype._pad=function(){var e=this.pendingTotal,t=this._delta8,r=t-(e+this.padLength)%t,n=new Array(r+this.padLength);n[0]=128;for(var i=1;i<r;i++)n[i]=0;if(e<<=3,"big"===this.endian){for(var s=8;s<this.padLength;s++)n[i++]=0;n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=e>>>24&255,n[i++]=e>>>16&255,n[i++]=e>>>8&255,n[i++]=255&e}else for(n[i++]=255&e,n[i++]=e>>>8&255,n[i++]=e>>>16&255,n[i++]=e>>>24&255,n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=0,s=8;s<this.padLength;s++)n[i++]=0;return n};var common$1={BlockHash:BlockHash_1},rotr32$1=utils.rotr32;function ft_1(e,t,r,n){return 0===e?ch32(t,r,n):1===e||3===e?p32(t,r,n):2===e?maj32(t,r,n):void 0}var ft_1_1=ft_1;function ch32(e,t,r){return e&t^~e&r}var ch32_1=ch32;function maj32(e,t,r){return e&t^e&r^t&r}var maj32_1=maj32;function p32(e,t,r){return e^t^r}var p32_1=p32;function s0_256(e){return rotr32$1(e,2)^rotr32$1(e,13)^rotr32$1(e,22)}var s0_256_1=s0_256;function s1_256(e){return rotr32$1(e,6)^rotr32$1(e,11)^rotr32$1(e,25)}var s1_256_1=s1_256;function g0_256(e){return rotr32$1(e,7)^rotr32$1(e,18)^e>>>3}var g0_256_1=g0_256;function g1_256(e){return rotr32$1(e,17)^rotr32$1(e,19)^e>>>10}var g1_256_1=g1_256,common$1$1={ft_1:ft_1_1,ch32:ch32_1,maj32:maj32_1,p32:p32_1,s0_256:s0_256_1,s1_256:s1_256_1,g0_256:g0_256_1,g1_256:g1_256_1},sum32$1=utils.sum32,sum32_4$1=utils.sum32_4,sum32_5$1=utils.sum32_5,ch32$1=common$1$1.ch32,maj32$1=common$1$1.maj32,s0_256$1=common$1$1.s0_256,s1_256$1=common$1$1.s1_256,g0_256$1=common$1$1.g0_256,g1_256$1=common$1$1.g1_256,BlockHash$1=common$1.BlockHash,sha256_K=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];function SHA256(){if(!(this instanceof SHA256))return new SHA256;BlockHash$1.call(this),this.h=[1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225],this.k=sha256_K,this.W=new Array(64)}utils.inherits(SHA256,BlockHash$1);var _256=SHA256;SHA256.blockSize=512,SHA256.outSize=256,SHA256.hmacStrength=192,SHA256.padLength=64,SHA256.prototype._update=function(e,t){for(var r=this.W,n=0;n<16;n++)r[n]=e[t+n];for(;n<r.length;n++)r[n]=sum32_4$1(g1_256$1(r[n-2]),r[n-7],g0_256$1(r[n-15]),r[n-16]);var i=this.h[0],s=this.h[1],o=this.h[2],a=this.h[3],u=this.h[4],c=this.h[5],h=this.h[6],p=this.h[7];for(minimalisticAssert(this.k.length===r.length),n=0;n<r.length;n++){var l=sum32_5$1(p,s1_256$1(u),ch32$1(u,c,h),this.k[n],r[n]),f=sum32$1(s0_256$1(i),maj32$1(i,s,o));p=h,h=c,c=u,u=sum32$1(a,l),a=o,o=s,s=i,i=sum32$1(l,f)}this.h[0]=sum32$1(this.h[0],i),this.h[1]=sum32$1(this.h[1],s),this.h[2]=sum32$1(this.h[2],o),this.h[3]=sum32$1(this.h[3],a),this.h[4]=sum32$1(this.h[4],u),this.h[5]=sum32$1(this.h[5],c),this.h[6]=sum32$1(this.h[6],h),this.h[7]=sum32$1(this.h[7],p)},SHA256.prototype._digest=function(e){return"hex"===e?utils.toHex32(this.h,"big"):utils.split32(this.h,"big")};for(var charToInteger={},chars="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",i=0;i<chars.length;i++)charToInteger[chars.charCodeAt(i)]=i;function decode(e){for(var t=0,r=0,n=0,i=0,s=0,o=[],a=[],u=[],c=0,h=0,p=0,l=0;c<e.length;c++){var f=e.charCodeAt(c);if(44===f)u.length&&a.push(u),u=[],h=0;else if(59===f)u.length&&a.push(u),u=[],h=0,o.push(a),a=[],t=0;else{var d=charToInteger[f];if(void 0===d)throw new Error("Invalid character ("+String.fromCharCode(f)+")");var m=32&d;if(l+=(d&=31)<<p,m)p+=5;else{var g=1&l;l>>=1;var y=g?-l:l;0==h?(t+=y,u.push(t)):1===h?(r+=y,u.push(r)):2===h?(n+=y,u.push(n)):3===h?(i+=y,u.push(i)):4===h&&(s+=y,u.push(s)),h++,l=p=0}}}return u.length&&a.push(u),o.push(a),o}function encode(e){for(var t=0,r=0,n=0,i=0,s="",o=0;o<e.length;o++){var a=e[o];if(o>0&&(s+=";"),0!==a.length){for(var u=0,c=[],h=0,p=a;h<p.length;h++){var l=p[h],f=encodeInteger(l[0]-u);u=l[0],l.length>1&&(f+=encodeInteger(l[1]-t)+encodeInteger(l[2]-r)+encodeInteger(l[3]-n),t=l[1],r=l[2],n=l[3]),5===l.length&&(f+=encodeInteger(l[4]-i),i=l[4]),c.push(f)}s+=c.join(",")}}return s}function encodeInteger(e){var t="";e=e<0?-e<<1|1:e<<1;do{var r=31&e;(e>>=5)>0&&(r|=32),t+=chars[r]}while(e>0);return t}var Chunk=function(e,t,r){this.start=e,this.end=t,this.original=r,this.intro="",this.outro="",this.content=r,this.storeName=!1,this.edited=!1,Object.defineProperties(this,{previous:{writable:!0,value:null},next:{writable:!0,value:null}})};Chunk.prototype.appendLeft=function(e){this.outro+=e},Chunk.prototype.appendRight=function(e){this.intro=this.intro+e},Chunk.prototype.clone=function(){var e=new Chunk(this.start,this.end,this.original);return e.intro=this.intro,e.outro=this.outro,e.content=this.content,e.storeName=this.storeName,e.edited=this.edited,e},Chunk.prototype.contains=function(e){return this.start<e&&e<this.end},Chunk.prototype.eachNext=function(e){for(var t=this;t;)e(t),t=t.next},Chunk.prototype.eachPrevious=function(e){for(var t=this;t;)e(t),t=t.previous},Chunk.prototype.edit=function(e,t,r){return this.content=e,r||(this.intro="",this.outro=""),this.storeName=t,this.edited=!0,this},Chunk.prototype.prependLeft=function(e){this.outro=e+this.outro},Chunk.prototype.prependRight=function(e){this.intro=e+this.intro},Chunk.prototype.split=function(e){var t=e-this.start,r=this.original.slice(0,t),n=this.original.slice(t);this.original=r;var i=new Chunk(e,this.end,n);return i.outro=this.outro,this.outro="",this.end=e,this.edited?(i.edit("",!1),this.content=""):this.content=r,i.next=this.next,i.next&&(i.next.previous=i),i.previous=this,this.next=i,i},Chunk.prototype.toString=function(){return this.intro+this.content+this.outro},Chunk.prototype.trimEnd=function(e){if(this.outro=this.outro.replace(e,""),this.outro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&this.split(this.start+t.length).edit("",void 0,!0),!0):(this.edit("",void 0,!0),this.intro=this.intro.replace(e,""),!!this.intro.length||void 0)},Chunk.prototype.trimStart=function(e){if(this.intro=this.intro.replace(e,""),this.intro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&(this.split(this.end-t.length),this.edit("",void 0,!0)),!0):(this.edit("",void 0,!0),this.outro=this.outro.replace(e,""),!!this.outro.length||void 0)};var btoa=function(){throw new Error("Unsupported environment: `window.btoa` or `Buffer` should be supported.")};"undefined"!=typeof window&&"function"==typeof window.btoa?btoa=window.btoa:"function"==typeof Buffer&&(btoa=function(e){return new Buffer(e).toString("base64")});var SourceMap=function(e){this.version=3,this.file=e.file,this.sources=e.sources,this.sourcesContent=e.sourcesContent,this.names=e.names,this.mappings=encode(e.mappings)};function guessIndent(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getRelativePath(e,t){var r=e.split(/[\/\\]/),n=t.split(/[\/\\]/);for(r.pop();r[0]===n[0];)r.shift(),n.shift();if(r.length)for(var i=r.length;i--;)r[i]="..";return r.concat(n).join("/")}SourceMap.prototype.toString=function(){return JSON.stringify(this)},SourceMap.prototype.toUrl=function(){return"data:application/json;charset=utf-8;base64,"+btoa(this.toString())};var toString=Object.prototype.toString;function isObject(e){return"[object Object]"===toString.call(e)}function getLocator(e){for(var t=e.split("\n"),r=[],n=0,i=0;n<t.length;n++)r.push(i),i+=t[n].length+1;return function(e){for(var t=0,n=r.length;t<n;){var i=t+n>>1;e<r[i]?n=i:t=i+1}var s=t-1;return{line:s,column:e-r[s]}}}var Mappings=function(e){this.hires=e,this.generatedCodeLine=0,this.generatedCodeColumn=0,this.raw=[],this.rawSegments=this.raw[this.generatedCodeLine]=[],this.pending=null};Mappings.prototype.addEdit=function(e,t,r,n){if(t.length){var i=[this.generatedCodeColumn,e,r.line,r.column];n>=0&&i.push(n),this.rawSegments.push(i)}else this.pending&&this.rawSegments.push(this.pending);this.advance(t),this.pending=null},Mappings.prototype.addUneditedChunk=function(e,t,r,n,i){for(var s=t.start,o=!0;s<t.end;)(this.hires||o||i[s])&&this.rawSegments.push([this.generatedCodeColumn,e,n.line,n.column]),"\n"===r[s]?(n.line+=1,n.column=0,this.generatedCodeLine+=1,this.raw[this.generatedCodeLine]=this.rawSegments=[],this.generatedCodeColumn=0):(n.column+=1,this.generatedCodeColumn+=1),s+=1,o=!1;this.pending=[this.generatedCodeColumn,e,n.line,n.column]},Mappings.prototype.advance=function(e){if(e){var t=e.split("\n");if(t.length>1){for(var r=0;r<t.length-1;r++)this.generatedCodeLine++,this.raw[this.generatedCodeLine]=this.rawSegments=[];this.generatedCodeColumn=0}this.generatedCodeColumn+=t[t.length-1].length}};var n="\n",warned={insertLeft:!1,insertRight:!1,storeName:!1},MagicString=function(e,t){void 0===t&&(t={});var r=new Chunk(0,e.length,e);Object.defineProperties(this,{original:{writable:!0,value:e},outro:{writable:!0,value:""},intro:{writable:!0,value:""},firstChunk:{writable:!0,value:r},lastChunk:{writable:!0,value:r},lastSearchedChunk:{writable:!0,value:r},byStart:{writable:!0,value:{}},byEnd:{writable:!0,value:{}},filename:{writable:!0,value:t.filename},indentExclusionRanges:{writable:!0,value:t.indentExclusionRanges},sourcemapLocations:{writable:!0,value:{}},storedNames:{writable:!0,value:{}},indentStr:{writable:!0,value:guessIndent(e)}}),this.byStart[0]=r,this.byEnd[e.length]=r};MagicString.prototype.addSourcemapLocation=function(e){this.sourcemapLocations[e]=!0},MagicString.prototype.append=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.outro+=e,this},MagicString.prototype.appendLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.appendLeft(t):this.intro+=t,this},MagicString.prototype.appendRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.appendRight(t):this.outro+=t,this},MagicString.prototype.clone=function(){for(var e=new MagicString(this.original,{filename:this.filename}),t=this.firstChunk,r=e.firstChunk=e.lastSearchedChunk=t.clone();t;){e.byStart[r.start]=r,e.byEnd[r.end]=r;var n=t.next,i=n&&n.clone();i&&(r.next=i,i.previous=r,r=i),t=n}return e.lastChunk=r,this.indentExclusionRanges&&(e.indentExclusionRanges=this.indentExclusionRanges.slice()),Object.keys(this.sourcemapLocations).forEach(function(t){e.sourcemapLocations[t]=!0}),e},MagicString.prototype.generateDecodedMap=function(e){var t=this;e=e||{};var r=Object.keys(this.storedNames),n=new Mappings(e.hires),i=getLocator(this.original);return this.intro&&n.advance(this.intro),this.firstChunk.eachNext(function(e){var s=i(e.start);e.intro.length&&n.advance(e.intro),e.edited?n.addEdit(0,e.content,s,e.storeName?r.indexOf(e.original):-1):n.addUneditedChunk(0,e,t.original,s,t.sourcemapLocations),e.outro.length&&n.advance(e.outro)}),{file:e.file?e.file.split(/[\/\\]/).pop():null,sources:[e.source?getRelativePath(e.file||"",e.source):null],sourcesContent:e.includeContent?[this.original]:[null],names:r,mappings:n.raw}},MagicString.prototype.generateMap=function(e){return new SourceMap(this.generateDecodedMap(e))},MagicString.prototype.getIndentString=function(){return null===this.indentStr?"\t":this.indentStr},MagicString.prototype.indent=function(e,t){var r=/^[^\r\n]/gm;if(isObject(e)&&(t=e,e=void 0),""===(e=void 0!==e?e:this.indentStr||"\t"))return this;var n={};(t=t||{}).exclude&&("number"==typeof t.exclude[0]?[t.exclude]:t.exclude).forEach(function(e){for(var t=e[0];t<e[1];t+=1)n[t]=!0});var i=!1!==t.indentStart,s=function(t){return i?""+e+t:(i=!0,t)};this.intro=this.intro.replace(r,s);for(var o=0,a=this.firstChunk;a;){var u=a.end;if(a.edited)n[o]||(a.content=a.content.replace(r,s),a.content.length&&(i="\n"===a.content[a.content.length-1]));else for(o=a.start;o<u;){if(!n[o]){var c=this.original[o];"\n"===c?i=!0:"\r"!==c&&i&&(i=!1,o===a.start?a.prependRight(e):(this._splitChunk(a,o),(a=a.next).prependRight(e)))}o+=1}o=a.end,a=a.next}return this.outro=this.outro.replace(r,s),this},MagicString.prototype.insert=function(){throw new Error("magicString.insert(...) is deprecated. Use prependRight(...) or appendLeft(...)")},MagicString.prototype.insertLeft=function(e,t){return warned.insertLeft||(console.warn("magicString.insertLeft(...) is deprecated. Use magicString.appendLeft(...) instead"),warned.insertLeft=!0),this.appendLeft(e,t)},MagicString.prototype.insertRight=function(e,t){return warned.insertRight||(console.warn("magicString.insertRight(...) is deprecated. Use magicString.prependRight(...) instead"),warned.insertRight=!0),this.prependRight(e,t)},MagicString.prototype.move=function(e,t,r){if(r>=e&&r<=t)throw new Error("Cannot move a selection inside itself");this._split(e),this._split(t),this._split(r);var n=this.byStart[e],i=this.byEnd[t],s=n.previous,o=i.next,a=this.byStart[r];if(!a&&i===this.lastChunk)return this;var u=a?a.previous:this.lastChunk;return s&&(s.next=o),o&&(o.previous=s),u&&(u.next=n),a&&(a.previous=i),n.previous||(this.firstChunk=i.next),i.next||(this.lastChunk=n.previous,this.lastChunk.next=null),n.previous=u,i.next=a||null,u||(this.firstChunk=n),a||(this.lastChunk=i),this},MagicString.prototype.overwrite=function(e,t,r,n){if("string"!=typeof r)throw new TypeError("replacement content must be a string");for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(t>this.original.length)throw new Error("end is out of bounds");if(e===t)throw new Error("Cannot overwrite a zero-length range – use appendLeft or prependRight instead");this._split(e),this._split(t),!0===n&&(warned.storeName||(console.warn("The final argument to magicString.overwrite(...) should be an options object. See https://github.com/rich-harris/magic-string"),warned.storeName=!0),n={storeName:!0});var i=void 0!==n&&n.storeName,s=void 0!==n&&n.contentOnly;if(i){var o=this.original.slice(e,t);this.storedNames[o]=!0}var a=this.byStart[e],u=this.byEnd[t];if(a){if(t>a.end&&a.next!==this.byStart[a.end])throw new Error("Cannot overwrite across a split point");if(a.edit(r,i,s),a!==u){for(var c=a.next;c!==u;)c.edit("",!1),c=c.next;c.edit("",!1)}}else{var h=new Chunk(e,t,"").edit(r,i);u.next=h,h.previous=u}return this},MagicString.prototype.prepend=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.intro=e+this.intro,this},MagicString.prototype.prependLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.prependLeft(t):this.intro=t+this.intro,this},MagicString.prototype.prependRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.prependRight(t):this.outro=t+this.outro,this},MagicString.prototype.remove=function(e,t){for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(e===t)return this;if(e<0||t>this.original.length)throw new Error("Character is out of bounds");if(e>t)throw new Error("end must be greater than start");this._split(e),this._split(t);for(var r=this.byStart[e];r;)r.intro="",r.outro="",r.edit(""),r=t>r.end?this.byStart[r.end]:null;return this},MagicString.prototype.lastChar=function(){if(this.outro.length)return this.outro[this.outro.length-1];var e=this.lastChunk;do{if(e.outro.length)return e.outro[e.outro.length-1];if(e.content.length)return e.content[e.content.length-1];if(e.intro.length)return e.intro[e.intro.length-1]}while(e=e.previous);return this.intro.length?this.intro[this.intro.length-1]:""},MagicString.prototype.lastLine=function(){var e=this.outro.lastIndexOf(n);if(-1!==e)return this.outro.substr(e+1);var t=this.outro,r=this.lastChunk;do{if(r.outro.length>0){if(-1!==(e=r.outro.lastIndexOf(n)))return r.outro.substr(e+1)+t;t=r.outro+t}if(r.content.length>0){if(-1!==(e=r.content.lastIndexOf(n)))return r.content.substr(e+1)+t;t=r.content+t}if(r.intro.length>0){if(-1!==(e=r.intro.lastIndexOf(n)))return r.intro.substr(e+1)+t;t=r.intro+t}}while(r=r.previous);return-1!==(e=this.intro.lastIndexOf(n))?this.intro.substr(e+1)+t:this.intro+t},MagicString.prototype.slice=function(e,t){for(void 0===e&&(e=0),void 0===t&&(t=this.original.length);e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;for(var r="",n=this.firstChunk;n&&(n.start>e||n.end<=e);){if(n.start<t&&n.end>=t)return r;n=n.next}if(n&&n.edited&&n.start!==e)throw new Error("Cannot use replaced character "+e+" as slice start anchor.");for(var i=n;n;){!n.intro||i===n&&n.start!==e||(r+=n.intro);var s=n.start<t&&n.end>=t;if(s&&n.edited&&n.end!==t)throw new Error("Cannot use replaced character "+t+" as slice end anchor.");var o=i===n?e-n.start:0,a=s?n.content.length+t-n.end:n.content.length;if(r+=n.content.slice(o,a),!n.outro||s&&n.end!==t||(r+=n.outro),s)break;n=n.next}return r},MagicString.prototype.snip=function(e,t){var r=this.clone();return r.remove(0,e),r.remove(t,r.original.length),r},MagicString.prototype._split=function(e){if(!this.byStart[e]&&!this.byEnd[e])for(var t=this.lastSearchedChunk,r=e>t.end;t;){if(t.contains(e))return this._splitChunk(t,e);t=r?this.byStart[t.end]:this.byEnd[t.start]}},MagicString.prototype._splitChunk=function(e,t){if(e.edited&&e.content.length){var r=getLocator(this.original)(t);throw new Error("Cannot split a chunk that has already been edited ("+r.line+":"+r.column+' – "'+e.original+'")')}var n=e.split(t);return this.byEnd[t]=e,this.byStart[t]=n,this.byEnd[n.end]=n,e===this.lastChunk&&(this.lastChunk=n),this.lastSearchedChunk=e,!0},MagicString.prototype.toString=function(){for(var e=this.intro,t=this.firstChunk;t;)e+=t.toString(),t=t.next;return e+this.outro},MagicString.prototype.isEmpty=function(){var e=this.firstChunk;do{if(e.intro.length&&e.intro.trim()||e.content.length&&e.content.trim()||e.outro.length&&e.outro.trim())return!1}while(e=e.next);return!0},MagicString.prototype.length=function(){var e=this.firstChunk,t=0;do{t+=e.intro.length+e.content.length+e.outro.length}while(e=e.next);return t},MagicString.prototype.trimLines=function(){return this.trim("[\\r\\n]")},MagicString.prototype.trim=function(e){return this.trimStart(e).trimEnd(e)},MagicString.prototype.trimEndAborted=function(e){var t=new RegExp((e||"\\s")+"+$");if(this.outro=this.outro.replace(t,""),this.outro.length)return!0;var r=this.lastChunk;do{var n=r.end,i=r.trimEnd(t);if(r.end!==n&&(this.lastChunk===r&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.previous}while(r);return!1},MagicString.prototype.trimEnd=function(e){return this.trimEndAborted(e),this},MagicString.prototype.trimStartAborted=function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),this.intro.length)return!0;var r=this.firstChunk;do{var n=r.end,i=r.trimStart(t);if(r.end!==n&&(r===this.lastChunk&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.next}while(r);return!1},MagicString.prototype.trimStart=function(e){return this.trimStartAborted(e),this};var hasOwnProp=Object.prototype.hasOwnProperty,Bundle=function(e){void 0===e&&(e={}),this.intro=e.intro||"",this.separator=void 0!==e.separator?e.separator:"\n",this.sources=[],this.uniqueSources=[],this.uniqueSourceIndexByFilename={}};Bundle.prototype.addSource=function(e){if(e instanceof MagicString)return this.addSource({content:e,filename:e.filename,separator:this.separator});if(!isObject(e)||!e.content)throw new Error("bundle.addSource() takes an object with a `content` property, which should be an instance of MagicString, and an optional `filename`");if(["filename","indentExclusionRanges","separator"].forEach(function(t){hasOwnProp.call(e,t)||(e[t]=e.content[t])}),void 0===e.separator&&(e.separator=this.separator),e.filename)if(hasOwnProp.call(this.uniqueSourceIndexByFilename,e.filename)){var t=this.uniqueSources[this.uniqueSourceIndexByFilename[e.filename]];if(e.content.original!==t.content)throw new Error("Illegal source: same filename ("+e.filename+"), different contents")}else this.uniqueSourceIndexByFilename[e.filename]=this.uniqueSources.length,this.uniqueSources.push({filename:e.filename,content:e.content.original});return this.sources.push(e),this},Bundle.prototype.append=function(e,t){return this.addSource({content:new MagicString(e),separator:t&&t.separator||""}),this},Bundle.prototype.clone=function(){var e=new Bundle({intro:this.intro,separator:this.separator});return this.sources.forEach(function(t){e.addSource({filename:t.filename,content:t.content.clone(),separator:t.separator})}),e},Bundle.prototype.generateDecodedMap=function(e){var t=this;void 0===e&&(e={});var r=[];this.sources.forEach(function(e){Object.keys(e.content.storedNames).forEach(function(e){~r.indexOf(e)||r.push(e)})});var n=new Mappings(e.hires);return this.intro&&n.advance(this.intro),this.sources.forEach(function(e,i){i>0&&n.advance(t.separator);var s=e.filename?t.uniqueSourceIndexByFilename[e.filename]:-1,o=e.content,a=getLocator(o.original);o.intro&&n.advance(o.intro),o.firstChunk.eachNext(function(t){var i=a(t.start);t.intro.length&&n.advance(t.intro),e.filename?t.edited?n.addEdit(s,t.content,i,t.storeName?r.indexOf(t.original):-1):n.addUneditedChunk(s,t,o.original,i,o.sourcemapLocations):n.advance(t.content),t.outro.length&&n.advance(t.outro)}),o.outro&&n.advance(o.outro)}),{file:e.file?e.file.split(/[\/\\]/).pop():null,sources:this.uniqueSources.map(function(t){return e.file?getRelativePath(e.file,t.filename):t.filename}),sourcesContent:this.uniqueSources.map(function(t){return e.includeContent?t.content:null}),names:r,mappings:n.raw}},Bundle.prototype.generateMap=function(e){return new SourceMap(this.generateDecodedMap(e))},Bundle.prototype.getIndentString=function(){var e={};return this.sources.forEach(function(t){var r=t.content.indentStr;null!==r&&(e[r]||(e[r]=0),e[r]+=1)}),Object.keys(e).sort(function(t,r){return e[t]-e[r]})[0]||"\t"},Bundle.prototype.indent=function(e){var t=this;if(arguments.length||(e=this.getIndentString()),""===e)return this;var r=!this.intro||"\n"===this.intro.slice(-1);return this.sources.forEach(function(n,i){var s=void 0!==n.separator?n.separator:t.separator,o=r||i>0&&/\r?\n$/.test(s);n.content.indent(e,{exclude:n.indentExclusionRanges,indentStart:o}),r="\n"===n.content.lastChar()}),this.intro&&(this.intro=e+this.intro.replace(/^[^\n]/gm,function(t,r){return r>0?e+t:t})),this},Bundle.prototype.prepend=function(e){return this.intro=e+this.intro,this},Bundle.prototype.toString=function(){var e=this,t=this.sources.map(function(t,r){var n=void 0!==t.separator?t.separator:e.separator;return(r>0?n:"")+t.content.toString()}).join("");return this.intro+t},Bundle.prototype.isEmpty=function(){return(!this.intro.length||!this.intro.trim())&&!this.sources.some(function(e){return!e.content.isEmpty()})},Bundle.prototype.length=function(){return this.sources.reduce(function(e,t){return e+t.content.length()},this.intro.length)},Bundle.prototype.trimLines=function(){return this.trim("[\\r\\n]")},Bundle.prototype.trim=function(e){return this.trimStart(e).trimEnd(e)},Bundle.prototype.trimStart=function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),!this.intro){var r,n=0;do{if(!(r=this.sources[n++]))break}while(!r.content.trimStartAborted(e))}return this},Bundle.prototype.trimEnd=function(e){var t,r=new RegExp((e||"\\s")+"+$"),n=this.sources.length-1;do{if(!(t=this.sources[n--])){this.intro=this.intro.replace(r,"");break}}while(!t.content.trimEndAborted(e));return this};const __assign$1=Object.assign||function(e){for(var t,r=1;r<arguments.length;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e};function __extends$1(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);function n(){this.constructor=e}e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var AssignmentPattern="AssignmentPattern",BlockStatement="BlockStatement",CallExpression="CallExpression",ClassDeclaration="ClassDeclaration",ExportAllDeclaration="ExportAllDeclaration",ExportDefaultDeclaration="ExportDefaultDeclaration",ExpressionStatement="ExpressionStatement",FunctionDeclaration="FunctionDeclaration",Identifier="Identifier",ImportDefaultSpecifier="ImportDefaultSpecifier",ImportNamespaceSpecifier="ImportNamespaceSpecifier",Literal="Literal",MemberExpression="MemberExpression",Program="Program",Property="Property",ReturnStatement="ReturnStatement",TemplateLiteral="TemplateLiteral",VariableDeclaration="VariableDeclaration",CallOptions=function(){function e(e){var t=void 0===e?{}:e,r=t.withNew,n=void 0!==r&&r,i=t.args,s=void 0===i?[]:i,o=t.callIdentifier,a=void 0===o?void 0:o;this.withNew=n,this.args=s,this.callIdentifier=a}return e.create=function(e){return new this(e)},e.prototype.equals=function(e){return e&&this.callIdentifier===e.callIdentifier},e}(),UNKNOWN_KEY={UNKNOWN_KEY:!0},EMPTY_PATH=[],UNKNOWN_PATH=[UNKNOWN_KEY];function assembleMemberDescriptions(e,t){return void 0===t&&(t=null),Object.create(t,e)}var UNKNOWN_VALUE={UNKNOWN_VALUE:!0},UNKNOWN_EXPRESSION={included:!0,getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(){return UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>0},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(){return!0},include:function(){},deoptimizePath:function(){},toString:function(){return"[[UNKNOWN]]"}},UNDEFINED_EXPRESSION={included:!0,getLiteralValueAtPath:function(){},getReturnExpressionWhenCalledAtPath:function(){return UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>0},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(){return!0},include:function(){},deoptimizePath:function(){},toString:function(){return"undefined"}},returnsUnknown={value:{returns:null,returnsPrimitive:UNKNOWN_EXPRESSION,callsArgs:null,mutatesSelf:!1}},mutatesSelfReturnsUnknown={value:{returns:null,returnsPrimitive:UNKNOWN_EXPRESSION,callsArgs:null,mutatesSelf:!0}},callsArgReturnsUnknown={value:{returns:null,returnsPrimitive:UNKNOWN_EXPRESSION,callsArgs:[0],mutatesSelf:!1}},UnknownArrayExpression=function(){function e(){this.included=!1}return e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(arrayMembers,e[0]):UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(arrayMembers,e[0],this.included,t,r)},e.prototype.include=function(){this.included=!0},e.prototype.deoptimizePath=function(){},e.prototype.toString=function(){return"[[UNKNOWN ARRAY]]"},e}(),returnsArray={value:{returns:UnknownArrayExpression,returnsPrimitive:null,callsArgs:null,mutatesSelf:!1}},mutatesSelfReturnsArray={value:{returns:UnknownArrayExpression,returnsPrimitive:null,callsArgs:null,mutatesSelf:!0}},callsArgReturnsArray={value:{returns:UnknownArrayExpression,returnsPrimitive:null,callsArgs:[0],mutatesSelf:!1}},callsArgMutatesSelfReturnsArray={value:{returns:UnknownArrayExpression,returnsPrimitive:null,callsArgs:[0],mutatesSelf:!0}},UNKNOWN_LITERAL_BOOLEAN={included:!0,getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalBooleanMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e){if(1===e.length){var t=e[0];return"string"!=typeof t||!literalBooleanMembers[t]}return!0},include:function(){},deoptimizePath:function(){},toString:function(){return"[[UNKNOWN BOOLEAN]]"}},returnsBoolean={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_BOOLEAN,callsArgs:null,mutatesSelf:!1}},callsArgReturnsBoolean={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_BOOLEAN,callsArgs:[0],mutatesSelf:!1}},UNKNOWN_LITERAL_NUMBER={included:!0,getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalNumberMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e){if(1===e.length){var t=e[0];return"string"!=typeof t||!literalNumberMembers[t]}return!0},include:function(){},deoptimizePath:function(){},toString:function(){return"[[UNKNOWN NUMBER]]"}},returnsNumber={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER,callsArgs:null,mutatesSelf:!1}},mutatesSelfReturnsNumber={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER,callsArgs:null,mutatesSelf:!0}},callsArgReturnsNumber={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER,callsArgs:[0],mutatesSelf:!1}},UNKNOWN_LITERAL_STRING={included:!0,getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalStringMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e){if(1===e.length){var t=e[0];return"string"!=typeof t||!literalStringMembers[t]}return!0},include:function(){},deoptimizePath:function(){},toString:function(){return"[[UNKNOWN STRING]]"}},returnsString={value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_STRING,callsArgs:null,mutatesSelf:!1}},UnknownObjectExpression=function(){function e(){this.included=!1}return e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(objectMembers,e[0]):UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(objectMembers,e[0],this.included,t,r)},e.prototype.include=function(){this.included=!0},e.prototype.deoptimizePath=function(){},e.prototype.toString=function(){return"[[UNKNOWN OBJECT]]"},e}(),objectMembers=assembleMemberDescriptions({hasOwnProperty:returnsBoolean,isPrototypeOf:returnsBoolean,propertyIsEnumerable:returnsBoolean,toLocaleString:returnsString,toString:returnsString,valueOf:returnsUnknown}),arrayMembers=assembleMemberDescriptions({concat:returnsArray,copyWithin:mutatesSelfReturnsArray,every:callsArgReturnsBoolean,fill:mutatesSelfReturnsArray,filter:callsArgReturnsArray,find:callsArgReturnsUnknown,findIndex:callsArgReturnsNumber,forEach:callsArgReturnsUnknown,includes:returnsBoolean,indexOf:returnsNumber,join:returnsString,lastIndexOf:returnsNumber,map:callsArgReturnsArray,pop:mutatesSelfReturnsUnknown,push:mutatesSelfReturnsNumber,reduce:callsArgReturnsUnknown,reduceRight:callsArgReturnsUnknown,reverse:mutatesSelfReturnsArray,shift:mutatesSelfReturnsUnknown,slice:returnsArray,some:callsArgReturnsBoolean,sort:callsArgMutatesSelfReturnsArray,splice:mutatesSelfReturnsArray,unshift:mutatesSelfReturnsNumber},objectMembers),literalBooleanMembers=assembleMemberDescriptions({valueOf:returnsBoolean},objectMembers),literalNumberMembers=assembleMemberDescriptions({toExponential:returnsString,toFixed:returnsString,toLocaleString:returnsString,toPrecision:returnsString,valueOf:returnsNumber},objectMembers),literalStringMembers=assembleMemberDescriptions({charAt:returnsString,charCodeAt:returnsNumber,codePointAt:returnsNumber,concat:returnsString,includes:returnsBoolean,endsWith:returnsBoolean,indexOf:returnsNumber,lastIndexOf:returnsNumber,localeCompare:returnsNumber,match:returnsBoolean,normalize:returnsString,padEnd:returnsString,padStart:returnsString,repeat:returnsString,replace:{value:{returns:null,returnsPrimitive:UNKNOWN_LITERAL_STRING,callsArgs:[1],mutatesSelf:!1}},search:returnsNumber,slice:returnsString,split:returnsArray,startsWith:returnsBoolean,substr:returnsString,substring:returnsString,toLocaleLowerCase:returnsString,toLocaleUpperCase:returnsString,toLowerCase:returnsString,toUpperCase:returnsString,trim:returnsString,valueOf:returnsString},objectMembers);function getLiteralMembersForValue(e){switch(typeof e){case"boolean":return literalBooleanMembers;case"number":return literalNumberMembers;case"string":return literalStringMembers;default:return Object.create(null)}}function hasMemberEffectWhenCalled(e,t,r,n,i){if("string"!=typeof t||!e[t])return!0;if(e[t].mutatesSelf&&r)return!0;if(!e[t].callsArgs)return!1;for(var s=0,o=e[t].callsArgs;s<o.length;s++){var a=o[s];if(n.args[a]&&n.args[a].hasEffectsWhenCalledAtPath(EMPTY_PATH,CallOptions.create({withNew:!1,args:[],callIdentifier:{}}),i.getHasEffectsWhenCalledOptions()))return!0}return!1}function getMemberReturnExpressionWhenCalled(e,t){return"string"==typeof t&&e[t]?null!==e[t].returnsPrimitive?e[t].returnsPrimitive:new e[t].returns:UNKNOWN_EXPRESSION}var Variable=function(){function e(e){this.exportName=null,this.safeExportName=null,this.included=!1,this.isId=!1,this.reexported=!1,this.isReassigned=!1,this.name=e,this.safeName=null}return e.prototype.addReference=function(e){},e.prototype.getName=function(e){return e&&this.safeName&&this.safeName!==this.name&&"$"===this.safeName[this.name.length]&&"$"===this.safeName[this.name.length+1]?(this.safeName=void 0,this.name):this.safeName||this.name},e.prototype.getLiteralValueAtPath=function(e,t,r){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!0},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!0},e.prototype.include=function(){this.included=!0},e.prototype.deoptimizePath=function(e){},e.prototype.setSafeName=function(e){this.safeName=e},e.prototype.toString=function(){return this.name},e}(),MAX_PATH_DEPTH=7,LocalVariable=function(e){function t(t,r,n,i){var s=e.call(this,t)||this;return s.additionalInitializers=null,s.expressionsToBeDeoptimized=[],s.declarations=r?[r]:[],s.init=n,s.deoptimizationTracker=i,s}return __extends$1(t,e),t.prototype.addDeclaration=function(e,t){this.declarations.push(e),null===this.additionalInitializers&&(this.additionalInitializers=null===this.init?[]:[this.init],this.init=UNKNOWN_EXPRESSION,this.isReassigned=!0),null!==t&&this.additionalInitializers.push(t)},t.prototype.consolidateInitializers=function(){if(null!==this.additionalInitializers){for(var e=0,t=this.additionalInitializers;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}this.additionalInitializers=null}},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isReassigned||!this.init||e.length>MAX_PATH_DEPTH||t.isTracked(this.init,e)?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.init.getLiteralValueAtPath(e,t.track(this.init,e),r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isReassigned||!this.init||e.length>MAX_PATH_DEPTH||t.isTracked(this.init,e)?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized.push(r),this.init.getReturnExpressionWhenCalledAtPath(e,t.track(this.init,e),r))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(this.isReassigned||e.length>MAX_PATH_DEPTH||this.init&&!t.hasNodeBeenAccessedAtPath(e,this.init)&&this.init.hasEffectsWhenAccessedAtPath(e,t.addAccessedNodeAtPath(e,this.init)))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!!(this.included||e.length>MAX_PATH_DEPTH)||0!==e.length&&(this.isReassigned||this.init&&!t.hasNodeBeenAssignedAtPath(e,this.init)&&this.init.hasEffectsWhenAssignedAtPath(e,t.addAssignedNodeAtPath(e,this.init)))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>MAX_PATH_DEPTH||(this.isReassigned||this.init&&!r.hasNodeBeenCalledAtPathWithOptions(e,this.init,t)&&this.init.hasEffectsWhenCalledAtPath(e,t,r.addCalledNodeAtPathWithOptions(e,this.init,t)))},t.prototype.include=function(){if(!this.included){this.included=!0;for(var e=0,t=this.declarations;e<t.length;e++){var r=t[e];r.included||r.include();for(var n=r.parent;!n.included&&(n.included=!0,n.type!==Program);)n=n.parent}}},t.prototype.deoptimizePath=function(e){if(!(e.length>MAX_PATH_DEPTH||this.isReassigned||this.deoptimizationTracker.track(this,e)))if(0===e.length){if(!this.isReassigned){this.isReassigned=!0;for(var t=0,r=this.expressionsToBeDeoptimized;t<r.length;t++){r[t].deoptimizeCache()}this.init&&this.init.deoptimizePath(UNKNOWN_PATH)}}else this.init&&this.init.deoptimizePath(e)},t}(Variable);function isExportDefaultVariable(e){return e.isDefault}LocalVariable.prototype.isLocal=!0;var ExportDefaultVariable=function(e){function t(t,r,n){var i=e.call(this,t,r,r.declaration,n)||this;return i.original=null,i.hasId=!!r.declaration.id,i}return __extends$1(t,e),t.prototype.addReference=function(e){this.hasId||(this.name=e.name,null!==this.original&&this.original.addReference(e))},t.prototype.getName=function(e){return!e&&this.safeName?this.safeName:null===this.original||this.original.isReassigned?this.name:this.original.getName()},t.prototype.referencesOriginal=function(){return this.original&&!this.original.isReassigned},t.prototype.getOriginalVariableName=function(){return this.original&&this.original.getName()},t.prototype.setOriginalVariable=function(e){this.original=e},t}(LocalVariable);ExportDefaultVariable.prototype.isDefault=!0;var pureFunctions={},arrayTypes="Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array".split(" "),simdTypes="Int8x16 Int16x8 Int32x4 Float32x4 Float64x2".split(" "),simdMethods="abs add and bool check div equal extractLane fromFloat32x4 fromFloat32x4Bits fromFloat64x2 fromFloat64x2Bits fromInt16x8Bits fromInt32x4 fromInt32x4Bits fromInt8x16Bits greaterThan greaterThanOrEqual lessThan lessThanOrEqual load max maxNum min minNum mul neg not notEqual or reciprocalApproximation reciprocalSqrtApproximation replaceLane select selectBits shiftLeftByScalar shiftRightArithmeticByScalar shiftRightLogicalByScalar shuffle splat sqrt store sub swizzle xor".split(" "),allSimdMethods=[];simdTypes.forEach(function(e){simdMethods.forEach(function(t){allSimdMethods.push("SIMD."+e+"."+t)})}),["Array.isArray","Error","EvalError","InternalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError","isFinite","isNaN","parseFloat","parseInt","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","unescape","Object","Object.create","Object.getNotifier","Object.getOwn","Object.getOwnPropertyDescriptor","Object.getOwnPropertyNames","Object.getOwnPropertySymbols","Object.getPrototypeOf","Object.is","Object.isExtensible","Object.isFrozen","Object.isSealed","Object.keys","Boolean","Number","Number.isFinite","Number.isInteger","Number.isNaN","Number.isSafeInteger","Number.parseFloat","Number.parseInt","Symbol","Symbol.for","Symbol.keyFor","Math.abs","Math.acos","Math.acosh","Math.asin","Math.asinh","Math.atan","Math.atan2","Math.atanh","Math.cbrt","Math.ceil","Math.clz32","Math.cos","Math.cosh","Math.exp","Math.expm1","Math.floor","Math.fround","Math.hypot","Math.imul","Math.log","Math.log10","Math.log1p","Math.log2","Math.max","Math.min","Math.pow","Math.random","Math.round","Math.sign","Math.sin","Math.sinh","Math.sqrt","Math.tan","Math.tanh","Math.trunc","Date","Date.UTC","Date.now","Date.parse","String","String.fromCharCode","String.fromCodePoint","String.raw","RegExp","Map","Set","WeakMap","WeakSet","ArrayBuffer","ArrayBuffer.isView","DataView","Promise.all","Promise.race","Promise.resolve","Intl.Collator","Intl.Collator.supportedLocalesOf","Intl.DateTimeFormat","Intl.DateTimeFormat.supportedLocalesOf","Intl.NumberFormat","Intl.NumberFormat.supportedLocalesOf"].concat(arrayTypes,arrayTypes.map(function(e){return e+".from"}),arrayTypes.map(function(e){return e+".of"}),simdTypes.map(function(e){return"SIMD."+e}),allSimdMethods).forEach(function(e){return pureFunctions[e]=!0});var GlobalVariable=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.included=!0,t}return __extends$1(t,e),t.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>0&&!this.isPureFunctionMember(e)&&!("Reflect"===this.name&&1===e.length)},t.prototype.hasEffectsWhenCalledAtPath=function(e){return!pureFunctions[[this.name].concat(e).join(".")]},t.prototype.isPureFunctionMember=function(e){return pureFunctions[[this.name].concat(e).join(".")]||e.length>=1&&pureFunctions[[this.name].concat(e.slice(0,-1)).join(".")]||e.length>=2&&pureFunctions[[this.name].concat(e.slice(0,-2)).join(".")]&&"prototype"===e[e.length-2]},t}(Variable),ExternalVariable=function(e){function t(t,r){var n=e.call(this,r)||this;return n.module=t,n.isNamespace="*"===r,n.referenced=!1,n}return __extends$1(t,e),t.prototype.addReference=function(e){this.referenced=!0,"default"!==this.name&&"*"!==this.name||this.module.suggestName(e.name)},t.prototype.include=function(){this.included||(this.included=!0,this.module.used=!0)},t}(Variable);ExternalVariable.prototype.isExternal=!0;var reservedWords="break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public".split(" "),builtins="Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl".split(" "),blacklisted=Object.create(null);reservedWords.concat(builtins).forEach(function(e){return blacklisted[e]=!0});var illegalCharacters=/[^$_a-zA-Z0-9]/g,startsWithDigit=function(e){return/\d/.test(e[0])};function isLegal(e){return!startsWithDigit(e)&&!blacklisted[e]&&!illegalCharacters.test(e)}function makeLegal(e){return e=e.replace(/-(\w)/g,function(e,t){return t.toUpperCase()}).replace(illegalCharacters,"_"),(startsWithDigit(e)||blacklisted[e])&&(e="_"+e),e}var absolutePath=/^(?:\/|(?:[A-Za-z]:)?[\\|\/])/,relativePath=/^\.?\.\//;function isAbsolute(e){return absolutePath.test(e)}function isRelative(e){return relativePath.test(e)}function normalize$1(e){return-1==e.indexOf("\\")?e:e.replace(/\\/g,"/")}var ExternalModule=function(){function e(e){var t=e.graph,r=e.id;this.exportsNames=!1,this.exportsNamespace=!1,this.renderPath=void 0,this.renormalizeRenderPath=!1,this.isExternal=!0,this.isEntryPoint=!1,this.mostCommonSuggestion=0,this.reexported=!1,this.used=!1,this.execIndex=void 0,this.graph=t,this.id=r;var n=r.split(/[\\\/]/);this.name=makeLegal(n.pop()),this.nameSuggestions=Object.create(null),this.declarations=Object.create(null),this.exportedVariables=new Map}return e.prototype.setRenderPath=function(e,t){return e.paths&&(this.renderPath="function"==typeof e.paths?e.paths(this.id):e.paths[this.id]),this.renderPath||(isAbsolute(this.id)?(this.renderPath=normalize$1(path.relative(t,this.id)),this.renormalizeRenderPath=!0):this.renderPath=this.id),this.renderPath},e.prototype.suggestName=function(e){this.nameSuggestions[e]||(this.nameSuggestions[e]=0),this.nameSuggestions[e]+=1,this.nameSuggestions[e]>this.mostCommonSuggestion&&(this.mostCommonSuggestion=this.nameSuggestions[e],this.name=e)},e.prototype.warnUnusedImports=function(){var e=this,t=Object.keys(this.declarations).filter(function(t){if("*"===t)return!1;var r=e.declarations[t];return!r.included&&!e.reexported&&!r.referenced});if(0!==t.length){var r=1===t.length?"'"+t[0]+"' is":t.slice(0,-1).map(function(e){return"'"+e+"'"}).join(", ")+" and '"+t.slice(-1)+"' are";this.graph.warn({code:"UNUSED_EXTERNAL_IMPORT",source:this.id,names:t,message:r+" imported from external module '"+this.id+"' but never used"})}},e.prototype.traceExport=function(e,t){"default"!==e&&"*"!==e&&(this.exportsNames=!0),"*"===e&&(this.exportsNamespace=!0);var r=this.declarations[e];return r||(this.declarations[e]=r=new ExternalVariable(this,e),this.exportedVariables.set(r,e),r)},e}(),esModuleExport="Object.defineProperty(exports, '__esModule', { value: true });",compactEsModuleExport="Object.defineProperty(exports,'__esModule',{value:true});";function getExportBlock(e,t,r,n,i,s){void 0===s&&(s="return ");var o,a=i?"":" ";if(!r)return e.some(function(e){return"default"===e.exported&&(o=e.local,!0)}),o||t.some(function(e){return!!e.reexports&&e.reexports.some(function(t){return"default"===t.reexported&&(o=e.namedExportsMode?e.name+"."+t.imported:e.name,!0)})}),""+s+o+";";var u="";return t.forEach(function(e){var t=e.name,n=e.reexports;n&&r&&n.forEach(function(e){"*"===e.reexported&&(!i&&u&&(u+="\n"),u+="Object.keys("+t+").forEach(function"+a+"(key)"+a+"{"+a+"exports[key]"+a+"="+a+t+"[key];"+a+"});")})}),t.forEach(function(e){var t=e.name,s=e.imports,o=e.reexports,c=e.isChunk;o&&r&&o.forEach(function(e){if("default"!==e.imported||c)"*"!==e.imported?(u&&!i&&(u+="\n"),u+="exports."+e.reexported+a+"="+a+t+"."+e.imported+";"):"*"!==e.reexported&&(u&&!i&&(u+="\n"),u+="exports."+e.reexported+a+"="+a+t+";");else{var r=s&&s.some(function(e){return"*"===e.imported||"default"!==e.imported})||o&&o.some(function(e){return"default"!==e.imported&&"*"!==e.imported});u&&!i&&(u+="\n"),u+=r?"exports."+e.reexported+a+"="+a+t+(!1!==n?"__default":".default")+";":"exports."+e.reexported+a+"="+a+t+";"}})}),e.forEach(function(e){var t="exports."+e.exported,r=e.local;t!==r&&(u&&!i&&(u+="\n"),u+=""+t+a+"="+a+r+";")}),u}function getInteropBlock(e,t,r){return e.map(function(e){var n=e.name,i=e.exportsNames,s=e.exportsDefault;if(e.namedExportsMode)return s&&!1!==t.interop?i?t.compact?r+" "+n+"__default='default'in "+n+"?"+n+"['default']:"+n+";":r+" "+n+"__default = 'default' in "+n+" ? "+n+"['default'] : "+n+";":t.compact?n+"="+n+"&&"+n+".hasOwnProperty('default')?"+n+"['default']:"+n+";":n+" = "+n+" && "+n+".hasOwnProperty('default') ? "+n+"['default'] : "+n+";":null}).filter(Boolean).join(t.compact?"":"\n")}var builtins$1={process:!0,events:!0,stream:!0,util:!0,path:!0,buffer:!0,querystring:!0,url:!0,string_decoder:!0,punycode:!0,http:!0,https:!0,os:!0,assert:!0,constants:!0,timers:!0,console:!0,vm:!0,zlib:!0,tty:!0,domain:!0};function warnOnBuiltins(e,t){var r=t.map(function(e){return e.id}).filter(function(e){return e in builtins$1});if(r.length){var n=1===r.length?"module ('"+r[0]+"')":"modules ("+r.slice(0,-1).map(function(e){return"'"+e+"'"}).join(", ")+" and '"+r.slice(-1)+"')";e.warn({code:"MISSING_NODE_BUILTINS",modules:r,message:"Creating a browser bundle that depends on Node.js built-in "+n+". You might need to include https://www.npmjs.com/package/rollup-plugin-node-builtins"})}}function amd(e,t,r){var n=t.graph,i=t.namedExportsMode,s=t.hasExports,o=t.indentString,a=t.intro,u=t.outro,c=t.dynamicImport,h=t.needsAmdModule,p=t.dependencies,l=t.exports,f=t.isEntryModuleFacade;warnOnBuiltins(n,p);var d=p.map(function(e){return"'"+e.id+"'"}),m=p.map(function(e){return e.name}),g=r.compact?"":"\n",y=r.compact?"":" ";i&&s&&(m.unshift("exports"),d.unshift("'exports'")),c&&(m.unshift("require"),d.unshift("'require'")),h&&(m.unshift("module"),d.unshift("'module'"));var v=r.amd||{},_=(v.id?"'"+v.id+"',"+y:"")+(d.length?"["+d.join(","+y)+"],"+y:""),x=!1!==r.strict?y+"'use strict';":"",b=(v.define||"define")+"("+_+"function"+y+"("+m.join(","+y)+")"+y+"{"+x+g+g,E=getInteropBlock(p,r,n.varOrConst);E&&e.prepend(E+g+g),a&&e.prepend(a);var S=getExportBlock(l,p,i,r.interop,r.compact);return S&&e.append(g+g+S),i&&s&&f&&r.esModule&&e.append(""+g+g+(r.compact?compactEsModuleExport:esModuleExport)),u&&e.append(u),e.indent(o).append(g+g+"});").prepend(b)}function cjs(e,t,r){var n=t.graph,i=t.isEntryModuleFacade,s=t.namedExportsMode,o=t.hasExports,a=t.intro,u=t.outro,c=t.dependencies,h=t.exports,p=r.compact?"":"\n",l=r.compact?"":" ";a=(!1===r.strict?a:"'use strict';"+p+p+a)+(s&&o&&i&&r.esModule?""+(r.compact?compactEsModuleExport:esModuleExport)+p+p:"");var f,d=!1,m=n.varOrConst,g=!1!==r.interop;if(r.compact){var y=!1;f="",c.forEach(function(e){var t=e.id,r=e.namedExportsMode,n=e.isChunk,i=e.name,s=e.reexports,o=e.imports,a=e.exportsNames,u=e.exportsDefault;s||o?(f+=y?",":(f?";":"")+m+" ",y=!0,g&&!n&&u&&r?(d=!0,f+=a?i+"=require('"+t+"'),"+i+"__default=_interopDefault("+i+")":i+"=_interopDefault(require('"+t+"'))"):f+=i+"=require('"+t+"')"):(f+=y?";":",",y=!1,f+="require('"+t+"')")}),f.length&&(f+=";")}else f=c.map(function(e){var t=e.id,r=e.namedExportsMode,n=e.isChunk,i=e.name,s=e.reexports,o=e.imports,a=e.exportsNames,u=e.exportsDefault;return s||o?g&&!n&&u&&r?(d=!0,a?m+" "+i+" = require('"+t+"');\n"+m+" "+i+"__default = _interopDefault("+i+");":m+" "+i+" = _interopDefault(require('"+t+"'));"):m+" "+i+" = require('"+t+"');":"require('"+t+"');"}).join("\n");d&&(r.compact?a+="function _interopDefault(e){return(e&&(typeof e==='object')&&'default'in e)?e['default']:e}":a+="function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }\n\n"),f&&(a+=f+p+p);var v=getExportBlock(h,c,s,r.interop,r.compact,"module.exports"+l+"="+l);return e.prepend(a),v&&e.append(p+p+v),u&&e.append(u),e}function esm(e,t,r){var n=t.intro,i=t.outro,s=t.dependencies,o=t.exports,a=r.compact?"":" ",u=r.compact?"":"\n",c=s.map(function(e){var t=e.id,r=e.reexports,n=e.imports,i=e.name;if(!r&&!n)return"import"+a+"'"+t+"';";var s="";if(n){var o=n.find(function(e){return"default"===e.imported}),c=n.find(function(e){return"*"===e.imported});c&&(s+="import"+a+"*"+a+"as "+c.local+" from"+a+"'"+t+"';",n.length>1&&(s+=u)),o&&1===n.length?s+="import "+o.local+" from"+a+"'"+t+"';":(!c||n.length>1)&&(s+="import "+(o?o.local+","+a:"")+"{"+a+n.filter(function(e){return e!==o&&e!==c}).map(function(e){return e.imported===e.local?e.imported:e.imported+" as "+e.local}).join(","+a)+a+"}"+a+"from"+a+"'"+t+"';")}if(r){n&&(s+=u);var h=r.find(function(e){return"*"===e.reexported}),p=r.find(function(e){return"*"===e.imported&&"*"!==e.reexported});if(h){if(s+="export"+a+"*"+a+"from"+a+"'"+t+"';",1===r.length)return s;s+=u}if(p){if(n&&n.some(function(e){return"*"===e.imported&&e.local===i})||(s+="import"+a+"*"+a+"as "+i+" from"+a+"'"+t+"';"+u),s+="export"+a+"{"+a+(i===p.reexported?i:i+" as "+p.reexported)+" };",r.length===(h?2:1))return s;s+=u}s+="export"+a+"{"+a+r.filter(function(e){return e!==h&&e!==p}).map(function(e){return e.imported===e.reexported?e.imported:e.imported+" as "+e.reexported}).join(","+a)+a+"}"+a+"from"+a+"'"+t+"';"}return s}).join(u);c&&(n+=c+u+u),n&&e.prepend(n);var h=[],p=[];return o.forEach(function(e){"default"===e.exported?h.push("export default "+e.local+";"):p.push(e.exported===e.local?e.local:e.local+" as "+e.exported)}),p.length&&h.push("export"+a+"{"+a+p.join(","+a)+a+"};"),h.length&&e.append(u+u+h.join(u).trim()),i&&e.append(i),e.trim()}function getLocator$1(e,t){void 0===t&&(t={});var r=t.offsetLine||0,n=t.offsetColumn||0,i=e.split("\n"),s=0,o=i.map(function(e,t){var r=s+e.length+1,n={start:s,end:r,line:t};return s=r,n}),a=0;function u(e,t){return e.start<=t&&t<e.end}function c(e,t){return{line:r+e.line,column:n+t-e.start,character:t}}return function(t,r){"string"==typeof t&&(t=e.indexOf(t,r||0));for(var n=o[a],i=t>=n.end?1:-1;n;){if(u(n,t))return c(n,t);n=o[a+=i]}}}function locate(e,t,r){if("number"==typeof r)throw new Error("locate takes a { startIndex, offsetLine, offsetColumn } object as the third argument");return getLocator$1(e,r)(t,r&&r.startIndex)}function spaces(e){for(var t="";e--;)t+=" ";return t}function tabsToSpaces(e){return e.replace(/^\t+/,function(e){return e.split("\t").join("  ")})}function getCodeFrame(e,t,r){var n=e.split("\n"),i=Math.max(0,t-3),s=Math.min(t+2,n.length);for(n=n.slice(i,s);!/\S/.test(n[n.length-1]);)n.pop(),s-=1;var o=String(s).length;return n.map(function(e,n){for(var s=i+n+1===t,a=String(n+i+1);a.length<o;)a=" "+a;if(s){var u=spaces(o+2+tabsToSpaces(e.slice(0,r)).length)+"^";return a+": "+tabsToSpaces(e)+"\n"+u}return a+": "+tabsToSpaces(e)}).join("\n")}function error(e,t){throw e instanceof Error==!1&&(e=Object.assign(new Error(e.message),e)),t&&Object.assign(e,t),e}function augmentCodeLocation(e,t,r,n){if(void 0!==t.line&&void 0!==t.column){var i=t.line,s=t.column;e.loc={file:n,line:i,column:s}}else{e.pos=t;var o=locate(r,t,{offsetLine:1});i=o.line,s=o.column;e.loc={file:n,line:i,column:s}}if(void 0===e.frame){var a=e.loc;i=a.line,s=a.column;e.frame=getCodeFrame(r,i,s)}}var shouldUseDot=/^[a-zA-Z$_][a-zA-Z0-9$_]*$/;function property(e){return shouldUseDot.test(e)?"."+e:"['"+e+"']"}function keypath(e){return e.split(".").map(property).join("")}function setupNamespace(e,t,r,n,i){var s=e.split(".");n&&(s[0]=("function"==typeof n?n(s[0]):n[s[0]])||s[0]);var o=i?"":" ",a=s.pop(),u=t;return r?s.map(function(e){return""+(u+=property(e))+o+"="+o+u+o+"||"+o+"{}"}).concat(""+u+property(a)).join(","+o):s.map(function(e){return""+(u+=property(e))+o+"="+o+u+o+"||"+o+"{}"+(i?"":";")}).join(i?",":"\n")+(i&&s.length?";":"\n")}function trimEmptyImports(e){for(var t=e.length;t--;){var r=e[t];if(r.exportsDefault||r.exportsNames)return e.slice(0,t+1)}return[]}var thisProp=function(e){return"this"+keypath(e)};function iife(e,t,r){var n=t.graph,i=t.namedExportsMode,s=t.hasExports,o=t.indentString,a=t.intro,u=t.outro,c=t.dependencies,h=t.exports,p=r.compact?"":" ",l=r.compact?"":"\n",f=r.extend,d=r.name,m=d&&-1!==d.indexOf(".");d&&(!f&&!m)&&!isLegal(d)&&error({code:"ILLEGAL_IDENTIFIER_AS_NAME",message:"Given name ("+d+") is not legal JS identifier. If you need this you can try --extend option"}),warnOnBuiltins(n,c);var g=trimEmptyImports(c),y=g.map(function(e){return e.globalName||"null"}),v=g.map(function(e){return e.name});s&&!d&&error({code:"INVALID_OPTION",message:"You must supply output.name for IIFE bundles"}),f?(y.unshift("("+thisProp(d)+p+"="+p+thisProp(d)+p+"||"+p+"{})"),v.unshift("exports")):i&&s&&(y.unshift("{}"),v.unshift("exports"));var _="(function"+p+"("+v+")"+p+"{"+l+(!1!==r.strict?o+"'use strict';"+l+l:"");s&&!f&&(_=(m?thisProp(d):n.varOrConst+" "+d)+(p+"=")+p+_),m&&(_=setupNamespace(d,"this",!1,r.globals,r.compact)+_);var x=""+l+l+"}("+y+"));";!f&&i&&s&&(x=""+l+l+o+"return exports;"+x);var b=getInteropBlock(c,r,n.varOrConst);b&&e.prepend(b+l+l),a&&e.prepend(a);var E=getExportBlock(h,c,i,r.interop,r.compact);return E&&e.append(l+l+E),u&&e.append(u),e.indent(o).prepend(_).append(x)}function getStarExcludes(e){var t=e.dependencies,r=e.exports,n=new Set(r.map(function(e){return e.exported}));return n.has("default")||n.add("default"),t.forEach(function(e){var t=e.reexports;t&&t.forEach(function(e){"*"===e.imported||n.has(e.reexported)||n.add(e.reexported)})}),n}function system(e,t,r){var n,i=t.graph,s=t.indentString,o=t.intro,a=t.outro,u=t.dependencies,c=t.exports,h=t.usesTopLevelAwait,p=r.compact?"":"\n",l=r.compact?"":" ",f=u.map(function(e){return"'"+e.id+"'"}),d=[],m=[],g=i.varOrConst;u.forEach(function(e){var t=e.imports,r=e.reexports,i=[];if(t&&t.forEach(function(e){d.push(e.local),"*"===e.imported?i.push(""+e.local+l+"="+l+"module;"):i.push(""+e.local+l+"="+l+"module."+e.imported+";")}),r){var o=!1;r.length>1||1===r.length&&("*"===r[0].reexported||"*"===r[0].imported)?(r.forEach(function(e){"*"===e.reexported&&(n||(n=getStarExcludes({dependencies:u,exports:c})),o||(i.push(g+" _setter"+l+"="+l+"{};"),o=!0),i.push("for"+l+"(var _$p"+l+"in"+l+"module)"+l+"{"),i.push(s+"if"+l+"(!_starExcludes[_$p])"+l+"_setter[_$p]"+l+"="+l+"module[_$p];"),i.push("}"))}),r.forEach(function(e){"*"===e.imported&&"*"!==e.reexported&&i.push("exports('"+e.reexported+"',"+l+"module);")}),r.forEach(function(e){"*"!==e.reexported&&"*"!==e.imported&&(o||(i.push(g+" _setter"+l+"="+l+"{};"),o=!0),i.push("_setter."+e.reexported+l+"="+l+"module."+e.imported+";"))}),o&&i.push("exports(_setter);")):r.forEach(function(e){i.push("exports('"+e.reexported+"',"+l+"module."+e.imported+");")})}m.push(i.join(""+p+s+s+s))});var y=[],v=c.filter(function(e){return e.hoisted||e.uninitialized});if(1===v.length){var _=v[0];y.push("exports('"+_.exported+"',"+l+(_.uninitialized?"void 0":_.local)+");")}else if(v.length>1){y.push("exports({");for(var x=0;x<v.length;x++){_=v[x];y.push(""+s+_.exported+":"+l+(_.uninitialized?"void 0":_.local)+(x===v.length-1?"":","))}y.push("});")}var b=n?""+p+s+g+" _starExcludes"+l+"="+l+"{"+l+Array.from(n).join(":"+l+"1,"+l)+(n.size?":"+l+"1":"")+l+"};":"",E=d.length?""+p+s+"var "+d.join(","+l)+";":"",S="System.register("+(r.name?"'"+r.name+"',"+l:"")+"["+f.join(","+l)+"],"+l+"function"+l+"(exports,"+l+"module)"+l+"{"+p;S+=s+"'use strict';"+b+E+p,S+=s+"return"+l+"{"+(m.length?""+p+s+s+"setters:"+l+"["+m.map(function(e){return e?"function"+l+"(module)"+l+"{"+p+s+s+s+e+p+s+s+"}":"function"+l+"()"+l+"{}"}).join(","+l)+"],":"")+p,S+=""+s+s+"execute:"+l+(h?"async"+l:"")+"function"+l+"()"+l+"{"+p+p,y.length&&(S+=""+s+s+s+y.join(""+p+s+s+s)+p+p);var A=""+p+p+s+s+"}";return A+=""+p+s+"}"+(r.compact?"":";"),A+=p+"});",o&&e.prepend(o),a&&e.append(a),e.indent(""+s+s+s).append(A).prepend(S)}function globalProp(e){return e?"global"+keypath(e):"null"}function safeAccess(e,t){var r=e.split("."),n="global";return r.map(function(e){return n+=property(e)}).join(t?"&&":" && ")}function umd(e,t,r){var n=t.graph,i=t.namedExportsMode,s=t.hasExports,o=t.indentString,a=t.intro,u=t.outro,c=t.dependencies,h=t.exports,p=r.compact?"":" ",l=r.compact?"":"\n",f=l+l+"})));";s&&!r.name&&error({code:"INVALID_OPTION",message:"You must supply output.name for UMD bundles"}),warnOnBuiltins(n,c);var d=c.map(function(e){return"'"+e.id+"'"}),m=c.map(function(e){return"require('"+e.id+"')"}),g=trimEmptyImports(c),y=g.map(function(e){return globalProp(e.globalName)}),v=g.map(function(e){return e.name});i&&s&&(d.unshift("'exports'"),m.unshift("exports"),y.unshift("("+setupNamespace(r.name,"global",!0,r.globals,r.compact)+p+"="+p+(r.extend?""+globalProp(r.name)+p+"||"+p:"")+"{})"),v.unshift("exports"));var _,x=r.amd||{},b=(x.id?"'"+x.id+"',"+p:"")+(d.length?"["+d.join(","+p)+"],"+p:""),E=x.define||"define",S=!i&&s?"module.exports"+p+"="+p:"",A=!i&&s?""+setupNamespace(r.name,"global",!0,r.globals,r.compact)+p+"="+p:"",w=!1!==r.strict?p+"'use strict';"+l:"";if(!0===r.noConflict){var k=void 0;if(!i&&s)k="var exports"+p+"="+p+"factory("+y+");";else if(i){k="var exports"+p+"="+p+y.shift()+";"+l,k+=""+o+o+"factory("+["exports"].concat(y)+");"}_="(function()"+p+"{"+l,_+=""+o+o+"var current"+p+"="+p+safeAccess(r.name,r.compact)+";"+l,_+=""+o+o+k+l,_+=""+o+o+globalProp(r.name)+p+"="+p+"exports;"+l,_+=""+o+o+"exports.noConflict"+p+"="+p+"function()"+p+"{"+p,_+=""+globalProp(r.name)+p+"="+p+"current;"+p+"return exports"+(r.compact?"":"; ")+"};"+l,_+=o+"})()"}else _="("+A+"factory("+y+"))";var N="(function"+p+"(global,"+p+"factory)"+p+"{"+l;N+=o+"typeof exports"+p+"==="+p+"'object'"+p+"&&"+p+"typeof module"+p+"!=="+p+"'undefined'"+p+"?",N+=""+p+S+"factory("+m.join(","+p)+")"+p+":"+l,N+=o+"typeof "+E+p+"==="+p+"'function'"+p+"&&"+p+E+".amd"+p+"?"+p+E+"("+b+"factory)"+p+":"+l,N+=""+o+_+";"+l,N+="}(this,"+p+"(function"+p+"("+v+")"+p+"{"+w+l;var P=getInteropBlock(c,r,n.varOrConst);P&&e.prepend(P+l+l),a&&e.prepend(a);var $=getExportBlock(h,c,i,r.interop,r.compact);return $&&e.append(l+l+$),i&&s&&r.esModule&&e.append(l+l+(r.compact?compactEsModuleExport:esModuleExport)),u&&e.append(u),e.trim().indent(o).append(f).prepend(N)}var finalisers={system:system,amd:amd,cjs:cjs,es:esm,iife:iife,umd:umd},BLANK=Object.create(null),NO_SEMICOLON={isNoStatement:!0};function findFirstOccurrenceOutsideComment(e,t,r){var n,i;for(void 0===r&&(r=0),n=e.indexOf(t,r);;){if(-1===(r=e.indexOf("/",r))||r>n)return n;if(i=e.charCodeAt(++r),++r,47===i){if(0===(r=e.indexOf("\n",r)+1))return-1;r>n&&(n=e.indexOf(t,r))}else 42===i&&(r=e.indexOf("*/",r)+2)>n&&(n=e.indexOf(t,r))}}function findFirstLineBreakOutsideComment(e,t){var r,n;for(void 0===t&&(t=0),r=e.indexOf("\n",t);;){if(-1===(t=e.indexOf("/",t))||t>r)return r;if(47===(n=e.charCodeAt(++t)))return r;++t,42===n&&(t=e.indexOf("*/",t)+2)>r&&(r=e.indexOf("\n",t))}}function renderStatementList(e,t,r,n,i){if(0!==e.length){var s,o,a,u,c=e[0],h=!c.included||c.needsBoundaries;h&&(u=r+findFirstLineBreakOutsideComment(t.original.slice(r,c.start))+1);for(var p=1;p<=e.length;p++)s=c,o=u,a=h,h=void 0!==(c=e[p])&&(!c.included||c.needsBoundaries),a||h?(u=s.end+findFirstLineBreakOutsideComment(t.original.slice(s.end,void 0===c?n:c.start))+1,s.included?a?s.render(t,i,{start:o,end:u}):s.render(t,i):t.remove(o,u)):s.render(t,i)}}function getCommaSeparatedNodesWithBoundaries(e,t,r,n){for(var i,s,o,a,u,c=[],h=r-1,p=0;p<e.length;p++){for(s=e[p],void 0!==i&&(h=i.end+findFirstOccurrenceOutsideComment(t.original.slice(i.end,s.start),",")),o=a=h+2+findFirstLineBreakOutsideComment(t.original.slice(h+1,s.start));32===(u=t.original.charCodeAt(o))||9===u||10===u||13===u;)o++;void 0!==i&&c.push({node:i,start:r,contentEnd:a,separator:h,end:o}),i=s,r=o}return c.push({node:i,start:r,separator:null,contentEnd:n,end:n}),c}var chars$1="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_$";function toBase64(e,t){void 0===t&&(t=!1);var r="",n=t?63:64;do{var i=e%n;e=Math.floor(e/n),r=chars$1[i]+r}while(0!==e);return r}var OptionTypes,Scope=function(){function e(e){void 0===e&&(e=null),this.isModuleScope=!1,this.parent=e,this.children=[],this.parent&&this.parent.children.push(this),this.variables=Object.create(null)}return e.prototype.addDeclaration=function(e,t,r,n){void 0===r&&(r=null);var i=e.name;return this.variables[i]?this.variables[i].addDeclaration(e,r):this.variables[i]=new LocalVariable(e.name,e,r||UNDEFINED_EXPRESSION,t),this.variables[i]},e.prototype.addExportDefaultDeclaration=function(e,t,r){return this.variables.default=new ExportDefaultVariable(e,t,r),this.variables.default},e.prototype.addReturnExpression=function(e){this.parent&&this.parent.addReturnExpression(e)},e.prototype.contains=function(e){return e in this.variables||!!this.parent&&this.parent.contains(e)},e.prototype.deshadow=function(e,t){void 0===t&&(t=this.children);for(var r=0,n=Object.keys(this.variables);r<n.length;r++){var i=n[r],s=this.variables[i];if((!s.exportName||!s.isReassigned||s.isId)&&!s.isDefault){var o=s.getName(!0);if(e.has(o)){o=s.name;var a=void 0,u=1;do{a=o+"$$"+toBase64(u++)}while(e.has(a));s.setSafeName(a)}}}for(var c=0,h=t;c<h.length;c++){h[c].deshadow(e)}},e.prototype.findLexicalBoundary=function(){return this.parent.findLexicalBoundary()},e.prototype.findVariable=function(e){return this.variables[e]||this.parent&&this.parent.findVariable(e)},e}(),immutable=createCommonjsModule$1(function(e,t){e.exports=function(){var e=Array.prototype.slice;function t(e,t){t&&(e.prototype=Object.create(t.prototype)),e.prototype.constructor=e}function r(e){return o(e)?e:K(e)}function n(e){return a(e)?e:G(e)}function i(e){return u(e)?e:H(e)}function s(e){return o(e)&&!c(e)?e:X(e)}function o(e){return!(!e||!e[p])}function a(e){return!(!e||!e[l])}function u(e){return!(!e||!e[f])}function c(e){return a(e)||u(e)}function h(e){return!(!e||!e[d])}t(n,r),t(i,r),t(s,r),r.isIterable=o,r.isKeyed=a,r.isIndexed=u,r.isAssociative=c,r.isOrdered=h,r.Keyed=n,r.Indexed=i,r.Set=s;var p="@@__IMMUTABLE_ITERABLE__@@",l="@@__IMMUTABLE_KEYED__@@",f="@@__IMMUTABLE_INDEXED__@@",d="@@__IMMUTABLE_ORDERED__@@",m=5,g=1<<m,y=g-1,v={},_={value:!1},x={value:!1};function b(e){return e.value=!1,e}function E(e){e&&(e.value=!0)}function S(){}function A(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),i=0;i<r;i++)n[i]=e[i+t];return n}function w(e){return void 0===e.size&&(e.size=e.__iterate(N)),e.size}function k(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?w(e)+t:t}function N(){return!0}function P(e,t,r){return(0===e||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function $(e,t){return I(e,t,0)}function C(e,t){return I(e,t,t)}function I(e,t,r){return void 0===e?r:e<0?Math.max(0,t+e):void 0===t?e:Math.min(t,e)}var O=0,R=1,T=2,M="function"==typeof Symbol&&Symbol.iterator,L="@@iterator",D=M||L;function j(e){this.next=e}function B(e,t,r,n){var i=0===e?t:1===e?r:[t,r];return n?n.value=i:n={value:i,done:!1},n}function U(){return{value:void 0,done:!0}}function W(e){return!!z(e)}function V(e){return e&&"function"==typeof e.next}function F(e){var t=z(e);return t&&t.call(e)}function z(e){var t=e&&(M&&e[M]||e[L]);if("function"==typeof t)return t}function q(e){return e&&"number"==typeof e.length}function K(e){return null==e?se():o(e)?e.toSeq():function(e){var t=ue(e)||"object"==typeof e&&new te(e);if(!t)throw new TypeError("Expected Array or iterable object of values, or keyed object: "+e);return t}(e)}function G(e){return null==e?se().toKeyedSeq():o(e)?a(e)?e.toSeq():e.fromEntrySeq():oe(e)}function H(e){return null==e?se():o(e)?a(e)?e.entrySeq():e.toIndexedSeq():ae(e)}function X(e){return(null==e?se():o(e)?a(e)?e.entrySeq():e:ae(e)).toSetSeq()}j.prototype.toString=function(){return"[Iterator]"},j.KEYS=O,j.VALUES=R,j.ENTRIES=T,j.prototype.inspect=j.prototype.toSource=function(){return this.toString()},j.prototype[D]=function(){return this},t(K,r),K.of=function(){return K(arguments)},K.prototype.toSeq=function(){return this},K.prototype.toString=function(){return this.__toString("Seq {","}")},K.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},K.prototype.__iterate=function(e,t){return ce(this,e,t,!0)},K.prototype.__iterator=function(e,t){return he(this,e,t,!0)},t(G,K),G.prototype.toKeyedSeq=function(){return this},t(H,K),H.of=function(){return H(arguments)},H.prototype.toIndexedSeq=function(){return this},H.prototype.toString=function(){return this.__toString("Seq [","]")},H.prototype.__iterate=function(e,t){return ce(this,e,t,!1)},H.prototype.__iterator=function(e,t){return he(this,e,t,!1)},t(X,K),X.of=function(){return X(arguments)},X.prototype.toSetSeq=function(){return this},K.isSeq=ie,K.Keyed=G,K.Set=X,K.Indexed=H;var Y,J,Q,Z="@@__IMMUTABLE_SEQ__@@";function ee(e){this._array=e,this.size=e.length}function te(e){var t=Object.keys(e);this._object=e,this._keys=t,this.size=t.length}function re(e){this._iterable=e,this.size=e.length||e.size}function ne(e){this._iterator=e,this._iteratorCache=[]}function ie(e){return!(!e||!e[Z])}function se(){return Y||(Y=new ee([]))}function oe(e){var t=Array.isArray(e)?new ee(e).fromEntrySeq():V(e)?new ne(e).fromEntrySeq():W(e)?new re(e).fromEntrySeq():"object"==typeof e?new te(e):void 0;if(!t)throw new TypeError("Expected Array or iterable object of [k, v] entries, or keyed object: "+e);return t}function ae(e){var t=ue(e);if(!t)throw new TypeError("Expected Array or iterable object of values: "+e);return t}function ue(e){return q(e)?new ee(e):V(e)?new ne(e):W(e)?new re(e):void 0}function ce(e,t,r,n){var i=e._cache;if(i){for(var s=i.length-1,o=0;o<=s;o++){var a=i[r?s-o:o];if(!1===t(a[1],n?a[0]:o,e))return o+1}return o}return e.__iterateUncached(t,r)}function he(e,t,r,n){var i=e._cache;if(i){var s=i.length-1,o=0;return new j(function(){var e=i[r?s-o:o];return o++>s?{value:void 0,done:!0}:B(t,n?e[0]:o-1,e[1])})}return e.__iteratorUncached(t,r)}function pe(e,t){return t?function e(t,r,n,i){return Array.isArray(r)?t.call(i,n,H(r).map(function(n,i){return e(t,n,i,r)})):fe(r)?t.call(i,n,G(r).map(function(n,i){return e(t,n,i,r)})):r}(t,e,"",{"":e}):le(e)}function le(e){return Array.isArray(e)?H(e).map(le).toList():fe(e)?G(e).map(le).toMap():e}function fe(e){return e&&(e.constructor===Object||void 0===e.constructor)}function de(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if(e=e.valueOf(),t=t.valueOf(),e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!("function"!=typeof e.equals||"function"!=typeof t.equals||!e.equals(t))}function me(e,t){if(e===t)return!0;if(!o(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||a(e)!==a(t)||u(e)!==u(t)||h(e)!==h(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!c(e);if(h(e)){var n=e.entries();return t.every(function(e,t){var i=n.next().value;return i&&de(i[1],e)&&(r||de(i[0],t))})&&n.next().done}var i=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{i=!0;var s=e;e=t,t=s}var p=!0,l=t.__iterate(function(t,n){if(r?!e.has(t):i?!de(t,e.get(n,v)):!de(e.get(n,v),t))return p=!1,!1});return p&&e.size===l}function ge(e,t){if(!(this instanceof ge))return new ge(e,t);if(this._value=e,this.size=void 0===t?1/0:Math.max(0,t),0===this.size){if(J)return J;J=this}}function ye(e,t){if(!e)throw new Error(t)}function ve(e,t,r){if(!(this instanceof ve))return new ve(e,t,r);if(ye(0!==r,"Cannot step a Range by 0"),e=e||0,void 0===t&&(t=1/0),r=void 0===r?1:Math.abs(r),t<e&&(r=-r),this._start=e,this._end=t,this._step=r,this.size=Math.max(0,Math.ceil((t-e)/r-1)+1),0===this.size){if(Q)return Q;Q=this}}function _e(){throw TypeError("Abstract")}function xe(){}function be(){}function Ee(){}K.prototype[Z]=!0,t(ee,H),ee.prototype.get=function(e,t){return this.has(e)?this._array[k(this,e)]:t},ee.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length-1,i=0;i<=n;i++)if(!1===e(r[t?n-i:i],i,this))return i+1;return i},ee.prototype.__iterator=function(e,t){var r=this._array,n=r.length-1,i=0;return new j(function(){return i>n?{value:void 0,done:!0}:B(e,i,r[t?n-i++:i++])})},t(te,G),te.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},te.prototype.has=function(e){return this._object.hasOwnProperty(e)},te.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,i=n.length-1,s=0;s<=i;s++){var o=n[t?i-s:s];if(!1===e(r[o],o,this))return s+1}return s},te.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,i=n.length-1,s=0;return new j(function(){var o=n[t?i-s:s];return s++>i?{value:void 0,done:!0}:B(e,o,r[o])})},te.prototype[d]=!0,t(re,H),re.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=this._iterable,n=F(r),i=0;if(V(n))for(var s;!(s=n.next()).done&&!1!==e(s.value,i++,this););return i},re.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=this._iterable,n=F(r);if(!V(n))return new j(U);var i=0;return new j(function(){var t=n.next();return t.done?t:B(e,i++,t.value)})},t(ne,H),ne.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);for(var r,n=this._iterator,i=this._iteratorCache,s=0;s<i.length;)if(!1===e(i[s],s++,this))return s;for(;!(r=n.next()).done;){var o=r.value;if(i[s]=o,!1===e(o,s++,this))break}return s},ne.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=this._iterator,n=this._iteratorCache,i=0;return new j(function(){if(i>=n.length){var t=r.next();if(t.done)return t;n[i]=t.value}return B(e,i,n[i++])})},t(ge,H),ge.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},ge.prototype.get=function(e,t){return this.has(e)?this._value:t},ge.prototype.includes=function(e){return de(this._value,e)},ge.prototype.slice=function(e,t){var r=this.size;return P(e,t,r)?this:new ge(this._value,C(t,r)-$(e,r))},ge.prototype.reverse=function(){return this},ge.prototype.indexOf=function(e){return de(this._value,e)?0:-1},ge.prototype.lastIndexOf=function(e){return de(this._value,e)?this.size:-1},ge.prototype.__iterate=function(e,t){for(var r=0;r<this.size;r++)if(!1===e(this._value,r,this))return r+1;return r},ge.prototype.__iterator=function(e,t){var r=this,n=0;return new j(function(){return n<r.size?B(e,n++,r._value):{value:void 0,done:!0}})},ge.prototype.equals=function(e){return e instanceof ge?de(this._value,e._value):me(e)},t(ve,H),ve.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},ve.prototype.get=function(e,t){return this.has(e)?this._start+k(this,e)*this._step:t},ve.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},ve.prototype.slice=function(e,t){return P(e,t,this.size)?this:(e=$(e,this.size),(t=C(t,this.size))<=e?new ve(0,0):new ve(this.get(e,this._end),this.get(t,this._end),this._step))},ve.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},ve.prototype.lastIndexOf=function(e){return this.indexOf(e)},ve.prototype.__iterate=function(e,t){for(var r=this.size-1,n=this._step,i=t?this._start+r*n:this._start,s=0;s<=r;s++){if(!1===e(i,s,this))return s+1;i+=t?-n:n}return s},ve.prototype.__iterator=function(e,t){var r=this.size-1,n=this._step,i=t?this._start+r*n:this._start,s=0;return new j(function(){var o=i;return i+=t?-n:n,s>r?{value:void 0,done:!0}:B(e,s++,o)})},ve.prototype.equals=function(e){return e instanceof ve?this._start===e._start&&this._end===e._end&&this._step===e._step:me(this,e)},t(_e,r),t(xe,_e),t(be,_e),t(Ee,_e),_e.Keyed=xe,_e.Indexed=be,_e.Set=Ee;var Se="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function Ae(e){return e>>>1&1073741824|3221225471&e}function we(e){if(!1===e||null==e)return 0;if("function"==typeof e.valueOf&&(!1===(e=e.valueOf())||null==e))return 0;if(!0===e)return 1;var t,r,n=typeof e;if("number"===n){if(e!=e||e===1/0)return 0;var i=0|e;for(i!==e&&(i^=4294967295*e);e>4294967295;)i^=e/=4294967295;return Ae(i)}if("string"===n)return e.length>Re?(void 0===(r=Le[t=e])&&(r=ke(t),Me===Te&&(Me=0,Le={}),Me++,Le[t]=r),r):ke(e);if("function"==typeof e.hashCode)return e.hashCode();if("object"===n)return function(e){var t;if(Ce&&void 0!==(t=Ne.get(e)))return t;if(void 0!==(t=e[Oe]))return t;if(!$e){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[Oe]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=++Ie,1073741824&Ie&&(Ie=0),Ce)Ne.set(e,t);else{if(void 0!==Pe&&!1===Pe(e))throw new Error("Non-extensible objects are not allowed as keys.");if($e)Object.defineProperty(e,Oe,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[Oe]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[Oe]=t}}return t}(e);if("function"==typeof e.toString)return ke(e.toString());throw new Error("Value type "+n+" cannot be hashed.")}function ke(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return Ae(t)}var Ne,Pe=Object.isExtensible,$e=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}(),Ce="function"==typeof WeakMap;Ce&&(Ne=new WeakMap);var Ie=0,Oe="__immutablehash__";"function"==typeof Symbol&&(Oe=Symbol(Oe));var Re=16,Te=255,Me=0,Le={};function De(e){ye(e!==1/0,"Cannot perform this action with an infinite size.")}function je(e){return null==e?Qe():Be(e)&&!h(e)?e:Qe().withMutations(function(t){var r=n(e);De(r.size),r.forEach(function(e,r){return t.set(r,e)})})}function Be(e){return!(!e||!e[We])}t(je,xe),je.of=function(){var t=e.call(arguments,0);return Qe().withMutations(function(e){for(var r=0;r<t.length;r+=2){if(r+1>=t.length)throw new Error("Missing value for key: "+t[r]);e.set(t[r],t[r+1])}})},je.prototype.toString=function(){return this.__toString("Map {","}")},je.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},je.prototype.set=function(e,t){return Ze(this,e,t)},je.prototype.setIn=function(e,t){return this.updateIn(e,v,function(){return t})},je.prototype.remove=function(e){return Ze(this,e,v)},je.prototype.deleteIn=function(e){return this.updateIn(e,function(){return v})},je.prototype.update=function(e,t,r){return 1===arguments.length?e(this):this.updateIn([e],t,r)},je.prototype.updateIn=function(e,t,r){r||(r=t,t=void 0);var n=function e(t,r,n,i){var s=t===v,o=r.next();if(o.done){var a=s?n:t,u=i(a);return u===a?t:u}ye(s||t&&t.set,"invalid keyPath");var c=o.value,h=s?v:t.get(c,v),p=e(h,r,n,i);return p===h?t:p===v?t.remove(c):(s?Qe():t).set(c,p)}(this,rr(e),t,r);return n===v?void 0:n},je.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):Qe()},je.prototype.merge=function(){return nt(this,void 0,arguments)},je.prototype.mergeWith=function(t){var r=e.call(arguments,1);return nt(this,t,r)},je.prototype.mergeIn=function(t){var r=e.call(arguments,1);return this.updateIn(t,Qe(),function(e){return"function"==typeof e.merge?e.merge.apply(e,r):r[r.length-1]})},je.prototype.mergeDeep=function(){return nt(this,it,arguments)},je.prototype.mergeDeepWith=function(t){var r=e.call(arguments,1);return nt(this,st(t),r)},je.prototype.mergeDeepIn=function(t){var r=e.call(arguments,1);return this.updateIn(t,Qe(),function(e){return"function"==typeof e.mergeDeep?e.mergeDeep.apply(e,r):r[r.length-1]})},je.prototype.sort=function(e){return $t(qt(this,e))},je.prototype.sortBy=function(e,t){return $t(qt(this,t,e))},je.prototype.withMutations=function(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this},je.prototype.asMutable=function(){return this.__ownerID?this:this.__ensureOwner(new S)},je.prototype.asImmutable=function(){return this.__ensureOwner()},je.prototype.wasAltered=function(){return this.__altered},je.prototype.__iterator=function(e,t){return new He(this,e,t)},je.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate(function(t){return n++,e(t[1],t[0],r)},t),n},je.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Je(this.size,this._root,e,this.__hash):(this.__ownerID=e,this.__altered=!1,this)},je.isMap=Be;var Ue,We="@@__IMMUTABLE_MAP__@@",Ve=je.prototype;function Fe(e,t){this.ownerID=e,this.entries=t}function ze(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r}function qe(e,t,r){this.ownerID=e,this.count=t,this.nodes=r}function Ke(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r}function Ge(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r}function He(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&Ye(e._root)}function Xe(e,t){return B(e,t[0],t[1])}function Ye(e,t){return{node:e,index:0,__prev:t}}function Je(e,t,r,n){var i=Object.create(Ve);return i.size=e,i._root=t,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function Qe(){return Ue||(Ue=Je(0))}function Ze(e,t,r){var n,i;if(e._root){var s=b(_),o=b(x);if(n=et(e._root,e.__ownerID,0,void 0,t,r,s,o),!o.value)return e;i=e.size+(s.value?r===v?-1:1:0)}else{if(r===v)return e;i=1,n=new Fe(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=i,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?Je(i,n):Qe()}function et(e,t,r,n,i,s,o,a){return e?e.update(t,r,n,i,s,o,a):s===v?e:(E(a),E(o),new Ge(t,n,[i,s]))}function tt(e){return e.constructor===Ge||e.constructor===Ke}function rt(e,t,r,n,i){if(e.keyHash===n)return new Ke(t,n,[e.entry,i]);var s,o=(0===r?e.keyHash:e.keyHash>>>r)&y,a=(0===r?n:n>>>r)&y,u=o===a?[rt(e,t,r+m,n,i)]:(s=new Ge(t,n,i),o<a?[e,s]:[s,e]);return new ze(t,1<<o|1<<a,u)}function nt(e,t,r){for(var i=[],s=0;s<r.length;s++){var a=r[s],u=n(a);o(a)||(u=u.map(function(e){return pe(e)})),i.push(u)}return ot(e,t,i)}function it(e,t,r){return e&&e.mergeDeep&&o(t)?e.mergeDeep(t):de(e,t)?e:t}function st(e){return function(t,r,n){if(t&&t.mergeDeepWith&&o(r))return t.mergeDeepWith(e,r);var i=e(t,r,n);return de(t,i)?t:i}}function ot(e,t,r){return 0===(r=r.filter(function(e){return 0!==e.size})).length?e:0!==e.size||e.__ownerID||1!==r.length?e.withMutations(function(e){for(var n=t?function(r,n){e.update(n,v,function(e){return e===v?r:t(e,r,n)})}:function(t,r){e.set(r,t)},i=0;i<r.length;i++)r[i].forEach(n)}):e.constructor(r[0])}function at(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,e+=e>>8,127&(e+=e>>16)}function ut(e,t,r,n){var i=n?e:A(e);return i[t]=r,i}Ve[We]=!0,Ve.delete=Ve.remove,Ve.removeIn=Ve.deleteIn,Fe.prototype.get=function(e,t,r,n){for(var i=this.entries,s=0,o=i.length;s<o;s++)if(de(r,i[s][0]))return i[s][1];return n},Fe.prototype.update=function(e,t,r,n,i,s,o){for(var a=i===v,u=this.entries,c=0,h=u.length;c<h&&!de(n,u[c][0]);c++);var p=c<h;if(p?u[c][1]===i:a)return this;if(E(o),(a||!p)&&E(s),!a||1!==u.length){if(!p&&!a&&u.length>=ct)return function(e,t,r,n){e||(e=new S);for(var i=new Ge(e,we(r),[r,n]),s=0;s<t.length;s++){var o=t[s];i=i.update(e,0,void 0,o[0],o[1])}return i}(e,u,n,i);var l=e&&e===this.ownerID,f=l?u:A(u);return p?a?c===h-1?f.pop():f[c]=f.pop():f[c]=[n,i]:f.push([n,i]),l?(this.entries=f,this):new Fe(e,f)}},ze.prototype.get=function(e,t,r,n){void 0===t&&(t=we(r));var i=1<<((0===e?t:t>>>e)&y),s=this.bitmap;return 0==(s&i)?n:this.nodes[at(s&i-1)].get(e+m,t,r,n)},ze.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=we(n));var a=(0===t?r:r>>>t)&y,u=1<<a,c=this.bitmap,h=0!=(c&u);if(!h&&i===v)return this;var p=at(c&u-1),l=this.nodes,f=h?l[p]:void 0,d=et(f,e,t+m,r,n,i,s,o);if(d===f)return this;if(!h&&d&&l.length>=ht)return function(e,t,r,n,i){for(var s=0,o=new Array(g),a=0;0!==r;a++,r>>>=1)o[a]=1&r?t[s++]:void 0;return o[n]=i,new qe(e,s+1,o)}(e,l,c,a,d);if(h&&!d&&2===l.length&&tt(l[1^p]))return l[1^p];if(h&&d&&1===l.length&&tt(d))return d;var _=e&&e===this.ownerID,x=h?d?c:c^u:c|u,b=h?d?ut(l,p,d,_):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var i=new Array(n),s=0,o=0;o<n;o++)o===t&&(s=1),i[o]=e[o+s];return i}(l,p,_):function(e,t,r,n){var i=e.length+1;if(n&&t+1===i)return e[t]=r,e;for(var s=new Array(i),o=0,a=0;a<i;a++)a===t?(s[a]=r,o=-1):s[a]=e[a+o];return s}(l,p,d,_);return _?(this.bitmap=x,this.nodes=b,this):new ze(e,x,b)},qe.prototype.get=function(e,t,r,n){void 0===t&&(t=we(r));var i=(0===e?t:t>>>e)&y,s=this.nodes[i];return s?s.get(e+m,t,r,n):n},qe.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=we(n));var a=(0===t?r:r>>>t)&y,u=i===v,c=this.nodes,h=c[a];if(u&&!h)return this;var p=et(h,e,t+m,r,n,i,s,o);if(p===h)return this;var l=this.count;if(h){if(!p&&--l<pt)return function(e,t,r,n){for(var i=0,s=0,o=new Array(r),a=0,u=1,c=t.length;a<c;a++,u<<=1){var h=t[a];void 0!==h&&a!==n&&(i|=u,o[s++]=h)}return new ze(e,i,o)}(e,c,l,a)}else l++;var f=e&&e===this.ownerID,d=ut(c,a,p,f);return f?(this.count=l,this.nodes=d,this):new qe(e,l,d)},Ke.prototype.get=function(e,t,r,n){for(var i=this.entries,s=0,o=i.length;s<o;s++)if(de(r,i[s][0]))return i[s][1];return n},Ke.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=we(n));var a=i===v;if(r!==this.keyHash)return a?this:(E(o),E(s),rt(this,e,t,r,[n,i]));for(var u=this.entries,c=0,h=u.length;c<h&&!de(n,u[c][0]);c++);var p=c<h;if(p?u[c][1]===i:a)return this;if(E(o),(a||!p)&&E(s),a&&2===h)return new Ge(e,this.keyHash,u[1^c]);var l=e&&e===this.ownerID,f=l?u:A(u);return p?a?c===h-1?f.pop():f[c]=f.pop():f[c]=[n,i]:f.push([n,i]),l?(this.entries=f,this):new Ke(e,this.keyHash,f)},Ge.prototype.get=function(e,t,r,n){return de(r,this.entry[0])?this.entry[1]:n},Ge.prototype.update=function(e,t,r,n,i,s,o){var a=i===v,u=de(n,this.entry[0]);return(u?i===this.entry[1]:a)?this:(E(o),a?void E(s):u?e&&e===this.ownerID?(this.entry[1]=i,this):new Ge(e,this.keyHash,[n,i]):(E(s),rt(this,e,t,we(n),[n,i])))},Fe.prototype.iterate=Ke.prototype.iterate=function(e,t){for(var r=this.entries,n=0,i=r.length-1;n<=i;n++)if(!1===e(r[t?i-n:n]))return!1},ze.prototype.iterate=qe.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,i=r.length-1;n<=i;n++){var s=r[t?i-n:n];if(s&&!1===s.iterate(e,t))return!1}},Ge.prototype.iterate=function(e,t){return e(this.entry)},t(He,j),He.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r,n=t.node,i=t.index++;if(n.entry){if(0===i)return Xe(e,n.entry)}else if(n.entries){if(r=n.entries.length-1,i<=r)return Xe(e,n.entries[this._reverse?r-i:i])}else if(r=n.nodes.length-1,i<=r){var s=n.nodes[this._reverse?r-i:i];if(s){if(s.entry)return Xe(e,s.entry);t=this._stack=Ye(s,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}};var ct=g/4,ht=g/2,pt=g/4;function lt(e){var t=Et();if(null==e)return t;if(ft(e))return e;var r=i(e),n=r.size;return 0===n?t:(De(n),n>0&&n<g?bt(0,n,m,null,new gt(r.toArray())):t.withMutations(function(e){e.setSize(n),r.forEach(function(t,r){return e.set(r,t)})}))}function ft(e){return!(!e||!e[dt])}t(lt,be),lt.of=function(){return this(arguments)},lt.prototype.toString=function(){return this.__toString("List [","]")},lt.prototype.get=function(e,t){if((e=k(this,e))>=0&&e<this.size){var r=wt(this,e+=this._origin);return r&&r.array[e&y]}return t},lt.prototype.set=function(e,t){return function(e,t,r){if((t=k(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations(function(e){t<0?kt(e,t).set(0,r):kt(e,0,t+1).set(t,r)});t+=e._origin;var n=e._tail,i=e._root,s=b(x);return t>=Pt(e._capacity)?n=St(n,e.__ownerID,0,t,r,s):i=St(i,e.__ownerID,e._level,t,r,s),s.value?e.__ownerID?(e._root=i,e._tail=n,e.__hash=void 0,e.__altered=!0,e):bt(e._origin,e._capacity,e._level,i,n):e}(this,e,t)},lt.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},lt.prototype.insert=function(e,t){return this.splice(e,0,t)},lt.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=m,this._root=this._tail=null,this.__hash=void 0,this.__altered=!0,this):Et()},lt.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations(function(r){kt(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])})},lt.prototype.pop=function(){return kt(this,0,-1)},lt.prototype.unshift=function(){var e=arguments;return this.withMutations(function(t){kt(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])})},lt.prototype.shift=function(){return kt(this,1)},lt.prototype.merge=function(){return Nt(this,void 0,arguments)},lt.prototype.mergeWith=function(t){var r=e.call(arguments,1);return Nt(this,t,r)},lt.prototype.mergeDeep=function(){return Nt(this,it,arguments)},lt.prototype.mergeDeepWith=function(t){var r=e.call(arguments,1);return Nt(this,st(t),r)},lt.prototype.setSize=function(e){return kt(this,0,e)},lt.prototype.slice=function(e,t){var r=this.size;return P(e,t,r)?this:kt(this,$(e,r),C(t,r))},lt.prototype.__iterator=function(e,t){var r=0,n=xt(this,t);return new j(function(){var t=n();return t===_t?{value:void 0,done:!0}:B(e,r++,t)})},lt.prototype.__iterate=function(e,t){for(var r,n=0,i=xt(this,t);(r=i())!==_t&&!1!==e(r,n++,this););return n},lt.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?bt(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):(this.__ownerID=e,this)},lt.isList=ft;var dt="@@__IMMUTABLE_LIST__@@",mt=lt.prototype;function gt(e,t){this.array=e,this.ownerID=t}mt[dt]=!0,mt.delete=mt.remove,mt.setIn=Ve.setIn,mt.deleteIn=mt.removeIn=Ve.removeIn,mt.update=Ve.update,mt.updateIn=Ve.updateIn,mt.mergeIn=Ve.mergeIn,mt.mergeDeepIn=Ve.mergeDeepIn,mt.withMutations=Ve.withMutations,mt.asMutable=Ve.asMutable,mt.asImmutable=Ve.asImmutable,mt.wasAltered=Ve.wasAltered,gt.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&y;if(n>=this.array.length)return new gt([],e);var i,s=0===n;if(t>0){var o=this.array[n];if((i=o&&o.removeBefore(e,t-m,r))===o&&s)return this}if(s&&!i)return this;var a=At(this,e);if(!s)for(var u=0;u<n;u++)a.array[u]=void 0;return i&&(a.array[n]=i),a},gt.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,i=r-1>>>t&y;if(i>=this.array.length)return this;if(t>0){var s=this.array[i];if((n=s&&s.removeAfter(e,t-m,r))===s&&i===this.array.length-1)return this}var o=At(this,e);return o.array.splice(i+1),n&&(o.array[i]=n),o};var yt,vt,_t={};function xt(e,t){var r=e._origin,n=e._capacity,i=Pt(n),s=e._tail;return o(e._root,e._level,0);function o(e,a,u){return 0===a?function(e,o){var a=o===i?s&&s.array:e&&e.array,u=o>r?0:r-o,c=n-o;return c>g&&(c=g),function(){if(u===c)return _t;var e=t?--c:u++;return a&&a[e]}}(e,u):function(e,i,s){var a,u=e&&e.array,c=s>r?0:r-s>>i,h=1+(n-s>>i);return h>g&&(h=g),function(){for(;;){if(a){var e=a();if(e!==_t)return e;a=null}if(c===h)return _t;var r=t?--h:c++;a=o(u&&u[r],i-m,s+(r<<i))}}}(e,a,u)}}function bt(e,t,r,n,i,s,o){var a=Object.create(mt);return a.size=t-e,a._origin=e,a._capacity=t,a._level=r,a._root=n,a._tail=i,a.__ownerID=s,a.__hash=o,a.__altered=!1,a}function Et(){return yt||(yt=bt(0,0,m))}function St(e,t,r,n,i,s){var o,a=n>>>r&y,u=e&&a<e.array.length;if(!u&&void 0===i)return e;if(r>0){var c=e&&e.array[a],h=St(c,t,r-m,n,i,s);return h===c?e:((o=At(e,t)).array[a]=h,o)}return u&&e.array[a]===i?e:(E(s),o=At(e,t),void 0===i&&a===o.array.length-1?o.array.pop():o.array[a]=i,o)}function At(e,t){return t&&e&&t===e.ownerID?e:new gt(e?e.array.slice():[],t)}function wt(e,t){if(t>=Pt(e._capacity))return e._tail;if(t<1<<e._level+m){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&y],n-=m;return r}}function kt(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new S,i=e._origin,s=e._capacity,o=i+t,a=void 0===r?s:r<0?s+r:i+r;if(o===i&&a===s)return e;if(o>=a)return e.clear();for(var u=e._level,c=e._root,h=0;o+h<0;)c=new gt(c&&c.array.length?[void 0,c]:[],n),h+=1<<(u+=m);h&&(o+=h,i+=h,a+=h,s+=h);for(var p=Pt(s),l=Pt(a);l>=1<<u+m;)c=new gt(c&&c.array.length?[c]:[],n),u+=m;var f=e._tail,d=l<p?wt(e,a-1):l>p?new gt([],n):f;if(f&&l>p&&o<s&&f.array.length){for(var g=c=At(c,n),v=u;v>m;v-=m){var _=p>>>v&y;g=g.array[_]=At(g.array[_],n)}g.array[p>>>m&y]=f}if(a<s&&(d=d&&d.removeAfter(n,0,a)),o>=l)o-=l,a-=l,u=m,c=null,d=d&&d.removeBefore(n,0,o);else if(o>i||l<p){for(h=0;c;){var x=o>>>u&y;if(x!==l>>>u&y)break;x&&(h+=(1<<u)*x),u-=m,c=c.array[x]}c&&o>i&&(c=c.removeBefore(n,u,o-h)),c&&l<p&&(c=c.removeAfter(n,u,l-h)),h&&(o-=h,a-=h)}return e.__ownerID?(e.size=a-o,e._origin=o,e._capacity=a,e._level=u,e._root=c,e._tail=d,e.__hash=void 0,e.__altered=!0,e):bt(o,a,u,c,d)}function Nt(e,t,r){for(var n=[],s=0,a=0;a<r.length;a++){var u=r[a],c=i(u);c.size>s&&(s=c.size),o(u)||(c=c.map(function(e){return pe(e)})),n.push(c)}return s>e.size&&(e=e.setSize(s)),ot(e,t,n)}function Pt(e){return e<g?0:e-1>>>m<<m}function $t(e){return null==e?Ot():Ct(e)?e:Ot().withMutations(function(t){var r=n(e);De(r.size),r.forEach(function(e,r){return t.set(r,e)})})}function Ct(e){return Be(e)&&h(e)}function It(e,t,r,n){var i=Object.create($t.prototype);return i.size=e?e.size:0,i._map=e,i._list=t,i.__ownerID=r,i.__hash=n,i}function Ot(){return vt||(vt=It(Qe(),Et()))}function Rt(e,t,r){var n,i,s=e._map,o=e._list,a=s.get(t),u=void 0!==a;if(r===v){if(!u)return e;o.size>=g&&o.size>=2*s.size?(i=o.filter(function(e,t){return void 0!==e&&a!==t}),n=i.toKeyedSeq().map(function(e){return e[0]}).flip().toMap(),e.__ownerID&&(n.__ownerID=i.__ownerID=e.__ownerID)):(n=s.remove(t),i=a===o.size-1?o.pop():o.set(a,void 0))}else if(u){if(r===o.get(a)[1])return e;n=s,i=o.set(a,[t,r])}else n=s.set(t,o.size),i=o.set(o.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=i,e.__hash=void 0,e):It(n,i)}function Tt(e,t){this._iter=e,this._useKeys=t,this.size=e.size}function Mt(e){this._iter=e,this.size=e.size}function Lt(e){this._iter=e,this.size=e.size}function Dt(e){this._iter=e,this.size=e.size}function jt(e){var t=Zt(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=er,t.__iterateUncached=function(t,r){var n=this;return e.__iterate(function(e,r){return!1!==t(r,e,n)},r)},t.__iteratorUncached=function(t,r){if(t===T){var n=e.__iterator(t,r);return new j(function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e})}return e.__iterator(t===R?O:R,r)},t}function Bt(e,t,r){var n=Zt(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,i){var s=e.get(n,v);return s===v?i:t.call(r,s,n,e)},n.__iterateUncached=function(n,i){var s=this;return e.__iterate(function(e,i,o){return!1!==n(t.call(r,e,i,o),i,s)},i)},n.__iteratorUncached=function(n,i){var s=e.__iterator(T,i);return new j(function(){var i=s.next();if(i.done)return i;var o=i.value,a=o[0];return B(n,a,t.call(r,o[1],a,e),i)})},n}function Ut(e,t){var r=Zt(e);return r._iter=e,r.size=e.size,r.reverse=function(){return e},e.flip&&(r.flip=function(){var t=jt(e);return t.reverse=function(){return e.flip()},t}),r.get=function(r,n){return e.get(t?r:-1-r,n)},r.has=function(r){return e.has(t?r:-1-r)},r.includes=function(t){return e.includes(t)},r.cacheResult=er,r.__iterate=function(t,r){var n=this;return e.__iterate(function(e,r){return t(e,r,n)},!r)},r.__iterator=function(t,r){return e.__iterator(t,!r)},r}function Wt(e,t,r,n){var i=Zt(e);return n&&(i.has=function(n){var i=e.get(n,v);return i!==v&&!!t.call(r,i,n,e)},i.get=function(n,i){var s=e.get(n,v);return s!==v&&t.call(r,s,n,e)?s:i}),i.__iterateUncached=function(i,s){var o=this,a=0;return e.__iterate(function(e,s,u){if(t.call(r,e,s,u))return a++,i(e,n?s:a-1,o)},s),a},i.__iteratorUncached=function(i,s){var o=e.__iterator(T,s),a=0;return new j(function(){for(;;){var s=o.next();if(s.done)return s;var u=s.value,c=u[0],h=u[1];if(t.call(r,h,c,e))return B(i,n?c:a++,h,s)}})},i}function Vt(e,t,r,n){var i=e.size;if(void 0!==t&&(t|=0),void 0!==r&&(r===1/0?r=i:r|=0),P(t,r,i))return e;var s=$(t,i),o=C(r,i);if(s!=s||o!=o)return Vt(e.toSeq().cacheResult(),t,r,n);var a,u=o-s;u==u&&(a=u<0?0:u);var c=Zt(e);return c.size=0===a?a:e.size&&a||void 0,!n&&ie(e)&&a>=0&&(c.get=function(t,r){return(t=k(this,t))>=0&&t<a?e.get(t+s,r):r}),c.__iterateUncached=function(t,r){var i=this;if(0===a)return 0;if(r)return this.cacheResult().__iterate(t,r);var o=0,u=!0,c=0;return e.__iterate(function(e,r){if(!u||!(u=o++<s))return c++,!1!==t(e,n?r:c-1,i)&&c!==a}),c},c.__iteratorUncached=function(t,r){if(0!==a&&r)return this.cacheResult().__iterator(t,r);var i=0!==a&&e.__iterator(t,r),o=0,u=0;return new j(function(){for(;o++<s;)i.next();if(++u>a)return{value:void 0,done:!0};var e=i.next();return n||t===R?e:B(t,u-1,t===O?void 0:e.value[1],e)})},c}function Ft(e,t,r,n){var i=Zt(e);return i.__iterateUncached=function(i,s){var o=this;if(s)return this.cacheResult().__iterate(i,s);var a=!0,u=0;return e.__iterate(function(e,s,c){if(!a||!(a=t.call(r,e,s,c)))return u++,i(e,n?s:u-1,o)}),u},i.__iteratorUncached=function(i,s){var o=this;if(s)return this.cacheResult().__iterator(i,s);var a=e.__iterator(T,s),u=!0,c=0;return new j(function(){var e,s,h;do{if((e=a.next()).done)return n||i===R?e:B(i,c++,i===O?void 0:e.value[1],e);var p=e.value;s=p[0],h=p[1],u&&(u=t.call(r,h,s,o))}while(u);return i===T?e:B(i,s,h,e)})},i}function zt(e,t,r){var n=Zt(e);return n.__iterateUncached=function(n,i){var s=0,a=!1;return function e(u,c){var h=this;u.__iterate(function(i,u){return(!t||c<t)&&o(i)?e(i,c+1):!1===n(i,r?u:s++,h)&&(a=!0),!a},i)}(e,0),s},n.__iteratorUncached=function(n,i){var s=e.__iterator(n,i),a=[],u=0;return new j(function(){for(;s;){var e=s.next();if(!1===e.done){var c=e.value;if(n===T&&(c=c[1]),t&&!(a.length<t)||!o(c))return r?e:B(n,u++,c,e);a.push(s),s=c.__iterator(n,i)}else s=a.pop()}return{value:void 0,done:!0}})},n}function qt(e,t,r){t||(t=tr);var n=a(e),i=0,s=e.toSeq().map(function(t,n){return[n,t,i++,r?r(t,n,e):t]}).toArray();return s.sort(function(e,r){return t(e[3],r[3])||e[2]-r[2]}).forEach(n?function(e,t){s[t].length=2}:function(e,t){s[t]=e[1]}),n?G(s):u(e)?H(s):X(s)}function Kt(e,t,r){if(t||(t=tr),r){var n=e.toSeq().map(function(t,n){return[t,r(t,n,e)]}).reduce(function(e,r){return Gt(t,e[1],r[1])?r:e});return n&&n[0]}return e.reduce(function(e,r){return Gt(t,e,r)?r:e})}function Gt(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function Ht(e,t,n){var i=Zt(e);return i.size=new ee(n).map(function(e){return e.size}).min(),i.__iterate=function(e,t){for(var r,n=this.__iterator(R,t),i=0;!(r=n.next()).done&&!1!==e(r.value,i++,this););return i},i.__iteratorUncached=function(e,i){var s=n.map(function(e){return e=r(e),F(i?e.reverse():e)}),o=0,a=!1;return new j(function(){var r;return a||(r=s.map(function(e){return e.next()}),a=r.some(function(e){return e.done})),a?{value:void 0,done:!0}:B(e,o++,t.apply(null,r.map(function(e){return e.value})))})},i}function Xt(e,t){return ie(e)?t:e.constructor(t)}function Yt(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function Jt(e){return De(e.size),w(e)}function Qt(e){return a(e)?n:u(e)?i:s}function Zt(e){return Object.create((a(e)?G:u(e)?H:X).prototype)}function er(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):K.prototype.cacheResult.call(this)}function tr(e,t){return e>t?1:e<t?-1:0}function rr(e){var t=F(e);if(!t){if(!q(e))throw new TypeError("Expected iterable or array-like: "+e);t=F(r(e))}return t}function nr(e,t){var r,n=function(s){if(s instanceof n)return s;if(!(this instanceof n))return new n(s);if(!r){r=!0;var o=Object.keys(e);!function(e,t){try{t.forEach(function(e,t){Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){ye(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}.bind(void 0,e))}catch(e){}}(i,o),i.size=o.length,i._name=t,i._keys=o,i._defaultValues=e}this._map=je(s)},i=n.prototype=Object.create(ir);return i.constructor=n,n}t($t,je),$t.of=function(){return this(arguments)},$t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},$t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},$t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this):Ot()},$t.prototype.set=function(e,t){return Rt(this,e,t)},$t.prototype.remove=function(e){return Rt(this,e,v)},$t.prototype.wasAltered=function(){return this._map.wasAltered()||this._list.wasAltered()},$t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate(function(t){return t&&e(t[1],t[0],r)},t)},$t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},$t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?It(t,r,e,this.__hash):(this.__ownerID=e,this._map=t,this._list=r,this)},$t.isOrderedMap=Ct,$t.prototype[d]=!0,$t.prototype.delete=$t.prototype.remove,t(Tt,G),Tt.prototype.get=function(e,t){return this._iter.get(e,t)},Tt.prototype.has=function(e){return this._iter.has(e)},Tt.prototype.valueSeq=function(){return this._iter.valueSeq()},Tt.prototype.reverse=function(){var e=this,t=Ut(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},Tt.prototype.map=function(e,t){var r=this,n=Bt(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},Tt.prototype.__iterate=function(e,t){var r,n=this;return this._iter.__iterate(this._useKeys?function(t,r){return e(t,r,n)}:(r=t?Jt(this):0,function(i){return e(i,t?--r:r++,n)}),t)},Tt.prototype.__iterator=function(e,t){if(this._useKeys)return this._iter.__iterator(e,t);var r=this._iter.__iterator(R,t),n=t?Jt(this):0;return new j(function(){var i=r.next();return i.done?i:B(e,t?--n:n++,i.value,i)})},Tt.prototype[d]=!0,t(Mt,H),Mt.prototype.includes=function(e){return this._iter.includes(e)},Mt.prototype.__iterate=function(e,t){var r=this,n=0;return this._iter.__iterate(function(t){return e(t,n++,r)},t)},Mt.prototype.__iterator=function(e,t){var r=this._iter.__iterator(R,t),n=0;return new j(function(){var t=r.next();return t.done?t:B(e,n++,t.value,t)})},t(Lt,X),Lt.prototype.has=function(e){return this._iter.includes(e)},Lt.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate(function(t){return e(t,t,r)},t)},Lt.prototype.__iterator=function(e,t){var r=this._iter.__iterator(R,t);return new j(function(){var t=r.next();return t.done?t:B(e,t.value,t.value,t)})},t(Dt,G),Dt.prototype.entrySeq=function(){return this._iter.toSeq()},Dt.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate(function(t){if(t){Yt(t);var n=o(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}},t)},Dt.prototype.__iterator=function(e,t){var r=this._iter.__iterator(R,t);return new j(function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){Yt(n);var i=o(n);return B(e,i?n.get(0):n[0],i?n.get(1):n[1],t)}}})},Mt.prototype.cacheResult=Tt.prototype.cacheResult=Lt.prototype.cacheResult=Dt.prototype.cacheResult=er,t(nr,xe),nr.prototype.toString=function(){return this.__toString(or(this)+" {","}")},nr.prototype.has=function(e){return this._defaultValues.hasOwnProperty(e)},nr.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._defaultValues[e];return this._map?this._map.get(e,r):r},nr.prototype.clear=function(){if(this.__ownerID)return this._map&&this._map.clear(),this;var e=this.constructor;return e._empty||(e._empty=sr(this,Qe()))},nr.prototype.set=function(e,t){if(!this.has(e))throw new Error('Cannot set unknown key "'+e+'" on '+or(this));if(this._map&&!this._map.has(e)){var r=this._defaultValues[e];if(t===r)return this}var n=this._map&&this._map.set(e,t);return this.__ownerID||n===this._map?this:sr(this,n)},nr.prototype.remove=function(e){if(!this.has(e))return this;var t=this._map&&this._map.remove(e);return this.__ownerID||t===this._map?this:sr(this,t)},nr.prototype.wasAltered=function(){return this._map.wasAltered()},nr.prototype.__iterator=function(e,t){var r=this;return n(this._defaultValues).map(function(e,t){return r.get(t)}).__iterator(e,t)},nr.prototype.__iterate=function(e,t){var r=this;return n(this._defaultValues).map(function(e,t){return r.get(t)}).__iterate(e,t)},nr.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map&&this._map.__ensureOwner(e);return e?sr(this,t,e):(this.__ownerID=e,this._map=t,this)};var ir=nr.prototype;function sr(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._map=t,n.__ownerID=r,n}function or(e){return e._name||e.constructor.name||"Record"}function ar(e){return null==e?dr():ur(e)&&!h(e)?e:dr().withMutations(function(t){var r=s(e);De(r.size),r.forEach(function(e){return t.add(e)})})}function ur(e){return!(!e||!e[hr])}ir.delete=ir.remove,ir.deleteIn=ir.removeIn=Ve.removeIn,ir.merge=Ve.merge,ir.mergeWith=Ve.mergeWith,ir.mergeIn=Ve.mergeIn,ir.mergeDeep=Ve.mergeDeep,ir.mergeDeepWith=Ve.mergeDeepWith,ir.mergeDeepIn=Ve.mergeDeepIn,ir.setIn=Ve.setIn,ir.update=Ve.update,ir.updateIn=Ve.updateIn,ir.withMutations=Ve.withMutations,ir.asMutable=Ve.asMutable,ir.asImmutable=Ve.asImmutable,t(ar,Ee),ar.of=function(){return this(arguments)},ar.fromKeys=function(e){return this(n(e).keySeq())},ar.prototype.toString=function(){return this.__toString("Set {","}")},ar.prototype.has=function(e){return this._map.has(e)},ar.prototype.add=function(e){return lr(this,this._map.set(e,!0))},ar.prototype.remove=function(e){return lr(this,this._map.remove(e))},ar.prototype.clear=function(){return lr(this,this._map.clear())},ar.prototype.union=function(){var t=e.call(arguments,0);return 0===(t=t.filter(function(e){return 0!==e.size})).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations(function(e){for(var r=0;r<t.length;r++)s(t[r]).forEach(function(t){return e.add(t)})}):this.constructor(t[0])},ar.prototype.intersect=function(){var t=e.call(arguments,0);if(0===t.length)return this;t=t.map(function(e){return s(e)});var r=this;return this.withMutations(function(e){r.forEach(function(r){t.every(function(e){return e.includes(r)})||e.remove(r)})})},ar.prototype.subtract=function(){var t=e.call(arguments,0);if(0===t.length)return this;t=t.map(function(e){return s(e)});var r=this;return this.withMutations(function(e){r.forEach(function(r){t.some(function(e){return e.includes(r)})&&e.remove(r)})})},ar.prototype.merge=function(){return this.union.apply(this,arguments)},ar.prototype.mergeWith=function(t){var r=e.call(arguments,1);return this.union.apply(this,r)},ar.prototype.sort=function(e){return mr(qt(this,e))},ar.prototype.sortBy=function(e,t){return mr(qt(this,t,e))},ar.prototype.wasAltered=function(){return this._map.wasAltered()},ar.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate(function(t,n){return e(n,n,r)},t)},ar.prototype.__iterator=function(e,t){return this._map.map(function(e,t){return t}).__iterator(e,t)},ar.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):(this.__ownerID=e,this._map=t,this)},ar.isSet=ur;var cr,hr="@@__IMMUTABLE_SET__@@",pr=ar.prototype;function lr(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function fr(e,t){var r=Object.create(pr);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function dr(){return cr||(cr=fr(Qe()))}function mr(e){return null==e?xr():gr(e)?e:xr().withMutations(function(t){var r=s(e);De(r.size),r.forEach(function(e){return t.add(e)})})}function gr(e){return ur(e)&&h(e)}pr[hr]=!0,pr.delete=pr.remove,pr.mergeDeep=pr.merge,pr.mergeDeepWith=pr.mergeWith,pr.withMutations=Ve.withMutations,pr.asMutable=Ve.asMutable,pr.asImmutable=Ve.asImmutable,pr.__empty=dr,pr.__make=fr,t(mr,ar),mr.of=function(){return this(arguments)},mr.fromKeys=function(e){return this(n(e).keySeq())},mr.prototype.toString=function(){return this.__toString("OrderedSet {","}")},mr.isOrderedSet=gr;var yr,vr=mr.prototype;function _r(e,t){var r=Object.create(vr);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function xr(){return yr||(yr=_r(Ot()))}function br(e){return null==e?Nr():Er(e)?e:Nr().unshiftAll(e)}function Er(e){return!(!e||!e[Ar])}vr[d]=!0,vr.__empty=xr,vr.__make=_r,t(br,be),br.of=function(){return this(arguments)},br.prototype.toString=function(){return this.__toString("Stack [","]")},br.prototype.get=function(e,t){var r=this._head;for(e=k(this,e);r&&e--;)r=r.next;return r?r.value:t},br.prototype.peek=function(){return this._head&&this._head.value},br.prototype.push=function(){if(0===arguments.length)return this;for(var e=this.size+arguments.length,t=this._head,r=arguments.length-1;r>=0;r--)t={value:arguments[r],next:t};return this.__ownerID?(this.size=e,this._head=t,this.__hash=void 0,this.__altered=!0,this):kr(e,t)},br.prototype.pushAll=function(e){if(0===(e=i(e)).size)return this;De(e.size);var t=this.size,r=this._head;return e.reverse().forEach(function(e){t++,r={value:e,next:r}}),this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):kr(t,r)},br.prototype.pop=function(){return this.slice(1)},br.prototype.unshift=function(){return this.push.apply(this,arguments)},br.prototype.unshiftAll=function(e){return this.pushAll(e)},br.prototype.shift=function(){return this.pop.apply(this,arguments)},br.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):Nr()},br.prototype.slice=function(e,t){if(P(e,t,this.size))return this;var r=$(e,this.size),n=C(t,this.size);if(n!==this.size)return be.prototype.slice.call(this,e,t);for(var i=this.size-r,s=this._head;r--;)s=s.next;return this.__ownerID?(this.size=i,this._head=s,this.__hash=void 0,this.__altered=!0,this):kr(i,s)},br.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?kr(this.size,this._head,e,this.__hash):(this.__ownerID=e,this.__altered=!1,this)},br.prototype.__iterate=function(e,t){if(t)return this.reverse().__iterate(e);for(var r=0,n=this._head;n&&!1!==e(n.value,r++,this);)n=n.next;return r},br.prototype.__iterator=function(e,t){if(t)return this.reverse().__iterator(e);var r=0,n=this._head;return new j(function(){if(n){var t=n.value;return n=n.next,B(e,r++,t)}return{value:void 0,done:!0}})},br.isStack=Er;var Sr,Ar="@@__IMMUTABLE_STACK__@@",wr=br.prototype;function kr(e,t,r,n){var i=Object.create(wr);return i.size=e,i._head=t,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function Nr(){return Sr||(Sr=kr(0))}function Pr(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}wr[Ar]=!0,wr.withMutations=Ve.withMutations,wr.asMutable=Ve.asMutable,wr.asImmutable=Ve.asImmutable,wr.wasAltered=Ve.wasAltered,r.Iterator=j,Pr(r,{toArray:function(){De(this.size);var e=new Array(this.size||0);return this.valueSeq().__iterate(function(t,r){e[r]=t}),e},toIndexedSeq:function(){return new Mt(this)},toJS:function(){return this.toSeq().map(function(e){return e&&"function"==typeof e.toJS?e.toJS():e}).__toJS()},toJSON:function(){return this.toSeq().map(function(e){return e&&"function"==typeof e.toJSON?e.toJSON():e}).__toJS()},toKeyedSeq:function(){return new Tt(this,!0)},toMap:function(){return je(this.toKeyedSeq())},toObject:function(){De(this.size);var e={};return this.__iterate(function(t,r){e[r]=t}),e},toOrderedMap:function(){return $t(this.toKeyedSeq())},toOrderedSet:function(){return mr(a(this)?this.valueSeq():this)},toSet:function(){return ar(a(this)?this.valueSeq():this)},toSetSeq:function(){return new Lt(this)},toSeq:function(){return u(this)?this.toIndexedSeq():a(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return br(a(this)?this.valueSeq():this)},toList:function(){return lt(a(this)?this.valueSeq():this)},toString:function(){return"[Iterable]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){var t=e.call(arguments,0);return Xt(this,function(e,t){var r=a(e),i=[e].concat(t).map(function(e){return o(e)?r&&(e=n(e)):e=r?oe(e):ae(Array.isArray(e)?e:[e]),e}).filter(function(e){return 0!==e.size});if(0===i.length)return e;if(1===i.length){var s=i[0];if(s===e||r&&a(s)||u(e)&&u(s))return s}var c=new ee(i);return r?c=c.toKeyedSeq():u(e)||(c=c.toSetSeq()),(c=c.flatten(!0)).size=i.reduce(function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}},0),c}(this,t))},includes:function(e){return this.some(function(t){return de(t,e)})},entries:function(){return this.__iterator(T)},every:function(e,t){De(this.size);var r=!0;return this.__iterate(function(n,i,s){if(!e.call(t,n,i,s))return r=!1,!1}),r},filter:function(e,t){return Xt(this,Wt(this,e,t,!0))},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return De(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){De(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate(function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""}),t},keys:function(){return this.__iterator(O)},map:function(e,t){return Xt(this,Bt(this,e,t))},reduce:function(e,t,r){var n,i;return De(this.size),arguments.length<2?i=!0:n=t,this.__iterate(function(t,s,o){i?(i=!1,n=t):n=e.call(r,n,t,s,o)}),n},reduceRight:function(e,t,r){var n=this.toKeyedSeq().reverse();return n.reduce.apply(n,arguments)},reverse:function(){return Xt(this,Ut(this,!0))},slice:function(e,t){return Xt(this,Vt(this,e,t,!0))},some:function(e,t){return!this.every(Rr(e),t)},sort:function(e){return Xt(this,qt(this,e))},values:function(){return this.__iterator(R)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some(function(){return!0})},count:function(e,t){return w(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=je().asMutable();return e.__iterate(function(i,s){n.update(t.call(r,i,s,e),0,function(e){return e+1})}),n.asImmutable()}(this,e,t)},equals:function(e){return me(this,e)},entrySeq:function(){var e=this;if(e._cache)return new ee(e._cache);var t=e.toSeq().map(Or).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(Rr(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate(function(r,i,s){if(e.call(t,r,i,s))return n=[i,r],!1}),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(){return this.find(N)},flatMap:function(e,t){return Xt(this,function(e,t,r){var n=Qt(e);return e.toSeq().map(function(i,s){return n(t.call(r,i,s,e))}).flatten(!0)}(this,e,t))},flatten:function(e){return Xt(this,zt(this,e,!0))},fromEntrySeq:function(){return new Dt(this)},get:function(e,t){return this.find(function(t,r){return de(r,e)},void 0,t)},getIn:function(e,t){for(var r,n=this,i=rr(e);!(r=i.next()).done;){var s=r.value;if((n=n&&n.get?n.get(s,v):v)===v)return t}return n},groupBy:function(e,t){return function(e,t,r){var n=a(e),i=(h(e)?$t():je()).asMutable();e.__iterate(function(s,o){i.update(t.call(r,s,o,e),function(e){return(e=e||[]).push(n?[o,s]:s),e})});var s=Qt(e);return i.map(function(t){return Xt(e,s(t))})}(this,e,t)},has:function(e){return this.get(e,v)!==v},hasIn:function(e){return this.getIn(e,v)!==v},isSubset:function(e){return e="function"==typeof e.includes?e:r(e),this.every(function(t){return e.includes(t)})},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:r(e)).isSubset(this)},keyOf:function(e){return this.findKey(function(t){return de(t,e)})},keySeq:function(){return this.toSeq().map(Ir).toIndexedSeq()},last:function(){return this.toSeq().reverse().first()},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return Kt(this,e)},maxBy:function(e,t){return Kt(this,t,e)},min:function(e){return Kt(this,e?Tr(e):Dr)},minBy:function(e,t){return Kt(this,t?Tr(t):Dr,e)},rest:function(){return this.slice(1)},skip:function(e){return this.slice(Math.max(0,e))},skipLast:function(e){return Xt(this,this.toSeq().reverse().skip(e).reverse())},skipWhile:function(e,t){return Xt(this,Ft(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(Rr(e),t)},sortBy:function(e,t){return Xt(this,qt(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return Xt(this,this.toSeq().reverse().take(e).reverse())},takeWhile:function(e,t){return Xt(this,function(e,t,r){var n=Zt(e);return n.__iterateUncached=function(n,i){var s=this;if(i)return this.cacheResult().__iterate(n,i);var o=0;return e.__iterate(function(e,i,a){return t.call(r,e,i,a)&&++o&&n(e,i,s)}),o},n.__iteratorUncached=function(n,i){var s=this;if(i)return this.cacheResult().__iterator(n,i);var o=e.__iterator(T,i),a=!0;return new j(function(){if(!a)return{value:void 0,done:!0};var e=o.next();if(e.done)return e;var i=e.value,u=i[0],c=i[1];return t.call(r,c,u,s)?n===T?e:B(n,u,c,e):(a=!1,{value:void 0,done:!0})})},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(Rr(e),t)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=h(e),r=a(e),n=t?1:0;return function(e,t){return t=Se(t,3432918353),t=Se(t<<15|t>>>-15,461845907),t=Se(t<<13|t>>>-13,5),t=Se((t=(t+3864292196|0)^e)^t>>>16,2246822507),t=Ae((t=Se(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+jr(we(e),we(t))|0}:function(e,t){n=n+jr(we(e),we(t))|0}:t?function(e){n=31*n+we(e)|0}:function(e){n=n+we(e)|0}),n)}(this))}});var $r=r.prototype;$r[p]=!0,$r[D]=$r.values,$r.__toJS=$r.toArray,$r.__toStringMapper=Mr,$r.inspect=$r.toSource=function(){return this.toString()},$r.chain=$r.flatMap,$r.contains=$r.includes,Pr(n,{flip:function(){return Xt(this,jt(this))},mapEntries:function(e,t){var r=this,n=0;return Xt(this,this.toSeq().map(function(i,s){return e.call(t,[s,i],n++,r)}).fromEntrySeq())},mapKeys:function(e,t){var r=this;return Xt(this,this.toSeq().flip().map(function(n,i){return e.call(t,n,i,r)}).flip())}});var Cr=n.prototype;function Ir(e,t){return t}function Or(e,t){return[t,e]}function Rr(e){return function(){return!e.apply(this,arguments)}}function Tr(e){return function(){return-e.apply(this,arguments)}}function Mr(e){return"string"==typeof e?JSON.stringify(e):String(e)}function Lr(){return A(arguments)}function Dr(e,t){return e<t?1:e>t?-1:0}function jr(e,t){return e^t+2654435769+(e<<6)+(e>>2)|0}return Cr[l]=!0,Cr[D]=$r.entries,Cr.__toJS=$r.toObject,Cr.__toStringMapper=function(e,t){return JSON.stringify(t)+": "+Mr(e)},Pr(i,{toKeyedSeq:function(){return new Tt(this,!1)},filter:function(e,t){return Xt(this,Wt(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return Xt(this,Ut(this,!1))},slice:function(e,t){return Xt(this,Vt(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(0|t,0),0===r||2===r&&!t)return this;e=$(e,e<0?this.count():this.size);var n=this.slice(0,e);return Xt(this,1===r?n:n.concat(A(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(){return this.get(0)},flatten:function(e){return Xt(this,zt(this,e,!1))},get:function(e,t){return(e=k(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find(function(t,r){return r===e},void 0,t)},has:function(e){return(e=k(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return Xt(this,function(e,t){var r=Zt(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var i=this,s=0;return e.__iterate(function(e,n){return(!s||!1!==r(t,s++,i))&&!1!==r(e,s++,i)},n),s},r.__iteratorUncached=function(r,n){var i,s=e.__iterator(R,n),o=0;return new j(function(){return(!i||o%2)&&(i=s.next()).done?i:o%2?B(r,o++,t):B(r,o++,i.value,i)})},r}(this,e))},interleave:function(){var e=[this].concat(A(arguments)),t=Ht(this.toSeq(),H.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),Xt(this,r)},keySeq:function(){return ve(0,this.size)},last:function(){return this.get(-1)},skipWhile:function(e,t){return Xt(this,Ft(this,e,t,!1))},zip:function(){return Xt(this,Ht(this,Lr,[this].concat(A(arguments))))},zipWith:function(e){var t=A(arguments);return t[0]=this,Xt(this,Ht(this,e,t))}}),i.prototype[f]=!0,i.prototype[d]=!0,Pr(s,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}}),s.prototype.has=$r.includes,s.prototype.contains=s.prototype.includes,Pr(G,n.prototype),Pr(H,i.prototype),Pr(X,s.prototype),Pr(xe,n.prototype),Pr(be,i.prototype),Pr(Ee,s.prototype),{Iterable:r,Seq:K,Collection:_e,Map:je,OrderedMap:$t,List:lt,Stack:br,Set:ar,OrderedSet:mr,Record:nr,Range:ve,Repeat:ge,is:de,fromJS:pe}}()});!function(e){e[e.IGNORED_LABELS=0]="IGNORED_LABELS",e[e.ACCESSED_NODES=1]="ACCESSED_NODES",e[e.ARGUMENTS_VARIABLES=2]="ARGUMENTS_VARIABLES",e[e.ASSIGNED_NODES=3]="ASSIGNED_NODES",e[e.IGNORE_BREAK_STATEMENTS=4]="IGNORE_BREAK_STATEMENTS",e[e.IGNORE_RETURN_AWAIT_YIELD=5]="IGNORE_RETURN_AWAIT_YIELD",e[e.NODES_CALLED_AT_PATH_WITH_OPTIONS=6]="NODES_CALLED_AT_PATH_WITH_OPTIONS",e[e.REPLACED_VARIABLE_INITS=7]="REPLACED_VARIABLE_INITS",e[e.RETURN_EXPRESSIONS_ACCESSED_AT_PATH=8]="RETURN_EXPRESSIONS_ACCESSED_AT_PATH",e[e.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH=9]="RETURN_EXPRESSIONS_ASSIGNED_AT_PATH",e[e.RETURN_EXPRESSIONS_CALLED_AT_PATH=10]="RETURN_EXPRESSIONS_CALLED_AT_PATH"}(OptionTypes||(OptionTypes={}));var RESULT_KEY={},ExecutionPathOptions=function(){function e(e){this.optionValues=e}return e.create=function(){return new this(immutable.Map())},e.prototype.get=function(e){return this.optionValues.get(e)},e.prototype.remove=function(t){return new e(this.optionValues.remove(t))},e.prototype.set=function(t,r){return new e(this.optionValues.set(t,r))},e.prototype.setIn=function(t,r){return new e(this.optionValues.setIn(t,r))},e.prototype.addAccessedNodeAtPath=function(e,t){return this.setIn([OptionTypes.ACCESSED_NODES,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAccessedReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_ACCESSED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAssignedNodeAtPath=function(e,t){return this.setIn([OptionTypes.ASSIGNED_NODES,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAssignedReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addCalledNodeAtPathWithOptions=function(e,t,r){return this.setIn([OptionTypes.NODES_CALLED_AT_PATH_WITH_OPTIONS,t].concat(e,[RESULT_KEY,r]),!0)},e.prototype.addCalledReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_CALLED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.getArgumentsVariables=function(){return this.get(OptionTypes.ARGUMENTS_VARIABLES)||[]},e.prototype.getHasEffectsWhenCalledOptions=function(){return this.setIgnoreReturnAwaitYield().setIgnoreBreakStatements(!1).setIgnoreNoLabels()},e.prototype.getReplacedVariableInit=function(e){return this.optionValues.getIn([OptionTypes.REPLACED_VARIABLE_INITS,e])},e.prototype.hasNodeBeenAccessedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.ACCESSED_NODES,t].concat(e,[RESULT_KEY]))},e.prototype.hasNodeBeenAssignedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.ASSIGNED_NODES,t].concat(e,[RESULT_KEY]))},e.prototype.hasNodeBeenCalledAtPathWithOptions=function(e,t,r){var n=this.optionValues.getIn([OptionTypes.NODES_CALLED_AT_PATH_WITH_OPTIONS,t].concat(e,[RESULT_KEY]));return n&&n.find(function(e,t){return t.equals(r)})},e.prototype.hasReturnExpressionBeenAccessedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_ACCESSED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.hasReturnExpressionBeenAssignedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.hasReturnExpressionBeenCalledAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_CALLED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.ignoreBreakStatements=function(){return this.get(OptionTypes.IGNORE_BREAK_STATEMENTS)},e.prototype.ignoreLabel=function(e){return this.optionValues.getIn([OptionTypes.IGNORED_LABELS,e])},e.prototype.ignoreReturnAwaitYield=function(){return this.get(OptionTypes.IGNORE_RETURN_AWAIT_YIELD)},e.prototype.replaceVariableInit=function(e,t){return this.setIn([OptionTypes.REPLACED_VARIABLE_INITS,e],t)},e.prototype.setArgumentsVariables=function(e){return this.set(OptionTypes.ARGUMENTS_VARIABLES,e)},e.prototype.setIgnoreBreakStatements=function(e){return void 0===e&&(e=!0),this.set(OptionTypes.IGNORE_BREAK_STATEMENTS,e)},e.prototype.setIgnoreLabel=function(e){return this.setIn([OptionTypes.IGNORED_LABELS,e],!0)},e.prototype.setIgnoreNoLabels=function(){return this.remove(OptionTypes.IGNORED_LABELS)},e.prototype.setIgnoreReturnAwaitYield=function(e){return void 0===e&&(e=!0),this.set(OptionTypes.IGNORE_RETURN_AWAIT_YIELD,e)},e}(),keys={Program:["body"],Literal:[]};function getAndCreateKeys(e){return keys[e.type]=Object.keys(e).filter(function(t){return"object"==typeof e[t]}),keys[e.type]}var NEW_EXECUTION_PATH=ExecutionPathOptions.create(),NodeBase=function(){function e(e,t,r){this.keys=keys[e.type]||getAndCreateKeys(e),this.parent=t,this.context=t.context,this.createScope(r),this.parseNode(e),this.initialise(),this.context.magicString.addSourcemapLocation(this.start),this.context.magicString.addSourcemapLocation(this.end)}return e.prototype.bind=function(){for(var e=0,t=this.keys;e<t.length;e++){var r=this[t[e]];if(null!==r)if(Array.isArray(r))for(var n=0,i=r;n<i.length;n++){var s=i[n];null!==s&&s.bind()}else r.bind()}},e.prototype.createScope=function(e){this.scope=e},e.prototype.declare=function(e,t){},e.prototype.getLiteralValueAtPath=function(e,t,r){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return UNKNOWN_EXPRESSION},e.prototype.hasEffects=function(e){for(var t=0,r=this.keys;t<r.length;t++){var n=this[r[t]];if(null!==n)if(Array.isArray(n))for(var i=0,s=n;i<s.length;i++){var o=s[i];if(null!==o&&o.hasEffects(e))return!0}else if(n.hasEffects(e))return!0}return!1},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!0},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!0},e.prototype.include=function(){this.included=!0;for(var e=0,t=this.keys;e<t.length;e++){var r=this[t[e]];if(null!==r)if(Array.isArray(r))for(var n=0,i=r;n<i.length;n++){var s=i[n];null!==s&&s.include()}else r.include()}},e.prototype.includeWithAllDeclaredVariables=function(){this.include()},e.prototype.initialise=function(){this.included=!1},e.prototype.insertSemicolon=function(e){";"!==e.original[this.end-1]&&e.appendLeft(this.end,";")},e.prototype.locate=function(){var e=locate(this.context.code,this.start,{offsetLine:1});return e.file=this.context.fileName,e.toString=function(){return JSON.stringify(e)},e},e.prototype.parseNode=function(e){for(var t=0,r=Object.keys(e);t<r.length;t++){var n=r[t];if(!this.hasOwnProperty(n)){var i=e[n];if("object"!=typeof i||null===i)this[n]=i;else if(Array.isArray(i)){this[n]=[];for(var s=0,o=i;s<o.length;s++){var a=o[s];this[n].push(null===a?null:new(this.context.nodeConstructors[a.type]||this.context.nodeConstructors.UnknownNode)(a,this,this.scope))}}else this[n]=new(this.context.nodeConstructors[i.type]||this.context.nodeConstructors.UnknownNode)(i,this,this.scope)}}},e.prototype.deoptimizePath=function(e){},e.prototype.render=function(e,t){for(var r=0,n=this.keys;r<n.length;r++){var i=this[n[r]];if(null!==i)if(Array.isArray(i))for(var s=0,o=i;s<o.length;s++){var a=o[s];null!==a&&a.render(e,t)}else i.render(e,t)}},e.prototype.shouldBeIncluded=function(){return this.included||this.hasEffects(NEW_EXECUTION_PATH)},e.prototype.toString=function(){return this.context.code.slice(this.start,this.end)},e}(),ClassNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new Scope(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return this.body.hasEffectsWhenCalledAtPath(e,t,r)||this.superClass&&this.superClass.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.initialise=function(){this.included=!1,null!==this.id&&this.id.declare("class",this)},t}(NodeBase);function isClassDeclaration(e){return e.type===ClassDeclaration}var ClassDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){e.prototype.initialise.call(this),null!==this.id&&(this.id.variable.isId=!0)},t.prototype.parseNode=function(t){null!==t.id&&(this.id=new this.context.nodeConstructors.Identifier(t.id,this,this.scope.parent)),e.prototype.parseNode.call(this,t)},t.prototype.render=function(t,r){"system"===r.format&&this.id&&this.id.variable.exportName&&t.appendLeft(this.end," exports('"+this.id.variable.exportName+"', "+this.id.variable.getName()+");"),e.prototype.render.call(this,t,r)},t}(ClassNode),getParameterVariable=function(e,t){var r=parseInt(e[0],10);return r<t.getArgumentsVariables().length&&t.getArgumentsVariables()[r]||UNKNOWN_EXPRESSION},ArgumentsVariable=function(e){function t(t,r){var n=e.call(this,"arguments",null,UNKNOWN_EXPRESSION,r)||this;return n.parameters=t,n}return __extends$1(t,e),t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1&&getParameterVariable(e,t).hasEffectsWhenAccessedAtPath(e.slice(1),t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||this.included||getParameterVariable(e,t).hasEffectsWhenAssignedAtPath(e.slice(1),t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 0===e.length||getParameterVariable(e,r).hasEffectsWhenCalledAtPath(e.slice(1),t,r)},t.prototype.deoptimizePath=function(e){var t=parseInt(e[0],10);e.length>0&&t>=0&&this.parameters[t]&&this.parameters[t].deoptimizePath(e.slice(1))},t}(LocalVariable),ReplaceableInitializationVariable=function(e){function t(t,r,n){return e.call(this,t,r,null,n)||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},t.prototype.hasEffectsWhenAccessedAtPath=function(t,r){return this._getInit(r).hasEffectsWhenAccessedAtPath(t,r)||e.prototype.hasEffectsWhenAccessedAtPath.call(this,t,r)},t.prototype.hasEffectsWhenAssignedAtPath=function(t,r){return this._getInit(r).hasEffectsWhenAssignedAtPath(t,r)||e.prototype.hasEffectsWhenAssignedAtPath.call(this,t,r)},t.prototype.hasEffectsWhenCalledAtPath=function(t,r,n){return this._getInit(n).hasEffectsWhenCalledAtPath(t,r,n)||e.prototype.hasEffectsWhenCalledAtPath.call(this,t,r,n)},t.prototype._getInit=function(e){return e.getReplacedVariableInit(this)||UNKNOWN_EXPRESSION},t}(LocalVariable),ThisVariable=function(e){function t(t){return e.call(this,"this",null,t)||this}return __extends$1(t,e),t}(ReplaceableInitializationVariable),ParameterVariable=function(e){function t(t,r){return e.call(this,t.name,t,r)||this}return __extends$1(t,e),t}(ReplaceableInitializationVariable),ParameterScope=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.parameters=[],t}return __extends$1(t,e),t.prototype.addParameterDeclaration=function(e,t){var r=new ParameterVariable(e,t);return this.variables[e.name]=r,this.parameters.push(r),r},t.prototype.getParameterVariables=function(){return this.parameters},t}(Scope),ReturnValueScope=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.returnExpressions=[],t.returnExpression=null,t}return __extends$1(t,e),t.prototype.addReturnExpression=function(e){this.returnExpressions.push(e)},t.prototype.getReturnExpression=function(){return null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression},t.prototype.updateReturnExpression=function(){if(1===this.returnExpressions.length)this.returnExpression=this.returnExpressions[0];else{this.returnExpression=UNKNOWN_EXPRESSION;for(var e=0,t=this.returnExpressions;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}}},t}(ParameterScope),FunctionScope=function(e){function t(t,r){var n=e.call(this,t)||this;return n.variables.arguments=new ArgumentsVariable(e.prototype.getParameterVariables.call(n),r),n.variables.this=new ThisVariable(r),n}return __extends$1(t,e),t.prototype.findLexicalBoundary=function(){return this},t.prototype.getOptionsWhenCalledWith=function(t,r){var n=this,i=t.args,s=t.withNew;return r.replaceVariableInit(this.variables.this,s?new UnknownObjectExpression:UNKNOWN_EXPRESSION).setArgumentsVariables(i.map(function(t,r){return e.prototype.getParameterVariables.call(n)[r]||t}))},t}(ReturnValueScope),FunctionNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new FunctionScope(e,this.context.deoptimizationTracker)},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 0===e.length?this.scope.getReturnExpression():UNKNOWN_EXPRESSION},t.prototype.hasEffects=function(e){return this.id&&this.id.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return!(e.length<=1)&&(e.length>2||"prototype"!==e[0]||this.isPrototypeDeoptimized)},t.prototype.hasEffectsWhenAssignedAtPath=function(e){return!(e.length<=1)&&(e.length>2||"prototype"!==e[0]||this.isPrototypeDeoptimized)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){if(e.length>0)return!0;for(var n=this.scope.getOptionsWhenCalledWith(t,r),i=0,s=this.params;i<s.length;i++){if(s[i].hasEffects(n))return!0}return this.body.hasEffects(n)},t.prototype.include=function(){this.scope.variables.arguments.include(),e.prototype.include.call(this)},t.prototype.initialise=function(){this.included=!1,this.isPrototypeDeoptimized=!1,null!==this.id&&this.id.declare("function",this);for(var e=0,t=this.params;e<t.length;e++){t[e].declare("parameter",UNKNOWN_EXPRESSION)}this.body.addImplicitReturnExpressionToScope()},t.prototype.parseNode=function(t){this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,new Scope(this.scope)),e.prototype.parseNode.call(this,t)},t.prototype.deoptimizePath=function(e){1===e.length&&("prototype"===e[0]?this.isPrototypeDeoptimized=!0:e[0]===UNKNOWN_KEY&&(this.isPrototypeDeoptimized=!0,this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH)))},t}(NodeBase);function isFunctionDeclaration(e){return e.type===FunctionDeclaration}FunctionNode.prototype.preventChildBlockScope=!0;var FunctionDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){e.prototype.initialise.call(this),null!==this.id&&(this.id.variable.isId=!0)},t.prototype.parseNode=function(t){null!==t.id&&(this.id=new this.context.nodeConstructors.Identifier(t.id,this,this.scope.parent)),e.prototype.parseNode.call(this,t)},t}(FunctionNode);function isReference(e,t){return"MemberExpression"===e.type?!e.computed&&isReference(e.object,e):"Identifier"===e.type&&(!t||("MemberExpression"===t.type||"MethodDefinition"===t.type?t.computed||e===t.object:"Property"===t.type?t.computed||e===t.value:"ExportSpecifier"!==t.type||e===t.local))}function isIdentifier(e){return e.type===Identifier}var Identifier$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){this.bound||(this.bound=!0,null===this.variable&&isReference(this,this.parent)&&(this.variable=this.scope.findVariable(this.name),this.variable.addReference(this)),null!==this.variable&&this.variable.isLocal&&null!==this.variable.additionalInitializers&&this.variable.consolidateInitializers())},t.prototype.declare=function(e,t){switch(e){case"var":case"function":this.variable=this.scope.addDeclaration(this,this.context.deoptimizationTracker,t,!0);break;case"let":case"const":case"class":this.variable=this.scope.addDeclaration(this,this.context.deoptimizationTracker,t,!1);break;case"parameter":this.variable=this.scope.addParameterDeclaration(this,this.context.deoptimizationTracker);break;default:throw new Error("Unexpected identifier kind "+e+".")}},t.prototype.getLiteralValueAtPath=function(e,t,r){return null!==this.variable?this.variable.getLiteralValueAtPath(e,t,r):UNKNOWN_VALUE},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.getReturnExpressionWhenCalledAtPath(e,t,r):UNKNOWN_EXPRESSION},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return this.variable&&this.variable.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!this.variable||this.variable.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!this.variable||this.variable.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(){this.included||(this.included=!0,null===this.variable||this.variable.included||(this.variable.include(),this.context.requestTreeshakingPass()))},t.prototype.initialise=function(){this.included=!1,this.bound=!1,this.variable||(this.variable=null)},t.prototype.deoptimizePath=function(e){this.bound||this.bind(),null!==this.variable&&(0===e.length&&this.name in this.context.imports&&!this.scope.contains(this.name)&&this.disallowImportReassignment(),this.variable.deoptimizePath(e))},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.renderedParentType,s=n.isCalleeOfRenderedParent;if(this.variable){var o=this.variable.getName();if(o!==this.name){e.overwrite(this.start,this.end,o,{storeName:!0,contentOnly:!0});var a=this.parent;a.type===AssignmentPattern&&(a=a.parent),a.type===Property&&a.shorthand&&e.prependRight(this.start,this.name+": ")}"eval"===o&&i===CallExpression&&s&&e.appendRight(this.start,"0, ")}},t.prototype.disallowImportReassignment=function(){this.context.error({code:"ILLEGAL_REASSIGNMENT",message:"Illegal reassignment to import '"+this.name+"'"},this.start)},t}(NodeBase),WHITESPACE=/\s/;function getDeclarationStart(e,t){for(void 0===t&&(t=0),t=findFirstOccurrenceOutsideComment(e,"default",t)+7;WHITESPACE.test(e[t]);)t++;return t}function getIdInsertPosition(e,t,r){void 0===r&&(r=0);var n=findFirstOccurrenceOutsideComment(e,t,r)+t.length;e=e.slice(n,findFirstOccurrenceOutsideComment(e,"{",n));var i=findFirstOccurrenceOutsideComment(e,"*");return-1===i?n:n+i+1}function isExportDefaultDeclaration(e){return e.type===ExportDefaultDeclaration}var ExportDefaultDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.declarationName&&(isFunctionDeclaration(this.declaration)||isClassDeclaration(this.declaration)||isIdentifier(this.declaration))&&this.variable.setOriginalVariable(this.scope.findVariable(this.declarationName))},t.prototype.initialise=function(){this.included=!1,this.declarationName=this.declaration.id&&this.declaration.id.name||this.declaration.name,this.variable=this.scope.addExportDefaultDeclaration(this.declarationName||this.context.getModuleName(),this,this.context.deoptimizationTracker),this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end,o=getDeclarationStart(e.original,this.start);if(isFunctionDeclaration(this.declaration))this.renderNamedDeclaration(e,o,"function",null===this.declaration.id,t);else if(isClassDeclaration(this.declaration))this.renderNamedDeclaration(e,o,"class",null===this.declaration.id,t);else{if(this.variable.referencesOriginal())return void("system"===t.format&&this.variable.exportName?e.overwrite(i,s,"exports('"+this.variable.exportName+"', "+this.variable.getName()+");"):e.remove(i,s));if(!this.variable.included)return e.remove(this.start,o),this.declaration.render(e,t,{renderedParentType:ExpressionStatement,isCalleeOfRenderedParent:!1}),void(";"!==e.original[this.end-1]&&e.appendLeft(this.end,";"));this.renderVariableDeclaration(e,o,t)}this.declaration.render(e,t)},t.prototype.renderNamedDeclaration=function(e,t,r,n,i){var s=this.variable.getName();e.remove(this.start,t),n&&e.appendLeft(getIdInsertPosition(e.original,r,t)," "+s),"system"===i.format&&isClassDeclaration(this.declaration)&&this.variable.exportName&&e.appendLeft(this.end," exports('"+this.variable.exportName+"', "+s+");")},t.prototype.renderVariableDeclaration=function(e,t,r){var n="system"===r.format&&this.variable.exportName?"exports('"+this.variable.exportName+"', ":"";e.overwrite(this.start,t,this.context.varOrConst+" "+this.variable.getName()+" = "+n);var i=59===e.original.charCodeAt(this.end-1);n?e.appendRight(i?this.end-1:this.end,")"+(i?"":";")):i||e.appendLeft(this.end,";")},t}(NodeBase);ExportDefaultDeclaration$1.prototype.needsBoundaries=!0;var ArrayExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this);for(var t=0,r=this.elements;t<r.length;t++){var n=r[t];null!==n&&n.deoptimizePath(UNKNOWN_PATH)}},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1!==e.length?UNKNOWN_EXPRESSION:getMemberReturnExpressionWhenCalled(arrayMembers,e[0])},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(arrayMembers,e[0],this.included,t,r)},t}(NodeBase),ArrayPattern$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.declare=function(e,t){for(var r=0,n=this.elements;r<n.length;r++){var i=n[r];null!==i&&i.declare(e,UNKNOWN_EXPRESSION)}},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(e.length>0)return!0;for(var r=0,n=this.elements;r<n.length;r++){var i=n[r];if(null!==i&&i.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t))return!0}return!1},t.prototype.deoptimizePath=function(e){if(0===e.length)for(var t=0,r=this.elements;t<r.length;t++){var n=r[t];null!==n&&n.deoptimizePath(e)}},t}(NodeBase),BlockScope=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.addDeclaration=function(t,r,n,i){return void 0===n&&(n=null),void 0===i&&(i=!1),i?this.parent.addDeclaration(t,r,n,!0):e.prototype.addDeclaration.call(this,t,r,n,!1)},t}(Scope),BlockStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.addImplicitReturnExpressionToScope=function(){var e=this.body[this.body.length-1];e&&e.type===ReturnStatement||this.scope.addReturnExpression(UNKNOWN_EXPRESSION)},t.prototype.createScope=function(e){this.scope=this.parent.preventChildBlockScope?e:new BlockScope(e)},t.prototype.hasEffects=function(e){for(var t=0,r=this.body;t<r.length;t++){if(r[t].hasEffects(e))return!0}},t.prototype.include=function(){this.included=!0;for(var e=0,t=this.body;e<t.length;e++){var r=t[e];r.shouldBeIncluded()&&r.include()}},t.prototype.render=function(t,r){this.body.length?renderStatementList(this.body,t,this.start+1,this.end-1,r):e.prototype.render.call(this,t,r)},t}(NodeBase),ArrowFunctionExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new ReturnValueScope(e)},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 0===e.length?this.scope.getReturnExpression():UNKNOWN_EXPRESSION},t.prototype.hasEffects=function(e){return!1},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){if(e.length>0)return!0;for(var n=0,i=this.params;n<i.length;n++){if(i[n].hasEffects(r))return!0}return this.body.hasEffects(r)},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.params;e<t.length;e++){t[e].declare("parameter",UNKNOWN_EXPRESSION)}this.body instanceof BlockStatement$1?this.body.addImplicitReturnExpressionToScope():this.scope.addReturnExpression(this.body)},t.prototype.parseNode=function(t){t.body.type===BlockStatement&&(this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,new Scope(this.scope))),e.prototype.parseNode.call(this,t)},t.prototype.deoptimizePath=function(e){1===e.length&&e[0]===UNKNOWN_KEY&&this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH)},t}(NodeBase);ArrowFunctionExpression$1.prototype.preventChildBlockScope=!0;var AssignmentExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.left.deoptimizePath(EMPTY_PATH),this.right.deoptimizePath(UNKNOWN_PATH)},t.prototype.hasEffects=function(e){return this.right.hasEffects(e)||this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.right.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.render=function(e,t){this.left.render(e,t),this.right.render(e,t),"system"===t.format&&this.left.variable&&this.left.variable.exportName&&(e.prependLeft(e.original.indexOf("=",this.left.end)+1," exports('"+this.left.variable.exportName+"',"),e.prependRight(this.right.end,")"))},t}(NodeBase),AssignmentPattern$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.left.deoptimizePath(EMPTY_PATH),this.right.deoptimizePath(UNKNOWN_PATH)},t.prototype.declare=function(e,t){this.left.declare(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>0||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t)},t.prototype.deoptimizePath=function(e){0===e.length&&this.left.deoptimizePath(e)},t}(NodeBase),AwaitExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.include=function(){if(e.prototype.include.call(this),!this.context.usesTopLevelAwait){var t=this.parent;do{if(t instanceof FunctionNode||t instanceof ArrowFunctionExpression$1)return}while(t=t.parent);this.context.usesTopLevelAwait=!0}},t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||!t.ignoreReturnAwaitYield()},t.prototype.render=function(t,r){e.prototype.render.call(this,t,r)},t}(NodeBase),binaryOperators={"==":function(e,t){return e==t},"!=":function(e,t){return e!=t},"===":function(e,t){return e===t},"!==":function(e,t){return e!==t},"<":function(e,t){return e<t},"<=":function(e,t){return e<=t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},"<<":function(e,t){return e<<t},">>":function(e,t){return e>>t},">>>":function(e,t){return e>>>t},"+":function(e,t){return e+t},"-":function(e,t){return e-t},"*":function(e,t){return e*t},"/":function(e,t){return e/t},"%":function(e,t){return e%t},"|":function(e,t){return e|t},"^":function(e,t){return e^t},"&":function(e,t){return e&t},"**":function(e,t){return Math.pow(e,t)},in:function(){return UNKNOWN_VALUE},instanceof:function(){return UNKNOWN_VALUE}},BinaryExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(e,t,r){if(e.length>0)return UNKNOWN_VALUE;var n=this.left.getLiteralValueAtPath(EMPTY_PATH,t,r);if(n===UNKNOWN_VALUE)return UNKNOWN_VALUE;var i=this.right.getLiteralValueAtPath(EMPTY_PATH,t,r);if(i===UNKNOWN_VALUE)return UNKNOWN_VALUE;var s=binaryOperators[this.operator];return s?s(n,i):UNKNOWN_VALUE},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t}(NodeBase),BreakStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||!t.ignoreBreakStatements()||this.label&&!t.ignoreLabel(this.label.name)},t}(NodeBase),RESULT_KEY$1={},ImmutableEntityPathTracker=function(){function e(e){void 0===e&&(e=immutable.Map()),this.entityPaths=e}return e.prototype.isTracked=function(e,t){return this.entityPaths.getIn([e].concat(t,[RESULT_KEY$1]))},e.prototype.track=function(t,r){return new e(this.entityPaths.setIn([t].concat(r,[RESULT_KEY$1]),!0))},e}(),EMPTY_IMMUTABLE_TRACKER=new ImmutableEntityPathTracker,CallExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.callee instanceof Identifier$1)&&(this.scope.findVariable(this.callee.name).isNamespace&&this.context.error({code:"CANNOT_CALL_NAMESPACE",message:"Cannot call a namespace ('"+this.callee.name+"')"},this.start),"eval"===this.callee.name&&this.context.warn({code:"EVAL",message:"Use of eval is strongly discouraged, as it poses security risks and may cause issues with minification",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#avoiding-eval"},this.start));null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this));for(var t=0,r=this.arguments;t<r.length;t++){r[t].deoptimizePath(UNKNOWN_PATH)}},t.prototype.deoptimizeCache=function(){if(this.returnExpression!==UNKNOWN_EXPRESSION){this.returnExpression=UNKNOWN_EXPRESSION;for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.getLiteralValueAtPath=function(e,t,r){return null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,t,this)),this.returnExpression===UNKNOWN_EXPRESSION||t.isTracked(this.returnExpression,e)?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.returnExpression.getLiteralValueAtPath(e,t.track(this.returnExpression,e),r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,t,this)),this.returnExpression===UNKNOWN_EXPRESSION||t.isTracked(this.returnExpression,e)?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized.push(r),this.returnExpression.getReturnExpressionWhenCalledAtPath(e,t.track(this.returnExpression,e),r))},t.prototype.hasEffects=function(e){for(var t=0,r=this.arguments;t<r.length;t++){if(r[t].hasEffects(e))return!0}return this.callee.hasEffects(e)||this.callee.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,e.getHasEffectsWhenCalledOptions())},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&!t.hasReturnExpressionBeenAccessedAtPath(e,this)&&this.returnExpression.hasEffectsWhenAccessedAtPath(e,t.addAccessedReturnExpressionAtPath(e,this))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||!t.hasReturnExpressionBeenAssignedAtPath(e,this)&&this.returnExpression.hasEffectsWhenAssignedAtPath(e,t.addAssignedReturnExpressionAtPath(e,this))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){if(r.hasReturnExpressionBeenCalledAtPath(e,this))return!1;var n=r.addCalledReturnExpressionAtPath(e,this);return this.hasEffects(n)||this.returnExpression.hasEffectsWhenCalledAtPath(e,t,n)},t.prototype.include=function(){e.prototype.include.call(this),this.returnExpression.included||this.returnExpression.include()},t.prototype.initialise=function(){this.included=!1,this.returnExpression=null,this.callOptions=CallOptions.create({withNew:!1,args:this.arguments,callIdentifier:this}),this.expressionsToBeDeoptimized=[]},t.prototype.deoptimizePath=function(e){e.length>0&&!this.context.deoptimizationTracker.track(this,e)&&(null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this)),this.returnExpression.deoptimizePath(e))},t}(NodeBase),CatchScope=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.addDeclaration=function(t,r,n,i){return void 0===n&&(n=null),void 0===i&&(i=!1),i?this.parent.addDeclaration(t,r,n,!0):e.prototype.addDeclaration.call(this,t,r,n,!1)},t}(ParameterScope),CatchClause$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new CatchScope(e)},t.prototype.initialise=function(){this.included=!1,this.param.declare("parameter",UNKNOWN_EXPRESSION)},t.prototype.parseNode=function(t){this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,this.scope),e.prototype.parseNode.call(this,t)},t}(NodeBase);CatchClause$1.prototype.preventChildBlockScope=!0;var ClassBody$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>0||null!==this.classConstructor&&this.classConstructor.hasEffectsWhenCalledAtPath(EMPTY_PATH,t,r)},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.body;e<t.length;e++){var r=t[e];if("constructor"===r.kind)return void(this.classConstructor=r)}this.classConstructor=null},t}(NodeBase),ClassExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t}(ClassNode),MultiExpression=function(){function e(e){this.expressions=e}return e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(t,r,n){return new e(this.expressions.map(function(e){return e.getReturnExpressionWhenCalledAtPath(t,r,n)}))},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){for(var r=0,n=this.expressions;r<n.length;r++){if(n[r].hasEffectsWhenAccessedAtPath(e,t))return!0}return!1},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){for(var r=0,n=this.expressions;r<n.length;r++){if(n[r].hasEffectsWhenAssignedAtPath(e,t))return!0}return!1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){for(var n=0,i=this.expressions;n<i.length;n++){if(i[n].hasEffectsWhenCalledAtPath(e,t,r))return!0}return!1},e.prototype.include=function(){},e.prototype.deoptimizePath=function(e){for(var t=0,r=this.expressions;t<r.length;t++){r[t].deoptimizePath(e)}},e}(),ConditionalExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isBranchResolutionAnalysed||this.analyseBranchResolution()},t.prototype.deoptimizeCache=function(){if(null!==this.usedBranch){this.usedBranch=null,this.unusedBranch.deoptimizePath(UNKNOWN_PATH);for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getLiteralValueAtPath(e,t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?new MultiExpression([this.consequent.getReturnExpressionWhenCalledAtPath(e,t,r),this.alternate.getReturnExpressionWhenCalledAtPath(e,t,r)]):(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getReturnExpressionWhenCalledAtPath(e,t,r))},t.prototype.hasEffects=function(e){return!!this.test.hasEffects(e)||(null===this.usedBranch?this.consequent.hasEffects(e)||this.alternate.hasEffects(e):this.usedBranch.hasEffects(e))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null===this.usedBranch?this.consequent.hasEffectsWhenAccessedAtPath(e,t)||this.alternate.hasEffectsWhenAccessedAtPath(e,t):this.usedBranch.hasEffectsWhenAccessedAtPath(e,t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||(null===this.usedBranch?this.consequent.hasEffectsWhenAssignedAtPath(e,t)||this.alternate.hasEffectsWhenAssignedAtPath(e,t):this.usedBranch.hasEffectsWhenAssignedAtPath(e,t))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null===this.usedBranch?this.consequent.hasEffectsWhenCalledAtPath(e,t,r)||this.alternate.hasEffectsWhenCalledAtPath(e,t,r):this.usedBranch.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.initialise=function(){this.included=!1,this.isBranchResolutionAnalysed=!1,this.usedBranch=null,this.unusedBranch=null,this.expressionsToBeDeoptimized=[]},t.prototype.include=function(){this.included=!0,null===this.usedBranch||this.test.shouldBeIncluded()?(this.test.include(),this.consequent.include(),this.alternate.include()):this.usedBranch.include()},t.prototype.deoptimizePath=function(e){e.length>0&&(this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?(this.consequent.deoptimizePath(e),this.alternate.deoptimizePath(e)):this.usedBranch.deoptimizePath(e))},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent;this.test.included?e.prototype.render.call(this,t,r):(t.remove(this.start,this.usedBranch.start),t.remove(this.usedBranch.end,this.end),this.usedBranch.render(t,r,{renderedParentType:s||this.parent.type,isCalleeOfRenderedParent:s?o:this.parent.callee===this}))},t.prototype.analyseBranchResolution=function(){this.isBranchResolutionAnalysed=!0;var e=this.test.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);e!==UNKNOWN_VALUE&&(e?(this.usedBranch=this.consequent,this.unusedBranch=this.alternate):(this.usedBranch=this.alternate,this.unusedBranch=this.consequent))},t}(NodeBase),DoWhileStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return this.test.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t}(NodeBase),EmptyStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.render=function(e,t){this.parent.type!==BlockStatement&&this.parent.type!==Program||e.remove(this.start,this.end)},t}(NodeBase),ExportAllDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){this.included=!1,this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;e.remove(i,s)},t}(NodeBase);ExportAllDeclaration$1.prototype.needsBoundaries=!0;var ExportNamedDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){null!==this.declaration&&this.declaration.bind()},t.prototype.hasEffects=function(e){return this.declaration&&this.declaration.hasEffects(e)},t.prototype.initialise=function(){this.included=!1,this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;null===this.declaration?e.remove(i,s):(e.remove(this.start,this.declaration.start),this.declaration.render(e,t,{start:i,end:s}))},t}(NodeBase);ExportNamedDeclaration$1.prototype.needsBoundaries=!0;var ExpressionStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){this.included=!1,this.directive&&"use strict"!==this.directive&&this.parent.type===Program&&this.context.warn({code:"MODULE_LEVEL_DIRECTIVE",message:"Module level directives cause errors when bundled, '"+this.directive+"' was ignored."},this.start)},t.prototype.shouldBeIncluded=function(){return this.directive&&"use strict"!==this.directive?this.parent.type!==Program:e.prototype.shouldBeIncluded.call(this)},t.prototype.render=function(t,r){e.prototype.render.call(this,t,r),this.included&&this.insertSemicolon(t)},t}(NodeBase),ForInStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){this.left.bind(),this.left.deoptimizePath(EMPTY_PATH),this.right.bind(),this.body.bind()},t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.left&&(this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e))||this.right&&this.right.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.include=function(){this.included=!0,this.left.includeWithAllDeclaredVariables(),this.left.deoptimizePath(EMPTY_PATH),this.right.include(),this.body.include()},t.prototype.render=function(e,t){this.left.render(e,t,NO_SEMICOLON),this.right.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),ForOfStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){this.left.bind(),this.left.deoptimizePath(EMPTY_PATH),this.right.bind(),this.body.bind()},t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.left&&(this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e))||this.right&&this.right.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.include=function(){this.included=!0,this.left.includeWithAllDeclaredVariables(),this.left.deoptimizePath(EMPTY_PATH),this.right.include(),this.body.include()},t.prototype.render=function(e,t){this.left.render(e,t,NO_SEMICOLON),this.right.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),ForStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.init&&this.init.hasEffects(e)||this.test&&this.test.hasEffects(e)||this.update&&this.update.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.render=function(e,t){this.init&&this.init.render(e,t,NO_SEMICOLON),this.test&&this.test.render(e,t,NO_SEMICOLON),this.update&&this.update.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),FunctionExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t}(FunctionNode),IfStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isTestValueAnalysed||(this.testValue=UNKNOWN_VALUE,this.isTestValueAnalysed=!0,this.testValue=this.test.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this))},t.prototype.deoptimizeCache=function(){this.testValue=UNKNOWN_VALUE},t.prototype.hasEffects=function(e){return!!this.test.hasEffects(e)||(this.testValue===UNKNOWN_VALUE?this.consequent.hasEffects(e)||null!==this.alternate&&this.alternate.hasEffects(e):this.testValue?this.consequent.hasEffects(e):null!==this.alternate&&this.alternate.hasEffects(e))},t.prototype.include=function(){this.included=!0,(this.testValue===UNKNOWN_VALUE||this.test.shouldBeIncluded())&&this.test.include(),(this.testValue===UNKNOWN_VALUE||this.testValue)&&this.consequent.shouldBeIncluded()&&this.consequent.include(),null===this.alternate||this.testValue!==UNKNOWN_VALUE&&this.testValue||!this.alternate.shouldBeIncluded()||this.alternate.include()},t.prototype.initialise=function(){this.included=!1,this.isTestValueAnalysed=!1},t.prototype.render=function(e,t){if(this.test.included||(this.testValue?null!==this.alternate&&this.alternate.included:this.consequent.included))this.test.included?this.test.render(e,t):e.overwrite(this.test.start,this.test.end,this.testValue?"true":"false"),this.consequent.included?this.consequent.render(e,t):e.overwrite(this.consequent.start,this.consequent.end,";"),null!==this.alternate&&(this.alternate.included?this.alternate.render(e,t):e.remove(this.consequent.end,this.alternate.end));else{var r=this.testValue?this.consequent:this.alternate;e.remove(this.start,r.start),e.remove(r.end,this.end),r.render(e,t)}},t}(NodeBase),getDynamicImportMechanism=function(e,t){switch(e){case"cjs":return{left:"Promise.resolve(require(",right:"))",interopLeft:"Promise.resolve({"+(r=t?"":" ")+"default:"+r+"require(",interopRight:")"+r+"})"};case"amd":var r,n=t?"c":"resolve",i=t?"e":"reject";return{left:"new Promise(function"+(r=t?"":" ")+"("+n+","+r+i+")"+r+"{"+r+"require([",right:"],"+r+n+","+r+i+")"+r+"})",interopLeft:"new Promise(function"+r+"("+n+","+r+i+")"+r+"{"+r+"require([",interopRight:"],"+r+"function"+r+"(m)"+r+"{"+r+n+"({"+r+"default:"+r+"m"+r+"})"+r+"},"+r+i+")"+r+"})"};case"system":return{left:"module.import(",right:")"}}},Import$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){this.included=!1,this.resolutionNamespace=void 0,this.resolutionInterop=!1,this.rendered=!1,this.context.addDynamicImport(this)},t.prototype.renderFinalResolution=function(e,t){this.rendered&&e.overwrite(this.parent.arguments[0].start,this.parent.arguments[0].end,t)},t.prototype.render=function(e,t){if(this.rendered=!0,this.resolutionNamespace){var r=t.compact?"":" ",n=t.compact?"":";";e.overwrite(this.parent.start,this.parent.end,"Promise.resolve().then(function"+r+"()"+r+"{"+r+"return "+this.resolutionNamespace+n+r+"})")}else{var i=getDynamicImportMechanism(t.format,t.compact);if(i){var s=this.resolutionInterop&&i.interopLeft||i.left;e.overwrite(this.parent.start,this.parent.arguments[0].start,s);var o=this.resolutionInterop&&i.interopRight||i.right;e.overwrite(this.parent.arguments[0].end,this.parent.end,o)}}},t.prototype.setResolution=function(e,t){void 0===t&&(t=void 0),this.rendered=!1,this.resolutionInterop=e,this.resolutionNamespace=t},t}(NodeBase),ImportDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){},t.prototype.initialise=function(){this.included=!1,this.context.addImport(this)},t.prototype.hasEffects=function(){return!1},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;e.remove(i,s)},t}(NodeBase);ImportDeclaration$1.prototype.needsBoundaries=!0;var LabeledStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return this.body.hasEffects(e.setIgnoreLabel(this.label.name).setIgnoreBreakStatements())},t}(NodeBase);function isLiteral(e){return e.type===Literal}var Literal$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(e){return e.length>0?UNKNOWN_VALUE:this.value},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1!==e.length?UNKNOWN_EXPRESSION:getMemberReturnExpressionWhenCalled(this.members,e[0])},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return null===this.value?e.length>0:e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>0},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(this.members,e[0],this.included,t,r)},t.prototype.initialise=function(){this.included=!1,this.members=getLiteralMembersForValue(this.value)},t.prototype.render=function(e,t){"string"==typeof this.value&&e.indentExclusionRanges.push([this.start+1,this.end-1])},t}(NodeBase),LogicalExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isBranchResolutionAnalysed||this.analyseBranchResolution()},t.prototype.deoptimizeCache=function(){if(null!==this.usedBranch){this.usedBranch=null,this.unusedBranch.deoptimizePath(UNKNOWN_PATH);for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getLiteralValueAtPath(e,t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?new MultiExpression([this.left.getReturnExpressionWhenCalledAtPath(e,t,r),this.right.getReturnExpressionWhenCalledAtPath(e,t,r)]):(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getReturnExpressionWhenCalledAtPath(e,t,r))},t.prototype.hasEffects=function(e){return null===this.usedBranch?this.left.hasEffects(e)||this.right.hasEffects(e):this.usedBranch.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null===this.usedBranch?this.left.hasEffectsWhenAccessedAtPath(e,t)||this.right.hasEffectsWhenAccessedAtPath(e,t):this.usedBranch.hasEffectsWhenAccessedAtPath(e,t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||(null===this.usedBranch?this.left.hasEffectsWhenAssignedAtPath(e,t)||this.right.hasEffectsWhenAssignedAtPath(e,t):this.usedBranch.hasEffectsWhenAssignedAtPath(e,t))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null===this.usedBranch?this.left.hasEffectsWhenCalledAtPath(e,t,r)||this.right.hasEffectsWhenCalledAtPath(e,t,r):this.usedBranch.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(){this.included=!0,null===this.usedBranch||this.unusedBranch.shouldBeIncluded()?(this.left.include(),this.right.include()):this.usedBranch.include()},t.prototype.initialise=function(){this.included=!1,this.isBranchResolutionAnalysed=!1,this.usedBranch=null,this.unusedBranch=null,this.expressionsToBeDeoptimized=[]},t.prototype.deoptimizePath=function(e){e.length>0&&(this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?(this.left.deoptimizePath(e),this.right.deoptimizePath(e)):this.usedBranch.deoptimizePath(e))},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent;this.left.included&&this.right.included?e.prototype.render.call(this,t,r):(t.remove(this.start,this.usedBranch.start),t.remove(this.usedBranch.end,this.end),this.usedBranch.render(t,r,{renderedParentType:s||this.parent.type,isCalleeOfRenderedParent:s?o:this.parent.callee===this}))},t.prototype.analyseBranchResolution=function(){this.isBranchResolutionAnalysed=!0;var e=this.left.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);e!==UNKNOWN_VALUE&&(("||"===this.operator?e:!e)?(this.usedBranch=this.left,this.unusedBranch=this.right):(this.usedBranch=this.right,this.unusedBranch=this.left))},t}(NodeBase);function getAliasName(e,t){var r=path.basename(t||e),n=path.extname(e);return r.endsWith(n)&&(r=r.substr(0,r.length-n.length)),r}function relativeId(e){return"undefined"!=typeof process&&isAbsolute(e)?path.relative(process.cwd(),e):e}function isPlainName(e){return"/"!==e[0]&&("."!==e[1]||"/"!==e[2]&&("."!==e[2]||"/"!==e[3]))&&-1===e.indexOf(":")}function getResolvablePropertyKey(e){return e.computed?getResolvableComputedPropertyKey(e.property):e.property.name}function getResolvableComputedPropertyKey(e){return e instanceof Literal$1?String(e.value):null}function getPathIfNotComputed(e){var t=e.propertyKey,r=e.object;if("string"==typeof t){if(r instanceof Identifier$1)return[{key:r.name,pos:r.start},{key:t,pos:e.property.start}];if(isMemberExpression(r)){var n=getPathIfNotComputed(r);return n&&n.concat([{key:t,pos:e.property.start}])}}return null}function isMemberExpression(e){return e.type===MemberExpression}var MemberExpression$1=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.variable=null,t}return __extends$1(t,e),t.prototype.bind=function(){if(!this.bound){this.bound=!0;var t=getPathIfNotComputed(this),r=t&&this.scope.findVariable(t[0].key);if(r&&r.isNamespace){var n=this.resolveNamespaceVariables(r,t.slice(1));n?"string"==typeof n?this.replacement=n:(n.isExternal&&n.module&&n.module.suggestName(t[0].key),this.variable=n):e.prototype.bind.call(this)}else e.prototype.bind.call(this),null===this.propertyKey&&this.analysePropertyKey()}},t.prototype.deoptimizeCache=function(){for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}},t.prototype.getLiteralValueAtPath=function(e,t,r){return null!==this.variable?this.variable.getLiteralValueAtPath(e,t,r):(null===this.propertyKey&&this.analysePropertyKey(),this.expressionsToBeDeoptimized.push(r),this.object.getLiteralValueAtPath([this.propertyKey].concat(e),t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.getReturnExpressionWhenCalledAtPath(e,t,r):(null===this.propertyKey&&this.analysePropertyKey(),this.expressionsToBeDeoptimized.push(r),this.object.getReturnExpressionWhenCalledAtPath([this.propertyKey].concat(e),t,r))},t.prototype.hasEffects=function(e){return this.property.hasEffects(e)||this.object.hasEffects(e)||this.context.propertyReadSideEffects&&this.object.hasEffectsWhenAccessedAtPath([this.propertyKey],e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null!==this.variable?this.variable.hasEffectsWhenAccessedAtPath(e,t):this.object.hasEffectsWhenAccessedAtPath([this.propertyKey].concat(e),t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return null!==this.variable?this.variable.hasEffectsWhenAssignedAtPath(e,t):this.object.hasEffectsWhenAssignedAtPath([this.propertyKey].concat(e),t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.hasEffectsWhenCalledAtPath(e,t,r):this.object.hasEffectsWhenCalledAtPath([this.propertyKey].concat(e),t,r)},t.prototype.include=function(){this.included||(this.included=!0,null===this.variable||this.variable.included||(this.variable.include(),this.context.requestTreeshakingPass())),this.object.include(),this.property.include()},t.prototype.initialise=function(){this.included=!1,this.propertyKey=getResolvablePropertyKey(this),this.variable=null,this.bound=!1,this.replacement=null,this.expressionsToBeDeoptimized=[]},t.prototype.deoptimizePath=function(e){this.bound||this.bind(),0===e.length&&this.disallowNamespaceReassignment(),this.variable?this.variable.deoptimizePath(e):(null===this.propertyKey&&this.analysePropertyKey(),this.object.deoptimizePath([this.propertyKey].concat(e)))},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent,a=s===CallExpression&&o;if(this.variable||this.replacement){var u=this.variable?this.variable.getName():this.replacement;a&&(u="0, "+u),t.overwrite(this.start,this.end,u,{storeName:!0,contentOnly:!0})}else a&&t.appendRight(this.start,"0, "),e.prototype.render.call(this,t,r)},t.prototype.disallowNamespaceReassignment=function(){this.object instanceof Identifier$1&&this.scope.findVariable(this.object.name).isNamespace&&this.context.error({code:"ILLEGAL_NAMESPACE_REASSIGNMENT",message:"Illegal reassignment to import '"+this.object.name+"'"},this.start)},t.prototype.resolveNamespaceVariables=function(e,t){if(0===t.length)return e;if(!e.isNamespace)return null;var r=t[0].key,n=e.isExternal?e.module.traceExport(r):e.context.traceExport(r);if(!n){var i=e.isExternal?e.module.id:e.context.fileName;return this.context.warn({code:"MISSING_EXPORT",missing:r,importer:relativeId(this.context.fileName),exporter:relativeId(i),message:"'"+r+"' is not exported by '"+relativeId(i)+"'",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#name-is-not-exported-by-module"},t[0].pos),"undefined"}return this.resolveNamespaceVariables(n,t.slice(1))},t.prototype.analysePropertyKey=function(){this.propertyKey=UNKNOWN_KEY;var e=this.property.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);this.propertyKey=e===UNKNOWN_VALUE?UNKNOWN_KEY:String(e)},t}(NodeBase),globalImportMetaUrlMechanism="(typeof document !== 'undefined' ? document.currentScript && document.currentScript.src || document.baseURI : new (typeof URL !== 'undefined' ? URL : require('ur'+'l').URL)('file:' + __filename).href)",importMetaUrlMechanisms={amd:"new URL((typeof process !== 'undefined' && process.versions && process.versions.node ? 'file:' : '') + module.uri).href",cjs:"new (typeof URL !== 'undefined' ? URL : require('ur'+'l').URL)((process.browser ? '' : 'file:') + __filename, process.browser && document.baseURI).href",iife:globalImportMetaUrlMechanism,umd:globalImportMetaUrlMechanism},globalImportMetaUrlMechanismCompact="(typeof document!=='undefined'?document.currentScript&&document.currentScript.src||document.baseURI:new(typeof URL!=='undefined'?URL:require('ur'+'l').URL)('file:'+__filename).href)",importMetaUrlMechanismsCompact={amd:"new URL((typeof process!=='undefined'&&process.versions&&process.versions.node?'file:':'')+module.uri).href",cjs:"new(typeof URL!=='undefined'?URL:require('ur'+'l').URL)((process.browser?'':'file:')+__filename,process.browser&&document.baseURI).href",iife:globalImportMetaUrlMechanismCompact,umd:globalImportMetaUrlMechanismCompact},globalRelUrlMechanism=function(e,t){var r=t?"":" ";return"new"+r+"(typeof URL"+r+"!=="+r+"'undefined'"+r+"?"+r+"URL"+r+":"+r+"require('ur'+'l').URL)((typeof document"+r+"!=="+r+"'undefined'"+r+"?"+r+"document.currentScript"+r+"&&"+r+"document.currentScript.src"+r+"||"+r+"document.baseURI"+r+":"+r+"'file:'"+r+"+"+r+"__filename)"+r+"+"+r+"'/../"+e+"').href"},relUrlMechanisms={amd:function(e,t){var r=t?"":" ";return"new URL((typeof process"+r+"!=="+r+"'undefined'"+r+"&&"+r+"process.versions"+r+"&&"+r+"process.versions.node"+r+"?"+r+"'file:'"+r+":"+r+"'')"+r+"+"+r+"module.uri"+r+"+"+r+"'/../"+e+"').href"},cjs:function(e,t){var r=t?"":" ";return"new"+r+"(typeof URL"+r+"!=="+r+"'undefined'"+r+"?"+r+"URL"+r+":"+r+"require('ur'+'l').URL)((process.browser"+r+"?"+r+"''"+r+":"+r+"'file:')"+r+"+"+r+"__dirname"+r+"+"+r+"'/"+e+"',"+r+"process.browser"+r+"&&"+r+"document.baseURI).href"},es:function(e,t){return"new URL('../"+e+"',"+(t?"":" ")+"import.meta.url).href"},system:function(e,t){return"new URL('../"+e+"',"+(t?"":" ")+"module.url).href"},iife:globalRelUrlMechanism,umd:globalRelUrlMechanism},MetaProperty$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.initialise=function(){"import"===this.meta.name&&(this.rendered=!1,this.context.addImportMeta(this)),this.included=!1},t.prototype.render=function(t,r){"import"===this.meta.name&&(this.rendered=!0),e.prototype.render.call(this,t,r)},t.prototype.renderFinalMechanism=function(e,t,r,n){if(!this.rendered)return!1;if(this.parent instanceof MemberExpression$1==!1)return!1;var i,s=this.parent;if(s.property instanceof Identifier$1)i=s.property.name;else{if(!(s.property instanceof Literal$1&&"string"==typeof s.property.value))return!1;i=s.property.value}if(i.startsWith("ROLLUP_ASSET_URL_")){var o=this.context.getAssetFileName(i.substr(17)),a=normalize$1(path.relative(path.dirname(t),o));return e.overwrite(s.start,s.end,relUrlMechanisms[r](a,n)),!0}if("system"===r)e.overwrite(this.meta.start,this.meta.end,"module");else if("url"===i){var u=(n?importMetaUrlMechanismsCompact:importMetaUrlMechanisms)[r];return u&&e.overwrite(s.start,s.end,u),!0}return!1},t}(NodeBase),MethodDefinition$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return this.key.hasEffects(e)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>0||this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,t,r)},t}(NodeBase),NewExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this);for(var t=0,r=this.arguments;t<r.length;t++){r[t].deoptimizePath(UNKNOWN_PATH)}},t.prototype.hasEffects=function(e){for(var t=0,r=this.arguments;t<r.length;t++){if(r[t].hasEffects(e))return!0}return this.callee.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,e.getHasEffectsWhenCalledOptions())},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.initialise=function(){this.included=!1,this.callOptions=CallOptions.create({withNew:!0,args:this.arguments,callIdentifier:this})},t}(NodeBase),SpreadElement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.argument.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t}(NodeBase),ObjectExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),null===this.propertyMap&&this.buildPropertyMap()},t.prototype.deoptimizeCache=function(){this.hasUnknownDeoptimizedProperty||this.deoptimizeAllProperties()},t.prototype.getLiteralValueAtPath=function(e,t,r){null===this.propertyMap&&this.buildPropertyMap();var n=e[0];return 0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]?UNKNOWN_VALUE:1!==e.length||this.propertyMap[n]||0!==this.unmatchablePropertiesRead.length?!this.propertyMap[n]||null===this.propertyMap[n].exactMatchRead||this.propertyMap[n].propertiesRead.length>1?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r],this.propertyMap[n].exactMatchRead.getLiteralValueAtPath(e.slice(1),t,r)):void(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r])},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){null===this.propertyMap&&this.buildPropertyMap();var n=e[0];return 0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]?UNKNOWN_EXPRESSION:1!==e.length||!objectMembers[n]||0!==this.unmatchablePropertiesRead.length||this.propertyMap[n]&&null!==this.propertyMap[n].exactMatchRead?!this.propertyMap[n]||null===this.propertyMap[n].exactMatchRead||this.propertyMap[n].propertiesRead.length>1?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r],this.propertyMap[n].exactMatchRead.getReturnExpressionWhenCalledAtPath(e.slice(1),t,r)):getMemberReturnExpressionWhenCalled(objectMembers,n)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){if(0===e.length)return!1;var r=e[0];if(e.length>1&&(this.hasUnknownDeoptimizedProperty||"string"!=typeof r||this.deoptimizedPaths[r]||!this.propertyMap[r]||null===this.propertyMap[r].exactMatchRead))return!0;for(var n=e.slice(1),i=0,s="string"!=typeof r?this.properties:this.propertyMap[r]?this.propertyMap[r].propertiesRead:[];i<s.length;i++){if(s[i].hasEffectsWhenAccessedAtPath(n,t))return!0}return!1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(0===e.length)return!1;var r=e[0];if(e.length>1&&(this.hasUnknownDeoptimizedProperty||"string"!=typeof r||this.deoptimizedPaths[r]||!this.propertyMap[r]||null===this.propertyMap[r].exactMatchRead))return!0;for(var n=e.slice(1),i=0,s="string"!=typeof r?this.properties:e.length>1?this.propertyMap[r].propertiesRead:this.propertyMap[r]?this.propertyMap[r].propertiesSet:[];i<s.length;i++){if(s[i].hasEffectsWhenAssignedAtPath(n,t))return!0}return!1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){var n=e[0];if(0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]||(this.propertyMap[n]?!this.propertyMap[n].exactMatchRead:e.length>1||!objectMembers[n]))return!0;for(var i=e.slice(1),s=0,o=this.propertyMap[n]?this.propertyMap[n].propertiesRead:[];s<o.length;s++){if(o[s].hasEffectsWhenCalledAtPath(i,t,r))return!0}return!(1!==e.length||!objectMembers[n])&&hasMemberEffectWhenCalled(objectMembers,n,this.included,t,r)},t.prototype.initialise=function(){this.included=!1,this.hasUnknownDeoptimizedProperty=!1,this.deoptimizedPaths=Object.create(null),this.propertyMap=null,this.expressionsToBeDeoptimized=Object.create(null)},t.prototype.deoptimizePath=function(e){if(!this.hasUnknownDeoptimizedProperty)if(null===this.propertyMap&&this.buildPropertyMap(),0!==e.length){var t=e[0];if(1===e.length){if("string"!=typeof t)return void this.deoptimizeAllProperties();if(!this.deoptimizedPaths[t]&&(this.deoptimizedPaths[t]=!0,this.expressionsToBeDeoptimized[t]))for(var r=0,n=this.expressionsToBeDeoptimized[t];r<n.length;r++){n[r].deoptimizeCache()}}for(var i=1===e.length?UNKNOWN_PATH:e.slice(1),s=0,o="string"==typeof t?this.propertyMap[t]?this.propertyMap[t].propertiesRead:[]:this.properties;s<o.length;s++){o[s].deoptimizePath(i)}}else this.deoptimizeAllProperties()},t.prototype.deoptimizeAllProperties=function(){this.hasUnknownDeoptimizedProperty=!0;for(var e=0,t=this.properties;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}for(var r=0,n=Object.keys(this.expressionsToBeDeoptimized);r<n.length;r++)for(var i=n[r],s=0,o=this.expressionsToBeDeoptimized[i];s<o.length;s++){o[s].deoptimizeCache()}},t.prototype.render=function(t,r,n){var i=(void 0===n?BLANK:n).renderedParentType;e.prototype.render.call(this,t,r),i===ExpressionStatement&&(t.appendRight(this.start,"("),t.prependLeft(this.end,")"))},t.prototype.buildPropertyMap=function(){var e,t;this.propertyMap=Object.create(null),this.unmatchablePropertiesRead=[],this.unmatchablePropertiesWrite=[];for(var r=this.properties.length-1;r>=0;r--){var n=this.properties[r];if(n instanceof SpreadElement$1)this.unmatchablePropertiesRead.push(n);else{var i="get"!==n.kind,s="set"!==n.kind,o=void 0;if(n.computed){var a=n.key.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);if(a===UNKNOWN_VALUE){s?this.unmatchablePropertiesRead.push(n):this.unmatchablePropertiesWrite.push(n);continue}o=String(a)}else o=n.key instanceof Identifier$1?n.key.name:String(n.key.value);var u=this.propertyMap[o];u?(s&&null===u.exactMatchRead&&(u.exactMatchRead=n,(e=u.propertiesRead).push.apply(e,[n].concat(this.unmatchablePropertiesRead))),i&&!s&&null===u.exactMatchWrite&&(u.exactMatchWrite=n,(t=u.propertiesSet).push.apply(t,[n].concat(this.unmatchablePropertiesWrite)))):this.propertyMap[o]={exactMatchRead:s?n:null,propertiesRead:s?[n].concat(this.unmatchablePropertiesRead):[],exactMatchWrite:i?n:null,propertiesSet:i&&!s?[n].concat(this.unmatchablePropertiesWrite):[]}}}},t}(NodeBase),ObjectPattern$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.declare=function(e,t){for(var r=0,n=this.properties;r<n.length;r++){n[r].declare(e,t)}},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(e.length>0)return!0;for(var r=0,n=this.properties;r<n.length;r++){if(n[r].hasEffectsWhenAssignedAtPath(EMPTY_PATH,t))return!0}return!1},t.prototype.deoptimizePath=function(e){if(0===e.length)for(var t=0,r=this.properties;t<r.length;t++){r[t].deoptimizePath(e)}},t}(NodeBase),Program$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){for(var t=0,r=this.body;t<r.length;t++){if(r[t].hasEffects(e))return!0}},t.prototype.include=function(){this.included=!0;for(var e=0,t=this.body;e<t.length;e++){var r=t[e];r.shouldBeIncluded()&&r.include()}},t.prototype.render=function(t,r){this.body.length?renderStatementList(this.body,t,this.start,this.end,r):e.prototype.render.call(this,t,r)},t}(NodeBase),Property$1=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.declarationInit=null,t}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),"get"===this.kind&&null===this.returnExpression&&this.updateReturnExpression(),null!==this.declarationInit&&this.declarationInit.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t.prototype.declare=function(e,t){this.declarationInit=t,this.value.declare(e,UNKNOWN_EXPRESSION)},t.prototype.deoptimizeCache=function(){throw new Error("Unexpected deoptimization")},t.prototype.getLiteralValueAtPath=function(e,t,r){return"set"===this.kind?UNKNOWN_VALUE:"get"===this.kind?(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.getLiteralValueAtPath(e,t,r)):this.value.getLiteralValueAtPath(e,t,r)},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return"set"===this.kind?UNKNOWN_EXPRESSION:"get"===this.kind?(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.getReturnExpressionWhenCalledAtPath(e,t,r)):this.value.getReturnExpressionWhenCalledAtPath(e,t,r)},t.prototype.hasEffects=function(e){return this.key.hasEffects(e)||this.value.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return"get"===this.kind?this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.accessorCallOptions,t.getHasEffectsWhenCalledOptions())||e.length>0&&this.returnExpression.hasEffectsWhenAccessedAtPath(e,t):this.value.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return"get"===this.kind?0===e.length||this.returnExpression.hasEffectsWhenAssignedAtPath(e,t):"set"===this.kind?e.length>0||this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.accessorCallOptions,t.getHasEffectsWhenCalledOptions()):this.value.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return"get"===this.kind?this.returnExpression.hasEffectsWhenCalledAtPath(e,t,r):this.value.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.initialise=function(){this.included=!1,this.returnExpression=null,this.accessorCallOptions=CallOptions.create({withNew:!1,callIdentifier:this})},t.prototype.deoptimizePath=function(e){"get"===this.kind?e.length>0&&(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.deoptimizePath(e)):"set"!==this.kind&&this.value.deoptimizePath(e)},t.prototype.render=function(e,t){this.shorthand||this.key.render(e,t),this.value.render(e,t)},t.prototype.updateReturnExpression=function(){this.returnExpression=UNKNOWN_EXPRESSION,this.returnExpression=this.value.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this)},t}(NodeBase),RestElement$1=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.declarationInit=null,t}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),null!==this.declarationInit&&this.declarationInit.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t.prototype.declare=function(e,t){this.argument.declare(e,UNKNOWN_EXPRESSION),this.declarationInit=t},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>0||this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t)},t.prototype.deoptimizePath=function(e){0===e.length&&this.argument.deoptimizePath(EMPTY_PATH)},t}(NodeBase),ReturnStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return!e.ignoreReturnAwaitYield()||this.argument&&this.argument.hasEffects(e)},t.prototype.initialise=function(){this.included=!1,this.scope.addReturnExpression(this.argument||UNKNOWN_EXPRESSION)},t.prototype.render=function(e,t){this.argument&&(this.argument.render(e,t),this.argument.start===this.start+6&&e.prependLeft(this.start+6," "))},t}(NodeBase),SequenceExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(e,t,r){return this.expressions[this.expressions.length-1].getLiteralValueAtPath(e,t,r)},t.prototype.hasEffects=function(e){for(var t=0,r=this.expressions;t<r.length;t++){if(r[t].hasEffects(e))return!0}return!1},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.expressions[this.expressions.length-1].hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||this.expressions[this.expressions.length-1].hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return this.expressions[this.expressions.length-1].hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(){this.included=!0;for(var e=0;e<this.expressions.length-1;e++){var t=this.expressions[e];t.shouldBeIncluded()&&t.include()}this.expressions[this.expressions.length-1].include()},t.prototype.deoptimizePath=function(e){e.length>0&&this.expressions[this.expressions.length-1].deoptimizePath(e)},t.prototype.render=function(e,t,r){for(var n,i=void 0===r?BLANK:r,s=i.renderedParentType,o=i.isCalleeOfRenderedParent,a=0,u=0,c=0,h=getCommaSeparatedNodesWithBoundaries(this.expressions,e,this.start,this.end);c<h.length;c++){var p=h[c],l=p.node,f=p.start,d=p.end;l.included?(u++,0===a&&(a=f),n=d,l===this.expressions[this.expressions.length-1]&&1===u?l.render(e,t,{renderedParentType:s||this.parent.type,isCalleeOfRenderedParent:s?o:this.parent.callee===this}):l.render(e,t)):e.remove(f,d)}u>1&&s&&(e.prependRight(a,"("),e.appendLeft(n,")"))},t}(NodeBase),SwitchCase$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.include=function(){this.included=!0,this.test&&this.test.include();for(var e=0,t=this.consequent;e<t.length;e++){var r=t[e];r.shouldBeIncluded()&&r.include()}},t.prototype.render=function(t,r){if(this.consequent.length){this.test&&this.test.render(t,r);var n=this.test?this.test.end:findFirstOccurrenceOutsideComment(t.original,"default",this.start)+7,i=findFirstOccurrenceOutsideComment(t.original,":",n)+1;renderStatementList(this.consequent,t,i,this.end,r)}else e.prototype.render.call(this,t,r)},t}(NodeBase),SwitchStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t.setIgnoreBreakStatements())},t}(NodeBase),TaggedTemplateExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.tag.type===Identifier)&&(this.scope.findVariable(this.tag.name).isNamespace&&this.context.error({code:"CANNOT_CALL_NAMESPACE",message:"Cannot call a namespace ('"+this.tag.name+"')"},this.start),"eval"===this.tag.name&&this.context.warn({code:"EVAL",message:"Use of eval is strongly discouraged, as it poses security risks and may cause issues with minification",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#avoiding-eval"},this.start))},t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||this.tag.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,t.getHasEffectsWhenCalledOptions())},t.prototype.initialise=function(){this.included=!1,this.callOptions=CallOptions.create({withNew:!1,callIdentifier:this})},t}(NodeBase),TemplateElement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return!1},t}(NodeBase);function isTemplateLiteral(e){return e.type===TemplateLiteral}var TemplateLiteral$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(e){return e.length>0||1!==this.quasis.length?UNKNOWN_VALUE:this.quasis[0].value.cooked},t.prototype.render=function(t,r){t.indentExclusionRanges.push([this.start,this.end]),e.prototype.render.call(this,t,r)},t}(NodeBase),ThisExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.variable=this.scope.findVariable("this")},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.variable.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return this.variable.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.initialise=function(){this.included=!1,this.variable=null,this.alias=this.scope.findLexicalBoundary().isModuleScope?this.context.moduleContext:null,"undefined"===this.alias&&this.context.warn({code:"THIS_IS_UNDEFINED",message:"The 'this' keyword is equivalent to 'undefined' at the top level of an ES module, and has been rewritten",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#this-is-undefined"},this.start)},t.prototype.render=function(e,t){null!==this.alias&&e.overwrite(this.start,this.end,this.alias,{storeName:!0,contentOnly:!1})},t}(NodeBase),ThrowStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return!0},t}(NodeBase),unaryOperators={"-":function(e){return-e},"+":function(e){return+e},"!":function(e){return!e},"~":function(e){return~e},typeof:function(e){return typeof e},void:function(){},delete:function(){return UNKNOWN_VALUE}},UnaryExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),"delete"===this.operator&&this.argument.deoptimizePath(EMPTY_PATH)},t.prototype.getLiteralValueAtPath=function(e,t,r){if(e.length>0)return UNKNOWN_VALUE;var n=this.argument.getLiteralValueAtPath(EMPTY_PATH,t,r);return n===UNKNOWN_VALUE?UNKNOWN_VALUE:unaryOperators[this.operator](n)},t.prototype.hasEffects=function(e){return this.argument.hasEffects(e)||"delete"===this.operator&&this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return"void"===this.operator?e.length>0:e.length>1},t}(NodeBase),UnknownNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return!0},t}(NodeBase),UpdateExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.argument.deoptimizePath(EMPTY_PATH),isIdentifier(this.argument))&&(this.scope.findVariable(this.argument.name).isReassigned=!0)},t.prototype.hasEffects=function(e){return this.argument.hasEffects(e)||this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.render=function(e,t){this.argument.render(e,t);var r=this.argument.variable;if("system"===t.format&&r&&r.exportName){var n=r.getName();if(this.prefix)e.overwrite(this.start,this.end,"exports('"+r.exportName+"', "+this.operator+n+")");else{var i=void 0;switch(this.operator){case"++":i=n+" + 1";break;case"--":i=n+" - 1"}e.overwrite(this.start,this.end,"(exports('"+r.exportName+"', "+i+"), "+n+this.operator+")")}}},t}(NodeBase);function isReassignedExportsMember(e){return e.safeName&&-1!==e.safeName.indexOf(".")&&e.exportName&&e.isReassigned}var VariableDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!1},t.prototype.includeWithAllDeclaredVariables=function(){var e=!1;this.included=!0;for(var t=0,r=this.declarations;t<r.length;t++){r[t].include()&&(e=!0)}return e},t.prototype.include=function(){this.included=!0;for(var e=0,t=this.declarations;e<t.length;e++){var r=t[e];r.shouldBeIncluded()&&r.include()}},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.declarations;e<t.length;e++){t[e].declareDeclarator(this.kind)}},t.prototype.deoptimizePath=function(e){for(var t=0,r=this.declarations;t<r.length;t++){r[t].deoptimizePath(EMPTY_PATH)}},t.prototype.render=function(e,t,r){if(void 0===r&&(r=BLANK),this.declarations.every(function(e){return e.included&&(!e.id.variable||!e.id.variable.exportName)})){for(var n=0,i=this.declarations;n<i.length;n++){i[n].render(e,t)}r.isNoStatement||59===e.original.charCodeAt(this.end-1)||e.appendLeft(this.end,";")}else this.renderReplacedDeclarations(e,t,r)},t.prototype.renderReplacedDeclarations=function(e,t,r){var n,i,s=r.start,o=void 0===s?this.start:s,a=r.end,u=void 0===a?this.end:a,c=r.isNoStatement,h=getCommaSeparatedNodesWithBoundaries(this.declarations,e,this.start+this.kind.length,this.end-(59===e.original.charCodeAt(this.end-1)?1:0)),p=(i=/\n\s*$/.test(e.slice(this.start,h[0].start))?this.start+this.kind.length:h[0].start)-1;e.remove(this.start,p);for(var l,f,d=!1,m=!1,g="",y=0,v=h;y<v.length;y++){var _=v[y],x=_.node,b=_.start,E=_.separator,S=_.contentEnd,A=_.end;!x.included||isIdentifier(x.id)&&isReassignedExportsMember(x.id.variable)&&null===x.init?e.remove(b,A):(l="",f="",isIdentifier(x.id)&&isReassignedExportsMember(x.id.variable)?(m&&(g+=";"),d=!1):("system"===t.format&&null!==x.init&&isIdentifier(x.id)&&x.id.variable.exportName&&(e.prependLeft(e.original.indexOf("=",x.id.end)+1," exports('"+(x.id.variable.safeExportName||x.id.variable.exportName)+"',"),f+=")"),d?g+=",":(m&&(g+=";"),l+=this.kind+" ",d=!0)),i===p+1?e.overwrite(p,i,g+l):(e.overwrite(p,p+1,g),e.appendLeft(i,l)),x.render(e,t),n=S,i=A,m=!0,p=E,g=f)}m?this.renderDeclarationEnd(e,g,p,n,i,!c):e.remove(o,u)},t.prototype.renderDeclarationEnd=function(e,t,r,n,i,s){return 59===e.original.charCodeAt(this.end-1)&&e.remove(this.end-1,this.end),s&&(t+=";"),null!==r?(10!==e.original.charCodeAt(n-1)||10!==e.original.charCodeAt(this.end)&&13!==e.original.charCodeAt(this.end)||(n--,13===e.original.charCodeAt(n)&&n--),n===r+1?e.overwrite(r,i,t):(e.overwrite(r,r+1,t),e.remove(n,i))):e.appendLeft(i,t),t},t}(NodeBase),VariableDeclarator$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.declareDeclarator=function(e){this.id.declare(e,this.init||UNDEFINED_EXPRESSION)},t.prototype.deoptimizePath=function(e){this.id.deoptimizePath(e)},t.prototype.render=function(t,r){null===this.init||this.init.included?e.prototype.render.call(this,t,r):(t.remove(this.id.end,this.end),this.id.render(t,r))},t}(NodeBase),WhileStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.hasEffects=function(e){return this.test.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t}(NodeBase),YieldExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends$1(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),null!==this.argument&&this.argument.deoptimizePath(UNKNOWN_PATH)},t.prototype.hasEffects=function(e){return!e.ignoreReturnAwaitYield()||this.argument&&this.argument.hasEffects(e)},t.prototype.render=function(e,t){this.argument&&(this.argument.render(e,t),this.argument.start===this.start+5&&e.prependLeft(this.start+5," "))},t}(NodeBase),nodeConstructors={ArrayExpression:ArrayExpression$1,ArrayPattern:ArrayPattern$1,ArrowFunctionExpression:ArrowFunctionExpression$1,AssignmentExpression:AssignmentExpression$1,AssignmentPattern:AssignmentPattern$1,AwaitExpression:AwaitExpression$1,BinaryExpression:BinaryExpression$1,BlockStatement:BlockStatement$1,BreakStatement:BreakStatement$1,CallExpression:CallExpression$1,CatchClause:CatchClause$1,ClassBody:ClassBody$1,ClassDeclaration:ClassDeclaration$1,ClassExpression:ClassExpression$1,ConditionalExpression:ConditionalExpression$1,DoWhileStatement:DoWhileStatement$1,EmptyStatement:EmptyStatement$1,ExportAllDeclaration:ExportAllDeclaration$1,ExportDefaultDeclaration:ExportDefaultDeclaration$1,ExportNamedDeclaration:ExportNamedDeclaration$1,ExpressionStatement:ExpressionStatement$1,ForStatement:ForStatement$1,ForInStatement:ForInStatement$1,ForOfStatement:ForOfStatement$1,FunctionDeclaration:FunctionDeclaration$1,FunctionExpression:FunctionExpression$1,Identifier:Identifier$1,IfStatement:IfStatement$1,Import:Import$1,ImportDeclaration:ImportDeclaration$1,LabeledStatement:LabeledStatement$1,Literal:Literal$1,LogicalExpression:LogicalExpression$1,MemberExpression:MemberExpression$1,MetaProperty:MetaProperty$1,MethodDefinition:MethodDefinition$1,NewExpression:NewExpression$1,ObjectExpression:ObjectExpression$1,ObjectPattern:ObjectPattern$1,Program:Program$1,Property:Property$1,RestElement:RestElement$1,ReturnStatement:ReturnStatement$1,SequenceExpression:SequenceExpression$1,SpreadElement:SpreadElement$1,SwitchCase:SwitchCase$1,SwitchStatement:SwitchStatement$1,TaggedTemplateExpression:TaggedTemplateExpression$1,TemplateElement:TemplateElement$1,TemplateLiteral:TemplateLiteral$1,ThisExpression:ThisExpression$1,ThrowStatement:ThrowStatement$1,TryStatement:NodeBase,UnaryExpression:UnaryExpression$1,UnknownNode:UnknownNode,UpdateExpression:UpdateExpression$1,VariableDeclarator:VariableDeclarator$1,VariableDeclaration:VariableDeclaration$1,WhileStatement:WhileStatement$1,YieldExpression:YieldExpression$1},addDeclaredNames=function(e,t){if(e.isNamespace&&!e.isExternal)for(var r=0,n=e.context.getExports();r<n.length;r++){var i=n[r];addDeclaredNames(e.context.traceExport(i),t)}t.add(e.getName())},ModuleScope=function(e){function t(t,r){var n=e.call(this,t)||this;return n.context=r,n.isModuleScope=!0,n.variables.this=new LocalVariable("this",null,UNDEFINED_EXPRESSION,r.deoptimizationTracker),n}return __extends$1(t,e),t.prototype.deshadow=function(t,r){void 0===r&&(r=this.children);for(var n=new Set(t),i=0,s=Object.keys(this.context.imports);i<s.length;i++){var o=s[i],a=this.context.imports[o];if(!a.module.isExternal&&!this.context.isCrossChunkImport(a)){for(var u=0,c=a.module.getAllExports();u<c.length;u++){var h=c[u];addDeclaredNames(a.module.traceExport(h),n)}if("*"!==a.name){var p=a.module.traceExport(a.name);if(!p){this.context.warn({code:"NON_EXISTENT_EXPORT",name:a.name,source:a.module.id,message:"Non-existent export '"+a.name+"' is imported from "+relativeId(a.module.id)},a.start);continue}(h=p.getName())!==a.name&&n.add(h),"default"!==a.name&&a.name!==o&&n.add(a.name)}}}e.prototype.deshadow.call(this,n,r)},t.prototype.findLexicalBoundary=function(){return this},t.prototype.findVariable=function(e){return this.variables[e]?this.variables[e]:this.context.traceVariable(e)||this.parent.findVariable(e)},t}(Scope);function extractNames(e){var t=[];return extractors[e.type](t,e),t}var extractors={Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){t instanceof RestElement$1?extractors[t.argument.type](e,t.argument):extractors[t.value.type](e,t.value)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors[t.type](e,t)})},RestElement:function(e,t){extractors[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){extractors[t.left.type](e,t.left)}},NamespaceVariable=function(e){function t(t,r){var n=e.call(this,t.getModuleName())||this;n.originals=Object.create(null),n.needsNamespaceBlock=!1,n.referencedEarly=!1,n.references=[],n.context=t,n.module=r;for(var i=0,s=n.context.getExports().concat(n.context.getReexports());i<s.length;i++){var o=s[i];n.originals[o]=n.context.traceExport(o)}return n}return __extends$1(t,e),t.prototype.addReference=function(e){this.references.push(e),this.name=e.name},t.prototype.include=function(){if(!this.included){this.context.includeNamespace(),this.included=!0,this.needsNamespaceBlock=!0;for(var e=0,t=this.references;e<t.length;e++){if(t[e].context.getModuleExecIndex()<=this.context.getModuleExecIndex()){this.referencedEarly=!0;break}}for(var r=0,n=Object.keys(this.originals);r<n.length;r++){var i=n[r];this.originals[i].include()}}},t.prototype.renderFirst=function(){return this.referencedEarly},t.prototype.deoptimizePath=function(){for(var e in this.originals)this.originals[e].deoptimizePath(UNKNOWN_PATH)},t.prototype.renderBlock=function(e){var t=this,r=e.compact?"":" ",n=e.compact?"":"\n",i=e.indent,s=Object.keys(this.originals).map(function(n){var s=t.originals[n];return t.referencedEarly||s.isReassigned?i+"get "+n+r+"()"+r+"{"+r+"return "+s.getName()+(e.compact?"":";")+r+"}":""+i+n+": "+s.getName()}),o=this.getName(),a=e.freeze?"/*#__PURE__*/Object.freeze":"",u=this.context.varOrConst+" "+o+" = "+(e.namespaceToStringTag?"{"+n+s.join(","+n)+n+"};":a+"({"+n+s.join(","+n)+n+"});");return e.namespaceToStringTag&&(u+=n+"if"+r+"(typeof Symbol"+r+"!=="+r+"'undefined'"+r+"&&"+r+"Symbol.toStringTag)"+n,u+=i+"Object.defineProperty("+o+","+r+"Symbol.toStringTag,"+r+"{"+r+"value:"+r+"'Module'"+r+"});"+n,u+="else"+(n||" "),u+=i+"Object.defineProperty("+o+","+r+"'toString',"+r+"{"+r+"value:"+r+"function"+r+"()"+r+"{"+r+"return"+r+"'[object Module]'"+(e.compact?";":"")+r+"}"+r+"});"+n,u+=a+"("+o+");"),"system"===e.format&&this.exportName&&(u+=n+"exports('"+this.exportName+"',"+r+o+");"),u},t}(Variable);function getOriginalLocation(e,t){for(var r=e.filter(function(e){return e.mappings});r.length>0;){var n=r.pop(),i=n.mappings[t.line-1],s=!1;if(void 0!==i)for(var o=0,a=i;o<a.length;o++){var u=a[o];if(u[0]>=t.column){if(u.length<4)break;t={line:u[2]+1,column:u[3],source:n.sources[u[1]],name:n.names[u[4]]},s=!0;break}}if(!s)throw new Error("Can't resolve original location of error.")}return t}NamespaceVariable.prototype.isNamespace=!0;var SOURCEMAPPING_URL="sourceMa";SOURCEMAPPING_URL+="ppingURL";var SOURCEMAPPING_URL_RE=new RegExp("^#\\s+"+SOURCEMAPPING_URL+"=.+\\n?"),NOOP=function(){},getStartTime=function(){return 0},getElapsedTime=function(){return 0},getStartMemory=function(){return 0},getTotalMemory=function(){return 0},getElapsedMemory=function(){return 0},timers={},normalizeHrTime=function(e){return 1e3*e[0]+e[1]/1e6};function setTimeHelpers(){"undefined"!=typeof process&&"function"==typeof process.hrtime?(getStartTime=process.hrtime.bind(process),getElapsedTime=function(e){return normalizeHrTime(process.hrtime(e))}):"undefined"!=typeof performance&&"function"==typeof performance.now&&(getStartTime=performance.now.bind(performance),getElapsedTime=function(e){return performance.now()-e}),"undefined"!=typeof process&&"function"==typeof process.memoryUsage&&(getStartMemory=function(){return process.memoryUsage().heapUsed},getTotalMemory=function(){return process.memoryUsage().heapTotal},getElapsedMemory=function(e){return getStartMemory()-e})}function getPersistedLabel(e,t){switch(t){case 1:return"# "+e;case 2:return"## "+e;case 3:return e;default:return"  ".repeat(t-4)+"- "+e}}function timeStartImpl(e,t){void 0===t&&(t=3),e=getPersistedLabel(e,t),timers.hasOwnProperty(e)||(timers[e]={totalMemory:void 0,startTime:void 0,startMemory:void 0,time:0,memory:0}),timers[e].startTime=getStartTime(),timers[e].totalMemory=getTotalMemory(),timers[e].startMemory=getStartMemory()}function timeEndImpl(e,t){void 0===t&&(t=3),e=getPersistedLabel(e,t),timers.hasOwnProperty(e)&&(timers[e].time+=getElapsedTime(timers[e].startTime),timers[e].memory+=getElapsedMemory(timers[e].startMemory))}function getTimings(){var e={};return Object.keys(timers).forEach(function(t){e[t]=[timers[t].time,timers[t].memory,timers[t].totalMemory]}),e}var timeStart=NOOP,timeEnd=NOOP,TIMED_PLUGIN_HOOKS={transform:!0,transformBundle:!0,load:!0,resolveId:!0,ongenerate:!0,onwrite:!0,resolveDynamicImport:!0};function getPluginWithTimers(e,t){for(var r={},n=function(n){if(!0===TIMED_PLUGIN_HOOKS[n]){var i="plugin "+t;e.name&&(i+=" ("+e.name+")"),i+=" - "+n,r[n]=function(){timeStart(i,4);var t=e[n].apply(this===r?e:this,arguments);return timeEnd(i,4),t&&"function"==typeof t.then&&(timeStart(i+" (async)",4),t.then(function(){return timeEnd(i+" (async)",4)})),t}}else r[n]=e[n]},i=0,s=Object.keys(e);i<s.length;i++){n(s[i])}return r}function initialiseTimers(e){e.perf?(timers={},setTimeHelpers(),timeStart=timeStartImpl,timeEnd=timeEndImpl,e.plugins=e.plugins.map(getPluginWithTimers)):(timeStart=NOOP,timeEnd=NOOP)}var defaultAcornOptions={ecmaVersion:2018,sourceType:"module",preserveParens:!1};function tryParse(e,t,r){try{return t(e.code,__assign$1({},defaultAcornOptions,r,{onComment:function(t,r,n,i){return e.comments.push({block:t,text:r,start:n,end:i})}}))}catch(t){e.error({code:"PARSE_ERROR",message:t.message.replace(/ \(\d+:\d+\)$/,"")},t.pos)}}function includeFully(e){e.included=!0,e.variable&&!e.variable.included&&e.variable.include();for(var t=0,r=e.keys;t<r.length;t++){var n=e[r[t]];if(null!==n)if(Array.isArray(n))for(var i=0,s=n;i<s.length;i++){var o=s[i];null!==o&&includeFully(o)}else includeFully(n)}}function handleMissingExport(e,t,r,n){t.error({code:"MISSING_EXPORT",message:"'"+e+"' is not exported by "+relativeId(r),url:"https://github.com/rollup/rollup/wiki/Troubleshooting#name-is-not-exported-by-module"},n)}var Module=function(){function e(e,t){this.usesTopLevelAwait=!1,this.namespaceVariable=void 0,this.needsTreeshakingPass=!1,this.id=t,this.chunkAlias=void 0,this.graph=e,this.comments=[],this.dynamicImports=[],this.importMetas=[],this.dynamicImportResolutions=[],this.isEntryPoint=!1,this.execIndex=null,this.entryPointsHash=new Uint8Array(10),this.excludeFromSourcemap=/\0/.test(t),this.context=e.getModuleContext(t),this.sources=[],this.dependencies=[],this.imports=Object.create(null),this.exports=Object.create(null),this.exportsAll=Object.create(null),this.reexports=Object.create(null),this.exportAllSources=[],this.exportAllModules=null}return e.prototype.setSource=function(e){var t=this,r=e.code,n=e.originalCode,i=e.originalSourcemap,s=e.ast,o=e.sourcemapChain,a=e.resolvedIds,u=e.transformDependencies,c=e.customTransformCache;this.code=r,this.originalCode=n,this.originalSourcemap=i,this.sourcemapChain=o,this.transformDependencies=u,this.customTransformCache=c,timeStart("generate ast",3),this.esTreeAst=s||tryParse(this,this.graph.acornParse,this.graph.acornOptions),timeEnd("generate ast",3),this.resolvedIds=a||Object.create(null);var h=this.id;this.magicString=new MagicString(r,{filename:this.excludeFromSourcemap?null:h,indentExclusionRanges:[]}),this.removeExistingSourceMap(),timeStart("analyse ast",3),this.astContext={addDynamicImport:this.addDynamicImport.bind(this),addExport:this.addExport.bind(this),addImport:this.addImport.bind(this),addImportMeta:this.addImportMeta.bind(this),code:r,error:this.error.bind(this),fileName:h,getAssetFileName:this.graph.pluginDriver.getAssetFileName,getExports:this.getExports.bind(this),getReexports:this.getReexports.bind(this),getModuleExecIndex:function(){return t.execIndex},getModuleName:this.basename.bind(this),imports:this.imports,includeNamespace:this.includeNamespace.bind(this),isCrossChunkImport:function(e){return e.module.chunk!==t.chunk},magicString:this.magicString,moduleContext:this.context,nodeConstructors:nodeConstructors,propertyReadSideEffects:!this.graph.treeshake||this.graph.treeshakingOptions.propertyReadSideEffects,deoptimizationTracker:this.graph.deoptimizationTracker,requestTreeshakingPass:function(){return t.needsTreeshakingPass=!0},traceExport:this.traceExport.bind(this),traceVariable:this.traceVariable.bind(this),treeshake:this.graph.treeshake,usesTopLevelAwait:!1,varOrConst:this.graph.varOrConst,warn:this.warn.bind(this)},this.scope=new ModuleScope(this.graph.scope,this.astContext),this.ast=new Program$1(this.esTreeAst,{type:"Module",context:this.astContext},this.scope),timeEnd("analyse ast",3)},e.prototype.removeExistingSourceMap=function(){for(var e=0,t=this.comments;e<t.length;e++){var r=t[e];!r.block&&SOURCEMAPPING_URL_RE.test(r.text)&&this.magicString.remove(r.start,r.end)}},e.prototype.addExport=function(e){var t=e.source&&e.source.value;if(t)if(-1===this.sources.indexOf(t)&&this.sources.push(t),e.type===ExportAllDeclaration)this.exportAllSources.push(t);else for(var r=0,n=e.specifiers;r<n.length;r++){var i=(d=n[r]).exported.name;(this.exports[i]||this.reexports[i])&&this.error({code:"DUPLICATE_EXPORT",message:"A module cannot have multiple exports with the same name ('"+i+"')"},d.start),this.reexports[i]={start:d.start,source:t,localName:d.local.name,module:null}}else if(isExportDefaultDeclaration(e)){var s=e.declaration.id&&e.declaration.id.name||e.declaration.name;this.exports.default&&this.error({code:"DUPLICATE_EXPORT",message:"A module can only have one default export"},e.start),this.exports.default={localName:"default",identifier:s,node:e}}else if(e.declaration){var o=e.declaration;if(o.type===VariableDeclaration)for(var a=0,u=o.declarations;a<u.length;a++)for(var c=0,h=extractNames(u[a].id);c<h.length;c++){var p=h[c];this.exports[p]={localName:p,node:e}}else{p=o.id.name;this.exports[p]={localName:p,node:e}}}else for(var l=0,f=e.specifiers;l<f.length;l++){p=(d=f[l]).local.name;var d,m=d.exported.name;(this.exports[m]||this.reexports[m])&&this.error({code:"DUPLICATE_EXPORT",message:"A module cannot have multiple exports with the same name ('"+m+"')"},d.start),this.exports[m]={localName:p,node:e}}},e.prototype.addImport=function(e){var t=e.source.value;-1===this.sources.indexOf(t)&&this.sources.push(t);for(var r=0,n=e.specifiers;r<n.length;r++){var i=n[r],s=i.local.name;this.imports[s]&&this.error({code:"DUPLICATE_IMPORT",message:"Duplicated import '"+s+"'"},i.start);var o=i.type===ImportDefaultSpecifier,a=i.type===ImportNamespaceSpecifier,u=o?"default":a?"*":i.imported.name;this.imports[s]={source:t,start:i.start,name:u,module:null}}},e.prototype.addDynamicImport=function(e){this.dynamicImports.push(e)},e.prototype.addImportMeta=function(e){this.importMetas.push(e)},e.prototype.basename=function(){var e=path.basename(this.id),t=path.extname(this.id);return makeLegal(t?e.slice(0,-t.length):e)},e.prototype.markPublicExports=function(){for(var e=0,t=this.getExports();e<t.length;e++){var r=t[e];(s=this.traceExport(r)).exportName=r,s.deoptimizePath(UNKNOWN_PATH),s.include(),s.isNamespace&&(s.needsNamespaceBlock=!0)}for(var n=0,i=this.getReexports();n<i.length;n++){var s,o=i[n];(s=this.traceExport(o)).exportName=o,s.isExternal?s.reexported=s.module.reexported=!0:(s.include(),s.deoptimizePath(UNKNOWN_PATH))}},e.prototype.linkDependencies=function(){for(var e=this,t=0,r=this.sources;t<r.length;t++){var n=r[t],i=this.resolvedIds[n];if(i){var s=this.graph.moduleById.get(i);this.dependencies.push(s)}}var o=function(t){for(var r=0,n=Object.keys(t);r<n.length;r++){var i=t[n[r]],s=e.resolvedIds[i.source];i.module=e.graph.moduleById.get(s)}};o(this.imports),o(this.reexports),this.exportAllModules=this.exportAllSources.map(function(t){var r=e.resolvedIds[t];return e.graph.moduleById.get(r)})},e.prototype.bindReferences=function(){this.ast.bind()},e.prototype.getDynamicImportExpressions=function(){return this.dynamicImports.map(function(e){var t=e.parent.arguments[0];if(isTemplateLiteral(t)){if(0===t.expressions.length&&1===t.quasis.length)return t.quasis[0].value.cooked}else{if(!isLiteral(t))return t;if("string"==typeof t.value)return t.value}})},e.prototype.error=function(e,t){if(void 0!==t){e.pos=t;var r=locate(this.code,t,{offsetLine:1});try{r=getOriginalLocation(this.sourcemapChain,r)}catch(e){this.warn({loc:{file:this.id,line:r.line,column:r.column},pos:t,message:"Error when using sourcemap for reporting an error: "+e.message,code:"SOURCEMAP_ERROR"},void 0)}e.loc={file:this.id,line:r.line,column:r.column},e.frame=getCodeFrame(this.originalCode,r.line,r.column)}error(e)},e.prototype.getAllExports=function(){var e=Object.assign(Object.create(null),this.exports,this.reexports);return this.exportAllModules.forEach(function(t){if(t.isExternal)e["*"+t.id]=!0;else for(var r=0,n=t.getAllExports();r<n.length;r++){var i=n[r];"default"!==i&&(e[i]=!0)}}),Object.keys(e)},e.prototype.getExports=function(){return Object.keys(this.exports)},e.prototype.getReexports=function(){var e=Object.create(null);for(var t in this.reexports)e[t]=!0;return this.exportAllModules.forEach(function(t){if(t.isExternal)e["*"+t.id]=!0;else for(var r=0,n=t.getExports().concat(t.getReexports());r<n.length;r++){var i=n[r];"default"!==i&&(e[i]=!0)}}),Object.keys(e)},e.prototype.includeAllInBundle=function(){includeFully(this.ast)},e.prototype.isIncluded=function(){return this.ast.included},e.prototype.include=function(){return this.needsTreeshakingPass=!1,this.ast.shouldBeIncluded()&&this.ast.include(),this.needsTreeshakingPass},e.prototype.getOrCreateNamespace=function(){return this.namespaceVariable?this.namespaceVariable:this.namespaceVariable=new NamespaceVariable(this.astContext,this)},e.prototype.includeNamespace=function(){var e=this.getOrCreateNamespace();if(!e.needsNamespaceBlock){var t=!1;for(var r in this.reexports){t=!0;var n=this.reexports[r];this.imports[r]={source:n.source,start:n.start,name:n.localName,module:n.module},e.originals[r]=n.module.traceExport(n.localName)}this.chunk&&this.chunk.linked&&t&&this.chunk.linkModule(this)}},e.prototype.render=function(e){var t=this.magicString.clone();return this.ast.render(t,e),this.usesTopLevelAwait=this.astContext.usesTopLevelAwait,t},e.prototype.toJSON=function(){return{id:this.id,dependencies:this.dependencies.map(function(e){return e.id}),transformDependencies:this.transformDependencies,transformAssets:this.transformAssets,code:this.code,originalCode:this.originalCode,originalSourcemap:this.originalSourcemap,ast:this.esTreeAst,sourcemapChain:this.sourcemapChain,resolvedIds:this.resolvedIds,customTransformCache:this.customTransformCache}},e.prototype.traceVariable=function(e){if(e in this.scope.variables)return this.scope.variables[e];if(e in this.imports){var t=this.imports[e],r=t.module;if(!r.isExternal&&"*"===t.name)return r.getOrCreateNamespace();var n=r.traceExport(t.name);return n||handleMissingExport(t.name,this,r.id,t.start),n}return null},e.prototype.getRenderedExports=function(){var e=[],t=[];for(var r in this.exports){var n=this.exports[r];(n.node&&n.node.included?e:t).push(r)}return{renderedExports:e,removedExports:t}},e.prototype.traceExport=function(e,t){if("*"===e[0])return 1===e.length?this.getOrCreateNamespace():this.graph.moduleById.get(e.slice(1)).traceExport("*");var r=this.reexports[e];if(r)return(o=r.module.traceExport(r.localName))||handleMissingExport(r.localName,this,r.module.id,r.start),o;var n=this.exports[e];if(n){var i=n.localName;return o=this.traceVariable(i)||this.graph.scope.findVariable(i)}if("default"!==e)for(var s=0;s<this.exportAllModules.length;s+=1){var o;if(o=this.exportAllModules[s].traceExport(e,!0))return o}return this.graph.shimMissingExports&&!t?this.shimMissingExport(e):void 0},e.prototype.warn=function(e,t){if(void 0!==t){e.pos=t;var r=locate(this.code,t,{offsetLine:1}),n=r.line,i=r.column;e.loc={file:this.id,line:n,column:i},e.frame=getCodeFrame(this.code,n,i)}e.id=this.id,this.graph.warn(e)},e.prototype.shimMissingExport=function(e){return this.exports[e]||this.graph.warn({message:'Missing export "'+e+'" has been shimmed in module '+relativeId(this.id)+".",code:"SHIMMED_EXPORT",exportName:e,exporter:relativeId(this.id)}),this.exports[e]={localName:"_missingExportShim"},this.graph.exportShimVariable},e}(),Source=function(){function e(e,t){this.isOriginal=!0,this.filename=e,this.content=t}return e.prototype.traceSegment=function(e,t,r){return{line:e,column:t,name:r,source:this}},e}(),Link=function(){function e(e,t){this.sources=t,this.names=e.names,this.mappings=e.mappings}return e.prototype.traceMappings=function(){for(var e=[],t=[],r=[],n=[],i=0,s=this.mappings;i<s.length;i++){for(var o=[],a=0,u=s[i];a<u.length;a++){var c=u[a],h=this.sources[c[1]];if(h){var p=h.traceSegment(c[2],c[3],this.names[c[4]]);if(p){var l=e.lastIndexOf(p.source.filename);-1===l?(l=e.length,e.push(p.source.filename),t[l]=p.source.content):null==t[l]?t[l]=p.source.content:null!=p.source.content&&t[l]!==p.source.content&&error({message:"Multiple conflicting contents for sourcemap source "+p.source.filename});var f=[c[0],l,p.line,p.column];if(p.name){var d=r.indexOf(p.name);-1===d&&(d=r.length,r.push(p.name)),f[4]=d}o.push(f)}}}n.push(o)}return{sources:e,sourcesContent:t,names:r,mappings:n}},e.prototype.traceSegment=function(e,t,r){var n=this.mappings[e];if(!n)return null;for(var i=0,s=n.length-1;i<=s;){var o=i+s>>1,a=n[o];if(a[0]===t){var u=this.sources[a[1]];return u?u.traceSegment(a[2],a[3],this.names[a[4]]||r):null}a[0]>t?s=o-1:i=o+1}return null},e}();function collapseSourcemaps(e,t,r,n,i){var s=n.filter(function(e){return!e.excludeFromSourcemap}).map(function(t){var r,n=t.sourcemapChain,i=t.originalSourcemap;if(i){var s=i.sources,o=i.sourcesContent||[];if(null==s||s.length<=1&&null==s[0])r=new Source(t.id,o[0]),n=[i].concat(n);else{var a=path.dirname(t.id)||".",u=i.sourceRoot||".",c=s.map(function(e,t){return new Source(path.resolve(a,u,e),o[t])});r=new Link(i,c)}}else r=new Source(t.id,t.originalCode);return n.forEach(function(t){t.missing&&(e.graph.warn({code:"SOURCEMAP_BROKEN",plugin:t.plugin,message:"Sourcemap is likely to be incorrect: a plugin"+(t.plugin?" ('"+t.plugin+"')":"")+" was used to transform files, but didn't generate a sourcemap for the transformation. Consult the plugin documentation for help",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#sourcemap-is-likely-to-be-incorrect"}),t={names:[],mappings:""}),r=new Link(t,[r])}),r}),o=new Link(r,s);i.forEach(function(e){o=new Link(e,[o])});var a=o.traceMappings(),u=a.sources,c=a.sourcesContent,h=a.names,p=a.mappings;if(t){var l=path.dirname(t);u=u.map(function(e){return path.relative(l,e)}),t=path.basename(t)}return new SourceMap({file:t,sources:u,sourcesContent:c,names:h,mappings:p})}function guessIndentString(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getIndentString(e,t){if(!0!==t.indent)return t.indent||"";for(var r=0;r<e.length;r++){var n=guessIndentString(e[r].originalCode);if(null!==n)return n}return"\t"}function renderChunk(e){var t=e.graph,r=e.chunk,n=e.renderChunk,i=e.code,s=e.sourcemapChain,o=e.options,a=function(e,t,r){if(null==t)return e;"string"==typeof t&&(t={code:t,map:void 0});var n="string"==typeof t.map?JSON.parse(t.map):t.map;return n&&"string"==typeof n.mappings&&(n.mappings=decode(n.mappings)),null!==n&&s.push(n||{missing:!0,plugin:r.name}),t.code},u=!1,c=!0;return t.pluginDriver.hookReduceArg0("renderChunk",[i,n,o],a).then(function(e){return c=!1,t.pluginDriver.hookReduceArg0("transformChunk",[e,o,r],a)}).then(function(e){return u=!0,t.pluginDriver.hookReduceArg0("transformBundle",[e,o,r],a)}).catch(function(e){if(c)throw e;error(e,{code:u?"BAD_BUNDLE_TRANSFORMER":"BAD_CHUNK_TRANSFORMER",message:"Error transforming "+(u?"bundle":"chunk")+(e.plugin?" with '"+e.plugin+"' plugin":"")+": "+e.message,plugin:e.plugin})})}function renderNamePattern(e,t,r){return isPlainName(e)||error({code:"INVALID_PATTERN",message:'Invalid output pattern "'+e+'" for '+t+", cannot be an absolute or relative URL or path."}),e.replace(/\[(\w+)\]/g,function(e,n){var i=r(n);return void 0===i&&error({code:"INVALID_PATTERN_REPLACEMENT",message:'"'+n+'" is not a valid substitution name in output option '+t+" pattern."}),isPlainName(i)||error({code:"INVALID_PATTERN_REPLACEMENT",message:'Invalid replacement "'+i+'" for "'+n+'" in '+t+" pattern, must be a plain path name."}),i})}function makeUnique(e,t){if(e in t==!1)return e;var r=path.extname(e);e=e.substr(0,e.length-r.length);for(var n,i=1;t[n=e+ ++i+r];);return n}function getGlobalName(e,t,r,n){var i;return"function"==typeof t?i=t(e.id):t&&(i=t[e.id]),i||(n?(r.warn({code:"MISSING_GLOBAL_NAME",source:e.id,guess:e.name,message:"No name was provided for external module '"+e.id+"' in output.globals – guessing '"+e.name+"'"}),e.name):void 0)}function isNamespaceVariable(e){return e.isNamespace}var Chunk$1=function(){function e(e,t){this.hasDynamicImport=!1,this.indentString=void 0,this.exportMode="named",this.usedModules=void 0,this.id=void 0,this.linked=!1,this.imports=new Map,this.exports=new Map,this.exportNames=Object.create(null),this.dependencies=void 0,this.entryModule=void 0,this.isEntryModuleFacade=!1,this.isManualChunk=!1,this.renderedHash=void 0,this.renderedModuleSources=void 0,this.renderedSource=void 0,this.renderedSourceLength=void 0,this.needsExportsShim=!1,this.renderedDeclarations=void 0,this.graph=e,this.orderedModules=t,this.isEmpty=!0;for(var r=0,n=t;r<n.length;r++){var i=n[r];this.isEmpty&&i.isIncluded()&&(this.isEmpty=!1),i.chunkAlias&&(this.isManualChunk=!0),i.chunk=this,i.isEntryPoint&&!this.entryModule&&(this.entryModule=i,this.isEntryModuleFacade=!0)}this.entryModule?this.name=makeLegal(path.basename(this.entryModule.chunkAlias||this.orderedModules[0].chunkAlias||this.entryModule.id)):this.name="__chunk_"+ ++e.curChunkIndex}return e.prototype.getImportIds=function(){return this.dependencies.map(function(e){return e.id})},e.prototype.getExportNames=function(){return Object.keys(this.exportNames)},e.prototype.inlineChunkDependencies=function(e,t){for(var r=0,n=e.dependencies;r<n.length;r++){var i=n[r];if(i instanceof ExternalModule)-1===this.dependencies.indexOf(i)&&this.dependencies.push(i);else{if(i===this||-1!==this.dependencies.indexOf(i))continue;i.isEmpty||this.dependencies.push(i),t&&this.inlineChunkDependencies(i,!0)}}},e.prototype.linkFacade=function(e){this.dependencies=[e.chunk],this.entryModule=e,this.isEntryModuleFacade=!0;for(var t=0,r=e.getAllExports();t<r.length;t++){var n=r[t],i=e.traceExport(n);this.exports.set(i,e),this.exportNames[n]=i}},e.prototype.link=function(){this.dependencies=[];for(var e=0,t=this.orderedModules;e<t.length;e++){var r=t[e];this.linkModule(r)}this.linked=!0},e.prototype.linkModule=function(e){for(var t=0,r=e.dependencies;t<r.length;t++){var n=r[t];if(n.chunk!==this){var i=void 0;if(n instanceof Module)i=n.chunk;else{if(!n.used&&this.graph.isPureExternalModule(n.id))continue;i=n}-1===this.dependencies.indexOf(i)&&this.dependencies.push(i)}}for(var s=0,o=Object.keys(e.imports);s<o.length;s++){var a=o[s],u=e.imports[a];this.traceImport(u.name,u.module)}for(var c=0,h=e.dynamicImportResolutions;c<h.length;c++){var p=h[c].resolution;this.hasDynamicImport=!0,p instanceof Module&&p.chunk===this&&p.getOrCreateNamespace().include()}},e.prototype.populateEntryExports=function(e){for(var t=Array.from(this.entryModule.getAllExports().entries()),r=[],n=0,i=t;n<i.length;n++){var s=i[n],o=s[0],a=s[1];if((!(g=this.traceExport(a,this.entryModule)).variable||g.variable.included||g.variable.isExternal)&&(r[o]=g,g.variable)){g.module.chunk&&g.module.chunk.exports.set(g.variable,g.module);var u=this.exportNames[a];u&&u!==g.variable&&(this.isEntryModuleFacade=!1)}}for(var c=function(e){if(r.every(function(t){return t.variable!==e}))return h.isEntryModuleFacade=!1,{value:void 0}},h=this,p=0,l=Array.from(this.exports.keys());p<l.length;p++){var f=c(l[p]);if("object"==typeof f)return f.value}if(e||this.isEntryModuleFacade)for(var d=0,m=t;d<m.length;d++){var g,y=m[d];o=y[0],a=y[1];if(g=r[o]){if(g.variable){if(!g.variable.included&&!g.variable.isExternal)continue;this.exports.set(g.variable,g.module)}this.exportNames[a]=g.variable}}},e.prototype.traceImport=function(e,t){var r=this.traceExport(e,t);if(r){if(isNamespaceVariable(r.variable))for(var n=r.variable.originals||r.variable.module.declarations,i=0,s=Object.keys(n);i<s.length;i++){var o=s[i],a=n[o];if(a.included)if(r.variable.module instanceof Module)this.traceImport(o,r.variable.module);else r.variable.module.traceExport(o).included&&this.imports.set(a,r.variable.module)}return r.module.chunk!==this&&r.variable.included?(this.imports.set(r.variable,r.module),r.module instanceof Module&&r.module.chunk.exports.set(r.variable,r.module),r):r}},e.prototype.traceExport=function(e,t){if("*"===e||t instanceof ExternalModule)return{variable:t.traceExport(e),module:t};if(t.chunk!==this)return t.isEntryPoint&&!t.chunk.isEmpty?{variable:t.traceExport(e),module:t}:t.chunk.traceExport(e,t);var r=t.exports[e];if(r){var n=t.imports[r.localName];return n?this.traceImport(n.name,n.module):{variable:t.traceExport(e),module:t}}var i=t.reexports[e];if(i)return this.traceExport(i.localName,i.module);if("default"!==e){if("*"===e[0])return{variable:void 0,module:this.graph.moduleById.get(e.substr(1))};for(var s=0;s<t.exportAllModules.length;s++){var o=t.exportAllModules[s];if(o.traceExport(e,!0))return this.traceExport(e,o)}}},e.prototype.getVariableExportName=function(e){for(var t=0,r=Object.keys(this.exportNames);t<r.length;t++){var n=r[t];if(this.exportNames[n]===e)return n}},e.prototype.generateInternalExports=function(e){if(!this.isEntryModuleFacade){var t,r="system"===e.format||"es"===e.format||e.compact,n=0;this.exportNames=Object.create(null);var i=Array.from(this.exports.keys());if(r)for(var s=0,o=i;s<o.length;s++){var a=o[s];49===(t=toBase64(++n)).charCodeAt(0)&&(t=toBase64(n+=9*Math.pow(64,t.length-1))),this.exportNames[t]=a}else for(var u=0,c=i;u<c.length;u++){for(n=0,t=(a=c[u]).name;this.exportNames[t];)t=a.name+"$"+ ++n;this.exportNames[t]=a}}},e.prototype.prepareDynamicImports=function(){for(var e=0,t=this.orderedModules;e<t.length;e++)for(var r=t[e],n=0;n<r.dynamicImportResolutions.length;n++){var i=r.dynamicImports[n],s=r.dynamicImportResolutions[n].resolution;if(s)if(s instanceof Module)if(s.chunk===this){var o=s.getOrCreateNamespace();i.setResolution(!1,o.getName())}else i.setResolution(!1);else s instanceof ExternalModule?i.setResolution(!0):i.setResolution(!1)}},e.prototype.finaliseDynamicImports=function(){for(var e=0;e<this.orderedModules.length;e++)for(var t=this.orderedModules[e],r=this.renderedModuleSources[e],n=0;n<t.dynamicImportResolutions.length;n++){var i=t.dynamicImports[n],s=t.dynamicImportResolutions[n].resolution;if(s)if(s instanceof Module){if(s.chunk!==this){var o=normalize$1(path.relative(path.dirname(this.id),s.chunk.id));o.startsWith("../")||(o="./"+o),i.renderFinalResolution(r,'"'+o+'"')}}else s instanceof ExternalModule?i.renderFinalResolution(r,'"'+s.id+'"'):i.renderFinalResolution(r,s)}},e.prototype.finaliseImportMetas=function(e){for(var t=!1,r=0;r<this.orderedModules.length;r++)for(var n=this.orderedModules[r],i=this.renderedModuleSources[r],s=0,o=n.importMetas;s<o.length;s++){o[s].renderFinalMechanism(i,this.id,e.format,e.compact)&&(t=!0)}return t},e.prototype.setIdentifierRenderResolutions=function(e){var t=this;this.needsExportsShim=!1;var r=Object.create(null),n="es"===e.format||"system"===e.format;function i(e){for(var t=e;r[t];)t=e+"$"+toBase64(r[e]++,!0);return r[t]=1,t}Object.keys(this.graph.scope.variables).forEach(function(e){return r[e]=1}),"system"===e.format&&(r._setter=r._starExcludes=r._$p=1);var s=new Set;n||this.dependencies.forEach(function(e){var t=i(e.name);s.add(t),e.name=t});for(var o=0,a=Object.keys(this.exportNames);o<a.length;o++){var u=a[o],c=this.exportNames[u];c===this.graph.exportShimVariable&&(this.needsExportsShim=!0),c&&c.exportName!==u&&(c.exportName=u)}Array.from(this.imports.entries()).forEach(function(t){var r,o=t[0],a=t[1];if(a instanceof ExternalModule)r="*"===o.name?a.name:"default"===o.name?!1!==e.interop&&(a.exportsNamespace||!n&&a.exportsNames)?a.name+"__default":a.name:n?o.name:a.name+"."+o.name,n&&(r=i(r),s.add(r));else if(n)r=i(o.name),s.add(r);else{var u=a.chunk;r="default"===u.exportMode?u.name:u.name+"."+a.chunk.getVariableExportName(o)}r&&o.setSafeName(r)}),this.orderedModules.forEach(function(e){t.deconflictExportsOfModule(e,i,n)}),this.graph.scope.deshadow(s,this.orderedModules.map(function(e){return e.scope}))},e.prototype.deconflictExportsOfModule=function(e,t,r){Object.keys(e.scope.variables).forEach(function(n){var i=e.scope.variables[n];if(isExportDefaultVariable(i)&&i.referencesOriginal())i.setSafeName(null);else if(!isExportDefaultVariable(i)||!i.hasId){var s=void 0;if(r||!i.isReassigned||i.isId)s=t(i.name);else{var o=i.exportName;s=o?"exports."+o:t(i.name)}i.setSafeName(s)}});var n=e.getOrCreateNamespace();n.needsNamespaceBlock&&n.setSafeName(t(n.name))},e.prototype.getChunkDependencyDeclarations=function(e,t){for(var r=this,n=new Map,i=0,s=Object.keys(this.exportNames);i<s.length;i++){var o=s[i],a=void 0,u=void 0;if("*"===o[0])a=this.graph.moduleById.get(o.substr(1)),u=o="*";else{var c=this.exportNames[o],h=this.exports.get(c);if(h.chunk===this)continue;h instanceof Module?(a=h.chunk,u=h.chunk.getVariableExportName(c)):(a=h,u=c.name)}var p=n.get(a);p||n.set(a,p=[]),p.push({imported:u,reexported:o})}var l=[];return this.dependencies.forEach(function(i){var s,o=Array.from(r.imports.entries()).filter(function(e){var t=e[1];return t instanceof Module?t.chunk===i:t===i});if(o.length){s=[];for(var a=0,u=o;a<u.length;a++){var c=u[a],h=c[0],p=c[1],f=h.safeName||h.name,d=void 0;d=p instanceof ExternalModule?h.name:p.chunk.getVariableExportName(h),s.push({local:f,imported:d})}}var m,g,y,v,_=n.get(i),x=!0;i instanceof ExternalModule?(m=i.exportsNames||i.exportsNamespace,g="default"in i.declarations):(m=!0,g=!1,x="default"!==i.exportMode),i instanceof ExternalModule&&(y=i.renderPath||i.setRenderPath(e,t),"umd"!==e.format&&"iife"!==e.format||(v=getGlobalName(i,e.globals,r.graph,m||g))),l.push({id:y,namedExportsMode:x,globalName:v,name:i.name,isChunk:!i.isExternal,exportsNames:m,exportsDefault:g,reexports:_,imports:s})}),l},e.prototype.getChunkExportDeclarations=function(){for(var e=[],t=function(t){if("*"===t[0])return"continue";var n=r.exportNames[t];if(r.exports.get(n).chunk!==r)return"continue";var i=!1,s=!1;n instanceof LocalVariable?(n.init===UNDEFINED_EXPRESSION&&(s=!0),n.declarations.forEach(function(e){e.type===ExportDefaultDeclaration?e.declaration.type===FunctionDeclaration&&(i=!0):e.parent.type===FunctionDeclaration&&(i=!0)})):n instanceof GlobalVariable&&(i=!0);var o=n.getName();e.push({local:o,exported:"*"===t?o:t,hoisted:i,uninitialized:s})},r=this,n=0,i=Object.keys(this.exportNames);n<i.length;n++){t(i[n])}return e},e.prototype.getRenderedHash=function(){if(this.renderedHash)return this.renderedHash;var e=_256();return e.update(this.renderedSource.toString()),this.renderedHash=e.digest("hex")},e.prototype.postVisitChunkDependencies=function(t){var r=new Set;return function n(i){if(!r.has(i)){if(r.add(i),i instanceof e)for(var s=0,o=i.dependencies;s<o.length;s++)if(n(o[s]))return!0;return!0===t(i)}}(this)},e.prototype.computeFullHash=function(e,t){var r=_256();return r.update(this.getRenderedHash()),r.update(e.hash),r.update(t.format),r.update(this.dependencies.length),this.postVisitChunkDependencies(function(e){e instanceof ExternalModule?r.update(":"+e.renderPath):r.update(e.getRenderedHash())}),r.digest("hex").substr(0,8)},e.prototype.preRender=function(t,r){timeStart("render modules",3);var n=new Bundle({separator:t.compact?"":"\n\n"});this.usedModules=[],this.indentString=t.compact?"":getIndentString(this.orderedModules,t);var i=t.compact?"":"\n",s=t.compact?"":" ",o={compact:t.compact,freeze:!1!==t.freeze,esModule:!1!==t.esModule,namespaceToStringTag:!0===t.namespaceToStringTag,indent:this.indentString,format:t.format};if(this.isEntryModuleFacade)for(var a=0,u=this.dependencies;a<u.length;a++){(f=u[a])instanceof e&&this.inlineChunkDependencies(f,!0)}else for(var c=0,h=Array.from(this.imports.values());c<h.length;c++){var p=(m=h[c])instanceof Module?m.chunk:m;-1===this.dependencies.indexOf(p)&&this.dependencies.push(p)}for(var l=0;l<this.dependencies.length;l++){var f;(f=this.dependencies[l])instanceof e&&f.isEmpty&&(this.dependencies.splice(l--,1),this.inlineChunkDependencies(f,!1))}this.setIdentifierRenderResolutions(t),this.prepareDynamicImports();var d="";this.renderedModules=Object.create(null),this.renderedModuleSources=[];for(l=0;l<this.orderedModules.length;l++){var m,g=(m=this.orderedModules[l]).render(o);g.trim(),t.compact&&-1!==g.lastLine().indexOf("//")&&g.append("\n"),this.renderedModuleSources.push(g);var y=m.getRenderedExports(),v=y.renderedExports,_=y.removedExports;this.renderedModules[m.id]={renderedExports:v,removedExports:_,renderedLength:g.length(),originalLength:m.originalCode.length};var x=m.getOrCreateNamespace();if((x.needsNamespaceBlock||!g.isEmpty())&&(n.addSource(g),this.usedModules.push(m),x.needsNamespaceBlock)){var b=x.renderBlock(o);x.renderFirst()?d+=i+b:n.addSource(new MagicString(b))}}d&&n.prepend(d+i+i),this.needsExportsShim&&n.prepend(""+i+this.graph.varOrConst+" _missingExportShim"+s+"="+s+"void 0;"+i+i),t.compact?this.renderedSource=n:this.renderedSource=n.trim(),this.renderedSourceLength=void 0,this.renderedHash=void 0,0===this.getExportNames().length&&0===this.getImportIds().length&&this.isEmpty&&this.graph.warn({code:"EMPTY_BUNDLE",message:"Generated an empty bundle"}),this.renderedDeclarations={dependencies:this.getChunkDependencyDeclarations(t,r),exports:"none"===this.exportMode?[]:this.getChunkExportDeclarations()},timeEnd("render modules",3)},e.prototype.getRenderedSourceLength=function(){return void 0!==this.renderedSourceLength?this.renderedSourceLength:this.renderedSourceLength=this.renderedSource.length()},e.prototype.merge=function(e,t,r,n){var i=this;if(this.isEntryModuleFacade||e.isEntryModuleFacade)throw new Error("Internal error: Code splitting chunk merges not supported for facades");for(var s=0,o=e.orderedModules;s<o.length;s++){(p=o[s]).chunk=this,this.orderedModules.push(p)}for(var a=0,u=Array.from(e.imports.entries());a<u.length;a++){var c=u[a],h=c[0],p=c[1];this.imports.has(h)||p.chunk===this||this.imports.set(h,p)}for(var l=0,f=Array.from(e.exports.entries());l<f.length;l++){var d=f[l];h=d[0],p=d[1];this.exports.has(h)||this.exports.set(h,p)}var m=this.exportNames;this.generateInternalExports(r);for(var g,y,v=function(e,t){if(e.imports)for(var r=0,n=e.imports;r<n.length;r++){var s=n[r];s.imported=i.getVariableExportName(t[s.imported])}if(e.reexports)for(var o=0,a=e.reexports;o<a.length;o++){var u=a[o];u.imported=i.getVariableExportName(t[u.imported])}},_=0,x=t;_<x.length;_++)for(var b=x[_],E=void 0,S=0;S<b.dependencies.length;S++){var A=b.dependencies[S];if(A!==e&&A!==this||!E)A===e?(b.dependencies[S]=this,v(E=b.renderedDeclarations.dependencies[S],e.exportNames)):A===this&&v(E=b.renderedDeclarations.dependencies[S],m);else{var w=b.renderedDeclarations.dependencies[S];v(w,A===e?e.exportNames:m),g=E,(y=w).imports&&(g.imports?g.imports=g.imports.concat(y.imports):g.imports=y.imports),y.reexports&&(g.reexports?g.reexports=g.reexports.concat(y.reexports):g.reexports=y.reexports),!g.exportsNames&&y.exportsNames&&(g.exportsNames=!0),!g.exportsDefault&&y.exportsDefault&&(g.exportsDefault=!0),g.name=i.name,b.renderedDeclarations.dependencies.splice(S,1),b.dependencies.splice(S--,1)}}this.preRender(r,n)},e.prototype.generateIdPreserveModules=function(e){return this.id=normalize$1(path.relative(e,this.entryModule.id))},e.prototype.generateId=function(e,t,r,n,i){var s=this,o=makeUnique(renderNamePattern(e,t,function(e){switch(e){case"format":return"es"===n.format?"esm":n.format;case"hash":return s.computeFullHash(r,n);case"name":if(s.entryModule&&s.entryModule.chunkAlias)return s.entryModule.chunkAlias;for(var t=0,i=s.orderedModules;t<i.length;t++){var o=i[t];if(o.chunkAlias)return o.chunkAlias}return"chunk"}}),i);this.id=o},e.prototype.render=function(t,r,n){var i=this;if(timeStart("render format",3),!this.renderedSource)throw new Error("Internal error: Chunk render called before preRender");var s=finalisers[t.format];s||error({code:"INVALID_OPTION",message:"Invalid format: "+t.format+" - valid options are "+Object.keys(finalisers).join(", ")});for(var o=0;o<this.dependencies.length;o++){var a=this.dependencies[o];if(!(a instanceof ExternalModule)||a.renormalizeRenderPath){var u=this.renderedDeclarations.dependencies[o],c=a instanceof ExternalModule?u.id:a.id,h=this.id?normalize$1(path.relative(path.dirname(this.id),c)):c;h.startsWith("../")||(h="./"+h),a instanceof e&&(u.namedExportsMode="default"!==a.exportMode),u.id=h}}this.finaliseDynamicImports();var p=this.finaliseImportMetas(t),l=0!==this.renderedDeclarations.exports.length||this.renderedDeclarations.dependencies.some(function(e){return e.reexports&&0!==e.reexports.length}),f=this.orderedModules.some(function(e){return e.usesTopLevelAwait});f&&"es"!==t.format&&"system"!==t.format&&error({code:"INVALID_TLA_FORMAT",message:"Module format "+t.format+' does not support top-level await. Use the "es" or "system" output formats rather.'});var d=s(this.renderedSource,{indentString:this.indentString,namedExportsMode:"default"!==this.exportMode,hasExports:l,intro:r.intro,outro:r.outro,dynamicImport:this.hasDynamicImport,needsAmdModule:p,dependencies:this.renderedDeclarations.dependencies,exports:this.renderedDeclarations.exports,graph:this.graph,isEntryModuleFacade:this.isEntryModuleFacade,usesTopLevelAwait:f},t);r.banner&&d.prepend(r.banner),r.footer&&d.append(r.footer);var m=d.toString();timeEnd("render format",3);var g=null,y=[];return renderChunk({graph:this.graph,chunk:this,renderChunk:n,code:m,sourcemapChain:y,options:t}).then(function(e){if(t.sourcemap){timeStart("sourcemap",3);var r=void 0;if(r=t.file?path.resolve(t.sourcemapFile||t.file):t.dir?path.resolve(t.dir,i.id):path.resolve(i.id),i.graph.pluginDriver.hasLoadersOrTransforms){var n=d.generateDecodedMap({});g=collapseSourcemaps(i,r,n,i.usedModules,y)}else g=d.generateMap({file:r,includeContent:!0});g.sources=g.sources.map(normalize$1),timeEnd("sourcemap",3)}return!0!==t.compact&&"\n"!==e[e.length-1]&&(e+="\n"),{code:e,map:g}})},e}();function optimizeChunks(e,t,r,n){for(var i,s=function(s){var o=e[s],a=[];if(o.postVisitChunkDependencies(function(e){e instanceof Chunk$1&&a.push(e)}),a.length<2)return i=s,"continue";var u,c=1,h=!0,p=a[0],l=a[1],f=function(e){return!e.isEntryModuleFacade&&!e.isManualChunk&&(!(!l||l.isEntryModuleFacade)&&!(e.getRenderedSourceLength()>r))},d=function(){if(h)return f(p)&&(h=!1),"continue";var i=r-u.getRenderedSourceLength()-p.getRenderedSourceLength();if(i<=0)return f(p)||(h=!0),"continue";var o=new Set;p.postVisitChunkDependencies(function(e){return o.add(e)});var d=new Set([p,u]);if(u.postVisitChunkDependencies(function(e){return e!==p&&e!==u&&(!o.has(e)&&(e instanceof ExternalModule||((i-=e.getRenderedSourceLength())<=0||void d.add(e))))}))return f(p)||(h=!0),"continue";if(p.postVisitChunkDependencies(function(e){return!d.has(e)&&(e instanceof ExternalModule||((i-=e.getRenderedSourceLength())<=0||void 0))}))return f(p)||(h=!0),"continue";var m=e.indexOf(p);m<=s&&s--,e.splice(m,1),u.merge(p,e,t,n),a.splice(--c,1),p=u,l&&!f(l)&&(h=!0)};do{d()}while(u=p,p=l,l=a[++c],p);i=s},o=0;o<e.length;o++)s(o),o=i;return e}var reservedWords$1={3:"abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",5:"class enum extends super const export import",6:"enum",strict:"implements interface let package private protected public static yield",strictBind:"eval arguments"},ecma5AndLessKeywords="break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this",keywords={5:ecma5AndLessKeywords,6:ecma5AndLessKeywords+" const class extends export import super"},keywordRelationalOperator=/^in(stanceof)?$/,nonASCIIidentifierStartChars="ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࢠ-ࢴࢶ-ࢽऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೞೠೡೱೲഅ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄງຈຊຍດ-ທນ-ຟມ-ຣລວສຫອ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜌᜎ-ᜑᜠ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭋᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳱᳵᳶᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-Ⱞⰰ-ⱞⱠ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆺㇰ-ㇿ㐀-䶵一-鿯ꀀ-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꞹꟷ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭥꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ",nonASCIIidentifierChars="‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࣓-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍ୖୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ංඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ູົຼ່-ໍ໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜔ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠐-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭ᳲ-᳴᳷-᳹᷀-᷹᷻-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿",nonASCIIidentifierStart=new RegExp("["+nonASCIIidentifierStartChars+"]"),nonASCIIidentifier=new RegExp("["+nonASCIIidentifierStartChars+nonASCIIidentifierChars+"]");nonASCIIidentifierStartChars=nonASCIIidentifierChars=null;var astralIdentifierStartCodes=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,14,29,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,157,310,10,21,11,7,153,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,28,43,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,14,35,477,28,11,0,9,21,190,52,76,44,33,24,27,35,30,0,12,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,85,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,159,52,19,3,54,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,86,26,230,43,117,63,32,0,257,0,11,39,8,0,22,0,12,39,3,3,20,0,35,56,264,8,2,36,18,0,50,29,113,6,2,1,2,37,22,0,26,5,2,1,2,31,15,0,328,18,270,921,103,110,18,195,2749,1070,4050,582,8634,568,8,30,114,29,19,47,17,3,32,20,6,18,689,63,129,68,12,0,67,12,65,1,31,6129,15,754,9486,286,82,395,2309,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,4149,196,60,67,1213,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42710,42,4148,12,221,3,5761,15,7472,3104,541],astralIdentifierCodes=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,574,3,9,9,525,10,176,2,54,14,32,9,16,3,46,10,54,9,7,2,37,13,2,9,6,1,45,0,13,2,49,13,9,3,4,9,83,11,7,0,161,11,6,9,7,3,56,1,2,6,3,1,3,2,10,0,11,1,3,6,4,4,193,17,10,9,5,0,82,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,84,14,5,9,243,14,166,9,280,9,41,6,2,3,9,0,10,10,47,15,406,7,2,7,17,9,57,21,2,13,123,5,4,0,2,1,2,6,2,0,9,9,49,4,2,1,2,4,9,9,330,3,19306,9,135,4,60,6,26,9,1016,45,17,3,19723,1,5319,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,2214,6,110,6,6,9,792487,239];function isInAstralSet(e,t){for(var r=65536,n=0;n<t.length;n+=2){if((r+=t[n])>e)return!1;if((r+=t[n+1])>=e)return!0}}function isIdentifierStart(e,t){return e<65?36===e:e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&nonASCIIidentifierStart.test(String.fromCharCode(e)):!1!==t&&isInAstralSet(e,astralIdentifierStartCodes)))}function isIdentifierChar(e,t){return e<48?36===e:e<58||!(e<65)&&(e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&nonASCIIidentifier.test(String.fromCharCode(e)):!1!==t&&(isInAstralSet(e,astralIdentifierStartCodes)||isInAstralSet(e,astralIdentifierCodes)))))}var TokenType=function(e,t){void 0===t&&(t={}),this.label=e,this.keyword=t.keyword,this.beforeExpr=!!t.beforeExpr,this.startsExpr=!!t.startsExpr,this.isLoop=!!t.isLoop,this.isAssign=!!t.isAssign,this.prefix=!!t.prefix,this.postfix=!!t.postfix,this.binop=t.binop||null,this.updateContext=null};function binop(e,t){return new TokenType(e,{beforeExpr:!0,binop:t})}var beforeExpr={beforeExpr:!0},startsExpr={startsExpr:!0},keywords$1={};function kw(e,t){return void 0===t&&(t={}),t.keyword=e,keywords$1[e]=new TokenType(e,t)}var types={num:new TokenType("num",startsExpr),regexp:new TokenType("regexp",startsExpr),string:new TokenType("string",startsExpr),name:new TokenType("name",startsExpr),eof:new TokenType("eof"),bracketL:new TokenType("[",{beforeExpr:!0,startsExpr:!0}),bracketR:new TokenType("]"),braceL:new TokenType("{",{beforeExpr:!0,startsExpr:!0}),braceR:new TokenType("}"),parenL:new TokenType("(",{beforeExpr:!0,startsExpr:!0}),parenR:new TokenType(")"),comma:new TokenType(",",beforeExpr),semi:new TokenType(";",beforeExpr),colon:new TokenType(":",beforeExpr),dot:new TokenType("."),question:new TokenType("?",beforeExpr),arrow:new TokenType("=>",beforeExpr),template:new TokenType("template"),invalidTemplate:new TokenType("invalidTemplate"),ellipsis:new TokenType("...",beforeExpr),backQuote:new TokenType("`",startsExpr),dollarBraceL:new TokenType("${",{beforeExpr:!0,startsExpr:!0}),eq:new TokenType("=",{beforeExpr:!0,isAssign:!0}),assign:new TokenType("_=",{beforeExpr:!0,isAssign:!0}),incDec:new TokenType("++/--",{prefix:!0,postfix:!0,startsExpr:!0}),prefix:new TokenType("!/~",{beforeExpr:!0,prefix:!0,startsExpr:!0}),logicalOR:binop("||",1),logicalAND:binop("&&",2),bitwiseOR:binop("|",3),bitwiseXOR:binop("^",4),bitwiseAND:binop("&",5),equality:binop("==/!=/===/!==",6),relational:binop("</>/<=/>=",7),bitShift:binop("<</>>/>>>",8),plusMin:new TokenType("+/-",{beforeExpr:!0,binop:9,prefix:!0,startsExpr:!0}),modulo:binop("%",10),star:binop("*",10),slash:binop("/",10),starstar:new TokenType("**",{beforeExpr:!0}),_break:kw("break"),_case:kw("case",beforeExpr),_catch:kw("catch"),_continue:kw("continue"),_debugger:kw("debugger"),_default:kw("default",beforeExpr),_do:kw("do",{isLoop:!0,beforeExpr:!0}),_else:kw("else",beforeExpr),_finally:kw("finally"),_for:kw("for",{isLoop:!0}),_function:kw("function",startsExpr),_if:kw("if"),_return:kw("return",beforeExpr),_switch:kw("switch"),_throw:kw("throw",beforeExpr),_try:kw("try"),_var:kw("var"),_const:kw("const"),_while:kw("while",{isLoop:!0}),_with:kw("with"),_new:kw("new",{beforeExpr:!0,startsExpr:!0}),_this:kw("this",startsExpr),_super:kw("super",startsExpr),_class:kw("class",startsExpr),_extends:kw("extends",beforeExpr),_export:kw("export"),_import:kw("import"),_null:kw("null",startsExpr),_true:kw("true",startsExpr),_false:kw("false",startsExpr),_in:kw("in",{beforeExpr:!0,binop:7}),_instanceof:kw("instanceof",{beforeExpr:!0,binop:7}),_typeof:kw("typeof",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_void:kw("void",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_delete:kw("delete",{beforeExpr:!0,prefix:!0,startsExpr:!0})},lineBreak=/\r\n?|\n|\u2028|\u2029/,lineBreakG=new RegExp(lineBreak.source,"g");function isNewLine(e,t){return 10===e||13===e||!t&&(8232===e||8233===e)}var nonASCIIwhitespace=/[\u1680\u180e\u2000-\u200a\u202f\u205f\u3000\ufeff]/,skipWhiteSpace=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g,ref=Object.prototype,hasOwnProperty=ref.hasOwnProperty,toString$1=ref.toString;function has(e,t){return hasOwnProperty.call(e,t)}var isArray$1=Array.isArray||function(e){return"[object Array]"===toString$1.call(e)},Position=function(e,t){this.line=e,this.column=t};Position.prototype.offset=function(e){return new Position(this.line,this.column+e)};var SourceLocation=function(e,t,r){this.start=t,this.end=r,null!==e.sourceFile&&(this.source=e.sourceFile)};function getLineInfo(e,t){for(var r=1,n=0;;){lineBreakG.lastIndex=n;var i=lineBreakG.exec(e);if(!(i&&i.index<t))return new Position(r,t-n);++r,n=i.index+i[0].length}}var defaultOptions={ecmaVersion:7,sourceType:"script",onInsertedSemicolon:null,onTrailingComma:null,allowReserved:null,allowReturnOutsideFunction:!1,allowImportExportEverywhere:!1,allowAwaitOutsideFunction:!1,allowHashBang:!1,locations:!1,onToken:null,onComment:null,ranges:!1,program:null,sourceFile:null,directSourceFile:null,preserveParens:!1,plugins:{}};function getOptions(e){var t={};for(var r in defaultOptions)t[r]=e&&has(e,r)?e[r]:defaultOptions[r];if(t.ecmaVersion>=2015&&(t.ecmaVersion-=2009),null==t.allowReserved&&(t.allowReserved=t.ecmaVersion<5),isArray$1(t.onToken)){var n=t.onToken;t.onToken=function(e){return n.push(e)}}return isArray$1(t.onComment)&&(t.onComment=pushComment(t,t.onComment)),t}function pushComment(e,t){return function(r,n,i,s,o,a){var u={type:r?"Block":"Line",value:n,start:i,end:s};e.locations&&(u.loc=new SourceLocation(this,o,a)),e.ranges&&(u.range=[i,s]),t.push(u)}}var plugins={};function keywordRegexp(e){return new RegExp("^(?:"+e.replace(/ /g,"|")+")$")}var Parser=function(e,t,r){this.options=e=getOptions(e),this.sourceFile=e.sourceFile,this.keywords=keywordRegexp(keywords[e.ecmaVersion>=6?6:5]);var n="";if(!e.allowReserved){for(var i=e.ecmaVersion;!(n=reservedWords$1[i]);i--);"module"===e.sourceType&&(n+=" await")}this.reservedWords=keywordRegexp(n);var s=(n?n+" ":"")+reservedWords$1.strict;this.reservedWordsStrict=keywordRegexp(s),this.reservedWordsStrictBind=keywordRegexp(s+" "+reservedWords$1.strictBind),this.input=String(t),this.containsEsc=!1,this.loadPlugins(e.plugins),r?(this.pos=r,this.lineStart=this.input.lastIndexOf("\n",r-1)+1,this.curLine=this.input.slice(0,this.lineStart).split(lineBreak).length):(this.pos=this.lineStart=0,this.curLine=1),this.type=types.eof,this.value=null,this.start=this.end=this.pos,this.startLoc=this.endLoc=this.curPosition(),this.lastTokEndLoc=this.lastTokStartLoc=null,this.lastTokStart=this.lastTokEnd=this.pos,this.context=this.initialContext(),this.exprAllowed=!0,this.inModule="module"===e.sourceType,this.strict=this.inModule||this.strictDirective(this.pos),this.potentialArrowAt=-1,this.inFunction=this.inGenerator=this.inAsync=!1,this.yieldPos=this.awaitPos=0,this.labels=[],0===this.pos&&e.allowHashBang&&"#!"===this.input.slice(0,2)&&this.skipLineComment(2),this.scopeStack=[],this.enterFunctionScope(),this.regexpState=null};Parser.prototype.isKeyword=function(e){return this.keywords.test(e)},Parser.prototype.isReservedWord=function(e){return this.reservedWords.test(e)},Parser.prototype.extend=function(e,t){this[e]=t(this[e])},Parser.prototype.loadPlugins=function(e){for(var t in e){var r=plugins[t];if(!r)throw new Error("Plugin '"+t+"' not found");r(this,e[t])}},Parser.prototype.parse=function(){var e=this.options.program||this.startNode();return this.nextToken(),this.parseTopLevel(e)};var pp=Parser.prototype,literal=/^(?:'((?:\\.|[^'])*?)'|"((?:\\.|[^"])*?)"|;)/;function DestructuringErrors(){this.shorthandAssign=this.trailingComma=this.parenthesizedAssign=this.parenthesizedBind=this.doubleProto=-1}pp.strictDirective=function(e){for(;;){skipWhiteSpace.lastIndex=e,e+=skipWhiteSpace.exec(this.input)[0].length;var t=literal.exec(this.input.slice(e));if(!t)return!1;if("use strict"===(t[1]||t[2]))return!0;e+=t[0].length}},pp.eat=function(e){return this.type===e&&(this.next(),!0)},pp.isContextual=function(e){return this.type===types.name&&this.value===e&&!this.containsEsc},pp.eatContextual=function(e){return!!this.isContextual(e)&&(this.next(),!0)},pp.expectContextual=function(e){this.eatContextual(e)||this.unexpected()},pp.canInsertSemicolon=function(){return this.type===types.eof||this.type===types.braceR||lineBreak.test(this.input.slice(this.lastTokEnd,this.start))},pp.insertSemicolon=function(){if(this.canInsertSemicolon())return this.options.onInsertedSemicolon&&this.options.onInsertedSemicolon(this.lastTokEnd,this.lastTokEndLoc),!0},pp.semicolon=function(){this.eat(types.semi)||this.insertSemicolon()||this.unexpected()},pp.afterTrailingComma=function(e,t){if(this.type===e)return this.options.onTrailingComma&&this.options.onTrailingComma(this.lastTokStart,this.lastTokStartLoc),t||this.next(),!0},pp.expect=function(e){this.eat(e)||this.unexpected()},pp.unexpected=function(e){this.raise(null!=e?e:this.start,"Unexpected token")},pp.checkPatternErrors=function(e,t){if(e){e.trailingComma>-1&&this.raiseRecoverable(e.trailingComma,"Comma is not permitted after the rest element");var r=t?e.parenthesizedAssign:e.parenthesizedBind;r>-1&&this.raiseRecoverable(r,"Parenthesized pattern")}},pp.checkExpressionErrors=function(e,t){if(!e)return!1;var r=e.shorthandAssign,n=e.doubleProto;if(!t)return r>=0||n>=0;r>=0&&this.raise(r,"Shorthand property assignments are valid only in destructuring patterns"),n>=0&&this.raiseRecoverable(n,"Redefinition of __proto__ property")},pp.checkYieldAwaitInDefaultParams=function(){this.yieldPos&&(!this.awaitPos||this.yieldPos<this.awaitPos)&&this.raise(this.yieldPos,"Yield expression cannot be a default value"),this.awaitPos&&this.raise(this.awaitPos,"Await expression cannot be a default value")},pp.isSimpleAssignTarget=function(e){return"ParenthesizedExpression"===e.type?this.isSimpleAssignTarget(e.expression):"Identifier"===e.type||"MemberExpression"===e.type};var pp$1=Parser.prototype;pp$1.parseTopLevel=function(e){var t={};for(e.body||(e.body=[]);this.type!==types.eof;){var r=this.parseStatement(!0,!0,t);e.body.push(r)}return this.adaptDirectivePrologue(e.body),this.next(),this.options.ecmaVersion>=6&&(e.sourceType=this.options.sourceType),this.finishNode(e,"Program")};var loopLabel={kind:"loop"},switchLabel={kind:"switch"};pp$1.isLet=function(){if(this.options.ecmaVersion<6||!this.isContextual("let"))return!1;skipWhiteSpace.lastIndex=this.pos;var e=skipWhiteSpace.exec(this.input),t=this.pos+e[0].length,r=this.input.charCodeAt(t);if(91===r||123===r)return!0;if(isIdentifierStart(r,!0)){for(var n=t+1;isIdentifierChar(this.input.charCodeAt(n),!0);)++n;var i=this.input.slice(t,n);if(!keywordRelationalOperator.test(i))return!0}return!1},pp$1.isAsyncFunction=function(){if(this.options.ecmaVersion<8||!this.isContextual("async"))return!1;skipWhiteSpace.lastIndex=this.pos;var e=skipWhiteSpace.exec(this.input),t=this.pos+e[0].length;return!(lineBreak.test(this.input.slice(this.pos,t))||"function"!==this.input.slice(t,t+8)||t+8!==this.input.length&&isIdentifierChar(this.input.charAt(t+8)))},pp$1.parseStatement=function(e,t,r){var n,i=this.type,s=this.startNode();switch(this.isLet()&&(i=types._var,n="let"),i){case types._break:case types._continue:return this.parseBreakContinueStatement(s,i.keyword);case types._debugger:return this.parseDebuggerStatement(s);case types._do:return this.parseDoStatement(s);case types._for:return this.parseForStatement(s);case types._function:return!e&&this.options.ecmaVersion>=6&&this.unexpected(),this.parseFunctionStatement(s,!1);case types._class:return e||this.unexpected(),this.parseClass(s,!0);case types._if:return this.parseIfStatement(s);case types._return:return this.parseReturnStatement(s);case types._switch:return this.parseSwitchStatement(s);case types._throw:return this.parseThrowStatement(s);case types._try:return this.parseTryStatement(s);case types._const:case types._var:return n=n||this.value,e||"var"===n||this.unexpected(),this.parseVarStatement(s,n);case types._while:return this.parseWhileStatement(s);case types._with:return this.parseWithStatement(s);case types.braceL:return this.parseBlock();case types.semi:return this.parseEmptyStatement(s);case types._export:case types._import:return this.options.allowImportExportEverywhere||(t||this.raise(this.start,"'import' and 'export' may only appear at the top level"),this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'")),i===types._import?this.parseImport(s):this.parseExport(s,r);default:if(this.isAsyncFunction())return e||this.unexpected(),this.next(),this.parseFunctionStatement(s,!0);var o=this.value,a=this.parseExpression();return i===types.name&&"Identifier"===a.type&&this.eat(types.colon)?this.parseLabeledStatement(s,o,a):this.parseExpressionStatement(s,a)}},pp$1.parseBreakContinueStatement=function(e,t){var r="break"===t;this.next(),this.eat(types.semi)||this.insertSemicolon()?e.label=null:this.type!==types.name?this.unexpected():(e.label=this.parseIdent(),this.semicolon());for(var n=0;n<this.labels.length;++n){var i=this.labels[n];if(null==e.label||i.name===e.label.name){if(null!=i.kind&&(r||"loop"===i.kind))break;if(e.label&&r)break}}return n===this.labels.length&&this.raise(e.start,"Unsyntactic "+t),this.finishNode(e,r?"BreakStatement":"ContinueStatement")},pp$1.parseDebuggerStatement=function(e){return this.next(),this.semicolon(),this.finishNode(e,"DebuggerStatement")},pp$1.parseDoStatement=function(e){return this.next(),this.labels.push(loopLabel),e.body=this.parseStatement(!1),this.labels.pop(),this.expect(types._while),e.test=this.parseParenExpression(),this.options.ecmaVersion>=6?this.eat(types.semi):this.semicolon(),this.finishNode(e,"DoWhileStatement")},pp$1.parseForStatement=function(e){this.next();var t=this.options.ecmaVersion>=9&&this.inAsync&&this.eatContextual("await")?this.lastTokStart:-1;if(this.labels.push(loopLabel),this.enterLexicalScope(),this.expect(types.parenL),this.type===types.semi)return t>-1&&this.unexpected(t),this.parseFor(e,null);var r=this.isLet();if(this.type===types._var||this.type===types._const||r){var n=this.startNode(),i=r?"let":this.value;return this.next(),this.parseVar(n,!0,i),this.finishNode(n,"VariableDeclaration"),!(this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of"))||1!==n.declarations.length||"var"!==i&&n.declarations[0].init?(t>-1&&this.unexpected(t),this.parseFor(e,n)):(this.options.ecmaVersion>=9&&(this.type===types._in?t>-1&&this.unexpected(t):e.await=t>-1),this.parseForIn(e,n))}var s=new DestructuringErrors,o=this.parseExpression(!0,s);return this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of")?(this.options.ecmaVersion>=9&&(this.type===types._in?t>-1&&this.unexpected(t):e.await=t>-1),this.toAssignable(o,!1,s),this.checkLVal(o),this.parseForIn(e,o)):(this.checkExpressionErrors(s,!0),t>-1&&this.unexpected(t),this.parseFor(e,o))},pp$1.parseFunctionStatement=function(e,t){return this.next(),this.parseFunction(e,!0,!1,t)},pp$1.parseIfStatement=function(e){return this.next(),e.test=this.parseParenExpression(),e.consequent=this.parseStatement(!this.strict&&this.type===types._function),e.alternate=this.eat(types._else)?this.parseStatement(!this.strict&&this.type===types._function):null,this.finishNode(e,"IfStatement")},pp$1.parseReturnStatement=function(e){return this.inFunction||this.options.allowReturnOutsideFunction||this.raise(this.start,"'return' outside of function"),this.next(),this.eat(types.semi)||this.insertSemicolon()?e.argument=null:(e.argument=this.parseExpression(),this.semicolon()),this.finishNode(e,"ReturnStatement")},pp$1.parseSwitchStatement=function(e){var t;this.next(),e.discriminant=this.parseParenExpression(),e.cases=[],this.expect(types.braceL),this.labels.push(switchLabel),this.enterLexicalScope();for(var r=!1;this.type!==types.braceR;)if(this.type===types._case||this.type===types._default){var n=this.type===types._case;t&&this.finishNode(t,"SwitchCase"),e.cases.push(t=this.startNode()),t.consequent=[],this.next(),n?t.test=this.parseExpression():(r&&this.raiseRecoverable(this.lastTokStart,"Multiple default clauses"),r=!0,t.test=null),this.expect(types.colon)}else t||this.unexpected(),t.consequent.push(this.parseStatement(!0));return this.exitLexicalScope(),t&&this.finishNode(t,"SwitchCase"),this.next(),this.labels.pop(),this.finishNode(e,"SwitchStatement")},pp$1.parseThrowStatement=function(e){return this.next(),lineBreak.test(this.input.slice(this.lastTokEnd,this.start))&&this.raise(this.lastTokEnd,"Illegal newline after throw"),e.argument=this.parseExpression(),this.semicolon(),this.finishNode(e,"ThrowStatement")};var empty=[];pp$1.parseTryStatement=function(e){if(this.next(),e.block=this.parseBlock(),e.handler=null,this.type===types._catch){var t=this.startNode();this.next(),this.eat(types.parenL)?(t.param=this.parseBindingAtom(),this.enterLexicalScope(),this.checkLVal(t.param,"let"),this.expect(types.parenR)):(this.options.ecmaVersion<10&&this.unexpected(),t.param=null,this.enterLexicalScope()),t.body=this.parseBlock(!1),this.exitLexicalScope(),e.handler=this.finishNode(t,"CatchClause")}return e.finalizer=this.eat(types._finally)?this.parseBlock():null,e.handler||e.finalizer||this.raise(e.start,"Missing catch or finally clause"),this.finishNode(e,"TryStatement")},pp$1.parseVarStatement=function(e,t){return this.next(),this.parseVar(e,!1,t),this.semicolon(),this.finishNode(e,"VariableDeclaration")},pp$1.parseWhileStatement=function(e){return this.next(),e.test=this.parseParenExpression(),this.labels.push(loopLabel),e.body=this.parseStatement(!1),this.labels.pop(),this.finishNode(e,"WhileStatement")},pp$1.parseWithStatement=function(e){return this.strict&&this.raise(this.start,"'with' in strict mode"),this.next(),e.object=this.parseParenExpression(),e.body=this.parseStatement(!1),this.finishNode(e,"WithStatement")},pp$1.parseEmptyStatement=function(e){return this.next(),this.finishNode(e,"EmptyStatement")},pp$1.parseLabeledStatement=function(e,t,r){for(var n=0,i=this.labels;n<i.length;n+=1){i[n].name===t&&this.raise(r.start,"Label '"+t+"' is already declared")}for(var s=this.type.isLoop?"loop":this.type===types._switch?"switch":null,o=this.labels.length-1;o>=0;o--){var a=this.labels[o];if(a.statementStart!==e.start)break;a.statementStart=this.start,a.kind=s}return this.labels.push({name:t,kind:s,statementStart:this.start}),e.body=this.parseStatement(!0),("ClassDeclaration"===e.body.type||"VariableDeclaration"===e.body.type&&"var"!==e.body.kind||"FunctionDeclaration"===e.body.type&&(this.strict||e.body.generator))&&this.raiseRecoverable(e.body.start,"Invalid labeled declaration"),this.labels.pop(),e.label=r,this.finishNode(e,"LabeledStatement")},pp$1.parseExpressionStatement=function(e,t){return e.expression=t,this.semicolon(),this.finishNode(e,"ExpressionStatement")},pp$1.parseBlock=function(e){void 0===e&&(e=!0);var t=this.startNode();for(t.body=[],this.expect(types.braceL),e&&this.enterLexicalScope();!this.eat(types.braceR);){var r=this.parseStatement(!0);t.body.push(r)}return e&&this.exitLexicalScope(),this.finishNode(t,"BlockStatement")},pp$1.parseFor=function(e,t){return e.init=t,this.expect(types.semi),e.test=this.type===types.semi?null:this.parseExpression(),this.expect(types.semi),e.update=this.type===types.parenR?null:this.parseExpression(),this.expect(types.parenR),this.exitLexicalScope(),e.body=this.parseStatement(!1),this.labels.pop(),this.finishNode(e,"ForStatement")},pp$1.parseForIn=function(e,t){var r=this.type===types._in?"ForInStatement":"ForOfStatement";return this.next(),"ForInStatement"===r&&("AssignmentPattern"===t.type||"VariableDeclaration"===t.type&&null!=t.declarations[0].init&&(this.strict||"Identifier"!==t.declarations[0].id.type))&&this.raise(t.start,"Invalid assignment in for-in loop head"),e.left=t,e.right="ForInStatement"===r?this.parseExpression():this.parseMaybeAssign(),this.expect(types.parenR),this.exitLexicalScope(),e.body=this.parseStatement(!1),this.labels.pop(),this.finishNode(e,r)},pp$1.parseVar=function(e,t,r){for(e.declarations=[],e.kind=r;;){var n=this.startNode();if(this.parseVarId(n,r),this.eat(types.eq)?n.init=this.parseMaybeAssign(t):"const"!==r||this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of")?"Identifier"===n.id.type||t&&(this.type===types._in||this.isContextual("of"))?n.init=null:this.raise(this.lastTokEnd,"Complex binding patterns require an initialization value"):this.unexpected(),e.declarations.push(this.finishNode(n,"VariableDeclarator")),!this.eat(types.comma))break}return e},pp$1.parseVarId=function(e,t){e.id=this.parseBindingAtom(t),this.checkLVal(e.id,t,!1)},pp$1.parseFunction=function(e,t,r,n){this.initFunction(e),(this.options.ecmaVersion>=9||this.options.ecmaVersion>=6&&!n)&&(e.generator=this.eat(types.star)),this.options.ecmaVersion>=8&&(e.async=!!n),t&&(e.id="nullableID"===t&&this.type!==types.name?null:this.parseIdent(),e.id&&this.checkLVal(e.id,"var"));var i=this.inGenerator,s=this.inAsync,o=this.yieldPos,a=this.awaitPos,u=this.inFunction;return this.inGenerator=e.generator,this.inAsync=e.async,this.yieldPos=0,this.awaitPos=0,this.inFunction=!0,this.enterFunctionScope(),t||(e.id=this.type===types.name?this.parseIdent():null),this.parseFunctionParams(e),this.parseFunctionBody(e,r),this.inGenerator=i,this.inAsync=s,this.yieldPos=o,this.awaitPos=a,this.inFunction=u,this.finishNode(e,t?"FunctionDeclaration":"FunctionExpression")},pp$1.parseFunctionParams=function(e){this.expect(types.parenL),e.params=this.parseBindingList(types.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams()},pp$1.parseClass=function(e,t){this.next(),this.parseClassId(e,t),this.parseClassSuper(e);var r=this.startNode(),n=!1;for(r.body=[],this.expect(types.braceL);!this.eat(types.braceR);){var i=this.parseClassMember(r);i&&"MethodDefinition"===i.type&&"constructor"===i.kind&&(n&&this.raise(i.start,"Duplicate constructor in the same class"),n=!0)}return e.body=this.finishNode(r,"ClassBody"),this.finishNode(e,t?"ClassDeclaration":"ClassExpression")},pp$1.parseClassMember=function(e){var t=this;if(this.eat(types.semi))return null;var r=this.startNode(),n=function(e,n){void 0===n&&(n=!1);var i=t.start,s=t.startLoc;return!!t.eatContextual(e)&&(!(t.type===types.parenL||n&&t.canInsertSemicolon())||(r.key&&t.unexpected(),r.computed=!1,r.key=t.startNodeAt(i,s),r.key.name=e,t.finishNode(r.key,"Identifier"),!1))};r.kind="method",r.static=n("static");var i=this.eat(types.star),s=!1;i||(this.options.ecmaVersion>=8&&n("async",!0)?(s=!0,i=this.options.ecmaVersion>=9&&this.eat(types.star)):n("get")?r.kind="get":n("set")&&(r.kind="set")),r.key||this.parsePropertyName(r);var o=r.key;return r.computed||r.static||!("Identifier"===o.type&&"constructor"===o.name||"Literal"===o.type&&"constructor"===o.value)?r.static&&"Identifier"===o.type&&"prototype"===o.name&&this.raise(o.start,"Classes may not have a static property named prototype"):("method"!==r.kind&&this.raise(o.start,"Constructor can't have get/set modifier"),i&&this.raise(o.start,"Constructor can't be a generator"),s&&this.raise(o.start,"Constructor can't be an async method"),r.kind="constructor"),this.parseClassMethod(e,r,i,s),"get"===r.kind&&0!==r.value.params.length&&this.raiseRecoverable(r.value.start,"getter should have no params"),"set"===r.kind&&1!==r.value.params.length&&this.raiseRecoverable(r.value.start,"setter should have exactly one param"),"set"===r.kind&&"RestElement"===r.value.params[0].type&&this.raiseRecoverable(r.value.params[0].start,"Setter cannot use rest params"),r},pp$1.parseClassMethod=function(e,t,r,n){t.value=this.parseMethod(r,n),e.body.push(this.finishNode(t,"MethodDefinition"))},pp$1.parseClassId=function(e,t){e.id=this.type===types.name?this.parseIdent():!0===t?this.unexpected():null},pp$1.parseClassSuper=function(e){e.superClass=this.eat(types._extends)?this.parseExprSubscripts():null},pp$1.parseExport=function(e,t){if(this.next(),this.eat(types.star))return this.expectContextual("from"),this.type!==types.string&&this.unexpected(),e.source=this.parseExprAtom(),this.semicolon(),this.finishNode(e,"ExportAllDeclaration");if(this.eat(types._default)){var r;if(this.checkExport(t,"default",this.lastTokStart),this.type===types._function||(r=this.isAsyncFunction())){var n=this.startNode();this.next(),r&&this.next(),e.declaration=this.parseFunction(n,"nullableID",!1,r)}else if(this.type===types._class){var i=this.startNode();e.declaration=this.parseClass(i,"nullableID")}else e.declaration=this.parseMaybeAssign(),this.semicolon();return this.finishNode(e,"ExportDefaultDeclaration")}if(this.shouldParseExportStatement())e.declaration=this.parseStatement(!0),"VariableDeclaration"===e.declaration.type?this.checkVariableExport(t,e.declaration.declarations):this.checkExport(t,e.declaration.id.name,e.declaration.id.start),e.specifiers=[],e.source=null;else{if(e.declaration=null,e.specifiers=this.parseExportSpecifiers(t),this.eatContextual("from"))this.type!==types.string&&this.unexpected(),e.source=this.parseExprAtom();else{for(var s=0,o=e.specifiers;s<o.length;s+=1){var a=o[s];this.checkUnreserved(a.local)}e.source=null}this.semicolon()}return this.finishNode(e,"ExportNamedDeclaration")},pp$1.checkExport=function(e,t,r){e&&(has(e,t)&&this.raiseRecoverable(r,"Duplicate export '"+t+"'"),e[t]=!0)},pp$1.checkPatternExport=function(e,t){var r=t.type;if("Identifier"===r)this.checkExport(e,t.name,t.start);else if("ObjectPattern"===r)for(var n=0,i=t.properties;n<i.length;n+=1){var s=i[n];this.checkPatternExport(e,s)}else if("ArrayPattern"===r)for(var o=0,a=t.elements;o<a.length;o+=1){var u=a[o];u&&this.checkPatternExport(e,u)}else"Property"===r?this.checkPatternExport(e,t.value):"AssignmentPattern"===r?this.checkPatternExport(e,t.left):"RestElement"===r?this.checkPatternExport(e,t.argument):"ParenthesizedExpression"===r&&this.checkPatternExport(e,t.expression)},pp$1.checkVariableExport=function(e,t){if(e)for(var r=0,n=t;r<n.length;r+=1){var i=n[r];this.checkPatternExport(e,i.id)}},pp$1.shouldParseExportStatement=function(){return"var"===this.type.keyword||"const"===this.type.keyword||"class"===this.type.keyword||"function"===this.type.keyword||this.isLet()||this.isAsyncFunction()},pp$1.parseExportSpecifiers=function(e){var t=[],r=!0;for(this.expect(types.braceL);!this.eat(types.braceR);){if(r)r=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var n=this.startNode();n.local=this.parseIdent(!0),n.exported=this.eatContextual("as")?this.parseIdent(!0):n.local,this.checkExport(e,n.exported.name,n.exported.start),t.push(this.finishNode(n,"ExportSpecifier"))}return t},pp$1.parseImport=function(e){return this.next(),this.type===types.string?(e.specifiers=empty,e.source=this.parseExprAtom()):(e.specifiers=this.parseImportSpecifiers(),this.expectContextual("from"),e.source=this.type===types.string?this.parseExprAtom():this.unexpected()),this.semicolon(),this.finishNode(e,"ImportDeclaration")},pp$1.parseImportSpecifiers=function(){var e=[],t=!0;if(this.type===types.name){var r=this.startNode();if(r.local=this.parseIdent(),this.checkLVal(r.local,"let"),e.push(this.finishNode(r,"ImportDefaultSpecifier")),!this.eat(types.comma))return e}if(this.type===types.star){var n=this.startNode();return this.next(),this.expectContextual("as"),n.local=this.parseIdent(),this.checkLVal(n.local,"let"),e.push(this.finishNode(n,"ImportNamespaceSpecifier")),e}for(this.expect(types.braceL);!this.eat(types.braceR);){if(t)t=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var i=this.startNode();i.imported=this.parseIdent(!0),this.eatContextual("as")?i.local=this.parseIdent():(this.checkUnreserved(i.imported),i.local=i.imported),this.checkLVal(i.local,"let"),e.push(this.finishNode(i,"ImportSpecifier"))}return e},pp$1.adaptDirectivePrologue=function(e){for(var t=0;t<e.length&&this.isDirectiveCandidate(e[t]);++t)e[t].directive=e[t].expression.raw.slice(1,-1)},pp$1.isDirectiveCandidate=function(e){return"ExpressionStatement"===e.type&&"Literal"===e.expression.type&&"string"==typeof e.expression.value&&('"'===this.input[e.start]||"'"===this.input[e.start])};var pp$2=Parser.prototype;pp$2.toAssignable=function(e,t,r){if(this.options.ecmaVersion>=6&&e)switch(e.type){case"Identifier":this.inAsync&&"await"===e.name&&this.raise(e.start,"Can not use 'await' as identifier inside an async function");break;case"ObjectPattern":case"ArrayPattern":case"RestElement":break;case"ObjectExpression":e.type="ObjectPattern",r&&this.checkPatternErrors(r,!0);for(var n=0,i=e.properties;n<i.length;n+=1){var s=i[n];this.toAssignable(s,t),"RestElement"!==s.type||"ArrayPattern"!==s.argument.type&&"ObjectPattern"!==s.argument.type||this.raise(s.argument.start,"Unexpected token")}break;case"Property":"init"!==e.kind&&this.raise(e.key.start,"Object pattern can't contain getter or setter"),this.toAssignable(e.value,t);break;case"ArrayExpression":e.type="ArrayPattern",r&&this.checkPatternErrors(r,!0),this.toAssignableList(e.elements,t);break;case"SpreadElement":e.type="RestElement",this.toAssignable(e.argument,t),"AssignmentPattern"===e.argument.type&&this.raise(e.argument.start,"Rest elements cannot have a default value");break;case"AssignmentExpression":"="!==e.operator&&this.raise(e.left.end,"Only '=' operator can be used for specifying default value."),e.type="AssignmentPattern",delete e.operator,this.toAssignable(e.left,t);case"AssignmentPattern":break;case"ParenthesizedExpression":this.toAssignable(e.expression,t);break;case"MemberExpression":if(!t)break;default:this.raise(e.start,"Assigning to rvalue")}else r&&this.checkPatternErrors(r,!0);return e},pp$2.toAssignableList=function(e,t){for(var r=e.length,n=0;n<r;n++){var i=e[n];i&&this.toAssignable(i,t)}if(r){var s=e[r-1];6===this.options.ecmaVersion&&t&&s&&"RestElement"===s.type&&"Identifier"!==s.argument.type&&this.unexpected(s.argument.start)}return e},pp$2.parseSpread=function(e){var t=this.startNode();return this.next(),t.argument=this.parseMaybeAssign(!1,e),this.finishNode(t,"SpreadElement")},pp$2.parseRestBinding=function(){var e=this.startNode();return this.next(),6===this.options.ecmaVersion&&this.type!==types.name&&this.unexpected(),e.argument=this.parseBindingAtom(),this.finishNode(e,"RestElement")},pp$2.parseBindingAtom=function(){if(this.options.ecmaVersion>=6)switch(this.type){case types.bracketL:var e=this.startNode();return this.next(),e.elements=this.parseBindingList(types.bracketR,!0,!0),this.finishNode(e,"ArrayPattern");case types.braceL:return this.parseObj(!0)}return this.parseIdent()},pp$2.parseBindingList=function(e,t,r){for(var n=[],i=!0;!this.eat(e);)if(i?i=!1:this.expect(types.comma),t&&this.type===types.comma)n.push(null);else{if(r&&this.afterTrailingComma(e))break;if(this.type===types.ellipsis){var s=this.parseRestBinding();this.parseBindingListItem(s),n.push(s),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.expect(e);break}var o=this.parseMaybeDefault(this.start,this.startLoc);this.parseBindingListItem(o),n.push(o)}return n},pp$2.parseBindingListItem=function(e){return e},pp$2.parseMaybeDefault=function(e,t,r){if(r=r||this.parseBindingAtom(),this.options.ecmaVersion<6||!this.eat(types.eq))return r;var n=this.startNodeAt(e,t);return n.left=r,n.right=this.parseMaybeAssign(),this.finishNode(n,"AssignmentPattern")},pp$2.checkLVal=function(e,t,r){switch(e.type){case"Identifier":this.strict&&this.reservedWordsStrictBind.test(e.name)&&this.raiseRecoverable(e.start,(t?"Binding ":"Assigning to ")+e.name+" in strict mode"),r&&(has(r,e.name)&&this.raiseRecoverable(e.start,"Argument name clash"),r[e.name]=!0),t&&"none"!==t&&(("var"===t&&!this.canDeclareVarName(e.name)||"var"!==t&&!this.canDeclareLexicalName(e.name))&&this.raiseRecoverable(e.start,"Identifier '"+e.name+"' has already been declared"),"var"===t?this.declareVarName(e.name):this.declareLexicalName(e.name));break;case"MemberExpression":t&&this.raiseRecoverable(e.start,"Binding member expression");break;case"ObjectPattern":for(var n=0,i=e.properties;n<i.length;n+=1){var s=i[n];this.checkLVal(s,t,r)}break;case"Property":this.checkLVal(e.value,t,r);break;case"ArrayPattern":for(var o=0,a=e.elements;o<a.length;o+=1){var u=a[o];u&&this.checkLVal(u,t,r)}break;case"AssignmentPattern":this.checkLVal(e.left,t,r);break;case"RestElement":this.checkLVal(e.argument,t,r);break;case"ParenthesizedExpression":this.checkLVal(e.expression,t,r);break;default:this.raise(e.start,(t?"Binding":"Assigning to")+" rvalue")}};var pp$3=Parser.prototype;pp$3.checkPropClash=function(e,t,r){if(!(this.options.ecmaVersion>=9&&"SpreadElement"===e.type||this.options.ecmaVersion>=6&&(e.computed||e.method||e.shorthand))){var n,i=e.key;switch(i.type){case"Identifier":n=i.name;break;case"Literal":n=String(i.value);break;default:return}var s=e.kind;if(this.options.ecmaVersion>=6)"__proto__"===n&&"init"===s&&(t.proto&&(r&&r.doubleProto<0?r.doubleProto=i.start:this.raiseRecoverable(i.start,"Redefinition of __proto__ property")),t.proto=!0);else{var o=t[n="$"+n];if(o)("init"===s?this.strict&&o.init||o.get||o.set:o.init||o[s])&&this.raiseRecoverable(i.start,"Redefinition of property");else o=t[n]={init:!1,get:!1,set:!1};o[s]=!0}}},pp$3.parseExpression=function(e,t){var r=this.start,n=this.startLoc,i=this.parseMaybeAssign(e,t);if(this.type===types.comma){var s=this.startNodeAt(r,n);for(s.expressions=[i];this.eat(types.comma);)s.expressions.push(this.parseMaybeAssign(e,t));return this.finishNode(s,"SequenceExpression")}return i},pp$3.parseMaybeAssign=function(e,t,r){if(this.inGenerator&&this.isContextual("yield"))return this.parseYield();var n=!1,i=-1,s=-1;t?(i=t.parenthesizedAssign,s=t.trailingComma,t.parenthesizedAssign=t.trailingComma=-1):(t=new DestructuringErrors,n=!0);var o=this.start,a=this.startLoc;this.type!==types.parenL&&this.type!==types.name||(this.potentialArrowAt=this.start);var u=this.parseMaybeConditional(e,t);if(r&&(u=r.call(this,u,o,a)),this.type.isAssign){var c=this.startNodeAt(o,a);return c.operator=this.value,c.left=this.type===types.eq?this.toAssignable(u,!1,t):u,n||DestructuringErrors.call(t),t.shorthandAssign=-1,this.checkLVal(u),this.next(),c.right=this.parseMaybeAssign(e),this.finishNode(c,"AssignmentExpression")}return n&&this.checkExpressionErrors(t,!0),i>-1&&(t.parenthesizedAssign=i),s>-1&&(t.trailingComma=s),u},pp$3.parseMaybeConditional=function(e,t){var r=this.start,n=this.startLoc,i=this.parseExprOps(e,t);if(this.checkExpressionErrors(t))return i;if(this.eat(types.question)){var s=this.startNodeAt(r,n);return s.test=i,s.consequent=this.parseMaybeAssign(),this.expect(types.colon),s.alternate=this.parseMaybeAssign(e),this.finishNode(s,"ConditionalExpression")}return i},pp$3.parseExprOps=function(e,t){var r=this.start,n=this.startLoc,i=this.parseMaybeUnary(t,!1);return this.checkExpressionErrors(t)?i:i.start===r&&"ArrowFunctionExpression"===i.type?i:this.parseExprOp(i,r,n,-1,e)},pp$3.parseExprOp=function(e,t,r,n,i){var s=this.type.binop;if(null!=s&&(!i||this.type!==types._in)&&s>n){var o=this.type===types.logicalOR||this.type===types.logicalAND,a=this.value;this.next();var u=this.start,c=this.startLoc,h=this.parseExprOp(this.parseMaybeUnary(null,!1),u,c,s,i),p=this.buildBinary(t,r,e,h,a,o);return this.parseExprOp(p,t,r,n,i)}return e},pp$3.buildBinary=function(e,t,r,n,i,s){var o=this.startNodeAt(e,t);return o.left=r,o.operator=i,o.right=n,this.finishNode(o,s?"LogicalExpression":"BinaryExpression")},pp$3.parseMaybeUnary=function(e,t){var r,n=this.start,i=this.startLoc;if(this.isContextual("await")&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction))r=this.parseAwait(),t=!0;else if(this.type.prefix){var s=this.startNode(),o=this.type===types.incDec;s.operator=this.value,s.prefix=!0,this.next(),s.argument=this.parseMaybeUnary(null,!0),this.checkExpressionErrors(e,!0),o?this.checkLVal(s.argument):this.strict&&"delete"===s.operator&&"Identifier"===s.argument.type?this.raiseRecoverable(s.start,"Deleting local variable in strict mode"):t=!0,r=this.finishNode(s,o?"UpdateExpression":"UnaryExpression")}else{if(r=this.parseExprSubscripts(e),this.checkExpressionErrors(e))return r;for(;this.type.postfix&&!this.canInsertSemicolon();){var a=this.startNodeAt(n,i);a.operator=this.value,a.prefix=!1,a.argument=r,this.checkLVal(r),this.next(),r=this.finishNode(a,"UpdateExpression")}}return!t&&this.eat(types.starstar)?this.buildBinary(n,i,r,this.parseMaybeUnary(null,!1),"**",!1):r},pp$3.parseExprSubscripts=function(e){var t=this.start,r=this.startLoc,n=this.parseExprAtom(e),i="ArrowFunctionExpression"===n.type&&")"!==this.input.slice(this.lastTokStart,this.lastTokEnd);if(this.checkExpressionErrors(e)||i)return n;var s=this.parseSubscripts(n,t,r);return e&&"MemberExpression"===s.type&&(e.parenthesizedAssign>=s.start&&(e.parenthesizedAssign=-1),e.parenthesizedBind>=s.start&&(e.parenthesizedBind=-1)),s},pp$3.parseSubscripts=function(e,t,r,n){for(var i=this.options.ecmaVersion>=8&&"Identifier"===e.type&&"async"===e.name&&this.lastTokEnd===e.end&&!this.canInsertSemicolon()&&"async"===this.input.slice(e.start,e.end),s=void 0;;)if((s=this.eat(types.bracketL))||this.eat(types.dot)){var o=this.startNodeAt(t,r);o.object=e,o.property=s?this.parseExpression():this.parseIdent(!0),o.computed=!!s,s&&this.expect(types.bracketR),e=this.finishNode(o,"MemberExpression")}else if(!n&&this.eat(types.parenL)){var a=new DestructuringErrors,u=this.yieldPos,c=this.awaitPos;this.yieldPos=0,this.awaitPos=0;var h=this.parseExprList(types.parenR,this.options.ecmaVersion>=8,!1,a);if(i&&!this.canInsertSemicolon()&&this.eat(types.arrow))return this.checkPatternErrors(a,!1),this.checkYieldAwaitInDefaultParams(),this.yieldPos=u,this.awaitPos=c,this.parseArrowExpression(this.startNodeAt(t,r),h,!0);this.checkExpressionErrors(a,!0),this.yieldPos=u||this.yieldPos,this.awaitPos=c||this.awaitPos;var p=this.startNodeAt(t,r);p.callee=e,p.arguments=h,e=this.finishNode(p,"CallExpression")}else{if(this.type!==types.backQuote)return e;var l=this.startNodeAt(t,r);l.tag=e,l.quasi=this.parseTemplate({isTagged:!0}),e=this.finishNode(l,"TaggedTemplateExpression")}},pp$3.parseExprAtom=function(e){var t,r=this.potentialArrowAt===this.start;switch(this.type){case types._super:return this.inFunction||this.raise(this.start,"'super' outside of function or class"),t=this.startNode(),this.next(),this.type!==types.dot&&this.type!==types.bracketL&&this.type!==types.parenL&&this.unexpected(),this.finishNode(t,"Super");case types._this:return t=this.startNode(),this.next(),this.finishNode(t,"ThisExpression");case types.name:var n=this.start,i=this.startLoc,s=this.containsEsc,o=this.parseIdent(this.type!==types.name);if(this.options.ecmaVersion>=8&&!s&&"async"===o.name&&!this.canInsertSemicolon()&&this.eat(types._function))return this.parseFunction(this.startNodeAt(n,i),!1,!1,!0);if(r&&!this.canInsertSemicolon()){if(this.eat(types.arrow))return this.parseArrowExpression(this.startNodeAt(n,i),[o],!1);if(this.options.ecmaVersion>=8&&"async"===o.name&&this.type===types.name&&!s)return o=this.parseIdent(),!this.canInsertSemicolon()&&this.eat(types.arrow)||this.unexpected(),this.parseArrowExpression(this.startNodeAt(n,i),[o],!0)}return o;case types.regexp:var a=this.value;return(t=this.parseLiteral(a.value)).regex={pattern:a.pattern,flags:a.flags},t;case types.num:case types.string:return this.parseLiteral(this.value);case types._null:case types._true:case types._false:return(t=this.startNode()).value=this.type===types._null?null:this.type===types._true,t.raw=this.type.keyword,this.next(),this.finishNode(t,"Literal");case types.parenL:var u=this.start,c=this.parseParenAndDistinguishExpression(r);return e&&(e.parenthesizedAssign<0&&!this.isSimpleAssignTarget(c)&&(e.parenthesizedAssign=u),e.parenthesizedBind<0&&(e.parenthesizedBind=u)),c;case types.bracketL:return t=this.startNode(),this.next(),t.elements=this.parseExprList(types.bracketR,!0,!0,e),this.finishNode(t,"ArrayExpression");case types.braceL:return this.parseObj(!1,e);case types._function:return t=this.startNode(),this.next(),this.parseFunction(t,!1);case types._class:return this.parseClass(this.startNode(),!1);case types._new:return this.parseNew();case types.backQuote:return this.parseTemplate();default:this.unexpected()}},pp$3.parseLiteral=function(e){var t=this.startNode();return t.value=e,t.raw=this.input.slice(this.start,this.end),this.next(),this.finishNode(t,"Literal")},pp$3.parseParenExpression=function(){this.expect(types.parenL);var e=this.parseExpression();return this.expect(types.parenR),e},pp$3.parseParenAndDistinguishExpression=function(e){var t,r=this.start,n=this.startLoc,i=this.options.ecmaVersion>=8;if(this.options.ecmaVersion>=6){this.next();var s,o=this.start,a=this.startLoc,u=[],c=!0,h=!1,p=new DestructuringErrors,l=this.yieldPos,f=this.awaitPos;for(this.yieldPos=0,this.awaitPos=0;this.type!==types.parenR;){if(c?c=!1:this.expect(types.comma),i&&this.afterTrailingComma(types.parenR,!0)){h=!0;break}if(this.type===types.ellipsis){s=this.start,u.push(this.parseParenItem(this.parseRestBinding())),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element");break}u.push(this.parseMaybeAssign(!1,p,this.parseParenItem))}var d=this.start,m=this.startLoc;if(this.expect(types.parenR),e&&!this.canInsertSemicolon()&&this.eat(types.arrow))return this.checkPatternErrors(p,!1),this.checkYieldAwaitInDefaultParams(),this.yieldPos=l,this.awaitPos=f,this.parseParenArrowList(r,n,u);u.length&&!h||this.unexpected(this.lastTokStart),s&&this.unexpected(s),this.checkExpressionErrors(p,!0),this.yieldPos=l||this.yieldPos,this.awaitPos=f||this.awaitPos,u.length>1?((t=this.startNodeAt(o,a)).expressions=u,this.finishNodeAt(t,"SequenceExpression",d,m)):t=u[0]}else t=this.parseParenExpression();if(this.options.preserveParens){var g=this.startNodeAt(r,n);return g.expression=t,this.finishNode(g,"ParenthesizedExpression")}return t},pp$3.parseParenItem=function(e){return e},pp$3.parseParenArrowList=function(e,t,r){return this.parseArrowExpression(this.startNodeAt(e,t),r)};var empty$1=[];pp$3.parseNew=function(){var e=this.startNode(),t=this.parseIdent(!0);if(this.options.ecmaVersion>=6&&this.eat(types.dot)){e.meta=t;var r=this.containsEsc;return e.property=this.parseIdent(!0),("target"!==e.property.name||r)&&this.raiseRecoverable(e.property.start,"The only valid meta property for new is new.target"),this.inFunction||this.raiseRecoverable(e.start,"new.target can only be used in functions"),this.finishNode(e,"MetaProperty")}var n=this.start,i=this.startLoc;return e.callee=this.parseSubscripts(this.parseExprAtom(),n,i,!0),this.eat(types.parenL)?e.arguments=this.parseExprList(types.parenR,this.options.ecmaVersion>=8,!1):e.arguments=empty$1,this.finishNode(e,"NewExpression")},pp$3.parseTemplateElement=function(e){var t=e.isTagged,r=this.startNode();return this.type===types.invalidTemplate?(t||this.raiseRecoverable(this.start,"Bad escape sequence in untagged template literal"),r.value={raw:this.value,cooked:null}):r.value={raw:this.input.slice(this.start,this.end).replace(/\r\n?/g,"\n"),cooked:this.value},this.next(),r.tail=this.type===types.backQuote,this.finishNode(r,"TemplateElement")},pp$3.parseTemplate=function(e){void 0===e&&(e={});var t=e.isTagged;void 0===t&&(t=!1);var r=this.startNode();this.next(),r.expressions=[];var n=this.parseTemplateElement({isTagged:t});for(r.quasis=[n];!n.tail;)this.expect(types.dollarBraceL),r.expressions.push(this.parseExpression()),this.expect(types.braceR),r.quasis.push(n=this.parseTemplateElement({isTagged:t}));return this.next(),this.finishNode(r,"TemplateLiteral")},pp$3.isAsyncProp=function(e){return!e.computed&&"Identifier"===e.key.type&&"async"===e.key.name&&(this.type===types.name||this.type===types.num||this.type===types.string||this.type===types.bracketL||this.type.keyword||this.options.ecmaVersion>=9&&this.type===types.star)&&!lineBreak.test(this.input.slice(this.lastTokEnd,this.start))},pp$3.parseObj=function(e,t){var r=this.startNode(),n=!0,i={};for(r.properties=[],this.next();!this.eat(types.braceR);){if(n)n=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var s=this.parseProperty(e,t);e||this.checkPropClash(s,i,t),r.properties.push(s)}return this.finishNode(r,e?"ObjectPattern":"ObjectExpression")},pp$3.parseProperty=function(e,t){var r,n,i,s,o=this.startNode();if(this.options.ecmaVersion>=9&&this.eat(types.ellipsis))return e?(o.argument=this.parseIdent(!1),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.finishNode(o,"RestElement")):(this.type===types.parenL&&t&&(t.parenthesizedAssign<0&&(t.parenthesizedAssign=this.start),t.parenthesizedBind<0&&(t.parenthesizedBind=this.start)),o.argument=this.parseMaybeAssign(!1,t),this.type===types.comma&&t&&t.trailingComma<0&&(t.trailingComma=this.start),this.finishNode(o,"SpreadElement"));this.options.ecmaVersion>=6&&(o.method=!1,o.shorthand=!1,(e||t)&&(i=this.start,s=this.startLoc),e||(r=this.eat(types.star)));var a=this.containsEsc;return this.parsePropertyName(o),!e&&!a&&this.options.ecmaVersion>=8&&!r&&this.isAsyncProp(o)?(n=!0,r=this.options.ecmaVersion>=9&&this.eat(types.star),this.parsePropertyName(o,t)):n=!1,this.parsePropertyValue(o,e,r,n,i,s,t,a),this.finishNode(o,"Property")},pp$3.parsePropertyValue=function(e,t,r,n,i,s,o,a){if((r||n)&&this.type===types.colon&&this.unexpected(),this.eat(types.colon))e.value=t?this.parseMaybeDefault(this.start,this.startLoc):this.parseMaybeAssign(!1,o),e.kind="init";else if(this.options.ecmaVersion>=6&&this.type===types.parenL)t&&this.unexpected(),e.kind="init",e.method=!0,e.value=this.parseMethod(r,n);else if(t||a||!(this.options.ecmaVersion>=5)||e.computed||"Identifier"!==e.key.type||"get"!==e.key.name&&"set"!==e.key.name||this.type===types.comma||this.type===types.braceR)this.options.ecmaVersion>=6&&!e.computed&&"Identifier"===e.key.type?(this.checkUnreserved(e.key),e.kind="init",t?e.value=this.parseMaybeDefault(i,s,e.key):this.type===types.eq&&o?(o.shorthandAssign<0&&(o.shorthandAssign=this.start),e.value=this.parseMaybeDefault(i,s,e.key)):e.value=e.key,e.shorthand=!0):this.unexpected();else{(r||n)&&this.unexpected(),e.kind=e.key.name,this.parsePropertyName(e),e.value=this.parseMethod(!1);var u="get"===e.kind?0:1;if(e.value.params.length!==u){var c=e.value.start;"get"===e.kind?this.raiseRecoverable(c,"getter should have no params"):this.raiseRecoverable(c,"setter should have exactly one param")}else"set"===e.kind&&"RestElement"===e.value.params[0].type&&this.raiseRecoverable(e.value.params[0].start,"Setter cannot use rest params")}},pp$3.parsePropertyName=function(e){if(this.options.ecmaVersion>=6){if(this.eat(types.bracketL))return e.computed=!0,e.key=this.parseMaybeAssign(),this.expect(types.bracketR),e.key;e.computed=!1}return e.key=this.type===types.num||this.type===types.string?this.parseExprAtom():this.parseIdent(!0)},pp$3.initFunction=function(e){e.id=null,this.options.ecmaVersion>=6&&(e.generator=!1,e.expression=!1),this.options.ecmaVersion>=8&&(e.async=!1)},pp$3.parseMethod=function(e,t){var r=this.startNode(),n=this.inGenerator,i=this.inAsync,s=this.yieldPos,o=this.awaitPos,a=this.inFunction;return this.initFunction(r),this.options.ecmaVersion>=6&&(r.generator=e),this.options.ecmaVersion>=8&&(r.async=!!t),this.inGenerator=r.generator,this.inAsync=r.async,this.yieldPos=0,this.awaitPos=0,this.inFunction=!0,this.enterFunctionScope(),this.expect(types.parenL),r.params=this.parseBindingList(types.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams(),this.parseFunctionBody(r,!1),this.inGenerator=n,this.inAsync=i,this.yieldPos=s,this.awaitPos=o,this.inFunction=a,this.finishNode(r,"FunctionExpression")},pp$3.parseArrowExpression=function(e,t,r){var n=this.inGenerator,i=this.inAsync,s=this.yieldPos,o=this.awaitPos,a=this.inFunction;return this.enterFunctionScope(),this.initFunction(e),this.options.ecmaVersion>=8&&(e.async=!!r),this.inGenerator=!1,this.inAsync=e.async,this.yieldPos=0,this.awaitPos=0,this.inFunction=!0,e.params=this.toAssignableList(t,!0),this.parseFunctionBody(e,!0),this.inGenerator=n,this.inAsync=i,this.yieldPos=s,this.awaitPos=o,this.inFunction=a,this.finishNode(e,"ArrowFunctionExpression")},pp$3.parseFunctionBody=function(e,t){var r=t&&this.type!==types.braceL,n=this.strict,i=!1;if(r)e.body=this.parseMaybeAssign(),e.expression=!0,this.checkParams(e,!1);else{var s=this.options.ecmaVersion>=7&&!this.isSimpleParamList(e.params);n&&!s||(i=this.strictDirective(this.end))&&s&&this.raiseRecoverable(e.start,"Illegal 'use strict' directive in function with non-simple parameter list");var o=this.labels;this.labels=[],i&&(this.strict=!0),this.checkParams(e,!n&&!i&&!t&&this.isSimpleParamList(e.params)),e.body=this.parseBlock(!1),e.expression=!1,this.adaptDirectivePrologue(e.body.body),this.labels=o}this.exitFunctionScope(),this.strict&&e.id&&this.checkLVal(e.id,"none"),this.strict=n},pp$3.isSimpleParamList=function(e){for(var t=0,r=e;t<r.length;t+=1){if("Identifier"!==r[t].type)return!1}return!0},pp$3.checkParams=function(e,t){for(var r={},n=0,i=e.params;n<i.length;n+=1){var s=i[n];this.checkLVal(s,"var",t?null:r)}},pp$3.parseExprList=function(e,t,r,n){for(var i=[],s=!0;!this.eat(e);){if(s)s=!1;else if(this.expect(types.comma),t&&this.afterTrailingComma(e))break;var o=void 0;r&&this.type===types.comma?o=null:this.type===types.ellipsis?(o=this.parseSpread(n),n&&this.type===types.comma&&n.trailingComma<0&&(n.trailingComma=this.start)):o=this.parseMaybeAssign(!1,n),i.push(o)}return i},pp$3.checkUnreserved=function(e){var t=e.start,r=e.end,n=e.name;(this.inGenerator&&"yield"===n&&this.raiseRecoverable(t,"Can not use 'yield' as identifier inside a generator"),this.inAsync&&"await"===n&&this.raiseRecoverable(t,"Can not use 'await' as identifier inside an async function"),this.isKeyword(n)&&this.raise(t,"Unexpected keyword '"+n+"'"),this.options.ecmaVersion<6&&-1!==this.input.slice(t,r).indexOf("\\"))||(this.strict?this.reservedWordsStrict:this.reservedWords).test(n)&&(this.inAsync||"await"!==n||this.raiseRecoverable(t,"Can not use keyword 'await' outside an async function"),this.raiseRecoverable(t,"The keyword '"+n+"' is reserved"))},pp$3.parseIdent=function(e,t){var r=this.startNode();return e&&"never"===this.options.allowReserved&&(e=!1),this.type===types.name?r.name=this.value:this.type.keyword?(r.name=this.type.keyword,"class"!==r.name&&"function"!==r.name||this.lastTokEnd===this.lastTokStart+1&&46===this.input.charCodeAt(this.lastTokStart)||this.context.pop()):this.unexpected(),this.next(),this.finishNode(r,"Identifier"),e||this.checkUnreserved(r),r},pp$3.parseYield=function(){this.yieldPos||(this.yieldPos=this.start);var e=this.startNode();return this.next(),this.type===types.semi||this.canInsertSemicolon()||this.type!==types.star&&!this.type.startsExpr?(e.delegate=!1,e.argument=null):(e.delegate=this.eat(types.star),e.argument=this.parseMaybeAssign()),this.finishNode(e,"YieldExpression")},pp$3.parseAwait=function(){this.awaitPos||(this.awaitPos=this.start);var e=this.startNode();return this.next(),e.argument=this.parseMaybeUnary(null,!0),this.finishNode(e,"AwaitExpression")};var pp$4=Parser.prototype;pp$4.raise=function(e,t){var r=getLineInfo(this.input,e);t+=" ("+r.line+":"+r.column+")";var n=new SyntaxError(t);throw n.pos=e,n.loc=r,n.raisedAt=this.pos,n},pp$4.raiseRecoverable=pp$4.raise,pp$4.curPosition=function(){if(this.options.locations)return new Position(this.curLine,this.pos-this.lineStart)};var pp$5=Parser.prototype,assign=Object.assign||function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];for(var n=0,i=t;n<i.length;n+=1){var s=i[n];for(var o in s)has(s,o)&&(e[o]=s[o])}return e};pp$5.enterFunctionScope=function(){this.scopeStack.push({var:{},lexical:{},childVar:{},parentLexical:{}})},pp$5.exitFunctionScope=function(){this.scopeStack.pop()},pp$5.enterLexicalScope=function(){var e=this.scopeStack[this.scopeStack.length-1],t={var:{},lexical:{},childVar:{},parentLexical:{}};this.scopeStack.push(t),assign(t.parentLexical,e.lexical,e.parentLexical)},pp$5.exitLexicalScope=function(){var e=this.scopeStack.pop(),t=this.scopeStack[this.scopeStack.length-1];assign(t.childVar,e.var,e.childVar)},pp$5.canDeclareVarName=function(e){var t=this.scopeStack[this.scopeStack.length-1];return!has(t.lexical,e)&&!has(t.parentLexical,e)},pp$5.canDeclareLexicalName=function(e){var t=this.scopeStack[this.scopeStack.length-1];return!has(t.lexical,e)&&!has(t.var,e)&&!has(t.childVar,e)},pp$5.declareVarName=function(e){this.scopeStack[this.scopeStack.length-1].var[e]=!0},pp$5.declareLexicalName=function(e){this.scopeStack[this.scopeStack.length-1].lexical[e]=!0};var Node=function(e,t,r){this.type="",this.start=t,this.end=0,e.options.locations&&(this.loc=new SourceLocation(e,r)),e.options.directSourceFile&&(this.sourceFile=e.options.directSourceFile),e.options.ranges&&(this.range=[t,0])},pp$6=Parser.prototype;function finishNodeAt(e,t,r,n){return e.type=t,e.end=r,this.options.locations&&(e.loc.end=n),this.options.ranges&&(e.range[1]=r),e}pp$6.startNode=function(){return new Node(this,this.start,this.startLoc)},pp$6.startNodeAt=function(e,t){return new Node(this,e,t)},pp$6.finishNode=function(e,t){return finishNodeAt.call(this,e,t,this.lastTokEnd,this.lastTokEndLoc)},pp$6.finishNodeAt=function(e,t,r,n){return finishNodeAt.call(this,e,t,r,n)};var TokContext=function(e,t,r,n,i){this.token=e,this.isExpr=!!t,this.preserveSpace=!!r,this.override=n,this.generator=!!i},types$1={b_stat:new TokContext("{",!1),b_expr:new TokContext("{",!0),b_tmpl:new TokContext("${",!1),p_stat:new TokContext("(",!1),p_expr:new TokContext("(",!0),q_tmpl:new TokContext("`",!0,!0,function(e){return e.tryReadTemplateToken()}),f_stat:new TokContext("function",!1),f_expr:new TokContext("function",!0),f_expr_gen:new TokContext("function",!0,!1,null,!0),f_gen:new TokContext("function",!1,!1,null,!0)},pp$7=Parser.prototype;pp$7.initialContext=function(){return[types$1.b_stat]},pp$7.braceIsBlock=function(e){var t=this.curContext();return t===types$1.f_expr||t===types$1.f_stat||(e!==types.colon||t!==types$1.b_stat&&t!==types$1.b_expr?e===types._return||e===types.name&&this.exprAllowed?lineBreak.test(this.input.slice(this.lastTokEnd,this.start)):e===types._else||e===types.semi||e===types.eof||e===types.parenR||e===types.arrow||(e===types.braceL?t===types$1.b_stat:e!==types._var&&e!==types.name&&!this.exprAllowed):!t.isExpr)},pp$7.inGeneratorContext=function(){for(var e=this.context.length-1;e>=1;e--){var t=this.context[e];if("function"===t.token)return t.generator}return!1},pp$7.updateContext=function(e){var t,r=this.type;r.keyword&&e===types.dot?this.exprAllowed=!1:(t=r.updateContext)?t.call(this,e):this.exprAllowed=r.beforeExpr},types.parenR.updateContext=types.braceR.updateContext=function(){if(1!==this.context.length){var e=this.context.pop();e===types$1.b_stat&&"function"===this.curContext().token&&(e=this.context.pop()),this.exprAllowed=!e.isExpr}else this.exprAllowed=!0},types.braceL.updateContext=function(e){this.context.push(this.braceIsBlock(e)?types$1.b_stat:types$1.b_expr),this.exprAllowed=!0},types.dollarBraceL.updateContext=function(){this.context.push(types$1.b_tmpl),this.exprAllowed=!0},types.parenL.updateContext=function(e){var t=e===types._if||e===types._for||e===types._with||e===types._while;this.context.push(t?types$1.p_stat:types$1.p_expr),this.exprAllowed=!0},types.incDec.updateContext=function(){},types._function.updateContext=types._class.updateContext=function(e){e.beforeExpr&&e!==types.semi&&e!==types._else&&(e!==types.colon&&e!==types.braceL||this.curContext()!==types$1.b_stat)?this.context.push(types$1.f_expr):this.context.push(types$1.f_stat),this.exprAllowed=!1},types.backQuote.updateContext=function(){this.curContext()===types$1.q_tmpl?this.context.pop():this.context.push(types$1.q_tmpl),this.exprAllowed=!1},types.star.updateContext=function(e){if(e===types._function){var t=this.context.length-1;this.context[t]===types$1.f_expr?this.context[t]=types$1.f_expr_gen:this.context[t]=types$1.f_gen}this.exprAllowed=!0},types.name.updateContext=function(e){var t=!1;this.options.ecmaVersion>=6&&("of"===this.value&&!this.exprAllowed||"yield"===this.value&&this.inGeneratorContext())&&(t=!0),this.exprAllowed=t};var data={$LONE:["ASCII","ASCII_Hex_Digit","AHex","Alphabetic","Alpha","Any","Assigned","Bidi_Control","Bidi_C","Bidi_Mirrored","Bidi_M","Case_Ignorable","CI","Cased","Changes_When_Casefolded","CWCF","Changes_When_Casemapped","CWCM","Changes_When_Lowercased","CWL","Changes_When_NFKC_Casefolded","CWKCF","Changes_When_Titlecased","CWT","Changes_When_Uppercased","CWU","Dash","Default_Ignorable_Code_Point","DI","Deprecated","Dep","Diacritic","Dia","Emoji","Emoji_Component","Emoji_Modifier","Emoji_Modifier_Base","Emoji_Presentation","Extender","Ext","Grapheme_Base","Gr_Base","Grapheme_Extend","Gr_Ext","Hex_Digit","Hex","IDS_Binary_Operator","IDSB","IDS_Trinary_Operator","IDST","ID_Continue","IDC","ID_Start","IDS","Ideographic","Ideo","Join_Control","Join_C","Logical_Order_Exception","LOE","Lowercase","Lower","Math","Noncharacter_Code_Point","NChar","Pattern_Syntax","Pat_Syn","Pattern_White_Space","Pat_WS","Quotation_Mark","QMark","Radical","Regional_Indicator","RI","Sentence_Terminal","STerm","Soft_Dotted","SD","Terminal_Punctuation","Term","Unified_Ideograph","UIdeo","Uppercase","Upper","Variation_Selector","VS","White_Space","space","XID_Continue","XIDC","XID_Start","XIDS"],General_Category:["Cased_Letter","LC","Close_Punctuation","Pe","Connector_Punctuation","Pc","Control","Cc","cntrl","Currency_Symbol","Sc","Dash_Punctuation","Pd","Decimal_Number","Nd","digit","Enclosing_Mark","Me","Final_Punctuation","Pf","Format","Cf","Initial_Punctuation","Pi","Letter","L","Letter_Number","Nl","Line_Separator","Zl","Lowercase_Letter","Ll","Mark","M","Combining_Mark","Math_Symbol","Sm","Modifier_Letter","Lm","Modifier_Symbol","Sk","Nonspacing_Mark","Mn","Number","N","Open_Punctuation","Ps","Other","C","Other_Letter","Lo","Other_Number","No","Other_Punctuation","Po","Other_Symbol","So","Paragraph_Separator","Zp","Private_Use","Co","Punctuation","P","punct","Separator","Z","Space_Separator","Zs","Spacing_Mark","Mc","Surrogate","Cs","Symbol","S","Titlecase_Letter","Lt","Unassigned","Cn","Uppercase_Letter","Lu"],Script:["Adlam","Adlm","Ahom","Anatolian_Hieroglyphs","Hluw","Arabic","Arab","Armenian","Armn","Avestan","Avst","Balinese","Bali","Bamum","Bamu","Bassa_Vah","Bass","Batak","Batk","Bengali","Beng","Bhaiksuki","Bhks","Bopomofo","Bopo","Brahmi","Brah","Braille","Brai","Buginese","Bugi","Buhid","Buhd","Canadian_Aboriginal","Cans","Carian","Cari","Caucasian_Albanian","Aghb","Chakma","Cakm","Cham","Cherokee","Cher","Common","Zyyy","Coptic","Copt","Qaac","Cuneiform","Xsux","Cypriot","Cprt","Cyrillic","Cyrl","Deseret","Dsrt","Devanagari","Deva","Duployan","Dupl","Egyptian_Hieroglyphs","Egyp","Elbasan","Elba","Ethiopic","Ethi","Georgian","Geor","Glagolitic","Glag","Gothic","Goth","Grantha","Gran","Greek","Grek","Gujarati","Gujr","Gurmukhi","Guru","Han","Hani","Hangul","Hang","Hanunoo","Hano","Hatran","Hatr","Hebrew","Hebr","Hiragana","Hira","Imperial_Aramaic","Armi","Inherited","Zinh","Qaai","Inscriptional_Pahlavi","Phli","Inscriptional_Parthian","Prti","Javanese","Java","Kaithi","Kthi","Kannada","Knda","Katakana","Kana","Kayah_Li","Kali","Kharoshthi","Khar","Khmer","Khmr","Khojki","Khoj","Khudawadi","Sind","Lao","Laoo","Latin","Latn","Lepcha","Lepc","Limbu","Limb","Linear_A","Lina","Linear_B","Linb","Lisu","Lycian","Lyci","Lydian","Lydi","Mahajani","Mahj","Malayalam","Mlym","Mandaic","Mand","Manichaean","Mani","Marchen","Marc","Masaram_Gondi","Gonm","Meetei_Mayek","Mtei","Mende_Kikakui","Mend","Meroitic_Cursive","Merc","Meroitic_Hieroglyphs","Mero","Miao","Plrd","Modi","Mongolian","Mong","Mro","Mroo","Multani","Mult","Myanmar","Mymr","Nabataean","Nbat","New_Tai_Lue","Talu","Newa","Nko","Nkoo","Nushu","Nshu","Ogham","Ogam","Ol_Chiki","Olck","Old_Hungarian","Hung","Old_Italic","Ital","Old_North_Arabian","Narb","Old_Permic","Perm","Old_Persian","Xpeo","Old_South_Arabian","Sarb","Old_Turkic","Orkh","Oriya","Orya","Osage","Osge","Osmanya","Osma","Pahawh_Hmong","Hmng","Palmyrene","Palm","Pau_Cin_Hau","Pauc","Phags_Pa","Phag","Phoenician","Phnx","Psalter_Pahlavi","Phlp","Rejang","Rjng","Runic","Runr","Samaritan","Samr","Saurashtra","Saur","Sharada","Shrd","Shavian","Shaw","Siddham","Sidd","SignWriting","Sgnw","Sinhala","Sinh","Sora_Sompeng","Sora","Soyombo","Soyo","Sundanese","Sund","Syloti_Nagri","Sylo","Syriac","Syrc","Tagalog","Tglg","Tagbanwa","Tagb","Tai_Le","Tale","Tai_Tham","Lana","Tai_Viet","Tavt","Takri","Takr","Tamil","Taml","Tangut","Tang","Telugu","Telu","Thaana","Thaa","Thai","Tibetan","Tibt","Tifinagh","Tfng","Tirhuta","Tirh","Ugaritic","Ugar","Vai","Vaii","Warang_Citi","Wara","Yi","Yiii","Zanabazar_Square","Zanb"]};Array.prototype.push.apply(data.$LONE,data.General_Category),data.gc=data.General_Category,data.sc=data.Script_Extensions=data.scx=data.Script;var pp$9=Parser.prototype,RegExpValidationState=function(e){this.parser=e,this.validFlags="gim"+(e.options.ecmaVersion>=6?"uy":"")+(e.options.ecmaVersion>=9?"s":""),this.source="",this.flags="",this.start=0,this.switchU=!1,this.switchN=!1,this.pos=0,this.lastIntValue=0,this.lastStringValue="",this.lastAssertionIsQuantifiable=!1,this.numCapturingParens=0,this.maxBackReference=0,this.groupNames=[],this.backReferenceNames=[]};function codePointToString$1(e){return e<=65535?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}function isSyntaxCharacter(e){return 36===e||e>=40&&e<=43||46===e||63===e||e>=91&&e<=94||e>=123&&e<=125}function isRegExpIdentifierStart(e){return isIdentifierStart(e,!0)||36===e||95===e}function isRegExpIdentifierPart(e){return isIdentifierChar(e,!0)||36===e||95===e||8204===e||8205===e}function isControlLetter(e){return e>=65&&e<=90||e>=97&&e<=122}function isValidUnicode(e){return e>=0&&e<=1114111}function isCharacterClassEscape(e){return 100===e||68===e||115===e||83===e||119===e||87===e}function isUnicodePropertyNameCharacter(e){return isControlLetter(e)||95===e}function isUnicodePropertyValueCharacter(e){return isUnicodePropertyNameCharacter(e)||isDecimalDigit(e)}function isDecimalDigit(e){return e>=48&&e<=57}function isHexDigit(e){return e>=48&&e<=57||e>=65&&e<=70||e>=97&&e<=102}function hexToInt(e){return e>=65&&e<=70?e-65+10:e>=97&&e<=102?e-97+10:e-48}function isOctalDigit(e){return e>=48&&e<=55}RegExpValidationState.prototype.reset=function(e,t,r){var n=-1!==r.indexOf("u");this.start=0|e,this.source=t+"",this.flags=r,this.switchU=n&&this.parser.options.ecmaVersion>=6,this.switchN=n&&this.parser.options.ecmaVersion>=9},RegExpValidationState.prototype.raise=function(e){this.parser.raiseRecoverable(this.start,"Invalid regular expression: /"+this.source+"/: "+e)},RegExpValidationState.prototype.at=function(e){var t=this.source,r=t.length;if(e>=r)return-1;var n=t.charCodeAt(e);return!this.switchU||n<=55295||n>=57344||e+1>=r?n:(n<<10)+t.charCodeAt(e+1)-56613888},RegExpValidationState.prototype.nextIndex=function(e){var t=this.source,r=t.length;if(e>=r)return r;var n=t.charCodeAt(e);return!this.switchU||n<=55295||n>=57344||e+1>=r?e+1:e+2},RegExpValidationState.prototype.current=function(){return this.at(this.pos)},RegExpValidationState.prototype.lookahead=function(){return this.at(this.nextIndex(this.pos))},RegExpValidationState.prototype.advance=function(){this.pos=this.nextIndex(this.pos)},RegExpValidationState.prototype.eat=function(e){return this.current()===e&&(this.advance(),!0)},pp$9.validateRegExpFlags=function(e){for(var t=e.validFlags,r=e.flags,n=0;n<r.length;n++){var i=r.charAt(n);-1===t.indexOf(i)&&this.raise(e.start,"Invalid regular expression flag"),r.indexOf(i,n+1)>-1&&this.raise(e.start,"Duplicate regular expression flag")}},pp$9.validateRegExpPattern=function(e){this.regexp_pattern(e),!e.switchN&&this.options.ecmaVersion>=9&&e.groupNames.length>0&&(e.switchN=!0,this.regexp_pattern(e))},pp$9.regexp_pattern=function(e){e.pos=0,e.lastIntValue=0,e.lastStringValue="",e.lastAssertionIsQuantifiable=!1,e.numCapturingParens=0,e.maxBackReference=0,e.groupNames.length=0,e.backReferenceNames.length=0,this.regexp_disjunction(e),e.pos!==e.source.length&&(e.eat(41)&&e.raise("Unmatched ')'"),(e.eat(93)||e.eat(125))&&e.raise("Lone quantifier brackets")),e.maxBackReference>e.numCapturingParens&&e.raise("Invalid escape");for(var t=0,r=e.backReferenceNames;t<r.length;t+=1){var n=r[t];-1===e.groupNames.indexOf(n)&&e.raise("Invalid named capture referenced")}},pp$9.regexp_disjunction=function(e){for(this.regexp_alternative(e);e.eat(124);)this.regexp_alternative(e);this.regexp_eatQuantifier(e,!0)&&e.raise("Nothing to repeat"),e.eat(123)&&e.raise("Lone quantifier brackets")},pp$9.regexp_alternative=function(e){for(;e.pos<e.source.length&&this.regexp_eatTerm(e););},pp$9.regexp_eatTerm=function(e){return this.regexp_eatAssertion(e)?(e.lastAssertionIsQuantifiable&&this.regexp_eatQuantifier(e)&&e.switchU&&e.raise("Invalid quantifier"),!0):!(e.switchU?!this.regexp_eatAtom(e):!this.regexp_eatExtendedAtom(e))&&(this.regexp_eatQuantifier(e),!0)},pp$9.regexp_eatAssertion=function(e){var t=e.pos;if(e.lastAssertionIsQuantifiable=!1,e.eat(94)||e.eat(36))return!0;if(e.eat(92)){if(e.eat(66)||e.eat(98))return!0;e.pos=t}if(e.eat(40)&&e.eat(63)){var r=!1;if(this.options.ecmaVersion>=9&&(r=e.eat(60)),e.eat(61)||e.eat(33))return this.regexp_disjunction(e),e.eat(41)||e.raise("Unterminated group"),e.lastAssertionIsQuantifiable=!r,!0}return e.pos=t,!1},pp$9.regexp_eatQuantifier=function(e,t){return void 0===t&&(t=!1),!!this.regexp_eatQuantifierPrefix(e,t)&&(e.eat(63),!0)},pp$9.regexp_eatQuantifierPrefix=function(e,t){return e.eat(42)||e.eat(43)||e.eat(63)||this.regexp_eatBracedQuantifier(e,t)},pp$9.regexp_eatBracedQuantifier=function(e,t){var r=e.pos;if(e.eat(123)){var n=0,i=-1;if(this.regexp_eatDecimalDigits(e)&&(n=e.lastIntValue,e.eat(44)&&this.regexp_eatDecimalDigits(e)&&(i=e.lastIntValue),e.eat(125)))return-1!==i&&i<n&&!t&&e.raise("numbers out of order in {} quantifier"),!0;e.switchU&&!t&&e.raise("Incomplete quantifier"),e.pos=r}return!1},pp$9.regexp_eatAtom=function(e){return this.regexp_eatPatternCharacters(e)||e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)},pp$9.regexp_eatReverseSolidusAtomEscape=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatAtomEscape(e))return!0;e.pos=t}return!1},pp$9.regexp_eatUncapturingGroup=function(e){var t=e.pos;if(e.eat(40)){if(e.eat(63)&&e.eat(58)){if(this.regexp_disjunction(e),e.eat(41))return!0;e.raise("Unterminated group")}e.pos=t}return!1},pp$9.regexp_eatCapturingGroup=function(e){if(e.eat(40)){if(this.options.ecmaVersion>=9?this.regexp_groupSpecifier(e):63===e.current()&&e.raise("Invalid group"),this.regexp_disjunction(e),e.eat(41))return e.numCapturingParens+=1,!0;e.raise("Unterminated group")}return!1},pp$9.regexp_eatExtendedAtom=function(e){return e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)||this.regexp_eatInvalidBracedQuantifier(e)||this.regexp_eatExtendedPatternCharacter(e)},pp$9.regexp_eatInvalidBracedQuantifier=function(e){return this.regexp_eatBracedQuantifier(e,!0)&&e.raise("Nothing to repeat"),!1},pp$9.regexp_eatSyntaxCharacter=function(e){var t=e.current();return!!isSyntaxCharacter(t)&&(e.lastIntValue=t,e.advance(),!0)},pp$9.regexp_eatPatternCharacters=function(e){for(var t=e.pos,r=0;-1!==(r=e.current())&&!isSyntaxCharacter(r);)e.advance();return e.pos!==t},pp$9.regexp_eatExtendedPatternCharacter=function(e){var t=e.current();return!(-1===t||36===t||t>=40&&t<=43||46===t||63===t||91===t||94===t||124===t)&&(e.advance(),!0)},pp$9.regexp_groupSpecifier=function(e){if(e.eat(63)){if(this.regexp_eatGroupName(e))return-1!==e.groupNames.indexOf(e.lastStringValue)&&e.raise("Duplicate capture group name"),void e.groupNames.push(e.lastStringValue);e.raise("Invalid group")}},pp$9.regexp_eatGroupName=function(e){if(e.lastStringValue="",e.eat(60)){if(this.regexp_eatRegExpIdentifierName(e)&&e.eat(62))return!0;e.raise("Invalid capture group name")}return!1},pp$9.regexp_eatRegExpIdentifierName=function(e){if(e.lastStringValue="",this.regexp_eatRegExpIdentifierStart(e)){for(e.lastStringValue+=codePointToString$1(e.lastIntValue);this.regexp_eatRegExpIdentifierPart(e);)e.lastStringValue+=codePointToString$1(e.lastIntValue);return!0}return!1},pp$9.regexp_eatRegExpIdentifierStart=function(e){var t=e.pos,r=e.current();return e.advance(),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e)&&(r=e.lastIntValue),isRegExpIdentifierStart(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},pp$9.regexp_eatRegExpIdentifierPart=function(e){var t=e.pos,r=e.current();return e.advance(),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e)&&(r=e.lastIntValue),isRegExpIdentifierPart(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},pp$9.regexp_eatAtomEscape=function(e){return!!(this.regexp_eatBackReference(e)||this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)||e.switchN&&this.regexp_eatKGroupName(e))||(e.switchU&&(99===e.current()&&e.raise("Invalid unicode escape"),e.raise("Invalid escape")),!1)},pp$9.regexp_eatBackReference=function(e){var t=e.pos;if(this.regexp_eatDecimalEscape(e)){var r=e.lastIntValue;if(e.switchU)return r>e.maxBackReference&&(e.maxBackReference=r),!0;if(r<=e.numCapturingParens)return!0;e.pos=t}return!1},pp$9.regexp_eatKGroupName=function(e){if(e.eat(107)){if(this.regexp_eatGroupName(e))return e.backReferenceNames.push(e.lastStringValue),!0;e.raise("Invalid named reference")}return!1},pp$9.regexp_eatCharacterEscape=function(e){return this.regexp_eatControlEscape(e)||this.regexp_eatCControlLetter(e)||this.regexp_eatZero(e)||this.regexp_eatHexEscapeSequence(e)||this.regexp_eatRegExpUnicodeEscapeSequence(e)||!e.switchU&&this.regexp_eatLegacyOctalEscapeSequence(e)||this.regexp_eatIdentityEscape(e)},pp$9.regexp_eatCControlLetter=function(e){var t=e.pos;if(e.eat(99)){if(this.regexp_eatControlLetter(e))return!0;e.pos=t}return!1},pp$9.regexp_eatZero=function(e){return 48===e.current()&&!isDecimalDigit(e.lookahead())&&(e.lastIntValue=0,e.advance(),!0)},pp$9.regexp_eatControlEscape=function(e){var t=e.current();return 116===t?(e.lastIntValue=9,e.advance(),!0):110===t?(e.lastIntValue=10,e.advance(),!0):118===t?(e.lastIntValue=11,e.advance(),!0):102===t?(e.lastIntValue=12,e.advance(),!0):114===t&&(e.lastIntValue=13,e.advance(),!0)},pp$9.regexp_eatControlLetter=function(e){var t=e.current();return!!isControlLetter(t)&&(e.lastIntValue=t%32,e.advance(),!0)},pp$9.regexp_eatRegExpUnicodeEscapeSequence=function(e){var t=e.pos;if(e.eat(117)){if(this.regexp_eatFixedHexDigits(e,4)){var r=e.lastIntValue;if(e.switchU&&r>=55296&&r<=56319){var n=e.pos;if(e.eat(92)&&e.eat(117)&&this.regexp_eatFixedHexDigits(e,4)){var i=e.lastIntValue;if(i>=56320&&i<=57343)return e.lastIntValue=1024*(r-55296)+(i-56320)+65536,!0}e.pos=n,e.lastIntValue=r}return!0}if(e.switchU&&e.eat(123)&&this.regexp_eatHexDigits(e)&&e.eat(125)&&isValidUnicode(e.lastIntValue))return!0;e.switchU&&e.raise("Invalid unicode escape"),e.pos=t}return!1},pp$9.regexp_eatIdentityEscape=function(e){if(e.switchU)return!!this.regexp_eatSyntaxCharacter(e)||!!e.eat(47)&&(e.lastIntValue=47,!0);var t=e.current();return!(99===t||e.switchN&&107===t)&&(e.lastIntValue=t,e.advance(),!0)},pp$9.regexp_eatDecimalEscape=function(e){e.lastIntValue=0;var t=e.current();if(t>=49&&t<=57){do{e.lastIntValue=10*e.lastIntValue+(t-48),e.advance()}while((t=e.current())>=48&&t<=57);return!0}return!1},pp$9.regexp_eatCharacterClassEscape=function(e){var t=e.current();if(isCharacterClassEscape(t))return e.lastIntValue=-1,e.advance(),!0;if(e.switchU&&this.options.ecmaVersion>=9&&(80===t||112===t)){if(e.lastIntValue=-1,e.advance(),e.eat(123)&&this.regexp_eatUnicodePropertyValueExpression(e)&&e.eat(125))return!0;e.raise("Invalid property name")}return!1},pp$9.regexp_eatUnicodePropertyValueExpression=function(e){var t=e.pos;if(this.regexp_eatUnicodePropertyName(e)&&e.eat(61)){var r=e.lastStringValue;if(this.regexp_eatUnicodePropertyValue(e)){var n=e.lastStringValue;return this.regexp_validateUnicodePropertyNameAndValue(e,r,n),!0}}if(e.pos=t,this.regexp_eatLoneUnicodePropertyNameOrValue(e)){var i=e.lastStringValue;return this.regexp_validateUnicodePropertyNameOrValue(e,i),!0}return!1},pp$9.regexp_validateUnicodePropertyNameAndValue=function(e,t,r){data.hasOwnProperty(t)&&-1!==data[t].indexOf(r)||e.raise("Invalid property name")},pp$9.regexp_validateUnicodePropertyNameOrValue=function(e,t){-1===data.$LONE.indexOf(t)&&e.raise("Invalid property name")},pp$9.regexp_eatUnicodePropertyName=function(e){var t=0;for(e.lastStringValue="";isUnicodePropertyNameCharacter(t=e.current());)e.lastStringValue+=codePointToString$1(t),e.advance();return""!==e.lastStringValue},pp$9.regexp_eatUnicodePropertyValue=function(e){var t=0;for(e.lastStringValue="";isUnicodePropertyValueCharacter(t=e.current());)e.lastStringValue+=codePointToString$1(t),e.advance();return""!==e.lastStringValue},pp$9.regexp_eatLoneUnicodePropertyNameOrValue=function(e){return this.regexp_eatUnicodePropertyValue(e)},pp$9.regexp_eatCharacterClass=function(e){if(e.eat(91)){if(e.eat(94),this.regexp_classRanges(e),e.eat(93))return!0;e.raise("Unterminated character class")}return!1},pp$9.regexp_classRanges=function(e){for(;this.regexp_eatClassAtom(e);){var t=e.lastIntValue;if(e.eat(45)&&this.regexp_eatClassAtom(e)){var r=e.lastIntValue;!e.switchU||-1!==t&&-1!==r||e.raise("Invalid character class"),-1!==t&&-1!==r&&t>r&&e.raise("Range out of order in character class")}}},pp$9.regexp_eatClassAtom=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatClassEscape(e))return!0;if(e.switchU){var r=e.current();(99===r||isOctalDigit(r))&&e.raise("Invalid class escape"),e.raise("Invalid escape")}e.pos=t}var n=e.current();return 93!==n&&(e.lastIntValue=n,e.advance(),!0)},pp$9.regexp_eatClassEscape=function(e){var t=e.pos;if(e.eat(98))return e.lastIntValue=8,!0;if(e.switchU&&e.eat(45))return e.lastIntValue=45,!0;if(!e.switchU&&e.eat(99)){if(this.regexp_eatClassControlLetter(e))return!0;e.pos=t}return this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)},pp$9.regexp_eatClassControlLetter=function(e){var t=e.current();return!(!isDecimalDigit(t)&&95!==t)&&(e.lastIntValue=t%32,e.advance(),!0)},pp$9.regexp_eatHexEscapeSequence=function(e){var t=e.pos;if(e.eat(120)){if(this.regexp_eatFixedHexDigits(e,2))return!0;e.switchU&&e.raise("Invalid escape"),e.pos=t}return!1},pp$9.regexp_eatDecimalDigits=function(e){var t=e.pos,r=0;for(e.lastIntValue=0;isDecimalDigit(r=e.current());)e.lastIntValue=10*e.lastIntValue+(r-48),e.advance();return e.pos!==t},pp$9.regexp_eatHexDigits=function(e){var t=e.pos,r=0;for(e.lastIntValue=0;isHexDigit(r=e.current());)e.lastIntValue=16*e.lastIntValue+hexToInt(r),e.advance();return e.pos!==t},pp$9.regexp_eatLegacyOctalEscapeSequence=function(e){if(this.regexp_eatOctalDigit(e)){var t=e.lastIntValue;if(this.regexp_eatOctalDigit(e)){var r=e.lastIntValue;t<=3&&this.regexp_eatOctalDigit(e)?e.lastIntValue=64*t+8*r+e.lastIntValue:e.lastIntValue=8*t+r}else e.lastIntValue=t;return!0}return!1},pp$9.regexp_eatOctalDigit=function(e){var t=e.current();return isOctalDigit(t)?(e.lastIntValue=t-48,e.advance(),!0):(e.lastIntValue=0,!1)},pp$9.regexp_eatFixedHexDigits=function(e,t){var r=e.pos;e.lastIntValue=0;for(var n=0;n<t;++n){var i=e.current();if(!isHexDigit(i))return e.pos=r,!1;e.lastIntValue=16*e.lastIntValue+hexToInt(i),e.advance()}return!0};var Token=function(e){this.type=e.type,this.value=e.value,this.start=e.start,this.end=e.end,e.options.locations&&(this.loc=new SourceLocation(e,e.startLoc,e.endLoc)),e.options.ranges&&(this.range=[e.start,e.end])},pp$8=Parser.prototype;function codePointToString(e){return e<=65535?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}pp$8.next=function(){this.options.onToken&&this.options.onToken(new Token(this)),this.lastTokEnd=this.end,this.lastTokStart=this.start,this.lastTokEndLoc=this.endLoc,this.lastTokStartLoc=this.startLoc,this.nextToken()},pp$8.getToken=function(){return this.next(),new Token(this)},"undefined"!=typeof Symbol&&(pp$8[Symbol.iterator]=function(){var e=this;return{next:function(){var t=e.getToken();return{done:t.type===types.eof,value:t}}}}),pp$8.curContext=function(){return this.context[this.context.length-1]},pp$8.nextToken=function(){var e=this.curContext();return e&&e.preserveSpace||this.skipSpace(),this.start=this.pos,this.options.locations&&(this.startLoc=this.curPosition()),this.pos>=this.input.length?this.finishToken(types.eof):e.override?e.override(this):void this.readToken(this.fullCharCodeAtPos())},pp$8.readToken=function(e){return isIdentifierStart(e,this.options.ecmaVersion>=6)||92===e?this.readWord():this.getTokenFromCode(e)},pp$8.fullCharCodeAtPos=function(){var e=this.input.charCodeAt(this.pos);return e<=55295||e>=57344?e:(e<<10)+this.input.charCodeAt(this.pos+1)-56613888},pp$8.skipBlockComment=function(){var e,t=this.options.onComment&&this.curPosition(),r=this.pos,n=this.input.indexOf("*/",this.pos+=2);if(-1===n&&this.raise(this.pos-2,"Unterminated comment"),this.pos=n+2,this.options.locations)for(lineBreakG.lastIndex=r;(e=lineBreakG.exec(this.input))&&e.index<this.pos;)++this.curLine,this.lineStart=e.index+e[0].length;this.options.onComment&&this.options.onComment(!0,this.input.slice(r+2,n),r,this.pos,t,this.curPosition())},pp$8.skipLineComment=function(e){for(var t=this.pos,r=this.options.onComment&&this.curPosition(),n=this.input.charCodeAt(this.pos+=e);this.pos<this.input.length&&!isNewLine(n);)n=this.input.charCodeAt(++this.pos);this.options.onComment&&this.options.onComment(!1,this.input.slice(t+e,this.pos),t,this.pos,r,this.curPosition())},pp$8.skipSpace=function(){e:for(;this.pos<this.input.length;){var e=this.input.charCodeAt(this.pos);switch(e){case 32:case 160:++this.pos;break;case 13:10===this.input.charCodeAt(this.pos+1)&&++this.pos;case 10:case 8232:case 8233:++this.pos,this.options.locations&&(++this.curLine,this.lineStart=this.pos);break;case 47:switch(this.input.charCodeAt(this.pos+1)){case 42:this.skipBlockComment();break;case 47:this.skipLineComment(2);break;default:break e}break;default:if(!(e>8&&e<14||e>=5760&&nonASCIIwhitespace.test(String.fromCharCode(e))))break e;++this.pos}}},pp$8.finishToken=function(e,t){this.end=this.pos,this.options.locations&&(this.endLoc=this.curPosition());var r=this.type;this.type=e,this.value=t,this.updateContext(r)},pp$8.readToken_dot=function(){var e=this.input.charCodeAt(this.pos+1);if(e>=48&&e<=57)return this.readNumber(!0);var t=this.input.charCodeAt(this.pos+2);return this.options.ecmaVersion>=6&&46===e&&46===t?(this.pos+=3,this.finishToken(types.ellipsis)):(++this.pos,this.finishToken(types.dot))},pp$8.readToken_slash=function(){var e=this.input.charCodeAt(this.pos+1);return this.exprAllowed?(++this.pos,this.readRegexp()):61===e?this.finishOp(types.assign,2):this.finishOp(types.slash,1)},pp$8.readToken_mult_modulo_exp=function(e){var t=this.input.charCodeAt(this.pos+1),r=1,n=42===e?types.star:types.modulo;return this.options.ecmaVersion>=7&&42===e&&42===t&&(++r,n=types.starstar,t=this.input.charCodeAt(this.pos+2)),61===t?this.finishOp(types.assign,r+1):this.finishOp(n,r)},pp$8.readToken_pipe_amp=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?this.finishOp(124===e?types.logicalOR:types.logicalAND,2):61===t?this.finishOp(types.assign,2):this.finishOp(124===e?types.bitwiseOR:types.bitwiseAND,1)},pp$8.readToken_caret=function(){return 61===this.input.charCodeAt(this.pos+1)?this.finishOp(types.assign,2):this.finishOp(types.bitwiseXOR,1)},pp$8.readToken_plus_min=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?45!==t||this.inModule||62!==this.input.charCodeAt(this.pos+2)||0!==this.lastTokEnd&&!lineBreak.test(this.input.slice(this.lastTokEnd,this.pos))?this.finishOp(types.incDec,2):(this.skipLineComment(3),this.skipSpace(),this.nextToken()):61===t?this.finishOp(types.assign,2):this.finishOp(types.plusMin,1)},pp$8.readToken_lt_gt=function(e){var t=this.input.charCodeAt(this.pos+1),r=1;return t===e?(r=62===e&&62===this.input.charCodeAt(this.pos+2)?3:2,61===this.input.charCodeAt(this.pos+r)?this.finishOp(types.assign,r+1):this.finishOp(types.bitShift,r)):33!==t||60!==e||this.inModule||45!==this.input.charCodeAt(this.pos+2)||45!==this.input.charCodeAt(this.pos+3)?(61===t&&(r=2),this.finishOp(types.relational,r)):(this.skipLineComment(4),this.skipSpace(),this.nextToken())},pp$8.readToken_eq_excl=function(e){var t=this.input.charCodeAt(this.pos+1);return 61===t?this.finishOp(types.equality,61===this.input.charCodeAt(this.pos+2)?3:2):61===e&&62===t&&this.options.ecmaVersion>=6?(this.pos+=2,this.finishToken(types.arrow)):this.finishOp(61===e?types.eq:types.prefix,1)},pp$8.getTokenFromCode=function(e){switch(e){case 46:return this.readToken_dot();case 40:return++this.pos,this.finishToken(types.parenL);case 41:return++this.pos,this.finishToken(types.parenR);case 59:return++this.pos,this.finishToken(types.semi);case 44:return++this.pos,this.finishToken(types.comma);case 91:return++this.pos,this.finishToken(types.bracketL);case 93:return++this.pos,this.finishToken(types.bracketR);case 123:return++this.pos,this.finishToken(types.braceL);case 125:return++this.pos,this.finishToken(types.braceR);case 58:return++this.pos,this.finishToken(types.colon);case 63:return++this.pos,this.finishToken(types.question);case 96:if(this.options.ecmaVersion<6)break;return++this.pos,this.finishToken(types.backQuote);case 48:var t=this.input.charCodeAt(this.pos+1);if(120===t||88===t)return this.readRadixNumber(16);if(this.options.ecmaVersion>=6){if(111===t||79===t)return this.readRadixNumber(8);if(98===t||66===t)return this.readRadixNumber(2)}case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return this.readNumber(!1);case 34:case 39:return this.readString(e);case 47:return this.readToken_slash();case 37:case 42:return this.readToken_mult_modulo_exp(e);case 124:case 38:return this.readToken_pipe_amp(e);case 94:return this.readToken_caret();case 43:case 45:return this.readToken_plus_min(e);case 60:case 62:return this.readToken_lt_gt(e);case 61:case 33:return this.readToken_eq_excl(e);case 126:return this.finishOp(types.prefix,1)}this.raise(this.pos,"Unexpected character '"+codePointToString(e)+"'")},pp$8.finishOp=function(e,t){var r=this.input.slice(this.pos,this.pos+t);return this.pos+=t,this.finishToken(e,r)},pp$8.readRegexp=function(){for(var e,t,r=this.pos;;){this.pos>=this.input.length&&this.raise(r,"Unterminated regular expression");var n=this.input.charAt(this.pos);if(lineBreak.test(n)&&this.raise(r,"Unterminated regular expression"),e)e=!1;else{if("["===n)t=!0;else if("]"===n&&t)t=!1;else if("/"===n&&!t)break;e="\\"===n}++this.pos}var i=this.input.slice(r,this.pos);++this.pos;var s=this.pos,o=this.readWord1();this.containsEsc&&this.unexpected(s);var a=this.regexpState||(this.regexpState=new RegExpValidationState(this));a.reset(r,i,o),this.validateRegExpFlags(a),this.validateRegExpPattern(a);var u=null;try{u=new RegExp(i,o)}catch(e){}return this.finishToken(types.regexp,{pattern:i,flags:o,value:u})},pp$8.readInt=function(e,t){for(var r=this.pos,n=0,i=0,s=null==t?1/0:t;i<s;++i){var o=this.input.charCodeAt(this.pos),a=void 0;if((a=o>=97?o-97+10:o>=65?o-65+10:o>=48&&o<=57?o-48:1/0)>=e)break;++this.pos,n=n*e+a}return this.pos===r||null!=t&&this.pos-r!==t?null:n},pp$8.readRadixNumber=function(e){this.pos+=2;var t=this.readInt(e);return null==t&&this.raise(this.start+2,"Expected number in radix "+e),isIdentifierStart(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(types.num,t)},pp$8.readNumber=function(e){var t=this.pos;e||null!==this.readInt(10)||this.raise(t,"Invalid number");var r=this.pos-t>=2&&48===this.input.charCodeAt(t);r&&this.strict&&this.raise(t,"Invalid number"),r&&/[89]/.test(this.input.slice(t,this.pos))&&(r=!1);var n=this.input.charCodeAt(this.pos);46!==n||r||(++this.pos,this.readInt(10),n=this.input.charCodeAt(this.pos)),69!==n&&101!==n||r||(43!==(n=this.input.charCodeAt(++this.pos))&&45!==n||++this.pos,null===this.readInt(10)&&this.raise(t,"Invalid number")),isIdentifierStart(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number");var i=this.input.slice(t,this.pos),s=r?parseInt(i,8):parseFloat(i);return this.finishToken(types.num,s)},pp$8.readCodePoint=function(){var e;if(123===this.input.charCodeAt(this.pos)){this.options.ecmaVersion<6&&this.unexpected();var t=++this.pos;e=this.readHexChar(this.input.indexOf("}",this.pos)-this.pos),++this.pos,e>1114111&&this.invalidStringToken(t,"Code point out of bounds")}else e=this.readHexChar(4);return e},pp$8.readString=function(e){for(var t="",r=++this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated string constant");var n=this.input.charCodeAt(this.pos);if(n===e)break;92===n?(t+=this.input.slice(r,this.pos),t+=this.readEscapedChar(!1),r=this.pos):(isNewLine(n,this.options.ecmaVersion>=10)&&this.raise(this.start,"Unterminated string constant"),++this.pos)}return t+=this.input.slice(r,this.pos++),this.finishToken(types.string,t)};var INVALID_TEMPLATE_ESCAPE_ERROR={};pp$8.tryReadTemplateToken=function(){this.inTemplateElement=!0;try{this.readTmplToken()}catch(e){if(e!==INVALID_TEMPLATE_ESCAPE_ERROR)throw e;this.readInvalidTemplateToken()}this.inTemplateElement=!1},pp$8.invalidStringToken=function(e,t){if(this.inTemplateElement&&this.options.ecmaVersion>=9)throw INVALID_TEMPLATE_ESCAPE_ERROR;this.raise(e,t)},pp$8.readTmplToken=function(){for(var e="",t=this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated template");var r=this.input.charCodeAt(this.pos);if(96===r||36===r&&123===this.input.charCodeAt(this.pos+1))return this.pos!==this.start||this.type!==types.template&&this.type!==types.invalidTemplate?(e+=this.input.slice(t,this.pos),this.finishToken(types.template,e)):36===r?(this.pos+=2,this.finishToken(types.dollarBraceL)):(++this.pos,this.finishToken(types.backQuote));if(92===r)e+=this.input.slice(t,this.pos),e+=this.readEscapedChar(!0),t=this.pos;else if(isNewLine(r)){switch(e+=this.input.slice(t,this.pos),++this.pos,r){case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:e+="\n";break;default:e+=String.fromCharCode(r)}this.options.locations&&(++this.curLine,this.lineStart=this.pos),t=this.pos}else++this.pos}},pp$8.readInvalidTemplateToken=function(){for(;this.pos<this.input.length;this.pos++)switch(this.input[this.pos]){case"\\":++this.pos;break;case"$":if("{"!==this.input[this.pos+1])break;case"`":return this.finishToken(types.invalidTemplate,this.input.slice(this.start,this.pos))}this.raise(this.start,"Unterminated template")},pp$8.readEscapedChar=function(e){var t=this.input.charCodeAt(++this.pos);switch(++this.pos,t){case 110:return"\n";case 114:return"\r";case 120:return String.fromCharCode(this.readHexChar(2));case 117:return codePointToString(this.readCodePoint());case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:return this.options.locations&&(this.lineStart=this.pos,++this.curLine),"";default:if(t>=48&&t<=55){var r=this.input.substr(this.pos-1,3).match(/^[0-7]+/)[0],n=parseInt(r,8);return n>255&&(r=r.slice(0,-1),n=parseInt(r,8)),this.pos+=r.length-1,t=this.input.charCodeAt(this.pos),"0"===r&&56!==t&&57!==t||!this.strict&&!e||this.invalidStringToken(this.pos-1-r.length,e?"Octal literal in template string":"Octal literal in strict mode"),String.fromCharCode(n)}return String.fromCharCode(t)}},pp$8.readHexChar=function(e){var t=this.pos,r=this.readInt(16,e);return null===r&&this.invalidStringToken(t,"Bad character escape sequence"),r},pp$8.readWord1=function(){this.containsEsc=!1;for(var e="",t=!0,r=this.pos,n=this.options.ecmaVersion>=6;this.pos<this.input.length;){var i=this.fullCharCodeAtPos();if(isIdentifierChar(i,n))this.pos+=i<=65535?1:2;else{if(92!==i)break;this.containsEsc=!0,e+=this.input.slice(r,this.pos);var s=this.pos;117!==this.input.charCodeAt(++this.pos)&&this.invalidStringToken(this.pos,"Expecting Unicode escape sequence \\uXXXX"),++this.pos;var o=this.readCodePoint();(t?isIdentifierStart:isIdentifierChar)(o,n)||this.invalidStringToken(s,"Invalid Unicode escape"),e+=codePointToString(o),r=this.pos}t=!1}return e+this.input.slice(r,this.pos)},pp$8.readWord=function(){var e=this.readWord1(),t=types.name;return this.keywords.test(e)&&(this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword "+e),t=keywords$1[e]),this.finishToken(t,e)};var parse_dammit,LooseParser,pluginsLoose,version$1="5.7.1";function parse$1(e,t){return new Parser(t,e).parse()}function parseExpressionAt(e,t,r){var n=new Parser(r,e,t);return n.nextToken(),n.parseExpression()}function tokenizer(e,t){return new Parser(t,e)}function addLooseExports(e,t,r){parse_dammit=e,LooseParser=t,pluginsLoose=r}var acorn=Object.freeze({version:version$1,parse:parse$1,parseExpressionAt:parseExpressionAt,tokenizer:tokenizer,get parse_dammit(){return parse_dammit},get LooseParser(){return LooseParser},get pluginsLoose(){return pluginsLoose},addLooseExports:addLooseExports,Parser:Parser,plugins:plugins,defaultOptions:defaultOptions,Position:Position,SourceLocation:SourceLocation,getLineInfo:getLineInfo,Node:Node,TokenType:TokenType,tokTypes:types,keywordTypes:keywords$1,TokContext:TokContext,tokContexts:types$1,isIdentifierChar:isIdentifierChar,isIdentifierStart:isIdentifierStart,Token:Token,isNewLine:isNewLine,lineBreak:lineBreak,lineBreakG:lineBreakG,nonASCIIwhitespace:nonASCIIwhitespace}),inject=createCommonjsModule$1(function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.tokTypes;return t._import.startsExpr=!0,e.plugins.dynamicImport=function(e){e.extend("parseStatement",function(e){return function(){var r=this.startNode();if(this.type===t._import&&function(){return this.input[this.pos]}.call(this)===t.parenL.label){var n=this.parseExpression();return this.parseExpressionStatement(r,n)}for(var i=arguments.length,s=Array(i),o=0;o<i;o++)s[o]=arguments[o];return e.apply(this,s)}}),e.extend("parseExprAtom",function(e){return function(n){return this.type===t._import?function(){var e=this.startNode();return this.next(),this.type!==t.parenL&&this.unexpected(),this.finishNode(e,r)}.call(this):e.call(this,n)}})},e};var r=t.DynamicImportKey="Import"}),injectDynamicImportPlugin=unwrapExports$1(inject),inject_1=inject.DynamicImportKey;const skipWhiteSpace$1=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;var inject$1=function(e){const t=e.tokTypes,r=e=>{skipWhiteSpace$1.lastIndex=e.pos;let t=skipWhiteSpace$1.exec(e.input),r=e.pos+t[0].length;return"."===e.input.slice(r,r+1)};return e.plugins.importMeta=function(e){e.extend("parseExprAtom",function(e){return function(n){if(this.type!==t._import||!r(this))return e.call(this,n);this.options.allowImportExportEverywhere||this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'");let i=this.startNode();return i.meta=this.parseIdent(!0),this.expect(t.dot),i.property=this.parseIdent(!0),"meta"!==i.property.name&&this.raiseRecoverable(i.property.start,"The only valid meta property for import is import.meta"),this.finishNode(i,"MetaProperty")}}),e.extend("parseStatement",function(e){return function(n,i,s){if(this.type!==t._import)return e.call(this,n,i,s);if(!r(this))return e.call(this,n,i,s);let o=this.startNode(),a=this.parseExpression();return this.parseExpressionStatement(o,a)}})},e},UndefinedVariable=function(e){function t(){return e.call(this,"undefined")||this}return __extends$1(t,e),t.prototype.getLiteralValueAtPath=function(){},t}(Variable),GlobalScope=function(e){function t(){var t=e.call(this)||this;return t.variables.undefined=new UndefinedVariable,t}return __extends$1(t,e),t.prototype.findVariable=function(e){return this.variables[e]?this.variables[e]:this.variables[e]=new GlobalVariable(e)},t.prototype.deshadow=function(t,r){void 0===r&&(r=this.children),e.prototype.deshadow.call(this,t,r)},t}(Scope),getNewTrackedPaths=function(){return{tracked:!1,unknownPath:null,paths:Object.create(null)}},EntityPathTracker=function(){function e(){this.entityPaths=new Map}return e.prototype.track=function(e,t){var r=this.entityPaths.get(e);r||(r=getNewTrackedPaths(),this.entityPaths.set(e,r));for(var n,i=0;i<t.length;){var s=t[i];"string"==typeof s?(n=r.paths[s])||(n=getNewTrackedPaths(),r.paths[s]=n):(n=r.unknownPath)||(n=getNewTrackedPaths(),r.unknownPath=n),r=n,i++}var o=r.tracked;return r.tracked=!0,o},e}();function getAssetFileName(e,t,r){return void 0===e.source&&error({code:"ASSET_SOURCE_NOT_FOUND",message:"Plugin error creating asset "+e.name+" - no asset source set."}),e.fileName?e.fileName:makeUnique(renderNamePattern(r,"assetFileNames",function(t){switch(t){case"hash":var r=_256();return r.update(t),r.update(":"),r.update(e.source),r.digest("hex").substr(0,8);case"name":return e.name.substr(0,e.name.length-path.extname(e.name).length);case"extname":return path.extname(e.name);case"ext":return path.extname(e.name).substr(1)}}),t)}function createAssetPluginHooks(e,t,r){return{emitAsset:function(n,i){var s;"string"==typeof n&&isPlainName(n)||error({code:"INVALID_ASSET_NAME",message:"Plugin error creating asset, name is not a plain (non relative or absolute URL) string name."});do{var o=_256();s?o.update(s):o.update(n),s=o.digest("hex").substr(0,8)}while(e.has(s));var a={name:n,source:i,fileName:void 0};return t&&void 0!==i&&finaliseAsset(a,t,r),e.set(s,a),s},setAssetSource:function(n,i){var s=e.get(n);s||error({code:"ASSET_NOT_FOUND",message:"Plugin error - Unable to set asset source for unknown asset "+n+"."}),void 0!==s.source&&error({code:"ASSET_SOURCE_ALREADY_SET",message:"Plugin error - Unable to set asset source for "+s.name+", source already set."}),"string"==typeof i||i||error({code:"ASSET_SOURCE_MISSING",message:"Plugin error creating asset "+name+", setAssetSource call without a source."}),s.source=i,t&&finaliseAsset(s,t,r)},getAssetFileName:function(t){var r=e.get(t);return r||error({code:"ASSET_NOT_FOUND",message:"Plugin error - Unable to get asset filename for unknown asset "+t+"."}),void 0===r.fileName&&error({code:"ASSET_NOT_FINALISED",message:"Plugin error - Unable to get asset file name for asset "+t+". Ensure that the source is set and that generate is called first."}),r.fileName}}}function finaliseAsset(e,t,r){var n=getAssetFileName(e,t,r);e.fileName=n,t[n]=e.source}function createTransformEmitAsset(e,t){var r=[];return{assets:r,emitAsset:function(n,i){var s=t(n,i),o=e.get(s);return r.push({name:o.name,source:o.source,fileName:void 0}),s}}}var CHAR_CODE_A=97,CHAR_CODE_0=48;function intToHex(e){return e<10?String.fromCharCode(CHAR_CODE_0+e):String.fromCharCode(CHAR_CODE_A+(e-10))}function Uint8ArrayToHexString(e){for(var t="",r=0;r<e.length;r++){var n=e[r];t+=intToHex(n>>4),t+=intToHex(15&n)}return t}function Uint8ArrayXor(e,t){for(var r=0;r<e.length;r++)e[r]=e[r]^t[r];return e}function randomUint8Array(e){for(var t=new Uint8Array(e),r=0;r<t.length;r++)t[r]=512*Math.random();return t}function Uint8ArrayEqual(e,t){for(var r=0;r<e.length;r++)if(e[r]!==t[r])return!1;return!0}var version$1$1="0.65.0";function mkdirpath(e){var t=path.dirname(e);try{fs$1.readdirSync(t)}catch(e){mkdirpath(t);try{fs$1.mkdirSync(t)}catch(e){if("EEXIST"!==e.code)throw e}}}function writeFile$1(e,t){return new Promise(function(r,n){mkdirpath(e),fs$1.writeFile(e,t,function(e){e?n(e):r()})})}function getRollupDefaultPlugin(e){return{name:"Rollup Core",resolveId:createResolveId(e),load:function(e){return fs$1.readFileSync(e,"utf-8")},resolveDynamicImport:function(e,t){if("string"==typeof e)return this.resolveId(e,t)}}}function findFile(e,t){try{var r=fs$1.lstatSync(e);if(!t&&r.isSymbolicLink())return findFile(fs$1.realpathSync(e),t);if(t&&r.isSymbolicLink()||r.isFile()){var n=path.basename(e);if(-1!==fs$1.readdirSync(path.dirname(e)).indexOf(n))return e}}catch(e){}}function addJsExtensionIfNecessary(e,t){var r=findFile(e,t);return r||((r=findFile(e+".mjs",t))?r:r=findFile(e+".js",t))}function createResolveId(e){return function(t,r){return"undefined"==typeof process&&error({code:"MISSING_PROCESS",message:"It looks like you're using Rollup in a non-Node.js environment. This means you must supply a plugin with custom resolveId and load functions",url:"https://github.com/rollup/rollup/wiki/Plugins"}),void 0===r||isAbsolute(t)||"."===t[0]?addJsExtensionIfNecessary(path.resolve(r?path.dirname(r):path.resolve(),t),e.preserveSymlinks):null}}function createPluginDriver(e,t,r,n){var i=(t.plugins||[]).concat([getRollupDefaultPlugin(t)]),s=createAssetPluginHooks(e.assetsById),o=s.emitAsset,a=s.getAssetFileName,u=s.setAssetSource,c=[],h=!1,p=i.map(function(t){var i,s=!0;if("string"!=typeof t.cacheKey&&("string"!=typeof t.name?s=!1:(-1!==c.indexOf(t.name)&&(s=!1),c.push(t.name))),!h&&(t.load||t.transform||t.transformBundle||t.transformChunk)&&(h=!0),r)if(s){var p=t.cacheKey||t.name;i=createPluginCache(r[p]||(r[p]=Object.create(null)))}else i=uncacheablePlugin(t.name);else i=noCache;return{addWatchFile:function(t){e.finished&&this.error("addWatchFile can only be called during the build."),e.watchFiles[t]=!0},cache:i,emitAsset:o,error:function(e){"string"==typeof e&&(e={message:e}),e.code&&(e.pluginCode=e.code),e.code="PLUGIN_ERROR",e.plugin=t.name||"(anonymous plugin)",error(e)},isExternal:function(t,r,n){return void 0===n&&(n=!1),e.isExternal(t,r,n)},getAssetFileName:a,meta:{rollupVersion:version$1$1},parse:e.contextParse,resolveId:function(e,t){return d.hookFirst("resolveId",[e,t])},setAssetSource:u,warn:function(r){"string"==typeof r&&(r={message:r}),r.code&&(r.pluginCode=r.code),r.code="PLUGIN_WARNING",r.plugin=t.name||"(anonymous plugin)",e.warn(r)},watcher:n}});function l(e,t,r,n,s){void 0===n&&(n=!1);var o=i[r],a=p[r],u=o[e];if(u){if(s&&(!(a=s(a,o))||a===p[r]))throw new Error("Internal Rollup error: hookContext must return a new context object.");try{if("function"!=typeof u){if(n)return u;error({code:"INVALID_PLUGIN_HOOK",message:"Error running plugin hook "+e+" for "+(o.name||"Plugin at pos "+(r+1))+", expected a function hook."})}return u.apply(a,t)}catch(t){"string"==typeof t&&(t={message:t}),"PLUGIN_ERROR"!==t.code&&(t.code&&(t.pluginCode=t.code),t.code="PLUGIN_ERROR"),t.plugin=o.name||"Plugin at pos "+r,t.hook=e,error(t)}}}function f(e,t,r,n,s){void 0===n&&(n=!1);var o=i[r],a=p[r],u=o[e];if(u){if(s&&(!(a=s(a,o))||a===p[r]))throw new Error("Internal Rollup error: hookContext must return a new context object.");return Promise.resolve().then(function(){if("function"!=typeof u){if(n)return u;error({code:"INVALID_PLUGIN_HOOK",message:"Error running plugin hook "+e+" for "+(o.name||"Plugin at pos "+(r+1))+", expected a function hook."})}return u.apply(a,t)}).catch(function(t){"string"==typeof t&&(t={message:t}),"PLUGIN_ERROR"!==t.code&&(t.code&&(t.pluginCode=t.code),t.code="PLUGIN_ERROR"),t.plugin=o.name||"Plugin at pos "+r,t.hook=e,error(t)})}}var d={emitAsset:o,getAssetFileName:a,hasLoadersOrTransforms:h,hookSeq:function(e,t,r){for(var n=Promise.resolve(),s=function(i){n=n.then(function(){return f(e,t,i,!1,r)})},o=0;o<i.length;o++)s(o);return n},hookSeqSync:function(e,t,r){for(var n=0;n<i.length;n++)l(e,t,n,!1,r)},hookFirst:function(e,t,r){for(var n=Promise.resolve(),s=function(i){n=n.then(function(n){return null!=n?n:f(e,t,i,!1,r)})},o=0;o<i.length;o++)s(o);return n},hookParallel:function(e,t,r){for(var n=[],s=0;s<i.length;s++){var o=f(e,t,s,!1,r);o&&n.push(o)}return Promise.all(n).then(function(){})},hookReduceArg0:function(e,t,r,n){for(var s=t[0],o=t.slice(1),a=Promise.resolve(s),u=function(t){a=a.then(function(s){var a=f(e,[s].concat(o),t,!1,n);return a?a.then(function(e){return r(s,e,i[t])}):s})},c=0;c<i.length;c++)u(c);return a},hookReduceValue:function(e,t,r,n,s){for(var o=Promise.resolve(t),a=function(t){o=o.then(function(o){var a=f(e,r,t,!0,s);return a?a.then(function(e){return n(o,e,i[t])}):o})},u=0;u<i.length;u++)a(u);return o}};return d}function createPluginCache(e){return{has:function(t){var r=e[t];return!!r&&(r[0]=0,!0)},get:function(t){var r=e[t];if(r)return r[0]=0,r[1]},set:function(t,r){e[t]=[0,r]},delete:function(t){return delete e[t]}}}function trackPluginCache(e){var t={used:!1,cache:void 0};return t.cache={has:function(r){return t.used=!0,e.has(r)},get:function(r){return t.used=!0,e.get(r)},set:function(r,n){return t.used=!0,e.set(r,n)},delete:function(r){return t.used=!0,e.delete(r)}},t}var noCache={has:function(){return!1},get:function(){},set:function(){},delete:function(){return!1}};function uncacheablePluginError(e){error(e?{code:"DUPLICATE_PLUGIN_NAME",message:"The plugin name ${pluginName} is being used twice in the same build. Plugin names must be distinct or provide a cacheKey (please post an issue to the plugin if you are a plugin user)."}:{code:"ANONYMOUS_PLUGIN_CACHE",message:"A plugin is trying to use the Rollup cache but is not declaring a plugin name or cacheKey."})}var uncacheablePlugin=function(e){return{has:function(){return uncacheablePluginError(e),!1},get:function(){uncacheablePluginError(e)},set:function(){uncacheablePluginError(e)},delete:function(){return uncacheablePluginError(e),!1}}};function transform(e,t,r){var n=r.id,i=[],s="string"==typeof t.map?JSON.parse(t.map):t.map;s&&"string"==typeof s.mappings&&(s.mappings=decode(s.mappings));var o,a,u,c,h=e.pluginDriver.emitAsset,p=t.code,l=t.ast,f=!1,d=t.code;return e.pluginDriver.hookReduceArg0("transform",[d,n],function(t,s,c){if(!f&&u.used&&(f=!0),f){if(s&&Array.isArray(s.dependencies))for(var h=0,p=s.dependencies;h<p.length;h++){var d=p[h],m=path.resolve(path.dirname(n),d);e.watchFiles[m]||(e.watchFiles[m]=!0)}}else if(a.length&&(r.transformAssets=a),s&&Array.isArray(s.dependencies)){o||(o=[]);for(var g=0,y=s.dependencies;g<y.length;g++)d=y[g],o.push(path.resolve(path.dirname(n),d))}return null==s?t:("string"==typeof s?s={code:s,ast:void 0,map:void 0}:"string"==typeof s.map&&(s.map=JSON.parse(s.map)),s.map&&"string"==typeof s.map.mappings&&(s.map.mappings=decode(s.map.mappings)),null!==s.map&&i.push(s.map||{missing:!0,plugin:c.name}),l=s.ast,s.code)},function(t,r){var i,s;return r.cacheKey?f=!0:u=trackPluginCache(t.cache),i=createTransformEmitAsset(e.assetsById,h),a=i.assets,s=i.emitAsset,__assign$1({},t,{cache:u?u.cache:t.cache,warn:function(t,i){"string"==typeof t&&(t={message:t}),i&&augmentCodeLocation(t,i,d,n),t.code&&(t.pluginCode=t.code),t.id=n,t.code="PLUGIN_WARNING",t.plugin=r.name||"(anonymous plugin)",t.hook="transform",e.warn(t)},error:function(e,t){"string"==typeof e&&(e={message:e}),t&&augmentCodeLocation(e,t,d,n),e.code&&(e.pluginCode=e.code),e.id=n,e.code="PLUGIN_ERROR",e.plugin=r.name||"(anonymous plugin)",e.hook="transform",error(e)},emitAsset:s,setAssetSource:function(e,r){if(t.setAssetSource(e,r),!f&&!c)try{this.error({code:"INVALID_SETASSETSOURCE",message:"setAssetSource cannot be called in transform for caching reasons. Use emitAsset with a source, or call setAssetSource in another hook."})}catch(e){c=e}}})}).catch(function(e){"string"==typeof e&&(e={message:e}),"PLUGIN_ERROR"!==e.code&&(e.code&&(e.pluginCode=e.code),e.code="PLUGIN_ERROR"),e.id=n,error(e)}).then(function(e){if(!f&&c)throw c;return{code:e,transformDependencies:o,originalCode:p,originalSourcemap:s,ast:l,sourcemapChain:i,customTransformCache:f}})}function makeOnwarn(){var e=Object.create(null);return function(t){var r=t.toString();r in e||(console.error(r),e[r]=!0)}}var Graph=function(){function e(e,t){var r=this;if(this.curChunkIndex=0,this.externalModules=[],this.moduleById=new Map,this.assetsById=new Map,this.modules=[],this.watchFiles=Object.create(null),this.finished=!1,this.curChunkIndex=0,this.deoptimizationTracker=new EntityPathTracker,this.cachedModules=new Map,e.cache&&e.cache.modules)for(var n=0,i=e.cache.modules;n<i.length;n++){var s=i[n];this.cachedModules.set(s.id,s)}if(!1!==e.cache)for(var o in this.pluginCache=e.cache&&e.cache.plugins||Object.create(null),this.pluginCache)for(var a=this.pluginCache[o],u=0,c=Object.keys(a);u<c.length;u++){a[v=c[u]][0]++}if(this.cacheExpiry=e.experimentalCacheExpiry,!e.input)throw new Error("You must supply options.input to rollup");if(this.treeshake=!1!==e.treeshake,this.treeshake)if(this.treeshakingOptions={propertyReadSideEffects:!e.treeshake||!1!==e.treeshake.propertyReadSideEffects,pureExternalModules:!!e.treeshake&&e.treeshake.pureExternalModules},!0===this.treeshakingOptions.pureExternalModules)this.isPureExternalModule=function(){return!0};else if("function"==typeof this.treeshakingOptions.pureExternalModules)this.isPureExternalModule=this.treeshakingOptions.pureExternalModules;else if(Array.isArray(this.treeshakingOptions.pureExternalModules)){var h=new Set(this.treeshakingOptions.pureExternalModules);this.isPureExternalModule=function(e){return h.has(e)}}else this.isPureExternalModule=function(){return!1};else this.isPureExternalModule=function(){return!1};if(this.contextParse=function(e,t){return void 0===t&&(t={}),r.acornParse(e,__assign$1({},defaultAcornOptions,t,r.acornOptions))},this.pluginDriver=createPluginDriver(this,e,this.pluginCache,t),t&&t.on("change",function(e){return r.pluginDriver.hookSeqSync("watchChange",[e])}),"function"==typeof e.external){var p=e.external;this.isExternal=function(e,t,r){return!e.startsWith("\0")&&p(e,t,r)}}else{var l=e.external,f=new Set(Array.isArray(l)?l:l?[l]:[]);this.isExternal=function(e){return f.has(e)}}this.shimMissingExports=e.shimMissingExports,this.scope=new GlobalScope;for(var d=0,m=["module","exports","_interopDefault"];d<m.length;d++){o=m[d];this.scope.findVariable(o)}this.exportShimVariable=this.scope.findVariable("_missingExportShim"),this.context=String(e.context);var g=e.moduleContext;if("function"==typeof g)this.getModuleContext=function(e){return g(e)||r.context};else if("object"==typeof g){var y=new Map;for(var v in g)y.set(path.resolve(v),g[v]);this.getModuleContext=function(e){return y.get(e)||r.context}}else this.getModuleContext=function(){return r.context};this.onwarn=e.onwarn||makeOnwarn(),this.varOrConst=e.preferConst?"const":"var",this.acornOptions=e.acorn||{};var _=[];_.push(injectDynamicImportPlugin),_.push(inject$1),this.acornOptions.plugins=this.acornOptions.plugins||{},this.acornOptions.plugins.dynamicImport=!0,this.acornOptions.plugins.importMeta=!0,e.experimentalTopLevelAwait&&(this.acornOptions.allowAwaitOutsideFunction=!0);var x=e.acornInjectPlugins;_.push.apply(_,Array.isArray(x)?x:x?[x]:[]),this.acornParse=_.reduce(function(e,t){return t(e)},acorn).parse}return e.prototype.getCache=function(){for(var e in this.pluginCache){for(var t=this.pluginCache[e],r=!0,n=0,i=Object.keys(t);n<i.length;n++){var s=i[n];t[s][0]>=this.cacheExpiry?delete t[s]:r=!1}r&&delete this.pluginCache[e]}return{modules:this.modules.map(function(e){return e.toJSON()}),plugins:this.pluginCache}},e.prototype.finaliseAssets=function(e){var t=Object.create(null);return this.assetsById.forEach(function(r){void 0!==r.source&&finaliseAsset(r,t,e)}),t},e.prototype.loadModule=function(e){var t=this;return this.pluginDriver.hookFirst("resolveId",[e,void 0]).then(function(r){return!1===r&&error({code:"UNRESOLVED_ENTRY",message:"Entry module cannot be external"}),null==r&&error({code:"UNRESOLVED_ENTRY",message:"Could not resolve entry ("+e+")"}),t.fetchModule(r,void 0)})},e.prototype.link=function(){for(var e=0,t=this.modules;e<t.length;e++){t[e].linkDependencies()}for(var r=0,n=this.modules;r<n.length;r++){n[r].bindReferences()}},e.prototype.includeMarked=function(e){if(this.treeshake){var t=void 0,r=1;do{timeStart("treeshaking pass "+r,3),t=!1;for(var n=0,i=e;n<i.length;n++){i[n].include()&&(t=!0)}timeEnd("treeshaking pass "+r++,3)}while(t)}else for(var s=0,o=e;s<o.length;s++){o[s].includeAllInBundle()}},e.prototype.loadEntryModules=function(e,t){var r,n,i=this,s=!1;"string"==typeof e&&(e=[e]),Array.isArray(e)?(s=!0,n=e.concat([]),r=e):(n=Object.keys(e),r=n.map(function(t){return e[t]}));var o=r.concat([]);return t&&Object.keys(t).forEach(function(e){t[e].forEach(function(e){-1===o.indexOf(e)&&o.push(e)})}),Promise.all(o.map(function(e){return i.loadModule(e)})).then(function(e){if(s)for(var i=0;i<n.length;i++)n[i]=getAliasName(e[i].id,n[i]);var a,u=e.slice(0,r.length);if(t){a={};for(var c=0,h=Object.keys(t);c<h.length;c++){var p=h[c],l=t[p];a[p]=l.map(function(t){var r=o.indexOf(t);return e[r]})}}return{entryModules:u,entryModuleAliases:n,manualChunkModules:a}})},e.prototype.build=function(e,t,r,n){var i=this;return timeStart("parse modules",2),this.loadEntryModules(e,t).then(function(e){var t=e.entryModules,s=e.entryModuleAliases,o=e.manualChunkModules;timeEnd("parse modules",2),timeStart("analyse dependency graph",2);for(var a=0;a<t.length;a++){var u=t[a],c=t.indexOf(u,a+1);-1!==c&&error({code:"DUPLICATE_ENTRY_POINTS",message:"Duplicate entry points detected. The input entries "+s[a]+" and "+s[c]+" both point to the same module, "+u.id})}i.link();var h=i.analyseExecution(t,!n&&!r,r,o),p=h.orderedModules,l=h.dynamicImports,f=h.dynamicImportAliases;if(s)for(a=t.length-1;a>=0;a--)t[a].chunkAlias=s[a];if(r){u=t[0];if(t.length>1)throw new Error("Internal Error: can only inline dynamic imports for single-file builds.");for(var d=0,m=l;d<m.length;d++){u!==(g=m[d])&&g.markPublicExports(),g.getOrCreateNamespace().include()}}else for(a=0;a<l.length;a++){var g=l[a];-1===t.indexOf(g)&&(t.push(g),g.chunkAlias||(g.chunkAlias=f[a]))}timeEnd("analyse dependency graph",2),timeStart("mark included statements",2);for(var y=0,v=t;y<v.length;y++){(u=v[y]).markPublicExports()}i.includeMarked(p);for(var _=0,x=i.externalModules;_<x.length;_++){x[_].warnUnusedImports()}timeEnd("mark included statements",2),timeStart("generate chunks",2);var b=[];if(n)for(var E=0,S=p;E<S.length;E++){P=S[E];var A=new Chunk$1(i,[P]);!P.isEntryPoint&&A.isEmpty||(A.entryModule=P),b.push(A)}else{for(var w={},k=0,N=p;k<N.length;k++){var P,$=Uint8ArrayToHexString((P=N[k]).entryPointsHash),C=w[$];C?C.push(P):w[$]=[P]}for(var I in w){var O=w[I].sort(function(e,t){return e.execIndex>t.execIndex?1:-1}),R=new Chunk$1(i,O);b.push(R)}}for(var T=0,M=b;T<M.length;T++){(R=M[T]).link()}for(var L=0,D=b=b.filter(function(e){return!e.isEmpty||e.entryModule||e.isManualChunk});L<D.length;L++){R=D[L];(n||R.entryModule)&&R.populateEntryExports(n)}if(!n)for(var j=0,B=t;j<B.length;j++){if(!(u=B[j]).chunk.isEntryModuleFacade){var U=new Chunk$1(i,[]);U.linkFacade(u),b.push(U)}}return timeEnd("generate chunks",2),i.finished=!0,b})},e.prototype.analyseExecution=function(e,t,r,n){var i,s,o,a,u,c,h=this,p={},l=[],f=[],d=[],m=function(e){t&&(a.chunkAlias?(e.chunkAlias=a.chunkAlias,e.entryPointsHash=u):Uint8ArrayXor(e.entryPointsHash,u));for(var r=0,n=e.dependencies;r<n.length;r++){var i=n[r];i instanceof ExternalModule||(i.id in c?p[i.id]||h.warnCycle(i.id,e.id,c):(c[i.id]=e.id,i.isEntryPoint||i.chunkAlias||m(i)))}for(var s=0,o=e.dynamicImportResolutions;s<o.length;s++){var g=o[s];g.resolution instanceof Module&&(t&&(g.resolution.chunkAlias||Uint8ArrayEqual(g.resolution.entryPointsHash,a.entryPointsHash))||-1===f.indexOf(g.resolution)&&(f.push(g.resolution),d.push(g.alias)))}p[e.id]||(p[e.id]=!0,e.execIndex=l.length,l.push(e))};if(t&&n)for(var g=0,y=Object.keys(n);g<y.length;g++){var v=y[g];u=randomUint8Array(10);for(var _=0,x=n[v];_<x.length;_++)(a=x[_]).chunkAlias&&error({code:"INVALID_CHUNK",message:"Cannot assign "+path.relative(process.cwd(),a.id)+' to the "'+v+'" chunk as it is already in the "'+a.chunkAlias+'" chunk.\nTry defining "'+v+'" first in the manualChunks definitions of the Rollup configuration.'}),a.chunkAlias=v,(i={})[a.id]=null,c=i,m(a)}for(var b=0,E=e;b<E.length;b++)(a=E[b]).isEntryPoint=!0,u=randomUint8Array(10),(s={})[a.id]=null,c=s,m(a);for(var S=0,A=f;S<A.length;S++)(a=A[S]).isEntryPoint||(r||(a.isEntryPoint=!0),u=randomUint8Array(10),(o={})[a.id]=null,c=o,m(a));return{orderedModules:l,dynamicImports:f,dynamicImportAliases:d}},e.prototype.warnCycle=function(e,t,r){for(var n=[relativeId(e)],i=t;i!==e&&(n.push(relativeId(i)),i=r[i]););n.push(n[0]),n.reverse(),this.warn({code:"CIRCULAR_DEPENDENCY",importer:n[0],message:"Circular dependency: "+n.join(" -> ")})},e.prototype.fetchModule=function(e,t){var r=this,n=this.moduleById.get(e);if(n){if(n.isExternal)throw new Error("Cannot fetch external module "+e);return Promise.resolve(n)}var i=new Module(this,e);return this.moduleById.set(e,i),this.watchFiles[e]=!0,timeStart("load modules",3),Promise.resolve(this.pluginDriver.hookFirst("load",[e])).catch(function(r){timeEnd("load modules",3);var n="Could not load "+e;throw t&&(n+=" (imported by "+t+")"),n+=": "+r.message,new Error(n)}).then(function(t){return timeEnd("load modules",3),"string"==typeof t?t:t&&"object"==typeof t&&"string"==typeof t.code?t:void error({code:"BAD_LOADER",message:"Error loading "+relativeId(e)+": plugin load hook should return a string, a { code, map } object, or nothing/null"})}).then(function(t){var n="string"==typeof t?{code:t,ast:null}:t,s=r.cachedModules.get(e);if(s&&!s.customTransformCache&&s.originalCode===n.code){if(s.transformAssets)for(var o=0,a=s.transformAssets;o<a.length;o++){var u=a[o];r.pluginDriver.emitAsset(u.name,u.source)}return s}return transform(r,n,i)}).then(function(t){return i.setSource(t),r.modules.push(i),r.moduleById.set(e,i),r.fetchAllDependencies(i).then(function(){for(var e in i.exports)"default"!==e&&(i.exportsAll[e]=i.id);return i.exportAllSources.forEach(function(e){var t=i.resolvedIds[e],n=r.moduleById.get(t);if(!n.isExternal)for(var s in n.exportsAll)s in i.exportsAll?r.warn({code:"NAMESPACE_CONFLICT",reexporter:i.id,name:s,sources:[i.exportsAll[s],n.exportsAll[s]],message:"Conflicting namespaces: "+relativeId(i.id)+" re-exports '"+s+"' from both "+relativeId(i.exportsAll[s])+" and "+relativeId(n.exportsAll[s])+" (will be ignored)"}):i.exportsAll[s]=n.exportsAll[s]}),i})})},e.prototype.fetchAllDependencies=function(e){var t=this,r=Promise.all(e.getDynamicImportExpressions().map(function(r,n){return Promise.resolve(t.pluginDriver.hookFirst("resolveDynamicImport",[r,e.id])).then(function(i){if(i){var s=getAliasName(i,"string"==typeof r?r:void 0);if("string"!=typeof r)e.dynamicImportResolutions[n]={alias:s,resolution:i};else{if(!t.isExternal(i,e.id,!0))return t.fetchModule(i,e.id).then(function(t){e.dynamicImportResolutions[n]={alias:s,resolution:t}});var o=void 0;t.moduleById.has(i)?o=t.moduleById.get(i):(o=new ExternalModule({graph:t,id:i}),t.externalModules.push(o),t.moduleById.set(i,e)),e.dynamicImportResolutions[n]={alias:s,resolution:o},o.exportsNamespace=!0}}else e.dynamicImportResolutions[n]={alias:void 0,resolution:void 0}})})).then(function(){});return r.catch(function(){}),Promise.all(e.sources.map(function(r){return Promise.resolve().then(function(){var n=e.resolvedIds[r];return n||!t.isExternal(r,e.id,!1)&&t.pluginDriver.hookFirst("resolveId",[r,e.id])}).then(function(n){var i=n||(isRelative(r)?path.resolve(e.id,"..",r):r),s=!1===n||t.isExternal(i,e.id,!0);if(n||s||(isRelative(r)&&error({code:"UNRESOLVED_IMPORT",message:"Could not resolve '"+r+"' from "+relativeId(e.id)}),!1!==n&&t.warn({code:"UNRESOLVED_IMPORT",source:r,importer:relativeId(e.id),message:"'"+r+"' is imported by "+relativeId(e.id)+", but could not be resolved – treating it as an external dependency",url:"https://github.com/rollup/rollup/wiki/Troubleshooting#treating-module-as-external-dependency"}),s=!0),!s)return e.resolvedIds[r]=n,t.fetchModule(n,e.id);if(e.resolvedIds[r]=i,!t.moduleById.has(i)){var o=new ExternalModule({graph:t,id:i});t.externalModules.push(o),t.moduleById.set(i,o)}var a=t.moduleById.get(i);for(var u in a instanceof ExternalModule==!1&&error({code:"INVALID_EXTERNAL_ID",message:"'"+r+"' is imported as an external by "+relativeId(e.id)+", but is already an existing non-external module id."}),e.imports){var c=e.imports[u];if(c.source!==r)return;a.traceExport(c.name)}})})).then(function(){return r})},e.prototype.warn=function(e){e.toString=function(){var t="";return e.plugin&&(t+="("+e.plugin+" plugin) "),e.loc&&(t+=relativeId(e.loc.file)+" ("+e.loc.line+":"+e.loc.column+") "),t+=e.message},this.onwarn(e)},e}();function evalIfFn(e){switch(typeof e){case"function":return e();case"string":return e;default:return""}}var concatSep=function(e,t){return t?e+"\n"+t:e},concatDblSep=function(e,t){return t?e+"\n\n"+t:e};function createAddons(e,t){var r=e.pluginDriver;return Promise.all([r.hookReduceValue("banner",evalIfFn(t.banner),[],concatSep),r.hookReduceValue("footer",evalIfFn(t.footer),[],concatSep),r.hookReduceValue("intro",evalIfFn(t.intro),[],concatDblSep),r.hookReduceValue("outro",evalIfFn(t.outro),[],concatDblSep)]).then(function(e){var t=e[0],r=e[1],n=e[2],i=e[3];return n&&(n+="\n\n"),i&&(i="\n\n"+i),t.length&&(t+="\n"),r.length&&(r="\n"+r),{intro:n,outro:i,banner:t,footer:r,hash:new Uint8Array(4)}}).catch(function(e){error({code:"ADDON_ERROR",message:"Could not retrieve "+e.hook+". Check configuration of "+e.plugin+".\n\tError Message: "+e.message})})}function commondir(e){if(1===e.length)return path.dirname(e[0]);var t=e.slice(1).reduce(function(e,t){var r,n=t.split(/\/+|\\+/);for(r=0;e[r]===n[r]&&r<Math.min(e.length,n.length);r++);return e.slice(0,r)},e[0].split(/\/+|\\+/));return t.length>1?t.join("/"):"/"}function badExports(e,t){error({code:"INVALID_EXPORT_OPTION",message:"'"+e+"' was specified for output.exports, but entry module has following exports: "+t.join(", ")})}function getExportMode(e,t){var r=t.exports,n=t.name,i=t.format,s=e.getExportNames();return"default"===r?1===s.length&&"default"===s[0]||badExports("default",s):"none"===r&&s.length&&badExports("none",s),r&&"auto"!==r||(0===s.length?r="none":1===s.length&&"default"===s[0]?r="default":(e.isEntryModuleFacade&&"es"!==i&&-1!==s.indexOf("default")&&e.graph.warn({code:"MIXED_EXPORTS",message:"Using named and default exports together. Consumers of your bundle will have to use "+(n||"bundle")+"['default'] to access the default export, which may not be what you want. Use `exports: 'named'` to disable this warning",url:"https://rollupjs.org/#exports"}),r="named")),/(?:default|named|none)/.test(r)||error({code:"INVALID_EXPORT_OPTION",message:"output.exports must be 'default', 'named', 'none', 'auto', or left unspecified (defaults to 'auto')"}),r}function deprecateOptions(e,t){var r=[];return t.input&&function(){!e.input&&e.entry&&function(t,n){r.push({new:n,old:t}),n in e||(e[n]=e[t]);delete e[t]}("entry","input");e.dest&&n("dest","file");e.moduleName&&n("moduleName","name");e.name&&n("name","name");e.extend&&n("extend","extend");e.globals&&n("globals","globals");e.indent&&n("indent","indent");e.noConflict&&n("noConflict","noConflict");e.paths&&n("paths","paths");e.sourcemap&&n("sourcemap","sourcemap");e.sourceMap&&n("sourceMap","sourcemap");e.sourceMapFile&&n("sourceMapFile","sourcemapFile");e.useStrict&&n("useStrict","strict");e.strict&&n("strict","strict");e.format&&n("format","format");e.banner&&n("banner","banner");e.footer&&n("footer","footer");e.intro&&n("intro","intro");e.outro&&n("outro","outro");e.interop&&n("interop","interop");e.freeze&&n("freeze","freeze");e.exports&&n("exports","exports");if(e.targets){r.push({old:"targets",new:"output"}),e.output=e.targets.map(function(t){return __assign$1({},t,e.output)}),delete e.targets;var t=!1;e.output.forEach(function(e){e.dest&&(t||(r.push({old:"targets.dest",new:"output.file"}),t=!0),e.file=e.dest,delete e.dest)})}e.pureExternalModules&&(r.push({old:"pureExternalModules",new:"treeshake.pureExternalModules"}),void 0===e.treeshake&&(e.treeshake={}),e.treeshake&&(e.treeshake.pureExternalModules=e.pureExternalModules),delete e.pureExternalModules)}(),t.output&&e.output&&e.output.moduleId&&(e.output.amd={id:e.moduleId},r.push({old:"moduleId",new:"amd"}),delete e.output.moduleId),r;function n(t,n){r.push({new:"output."+n,old:t}),e.output=e.output||{},n in e.output||(e.output[n]=e[t]),delete e[t]}}var createGetOption=function(e,t){return function(r,n){return void 0!==t[r]?t[r]:void 0!==e[r]?e[r]:n}},normalizeObjectOptionValue=function(e){return e&&"object"!=typeof e?{}:e},getObjectOption=function(e,t,r){var n=normalizeObjectOptionValue(t[r]),i=normalizeObjectOptionValue(e[r]);return void 0!==n?n&&i?__assign$1({},i,n):n:i},defaultOnWarn=function(e){"string"==typeof e?console.warn(e):console.warn(e.message)},getOnWarn=function(e,t,r){return void 0===r&&(r=defaultOnWarn),t.silent?function(){}:e.onwarn?function(t){return e.onwarn(t,r)}:r},getExternal=function(e,t){var r=e.external;return"function"==typeof r?function(e){for(var n=[],i=1;i<arguments.length;i++)n[i-1]=arguments[i];return r.apply(void 0,[e].concat(n))||-1!==t.external.indexOf(e)}:(r||[]).concat(t.external)},commandAliases={c:"config",e:"external",f:"format",g:"globals",h:"help",i:"input",m:"sourcemap",n:"name",o:"file",v:"version",w:"watch"};function mergeOptions(e){var t=e.config,r=void 0===t?{}:t,n=e.command,i=void 0===n?{}:n,s=e.deprecateConfig,o=e.defaultOnWarnHandler,a=deprecate(r,i,s),u=getCommandOptions(i),c=getInputOptions(r,u,o);u.output&&Object.assign(u,u.output);var h=r.output,p=Array.isArray(h)?h:h?[h]:[];0===p.length&&p.push({});var l=p.map(function(e){return getOutputOptions(e,u)}),f=[],d=Object.keys(c);addUnknownOptionErrors(f,Object.keys(r),d,"input option",/^output$/);var m=Object.keys(l[0]);return addUnknownOptionErrors(f,l.reduce(function(e,t){return e.concat(Object.keys(t))},[]),m,"output option"),addUnknownOptionErrors(f,Object.keys(u),d.concat(m,Object.keys(commandAliases),"config","environment","silent"),"CLI flag",/^_|output|(config.*)$/),{inputOptions:c,outputOptions:l,deprecations:a,optionError:f.length>0?f.join("\n"):null}}function addUnknownOptionErrors(e,t,r,n,i){void 0===i&&(i=/$./);var s=t.filter(function(e){return-1===r.indexOf(e)&&!i.test(e)});s.length>0&&e.push("Unknown "+n+": "+s.join(", ")+". Allowed options: "+r.sort().join(", "))}function getCommandOptions(e){var t=__assign$1({},e);return t.external=(e.external||"").split(","),e.globals&&(t.globals=Object.create(null),e.globals.split(",").forEach(function(e){var r=e.split(":");t.globals[r[0]]=r[1],-1===t.external.indexOf(r[0])&&t.external.push(r[0])})),t}function getInputOptions(e,t,r){void 0===t&&(t={});var n=createGetOption(e,t),i={acorn:e.acorn,acornInjectPlugins:e.acornInjectPlugins,cache:n("cache"),experimentalCacheExpiry:n("experimentalCacheExpiry",10),context:e.context,experimentalCodeSplitting:n("experimentalCodeSplitting"),experimentalPreserveModules:n("experimentalPreserveModules"),experimentalTopLevelAwait:n("experimentalTopLevelAwait"),external:getExternal(e,t),inlineDynamicImports:n("inlineDynamicImports",!1),input:n("input"),manualChunks:n("manualChunks"),chunkGroupingSize:n("chunkGroupingSize",5e3),optimizeChunks:n("optimizeChunks"),moduleContext:e.moduleContext,onwarn:getOnWarn(e,t,r),perf:n("perf",!1),plugins:e.plugins,preferConst:n("preferConst"),preserveSymlinks:n("preserveSymlinks"),treeshake:getObjectOption(e,t,"treeshake"),shimMissingExports:n("shimMissingExports"),watch:e.watch};if(Array.isArray(i.input))i.entry=i.input[0];else if("object"==typeof i.input)for(var s in i.input){i.entry=i.input[s];break}else i.entry=i.input;return i}function getOutputOptions(e,t){void 0===t&&(t={});var r=createGetOption(e,t),n=r("format");return{amd:__assign$1({},e.amd,t.amd),assetFileNames:r("assetFileNames"),banner:r("banner"),dir:r("dir"),chunkFileNames:r("chunkFileNames"),compact:r("compact",!1),entryFileNames:r("entryFileNames"),esModule:r("esModule",!0),exports:r("exports"),extend:r("extend"),file:r("file"),footer:r("footer"),format:"esm"===n?"es":n,freeze:r("freeze",!0),globals:r("globals"),indent:r("indent",!0),interop:r("interop",!0),intro:r("intro"),name:r("name"),namespaceToStringTag:r("namespaceToStringTag",!1),noConflict:r("noConflict"),outro:r("outro"),paths:r("paths"),sourcemap:r("sourcemap"),sourcemapFile:r("sourcemapFile"),strict:r("strict",!0)}}function deprecate(e,t,r){void 0===t&&(t={}),void 0===r&&(r={input:!0,output:!0});var n=[];return t.id&&(n.push({old:"-u/--id",new:"--amd.id"}),(t.amd||(t.amd={})).id=t.id),"string"==typeof t.output&&(n.push({old:"--output",new:"--file"}),t.output={file:t.output}),t.d&&(n.push({old:"-d",new:"--indent"}),t.indent=t.d),n.push.apply(n,deprecateOptions(e,r)),n}function addDeprecations(e,t){t({code:"DEPRECATED_OPTIONS",message:"The following options have been renamed — please update your config: "+e.map(function(e){return e.old+" -> "+e.new}).join(", "),deprecations:e})}function checkInputOptions(e){if(e.transform||e.load||e.resolveId||e.resolveExternal)throw new Error("The `transform`, `load`, `resolveId` and `resolveExternal` options are deprecated in favour of a unified plugin API. See https://github.com/rollup/rollup/wiki/Plugins for details")}function checkOutputOptions(e){if("es6"===e.format&&error({message:"The `es6` output format is deprecated – use `es` instead",url:"https://rollupjs.org/#format-f-output-format-"}),e.format||error({message:"You must specify output.format, which can be one of 'amd', 'cjs', 'system', 'esm', 'iife' or 'umd'",url:"https://rollupjs.org/#format-f-output-format-"}),e.moduleId&&e.amd)throw new Error("Cannot have both output.amd and output.moduleId")}var curWatcher,throwAsyncGenerateError={get:function(){throw new Error("bundle.generate(...) now returns a Promise instead of a { code, map } object")}};function applyOptionHook(e,t){return t.options&&t.options(e)||e}function getInputOptions$1(e){if(!e)throw new Error("You must supply an options object to rollup");var t=mergeOptions({config:e,deprecateConfig:{input:!0}}),r=t.inputOptions,n=t.deprecations,i=t.optionError;i&&r.onwarn({message:i,code:"UNKNOWN_OPTION"}),n.length&&addDeprecations(n,r.onwarn),checkInputOptions(r);var s=r.plugins;return r.plugins=Array.isArray(s)?s:s?[s]:[],(r=r.plugins.reduce(applyOptionHook,r)).experimentalCodeSplitting||(r.inlineDynamicImports=!0,r.manualChunks&&error({code:"INVALID_OPTION",message:'"manualChunks" option is only supported for experimentalCodeSplitting.'}),r.optimizeChunks&&error({code:"INVALID_OPTION",message:'"optimizeChunks" option is only supported for experimentalCodeSplitting.'}),(r.input instanceof Array||"object"==typeof r.input)&&error({code:"INVALID_OPTION",message:"Multiple inputs are only supported for experimentalCodeSplitting."})),r.inlineDynamicImports?(r.manualChunks&&error({code:"INVALID_OPTION",message:'"manualChunks" option is not supported for inlineDynamicImports.'}),r.optimizeChunks&&error({code:"INVALID_OPTION",message:'"optimizeChunks" option is not supported for inlineDynamicImports.'}),(r.input instanceof Array||"object"==typeof r.input)&&error({code:"INVALID_OPTION",message:"Multiple inputs are not supported for inlineDynamicImports."})):r.experimentalPreserveModules&&(r.inlineDynamicImports&&error({code:"INVALID_OPTION",message:"experimentalPreserveModules does not support the inlineDynamicImports option."}),r.manualChunks&&error({code:"INVALID_OPTION",message:"experimentalPreserveModules does not support the manualChunks option."}),r.optimizeChunks&&error({code:"INVALID_OPTION",message:"experimentalPreserveModules does not support the optimizeChunks option."})),r}function setWatcher(e){curWatcher=e}function rollup(e){try{var t=getInputOptions$1(e);initialiseTimers(t);var r=new Graph(t,curWatcher);return curWatcher=void 0,timeStart("BUILD",1),r.pluginDriver.hookParallel("buildStart").then(function(){return r.build(t.input,t.manualChunks,t.inlineDynamicImports,t.experimentalPreserveModules)}).then(function(e){return r.pluginDriver.hookParallel("buildEnd").then(function(){return e})},function(e){return r.pluginDriver.hookParallel("buildEnd",e).then(function(){throw e})}).then(function(n){var i;timeEnd("BUILD",1);var s="string"==typeof t.input||t.input instanceof Array&&1===t.input.length;if(!t.experimentalPreserveModules&&s)for(var o=0,a=n;o<a.length;o++){var u=a[o];if(void 0!==u.entryModule){if(i){i=void 0;break}i=u}}var c=!1;function h(e,o){var a=normalizeOutputOptions(t,e);t.experimentalCodeSplitting&&("string"==typeof a.file&&"string"==typeof a.dir&&error({code:"INVALID_OPTION",message:"Build must set either output.file for a single-file build or output.dir when generating multiple chunks."}),n.length>1&&("umd"!==a.format&&"iife"!==a.format||error({code:"INVALID_OPTION",message:"UMD and IIFE output formats are not supported with the experimentalCodeSplitting option."}),a.sourcemapFile&&error({code:"INVALID_OPTION",message:'"sourcemapFile" is only supported for single-file builds.'})),i||"string"!=typeof a.file||error({code:"INVALID_OPTION",message:s?"When building a bundle using dynamic imports, the output.dir option must be used, not output.file. Alternatively set inlineDynamicImports: true to output a single file.":"When building multiple entry point inputs, the output.dir option must be used, not output.file."})),!a.file&&t.experimentalCodeSplitting&&(i=void 0),timeStart("GENERATE",1);var u=a.assetFileNames||"assets/[name]-[hash][extname]",h=r.finaliseAssets(u),p=commondir(n.filter(function(e){return e.entryModule}).map(function(e){return e.entryModule.id}));return createAddons(r,a).then(function(e){for(var s=0,o=n;s<o.length;s++){var u=o[s];t.experimentalPreserveModules||u.generateInternalExports(a),u.isEntryModuleFacade&&(u.exportMode=getExportMode(u,a))}for(var l=0,f=n;l<f.length;l++){(u=f[l]).preRender(a,p)}!c&&t.optimizeChunks&&(optimizeChunks(n,a,t.chunkGroupingSize,p),c=!0);for(var d=0;d<n.length;d++){var m=(u=n[d]).getImportIds(),g=u.getExportNames(),y=u.renderedModules;if(u===i)i.id=path.basename(a.file||(t.input instanceof Array?t.input[0]:t.input));else if(t.experimentalPreserveModules)u.generateIdPreserveModules(p);else{var v=void 0,_=void 0;u.isEntryModuleFacade?(v=a.entryFileNames||"[name].js",_="output.entryFileNames"):(v=a.chunkFileNames||"[name]-[hash].js",_="output.chunkFileNames"),u.generateId(v,_,e,a,h)}h[u.id]={fileName:u.id,isEntry:void 0!==u.entryModule,imports:m,exports:g,modules:y,code:void 0,map:void 0}}return Promise.all(n.map(function(t){var n=h[t.id];return t.render(a,e,n).then(function(e){return n.code=e.code,n.map=e.map,r.pluginDriver.hookParallel("ongenerate",[__assign$1({bundle:n},a),n])})})).then(function(){})}).then(function(){var e=new Map(r.assetsById),t=createAssetPluginHooks(e,h,u);return r.pluginDriver.hookSeq("generateBundle",[a,h,o],function(e){return __assign$1({},e,t)}).then(function(){e.forEach(function(e){void 0===e.fileName&&finaliseAsset(e,h,u)})})}).then(function(){return timeEnd("GENERATE",1),h})}var p=!1===e.cache?void 0:r.getCache(),l={cache:p,watchFiles:Object.keys(r.watchFiles),generate:function(e){var r=h(e,!1).then(function(e){return t.experimentalCodeSplitting?{output:e}:e[n[0].id]});return Object.defineProperty(r,"code",throwAsyncGenerateError),Object.defineProperty(r,"map",throwAsyncGenerateError),r},write:function(e){return!t.experimentalCodeSplitting||e&&(e.dir||e.file)?t.experimentalCodeSplitting||e&&e.file||error({code:"MISSING_OPTION",message:"You must specify output.file."}):error({code:"MISSING_OPTION",message:"You must specify output.file or output.dir for the build."}),h(e,!0).then(function(i){return Promise.all(Object.keys(i).map(function(t){return writeOutputFile(r,l,t,i[t],e)})).then(function(){return t.experimentalCodeSplitting?{output:i}:i[n[0].id]})})}};return t.experimentalCodeSplitting||(l.imports=i.getImportIds(),l.exports=i.getExportNames(),l.modules=(p||r.getCache()).modules),!0===t.perf&&(l.getTimings=getTimings),l})}catch(e){return Promise.reject(e)}}function isOutputChunk(e){return"string"==typeof e.code}function writeOutputFile(e,t,r,n,i){var s,o,a=path.resolve(i.dir||path.dirname(i.file),r);if(isOutputChunk(n)){if(o=n.code,i.sourcemap&&n.map){var u=void 0;"inline"===i.sourcemap?u=n.map.toUrl():(u=path.basename(r)+".map",s=writeFile$1(a+".map",n.map.toString())),o+="//# "+SOURCEMAPPING_URL+"="+u+"\n"}}else o=n;return writeFile$1(a,o).then(function(){return s}).then(function(){return isOutputChunk(n)&&e.pluginDriver.hookSeq("onwrite",[__assign$1({bundle:t},i),n])}).then(function(){})}function normalizeOutputOptions(e,t){if(!t)throw new Error("You must supply an options object");var r=mergeOptions({config:{output:__assign$1({},t,t.output,e.output)},deprecateConfig:{output:!0}});if(r.optionError)throw new Error(r.optionError);var n=r.outputOptions[0],i=r.deprecations;return i.length&&addDeprecations(i,e.onwarn),checkOutputOptions(n),n}var filenameRegex=function(){return/([^\\\/]+)$/},arrFlatten=function(e){return flat(e,[])};function flat(e,t){for(var r,n=0,i=e.length;n<i;n++)r=e[n],Array.isArray(r)?flat(r,t):t.push(r);return t}var slice$1=[].slice;function diff(e,t){var r=arguments.length,n=e.length,i=-1,s=[];if(1===r)return e;for(r>2&&(t=arrFlatten(slice$1.call(arguments,1)));++i<n;)~t.indexOf(e[i])||s.push(e[i]);return s}var arrDiff=diff,arrayUnique=function(e){if(!Array.isArray(e))throw new TypeError("array-unique expects an array.");for(var t=e.length,r=-1;r++<t;)for(var n=r+1;n<e.length;++n)e[r]===e[n]&&e.splice(n--,1);return e},toString$2={}.toString,isarray=Array.isArray||function(e){return"[object Array]"==toString$2.call(e)},isobject=function(e){return null!=e&&"object"==typeof e&&!1===isarray(e)},isBuffer_1=function(e){return null!=e&&(isBuffer(e)||isSlowBuffer(e)||!!e._isBuffer)};function isBuffer(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isSlowBuffer(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer(e.slice(0,0))}var toString$3=Object.prototype.toString,kindOf=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$3.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isNumber=function(e){var t=kindOf(e);if("number"!==t&&"string"!==t)return!1;var r=+e;return r-r+1>=0&&""!==e},isNumber$1=function(e){var t=typeof e;if("string"===t||e instanceof String){if(!e.trim())return!1}else if("number"!==t&&!(e instanceof Number))return!1;return e-e+1>=0},toString$4=Object.prototype.toString,kindOf$1=function(e){if(void 0===e)return"undefined";if(null===e)return"null";var t=typeof e;if("boolean"===t)return"boolean";if("string"===t)return"string";if("number"===t)return"number";if("symbol"===t)return"symbol";if("function"===t)return isGeneratorFn(e)?"generatorfunction":"function";if(isArray$1$1(e))return"array";if(isBuffer$1(e))return"buffer";if(isArguments(e))return"arguments";if(isDate(e))return"date";if(isError(e))return"error";if(isRegexp(e))return"regexp";switch(ctorName(e)){case"Symbol":return"symbol";case"Promise":return"promise";case"WeakMap":return"weakmap";case"WeakSet":return"weakset";case"Map":return"map";case"Set":return"set";case"Int8Array":return"int8array";case"Uint8Array":return"uint8array";case"Uint8ClampedArray":return"uint8clampedarray";case"Int16Array":return"int16array";case"Uint16Array":return"uint16array";case"Int32Array":return"int32array";case"Uint32Array":return"uint32array";case"Float32Array":return"float32array";case"Float64Array":return"float64array"}if(isGeneratorObj(e))return"generator";switch(t=toString$4.call(e)){case"[object Object]":return"object";case"[object Map Iterator]":return"mapiterator";case"[object Set Iterator]":return"setiterator";case"[object String Iterator]":return"stringiterator";case"[object Array Iterator]":return"arrayiterator"}return t.slice(8,-1).toLowerCase().replace(/\s/g,"")};function ctorName(e){return e.constructor?e.constructor.name:null}function isArray$1$1(e){return Array.isArray?Array.isArray(e):e instanceof Array}function isError(e){return e instanceof Error||"string"==typeof e.message&&e.constructor&&"number"==typeof e.constructor.stackTraceLimit}function isDate(e){return e instanceof Date||"function"==typeof e.toDateString&&"function"==typeof e.getDate&&"function"==typeof e.setDate}function isRegexp(e){return e instanceof RegExp||"string"==typeof e.flags&&"boolean"==typeof e.ignoreCase&&"boolean"==typeof e.multiline&&"boolean"==typeof e.global}function isGeneratorFn(e,t){return"GeneratorFunction"===ctorName(e)}function isGeneratorObj(e){return"function"==typeof e.throw&&"function"==typeof e.return&&"function"==typeof e.next}function isArguments(e){try{if("number"==typeof e.length&&"function"==typeof e.callee)return!0}catch(e){if(-1!==e.message.indexOf("callee"))return!0}return!1}function isBuffer$1(e){return!(!e.constructor||"function"!=typeof e.constructor.isBuffer)&&e.constructor.isBuffer(e)}var max=Math.pow(2,32),node=random,cryptographic=!0;function random(){var e=crypto__default.randomBytes(4).toString("hex");return parseInt(e,16)/max}node.cryptographic=cryptographic;var randomatic_1=randomatic,isCrypto=!!node.cryptographic,type={lower:"abcdefghijklmnopqrstuvwxyz",upper:"ABCDEFGHIJKLMNOPQRSTUVWXYZ",number:"0123456789",special:"~!@#$%^&()_+-={}[];',."};function randomatic(e,t,r){if(void 0===e)throw new Error("randomatic expects a string or number.");var n=!1;1===arguments.length&&("string"==typeof e?t=e.length:isNumber$1(e)&&(r={},t=e,e="*")),"object"===kindOf$1(t)&&t.hasOwnProperty("chars")&&(t=(e=(r=t).chars).length,n=!0);var i=r||{},s="",o="";for(-1!==e.indexOf("?")&&(s+=i.chars),-1!==e.indexOf("a")&&(s+=type.lower),-1!==e.indexOf("A")&&(s+=type.upper),-1!==e.indexOf("0")&&(s+=type.number),-1!==e.indexOf("!")&&(s+=type.special),-1!==e.indexOf("*")&&(s+=type.all),n&&(s+=e);t--;)o+=s.charAt(parseInt(node()*s.length,10));return o}type.all=type.lower+type.upper+type.number+type.special,randomatic_1.isCrypto=isCrypto;var cache,res="",repeatString=repeat;function repeat(e,t){if("string"!=typeof e)throw new TypeError("expected a string");if(1===t)return e;if(2===t)return e+e;var r=e.length*t;if(cache!==e||void 0===cache)cache=e,res="";else if(res.length>=r)return res.substr(0,r);for(;r>res.length&&t>1;)1&t&&(res+=e),t>>=1,e+=e;return res=(res+=e).substr(0,r)}var repeatElement=function(e,t){for(var r=new Array(t),n=0;n<t;n++)r[n]=e;return r},fillRange_1=fillRange;function fillRange(e,t,r,n,i){if(null==e||null==t)throw new Error("fill-range expects the first and second args to be strings.");"function"==typeof r&&(i=r,n={},r=null),"function"==typeof n&&(i=n,n={}),isobject(r)&&(n=r,r="");var s,o=!1,a="",u=n||{};void 0===u.silent&&(u.silent=!0),r=r||u.step;var c=e,h=t;if(t="-0"===t.toString()?0:t,(u.optimize||u.makeRe)&&(r=r?r+="~":r,s=!0,o=!0,a="~"),"string"==typeof r){var p=stepRe().exec(r);if(p){var l=p.index,f=p[0];if("+"===f)return repeatElement(e,t);if("?"===f)return[randomatic_1(e,t)];">"===f?(r=r.substr(0,l)+r.substr(l+1),s=!0):"|"===f?(r=r.substr(0,l)+r.substr(l+1),s=!0,o=!0,a=f):"~"===f&&(r=r.substr(0,l)+r.substr(l+1),s=!0,o=!0,a=f)}else if(!isNumber(r)){if(!u.silent)throw new TypeError("fill-range: invalid step.");return null}}if(/[.&*()[\]^%$#@!]/.test(e)||/[.&*()[\]^%$#@!]/.test(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}if(!noAlphaNum(e)||!noAlphaNum(t)||hasBoth(e)||hasBoth(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}var d=isNumber(zeros(e)),m=isNumber(zeros(t));if(!d&&m||d&&!m){if(!u.silent)throw new TypeError("fill-range: first range argument is incompatible with second.");return null}var g=d,y=formatStep(r);g?(e=+e,t=+t):(e=e.charCodeAt(0),t=t.charCodeAt(0));var v=e>t;(e<0||t<0)&&(s=!1,o=!1);var _,x,b=isPadded$1(c,h),E=[],S=0;if(o&&shouldExpand(e,t,y,g,b,u))return"|"!==a&&"~"!==a||(a=detectSeparator(e,t,y,g,v)),wrap$1([c,h],a,u);for(;v?e>=t:e<=t;)b&&g&&(x=b(e)),null!==(_="function"==typeof i?i(e,g,x,S++):g?formatPadding(e,x):o&&isInvalidChar(e)?null:String.fromCharCode(e))&&E.push(_),v?e-=y:e+=y;return!o&&!s||u.noexpand?E:("|"!==a&&"~"!==a||(a=detectSeparator(e,t,y,g,v)),1===E.length||e<0||t<0?E:wrap$1(E,a,u))}function wrap$1(e,t,r){"~"===t&&(t="-");var n=e.join(t),i=r&&r.regexPrefix;return"|"===t&&(n="("+(n=i?i+n:n)+")"),"-"===t&&(n="["+(n=i&&"^"===i?i+n:n)+"]"),[n]}function isCharClass(e,t,r,n,i){return!i&&(n?e<=9&&t<=9:e<t&&1===r)}function shouldExpand(e,t,r,n,i,s){return(!n||!(e>9||t>9))&&(!i&&1===r&&e<t)}function detectSeparator(e,t,r,n,i){return isCharClass(e,t,r,n,i)?"~":"|"}function formatStep(e){return Math.abs(e>>0)||1}function formatPadding(e,t){var r=t?t+e:e;return t&&"-"===e.toString().charAt(0)&&(r="-"+t+e.toString().substr(1)),r.toString()}function isInvalidChar(e){var t=toStr(e);return"\\"===t||"["===t||"]"===t||"^"===t||"("===t||")"===t||"`"===t}function toStr(e){return String.fromCharCode(e)}function stepRe(){return/\?|>|\||\+|\~/g}function noAlphaNum(e){return/[a-z0-9]/i.test(e)}function hasBoth(e){return/[a-z][0-9]|[0-9][a-z]/i.test(e)}function zeros(e){return/^-*0+$/.test(e.toString())?"0":e}function hasZeros(e){return/[^.]\.|^-*0+[0-9]/.test(e)}function isPadded$1(e,t){if(hasZeros(e)||hasZeros(t)){var r=length(e),n=length(t),i=r>=n?r:n;return function(e){return repeatString("0",i-length(e))}}return!1}function length(e){return e.toString().length}var expandRange=function(e,t,r){if("string"!=typeof e)throw new TypeError("expand-range expects a string.");"function"==typeof t&&(r=t,t={}),"boolean"==typeof t&&((t={}).makeRe=!0);var n=t||{},i=e.split(".."),s=i.length;return s>3?e:1===s?i:("boolean"==typeof r&&!0===r&&(n.makeRe=!0),i.push(n),fillRange_1.apply(null,i.concat(r)))},before=function(e,t){return e.replace(t,function(e){var t=randomize();return cache$1[t]=e,"__ID"+t+"__"})},after=function(e){return e.replace(/__ID(.{5})__/g,function(e,t){return cache$1[t]})};function randomize(){return Math.random().toString().slice(2,7)}var braceRe,patternRe,cache$1={},preserve={before:before,after:after},braces_1=function(e,t){if("string"!=typeof e)throw new Error("braces expects a string");return braces(e,t)};function braces(e,t,r){if(""===e)return[];Array.isArray(t)||(r=t,t=[]);var n=r||{};t=t||[],void 0===n.nodupes&&(n.nodupes=!0);var i,s=n.fn;switch("function"==typeof n&&(s=n,n={}),patternRe instanceof RegExp||(patternRe=patternRegex()),(e.match(patternRe)||[])[0]){case"\\,":return escapeCommas(e,t,n);case"\\.":return escapeDots(e,t,n);case"/.":return escapePaths(e,t,n);case" ":return splitWhitespace(e);case"{,}":return exponential(e,n,braces);case"{}":return emptyBraces(e,t,n);case"\\{":case"\\}":return escapeBraces$1(e,t,n);case"${":if(!/\{[^{]+\{/.test(e))return t.concat(e);i=!0,e=preserve.before(e,es6Regex())}braceRe instanceof RegExp||(braceRe=braceRegex());var o=braceRe.exec(e);if(null==o)return[e];var a,u,c=o[1],h=o[2];if(""===h)return[e];if(-1!==h.indexOf(".."))u=(a=expandRange(h,n,s)||h.split(",")).length;else{if('"'===h[0]||"'"===h[0])return t.concat(e.split(/['"]/).join(""));if(a=h.split(","),n.makeRe)return braces(e.replace(c,wrap$1$1(a,"|")),n);1===(u=a.length)&&n.bash&&(a[0]=wrap$1$1(a[0],"\\"))}for(var p,l=a.length,f=0;l--;){var d=a[f++];if(/(\.[^.\/])/.test(d))return u>1?a:[e];if(p=splice(e,c,d),/\{[^{}]+?\}/.test(p))t=braces(p,t,n);else if(""!==p){if(n.nodupes&&-1!==t.indexOf(p))continue;t.push(i?preserve.after(p):p)}}return n.strict?filter$1(t,filterEmpty):t}function exponential(e,t,r){"function"==typeof t&&(r=t,t=null);var n,i,s=t||{},o="__ESC_EXP__",a=e.split("{,}");if(s.nodupes)return r(a.join(""),s);n=a.length-1;for(var u=(i=r(a.join(o),s)).length,c=[],h=0;u--;){var p=i[h++];if(-1===p.indexOf(o))c.push(p);else if((p=p.split("__ESC_EXP__").join(""))&&!1!==s.nodupes)c.push(p);else{var l=Math.pow(2,n);c.push.apply(c,repeatElement(p,l))}}return c}function wrap$1$1(e,t){return"|"===t?"("+e.join(t)+")":","===t?"{"+e.join(t)+"}":"-"===t?"["+e.join(t)+"]":"\\"===t?"\\{"+e+"\\}":void 0}function emptyBraces(e,t,r){return braces(e.split("{}").join("\\{\\}"),t,r)}function filterEmpty(e){return!!e&&"\\"!==e}function splitWhitespace(e){for(var t=e.split(" "),r=t.length,n=[],i=0;r--;)n.push.apply(n,braces(t[i++]));return n}function escapeBraces$1(e,t,r){return/\{[^{]+\{/.test(e)?map(braces(e=(e=e.split("\\{").join("__LT_BRACE__")).split("\\}").join("__RT_BRACE__"),t,r),function(e){return(e=e.split("__LT_BRACE__").join("{")).split("__RT_BRACE__").join("}")}):t.concat(e.split("\\").join(""))}function escapeDots(e,t,r){return/[^\\]\..+\\\./.test(e)?map(braces(e=e.split("\\.").join("__ESC_DOT__"),t,r),function(e){return e.split("__ESC_DOT__").join(".")}):t.concat(e.split("\\").join(""))}function escapePaths(e,t,r){return map(braces(e=e.split("/.").join("__ESC_PATH__"),t,r),function(e){return e.split("__ESC_PATH__").join("/.")})}function escapeCommas(e,t,r){return/\w,/.test(e)?map(braces(e=e.split("\\,").join("__ESC_COMMA__"),t,r),function(e){return e.split("__ESC_COMMA__").join(",")}):t.concat(e.split("\\").join(""))}function patternRegex(){return/\${|( (?=[{,}])|(?=[{,}]) )|{}|{,}|\\,(?=.*[{}])|\/\.(?=.*[{}])|\\\.(?={)|\\{|\\}/}function braceRegex(){return/.*(\\?\{([^}]+)\})/}function es6Regex(){return/\$\{([^}]+)\}/}function splice(e,t,r){var n=e.indexOf(t);return e.substr(0,n)+r+e.substr(n+t.length)}function map(e,t){if(null==e)return[];for(var r=e.length,n=new Array(r),i=-1;++i<r;)n[i]=t(e[i],i,e);return n}function filter$1(e,t){if(null==e)return[];if("function"!=typeof t)throw new TypeError("braces: filter expects a callback function.");for(var r=e.length,n=e.slice(),i=0;r--;)t(e[r],i++)||n.splice(r,1);return n}var isPosixBracket=function(e){return"string"==typeof e&&/\[([:.=+])(?:[^\[\]]|)+\1\]/.test(e)},POSIX={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E",punct:"-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"},expandBrackets=brackets;function brackets(e){if(!isPosixBracket(e))return e;var t=!1;-1!==e.indexOf("[^")&&(t=!0,e=e.split("[^").join("[")),-1!==e.indexOf("[!")&&(t=!0,e=e.split("[!").join("["));for(var r=e.split("["),n=e.split("]"),i=r.length!==n.length,s=e.split(/(?::\]\[:|\[?\[:|:\]\]?)/),o=s.length,a=0,u="",c="",h=[];o--;){var p=s[a++];"^[!"!==p&&"[!"!==p||(p="",t=!0);var l=t?"^":"",f=POSIX[p];f?h.push("["+l+f+"]"):p&&(/^\[?\w-\w\]?$/.test(p)?a===s.length?h.push("["+l+p):1===a?h.push(l+p+"]"):h.push(l+p):1===a?c+=p:a===s.length?u+=p:h.push("["+l+p+"]"))}var d=h.join("|"),m=h.length||1;return m>1&&(d="(?:"+d+")",m=1),c&&(m++,"["===c.charAt(0)&&(i?c="\\["+c.slice(1):c+="]"),d=c+d),u&&(m++,"]"===u.slice(-1)&&(u=i?u.slice(0,u.length-1)+"\\]":"["+u),d+=u),m>1&&(-1===(d=d.split("][").join("]|[")).indexOf("|")||/\(\?/.test(d)||(d="(?:"+d+")")),d=d.replace(/\[+=|=\]+/g,"\\b")}brackets.makeRe=function(e){try{return new RegExp(brackets(e))}catch(e){}},brackets.isMatch=function(e,t){try{return brackets.makeRe(t).test(e)}catch(e){return!1}},brackets.match=function(e,t){for(var r=e.length,n=0,i=e.slice(),s=brackets.makeRe(t);n<r;){var o=e[n++];s.test(o)&&i.splice(n,1)}return i};var re,isExtglob=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},cache$2={},extglob_1=extglob;function extglob(e,t){t=t||{};var r,n={},i=0,s=(e=(e=e.replace(/!\(([^\w*()])/g,"$1!(")).replace(/([*\/])\.!\([*]\)/g,function(e,t){return escape("/"===t?"\\/[^.]+":"[^.]+")}))+String(!!t.regex)+String(!!t.contains)+String(!!t.escape);if(cache$2.hasOwnProperty(s))return cache$2[s];for(re instanceof RegExp||(re=regex()),t.negate=!1;r=re.exec(e);){var o=r[1],a=r[3];"!"===o&&(t.negate=!0);var u="__EXTGLOB_"+i+++"__";n[u]=wrap$2(a,o,t.escape),e=e.split(r[0]).join(u)}for(var c=Object.keys(n),h=c.length;h--;){var p=c[h];e=e.split(p).join(n[p])}var l=t.regex?toRegex(e,t.contains,t.negate):e;return l=l.split(".").join("\\."),cache$2[s]=l}function wrap$2(e,t,r){switch(r&&(e=escape(e)),t){case"!":return"(?!"+e+")[^/]"+(r?"%%%~":"*?");case"@":return"(?:"+e+")";case"+":return"(?:"+e+")+";case"*":return"(?:"+e+")"+(r?"%%":"*");case"?":return"(?:"+e+"|)";default:return e}}function escape(e){return e=(e=e.split("*").join("[^/]%%%~")).split(".").join("\\.")}function regex(){return/(\\?[@?!+*$]\\?)(\(([^()]*?)\))/}function negate(e){return"(?!^"+e+").*$"}function toRegex(e,t,r){var n=t?"^":"";return e="(?:"+e+")"+(t?"$":""),r&&(e=n+negate(e)),new RegExp(n+e)}var isGlob=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob(e))},isWin="win32"===process.platform,removeTrailingSeparator=function(e){var t=e.length-1;if(t<2)return e;for(;isSeparator(e,t);)t--;return e.substr(0,t+1)};function isSeparator(e,t){var r=e[t];return t>0&&("/"===r||isWin&&"\\"===r)}var normalizePath$1=function(e,t){if("string"!=typeof e)throw new TypeError("expected a string");return e=e.replace(/[\\\/]+/g,"/"),!1!==t&&(e=removeTrailingSeparator(e)),e},isExtendable=function(e){return null!=e&&("object"==typeof e||"function"==typeof e)},forIn=function(e,t,r){for(var n in e)if(!1===t.call(r,e[n],n,e))break},hasOwn=Object.prototype.hasOwnProperty,forOwn=function(e,t,r){forIn(e,function(n,i){if(hasOwn.call(e,i))return t.call(r,e[i],i,e)})},object_omit=function(e,t){if(!isExtendable(e))return{};var r,n=(t=[].concat.apply([],[].slice.call(arguments,1)))[t.length-1],i={};"function"==typeof n&&(r=t.pop());var s="function"==typeof r;return t.length||s?(forOwn(e,function(n,o){-1===t.indexOf(o)&&(s?r(n,o,e)&&(i[o]=n):i[o]=n)}),i):e},isExtglob$1=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$1=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$1(e))},isExtglob$2=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$2=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$2(e))},globParent=function(e){e+="a";do{e=path__default.dirname(e)}while(isGlob$2(e));return e},isExtglob$3=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$3=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$3(e))},globBase=function(e){if("string"!=typeof e)throw new TypeError("glob-base expects a string.");var t={};return t.base=globParent(e),t.isGlob=isGlob$3(e),"."!==t.base?(t.glob=e.substr(t.base.length),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1))):t.glob=e,t.isGlob||(t.base=dirname$1(e),t.glob="."!==t.base?e.substr(t.base.length):e),"./"===t.glob.substr(0,2)&&(t.glob=t.glob.substr(2)),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1)),t};function dirname$1(e){return"/"===e.slice(-1)?e:path__default.dirname(e)}var isDotfile=function(e){if(46===e.charCodeAt(0)&&-1===e.indexOf("/",1))return!0;var t=e.lastIndexOf("/");return-1!==t&&46===e.charCodeAt(t+1)},parseGlob=createCommonjsModule$1(function(e){var t=e.exports.cache={};function r(e,t,r){return e&&-1!==t.indexOf(r)}function n(e){return e=(e=e.split("__SLASH__").join("/")).split("__DOT__").join(".")}e.exports=function(e){if(t.hasOwnProperty(e))return t[e];var i={};i.orig=e,i.is={},e=e.replace(/\{([^{}]*?)}|\(([^()]*?)\)|\[([^\[\]]*?)\]/g,function(e,t,r,n){var i=t||r||n;return i?e.split(i).join(i.split("/").join("__SLASH__").split(".").join("__DOT__")):e});var s=globBase(e);i.is.glob=s.isGlob,i.glob=s.glob,i.base=s.base;var o=/([^\/]*)$/.exec(e);i.path={},i.path.dirname="",i.path.basename=o[1]||"",i.path.dirname=e.split(i.path.basename).join("")||"";var a=(i.path.basename||"").split(".")||"";i.path.filename=a[0]||"",i.path.extname=a.slice(1).join(".")||"",i.path.ext="",isGlob$1(i.path.dirname)&&!i.path.basename&&(/\/$/.test(i.glob)||(i.path.basename=i.glob),i.path.dirname=i.base),-1!==e.indexOf("/")||i.is.globstar||(i.path.dirname="",i.path.basename=i.orig);var u=i.path.basename.indexOf(".");if(-1!==u&&(i.path.filename=i.path.basename.slice(0,u),i.path.extname=i.path.basename.slice(u)),"."===i.path.extname.charAt(0)){var c=i.path.extname.split(".");i.path.ext=c[c.length-1]}i.glob=n(i.glob),i.path.dirname=n(i.path.dirname),i.path.basename=n(i.path.basename),i.path.filename=n(i.path.filename),i.path.extname=n(i.path.extname);var h=e&&i.is.glob;return i.is.negated=e&&"!"===e.charAt(0),i.is.extglob=e&&isExtglob$1(e),i.is.braces=r(h,e,"{"),i.is.brackets=r(h,e,"[:"),i.is.globstar=r(h,e,"**"),i.is.dotfile=isDotfile(i.path.basename)||isDotfile(i.path.filename),i.is.dotdir=function(e){if(-1!==e.indexOf("/."))return!0;if("."===e.charAt(0)&&"/"!==e.charAt(1))return!0;return!1}(i.path.dirname),t[e]=i}}),parseGlob_1=parseGlob.cache,isPrimitive=function(e){return null==e||"function"!=typeof e&&"object"!=typeof e},isEqualShallow=function(e,t){if(!e&&!t)return!0;if(!e&&t||e&&!t)return!1;var r,n=0,i=0;for(r in t)if(i++,!isPrimitive(t[r])||!e.hasOwnProperty(r)||e[r]!==t[r])return!1;for(r in e)n++;return n===i},basic={},cache$3={},regexCache_1=regexCache;function regexCache(e,t,r){var n,i,s="_default_";if(!t&&!r)return"function"!=typeof e?e:basic[s]||(basic[s]=e(t));if("string"==typeof t){if(!r)return basic[t]||(basic[t]=e(t));s=t}else r=t;return(i=cache$3[s])&&isEqualShallow(i.opts,r)?i.regex:(memo(s,r,n=e(t,r)),n)}function memo(e,t,r){cache$3[e]={regex:r,opts:t}}var cache_1=cache$3,basic_1=basic;regexCache_1.cache=cache_1,regexCache_1.basic=basic_1;var unesc,temp,utils_1=createCommonjsModule$1(function(e){var t=process&&"win32"===process.platform,r=e.exports;r.diff=arrDiff,r.unique=arrayUnique,r.braces=braces_1,r.brackets=expandBrackets,r.extglob=extglob_1,r.isExtglob=isExtglob,r.isGlob=isGlob,r.typeOf=kindOf,r.normalize=normalizePath$1,r.omit=object_omit,r.parseGlob=parseGlob,r.cache=regexCache_1,r.filename=function(e){var t=e.match(filenameRegex());return t&&t[0]},r.isPath=function(e,t){return t=t||{},function(n){var i=r.unixify(n,t);return t.nocase?e.toLowerCase()===i.toLowerCase():e===i}},r.hasPath=function(e,t){return function(n){return-1!==r.unixify(e,t).indexOf(n)}},r.matchPath=function(e,t){return t&&t.contains?r.hasPath(e,t):r.isPath(e,t)},r.hasFilename=function(e){return function(t){var n=r.filename(t);return n&&e.test(n)}},r.arrayify=function(e){return Array.isArray(e)?e:[e]},r.unixify=function(e,n){return n&&!1===n.unixify?e:n&&!0===n.unixify||t||"\\"===path__default.sep?r.normalize(e,!1):n&&!0===n.unescape?e?e.toString().replace(/\\(\w)/g,"$1"):"":e},r.escapePath=function(e){return e.replace(/[\\.]/g,"\\$&")},r.unescapeGlob=function(e){return e.replace(/[\\"']/g,"")},r.escapeRe=function(e){return e.replace(/[-[\\$*+?.#^\s{}(|)\]]/g,"\\$&")},e.exports=r}),chars$2={};function reverse(e,t){return Object.keys(e).reduce(function(r,n){var i=t?t+n:n;return r[e[n]]=i,r},{})}chars$2.escapeRegex={"?":/\?/g,"@":/\@/g,"!":/\!/g,"+":/\+/g,"*":/\*/g,"(":/\(/g,")":/\)/g,"[":/\[/g,"]":/\]/g},chars$2.ESC={"?":"__UNESC_QMRK__","@":"__UNESC_AMPE__","!":"__UNESC_EXCL__","+":"__UNESC_PLUS__","*":"__UNESC_STAR__",",":"__UNESC_COMMA__","(":"__UNESC_LTPAREN__",")":"__UNESC_RTPAREN__","[":"__UNESC_LTBRACK__","]":"__UNESC_RTBRACK__"},chars$2.UNESC=unesc||(unesc=reverse(chars$2.ESC,"\\")),chars$2.ESC_TEMP={"?":"__TEMP_QMRK__","@":"__TEMP_AMPE__","!":"__TEMP_EXCL__","*":"__TEMP_STAR__","+":"__TEMP_PLUS__",",":"__TEMP_COMMA__","(":"__TEMP_LTPAREN__",")":"__TEMP_RTPAREN__","[":"__TEMP_LTBRACK__","]":"__TEMP_RTBRACK__"},chars$2.TEMP=temp||(temp=reverse(chars$2.ESC_TEMP));var chars_1=chars$2,glob$1=createCommonjsModule$1(function(e){var t=e.exports=function e(t,r){if(!(this instanceof e))return new e(t,r);this.options=r||{},this.pattern=t,this.history=[],this.tokens={},this.init(t)};t.prototype.init=function(e){this.orig=e,this.negated=this.isNegated(),this.options.track=this.options.track||!1,this.options.makeRe=!0},t.prototype.track=function(e){this.options.track&&this.history.push({msg:e,pattern:this.pattern})},t.prototype.isNegated=function(){return 33===this.pattern.charCodeAt(0)&&(this.pattern=this.pattern.slice(1),!0)},t.prototype.braces=function(){if(!0!==this.options.nobraces&&!0!==this.options.nobrace){var e=this.pattern.match(/[\{\(\[]/g),t=this.pattern.match(/[\}\)\]]/g);e&&t&&e.length!==t.length&&(this.options.makeRe=!1);var r=utils_1.braces(this.pattern,this.options);this.pattern=r.join("|")}},t.prototype.brackets=function(){!0!==this.options.nobrackets&&(this.pattern=utils_1.brackets(this.pattern))},t.prototype.extglob=function(){!0!==this.options.noextglob&&utils_1.isExtglob(this.pattern)&&(this.pattern=utils_1.extglob(this.pattern,{escape:!0}))},t.prototype.parse=function(e){return this.tokens=utils_1.parseGlob(e||this.pattern,!0),this.tokens},t.prototype._replace=function(e,t,r){this.track('before (find): "'+e+'" (replace with): "'+t+'"'),r&&(t=t.split("?").join("%~").split("*").join("%%")),this.pattern=e&&t&&"string"==typeof e?this.pattern.split(e).join(t):this.pattern.replace(e,t),this.track("after")},t.prototype.escape=function(e){this.track("before escape: ");this.pattern=e.replace(/["\\](['"]?[^"'\\]['"]?)/g,function(e,t){var r=chars_1.ESC,n=r&&r[t];return n||(/[a-z]/i.test(e)?e.split("\\").join(""):e)}),this.track("after escape: ")},t.prototype.unescape=function(e){this.pattern=e.replace(/__([A-Z]+)_([A-Z]+)__/g,function(e,t){return chars_1[t][e]}),this.pattern=function(e){return e=(e=e.split("%~").join("?")).split("%%").join("*")}(this.pattern)}}),expand_1=expand$1;function expand$1(e,t){if("string"!=typeof e)throw new TypeError("micromatch.expand(): argument should be a string.");var r=new glob$1(e,t||{}),n=r.options;if(!utils_1.isGlob(e))return r.pattern=r.pattern.replace(/([\/.])/g,"\\$1"),r;if(r.pattern=r.pattern.replace(/(\+)(?!\()/g,"\\$1"),r.pattern=r.pattern.split("$").join("\\$"),"boolean"!=typeof n.braces&&"boolean"!=typeof n.nobraces&&(n.braces=!0),".*"===r.pattern)return{pattern:"\\."+star$1,tokens:i,options:n};if("*"===r.pattern)return{pattern:oneStar(n.dot),tokens:i,options:n};r.parse();var i=r.tokens;return i.is.negated=n.negated,!0!==n.dotfiles&&!i.is.dotfile||!1===n.dot||(n.dotfiles=!0,n.dot=!0),!0!==n.dotdirs&&!i.is.dotdir||!1===n.dot||(n.dotdirs=!0,n.dot=!0),/[{,]\./.test(r.pattern)&&(n.makeRe=!1,n.dot=!0),!0!==n.nonegate&&(n.negated=r.negated),"."===r.pattern.charAt(0)&&"/"!==r.pattern.charAt(1)&&(r.pattern="\\"+r.pattern),r.track("before braces"),i.is.braces&&r.braces(),r.track("after braces"),r.track("before extglob"),i.is.extglob&&r.extglob(),r.track("after extglob"),r.track("before brackets"),i.is.brackets&&r.brackets(),r.track("after brackets"),r._replace("[!","[^"),r._replace("(?","(%~"),r._replace(/\[\]/,"\\[\\]"),r._replace("/[","/"+(n.dot?dotfiles:nodot)+"[",!0),r._replace("/?","/"+(n.dot?dotfiles:nodot)+"[^/]",!0),r._replace("/.","/(?=.)\\.",!0),r._replace(/^(\w):([\\\/]+?)/gi,"(?=.)$1:$2",!0),-1!==r.pattern.indexOf("[^")&&(r.pattern=negateSlash(r.pattern)),!1!==n.globstar&&"**"===r.pattern?r.pattern=globstar(n.dot):(r.pattern=balance(r.pattern,"[","]"),r.escape(r.pattern),i.is.globstar&&(r.pattern=collapse(r.pattern,"/**"),r.pattern=collapse(r.pattern,"**/"),r._replace("/**/","(?:/"+globstar(n.dot)+"/|/)",!0),r._replace(/\*{2,}/g,"**"),r._replace(/(\w+)\*(?!\/)/g,"$1[^/]*?",!0),r._replace(/\*\*\/\*(\w)/g,globstar(n.dot)+"\\/"+(n.dot?dotfiles:nodot)+"[^/]*?$1",!0),!0!==n.dot&&r._replace(/\*\*\/(.)/g,"(?:**\\/|)$1"),(""!==i.path.dirname||/,\*\*|\*\*,/.test(r.orig))&&r._replace("**",globstar(n.dot),!0)),r._replace(/\/\*$/,"\\/"+oneStar(n.dot),!0),r._replace(/(?!\/)\*$/,star$1,!0),r._replace(/([^\/]+)\*/,"$1"+oneStar(!0),!0),r._replace("*",oneStar(n.dot),!0),r._replace("?.","?\\.",!0),r._replace("?:","?:",!0),r._replace(/\?+/g,function(e){var t=e.length;return 1===t?qmark$1:qmark$1+"{"+t+"}"}),r._replace(/\.([*\w]+)/g,"\\.$1"),r._replace(/\[\^[\\\/]+\]/g,qmark$1),r._replace(/\/+/g,"\\/"),r._replace(/\\{2,}/g,"\\")),r.unescape(r.pattern),r._replace("__UNESC_STAR__","*"),r._replace("?.","?\\."),r._replace("[^\\/]",qmark$1),r.pattern.length>1&&/^[\[?*]/.test(r.pattern)&&(r.pattern=(n.dot?dotfiles:nodot)+r.pattern),r}function collapse(e,t){var r=e.split(t),n=""===r[0],i=""===r[r.length-1];return r=r.filter(Boolean),n&&r.unshift(""),i&&r.push(""),r.join(t)}function negateSlash(e){return e.replace(/\[\^([^\]]*?)\]/g,function(e,t){return-1===t.indexOf("/")&&(t="\\/"+t),"[^"+t+"]"})}function balance(e,t,r){var n=e.split(t);return n.join("").length!==e.split(r).join("").length?(e=n.join("\\"+t)).split(r).join("\\"+r):e}var qmark$1="[^/]",star$1=qmark$1+"*?",nodot="(?!\\.)(?=.)",dotfileGlob="(?:\\/|^)\\.{1,2}($|\\/)",dotfiles="(?!"+dotfileGlob+")(?=.)",twoStarDot$1="(?:(?!"+dotfileGlob+").)*?";function oneStar(e){return e?"(?!"+dotfileGlob+")(?=.)"+star$1:nodot+star$1}function globstar(e){return e?twoStarDot$1:"(?:(?!(?:\\/|^)\\.).)*?"}function micromatch(e,t,r){if(!e||!t)return[];if(void 0===(r=r||{}).cache&&(r.cache=!0),!Array.isArray(t))return match$1(e,t,r);for(var n=t.length,i=0,s=[],o=[];n--;){var a=t[i++];"string"==typeof a&&33===a.charCodeAt(0)?s.push.apply(s,match$1(e,a.slice(1),r)):o.push.apply(o,match$1(e,a,r))}return utils_1.diff(o,s)}function match$1(e,t,r){if("string"!==utils_1.typeOf(e)&&!Array.isArray(e))throw new Error(msg("match","files","a string or array"));e=utils_1.arrayify(e);var n=(r=r||{}).negate||!1,i=t;"string"==typeof t&&((n="!"===t.charAt(0))&&(t=t.slice(1)),!0===r.nonegate&&(n=!1));for(var s=matcher(t,r),o=e.length,a=0,u=[];a<o;){var c=e[a++],h=utils_1.unixify(c,r);s(h)&&u.push(h)}if(0===u.length){if(!0===r.failglob)throw new Error('micromatch.match() found no matches for: "'+i+'".');(r.nonull||r.nullglob)&&u.push(utils_1.unescapeGlob(i))}return n&&(u=utils_1.diff(e,u)),r.ignore&&r.ignore.length&&(t=r.ignore,r=utils_1.omit(r,["ignore"]),u=utils_1.diff(u,micromatch(u,t,r))),r.nodupes?utils_1.unique(u):u}function filter$1$1(e,t){if(!Array.isArray(e)&&"string"!=typeof e)throw new TypeError(msg("filter","patterns","a string or array"));for(var r=(e=utils_1.arrayify(e)).length,n=0,i=Array(r);n<r;)i[n]=matcher(e[n++],t);return function(e){if(null==e)return[];var r=i.length,n=0,s=!0;for(e=utils_1.unixify(e,t);n<r;){if(!(0,i[n++])(e)){s=!1;break}}return s}}function isMatch(e,t,r){if("string"!=typeof e)throw new TypeError(msg("isMatch","filepath","a string"));return e=utils_1.unixify(e,r),"object"===utils_1.typeOf(t)?matcher(e,t):matcher(t,r)(e)}function contains(e,t,r){if("string"!=typeof e)throw new TypeError(msg("contains","pattern","a string"));return(r=r||{}).contains=""!==t,e=utils_1.unixify(e,r),r.contains&&!utils_1.isGlob(t)?-1!==e.indexOf(t):matcher(t,r)(e)}function any(e,t,r){if(!Array.isArray(t)&&"string"!=typeof t)throw new TypeError(msg("any","patterns","a string or array"));var n=(t=utils_1.arrayify(t)).length;for(e=utils_1.unixify(e,r);n--;){if(matcher(t[n],r)(e))return!0}return!1}function matchKeys(e,t,r){if("object"!==utils_1.typeOf(e))throw new TypeError(msg("matchKeys","first argument","an object"));var n=matcher(t,r),i={};for(var s in e)e.hasOwnProperty(s)&&n(s)&&(i[s]=e[s]);return i}function matcher(e,t){if("function"==typeof e)return e;if(e instanceof RegExp)return function(t){return e.test(t)};if("string"!=typeof e)throw new TypeError(msg("matcher","pattern","a string, regex, or function"));if(e=utils_1.unixify(e,t),!utils_1.isGlob(e))return utils_1.matchPath(e,t);var r=makeRe$1(e,t);return t&&t.matchBase?utils_1.hasFilename(r,t):function(e){return e=utils_1.unixify(e,t),r.test(e)}}function toRegex$1(e,t){var r=Object.create(t||{}),n=r.flags||"";r.nocase&&-1===n.indexOf("i")&&(n+="i");var i,s=expand_1(e,r);r.negated=r.negated||s.negated,r.negate=r.negated,e=wrapGlob(s.pattern,r);try{return i=new RegExp(e,n)}catch(e){if(e.reason="micromatch invalid regex: ("+i+")",r.strict)throw new SyntaxError(e)}return/$^/}function wrapGlob(e,t){var r=t&&!t.contains?"^":"";return e="(?:"+e+")"+(t&&!t.contains?"$":""),t&&t.negate?r+"(?!^"+e+").*$":r+e}function makeRe$1(e,t){if("string"!==utils_1.typeOf(e))throw new Error(msg("makeRe","glob","a string"));return utils_1.cache(toRegex$1,e,t)}function msg(e,t,r){return"micromatch."+e+"(): "+t+" should be "+r+"."}micromatch.any=any,micromatch.braces=micromatch.braceExpand=utils_1.braces,micromatch.contains=contains,micromatch.expand=expand_1,micromatch.filter=filter$1$1,micromatch.isMatch=isMatch,micromatch.makeRe=makeRe$1,micromatch.match=match$1,micromatch.matcher=matcher,micromatch.matchKeys=matchKeys;var micromatch_1=micromatch;function ensureArray(e){return Array.isArray(e)?e:null==e?[]:[e]}function createFilter(e,t){const r=e=>isRegexp$1(e)?e:{test:micromatch_1.matcher(path.resolve(e))};return e=ensureArray(e).map(r),t=ensureArray(t).map(r),function(r){if("string"!=typeof r)return!1;if(/\0/.test(r))return!1;r=r.split(path.sep).join("/");for(let e=0;e<t.length;++e){if(t[e].test(r))return!1}for(let t=0;t<e.length;++t){if(e[t].test(r))return!0}return!e.length}}function isRegexp$1(e){return e instanceof RegExp}var modules={},getModule=function(e){var t=e?path__default.resolve(e):process.cwd(),r=path__default.join(t,"@root"),n=modules[r];return n||((n=new module$1(r)).filename=r,n.paths=module$1._nodeModulePaths(t),modules[r]=n),n},requireRelative=function(e,t){return getModule(t).require(e)};requireRelative.resolve=function(e,t){var r=getModule(t);return module$1._resolveFilename(e,r)};var chokidar,requireRelative_1=requireRelative;try{chokidar=requireRelative_1("chokidar",process.cwd())}catch(e){chokidar=null}var chokidar$1=chokidar,opts={encoding:"utf-8",persistent:!0},watchers=new Map;function addTask(e,t,r,n,i){watchers.has(n)||watchers.set(n,new Map);var s=watchers.get(n),o=s.get(e)||new FileWatcher(e,r,s);if(o.fileExists)o.addTask(t,i);else if(i)throw new Error("Transform dependency "+e+" does not exist.")}function deleteTask(e,t,r){var n=watchers.get(r),i=n.get(e);i&&i.deleteTask(t,n)}var FileWatcher=function(){function e(e,t,r){var n,i=this;this.id=e,this.tasks=new Set,this.transformDependencyTasks=new Set;try{var s=fs$1.statSync(e);n=+s.mtime,this.fileExists=!0}catch(e){if("ENOENT"===e.code)return void(this.fileExists=!1);throw e}var o=function(t){if("rename"===t||"unlink"===t)i.close(),r.delete(e),i.trigger(e);else{var s=void 0;try{s=fs$1.statSync(e)}catch(t){if("ENOENT"===t.code)return n=-1,void i.trigger(e);throw t}+s.mtime-n>15&&i.trigger(e)}};this.fsWatcher=t?chokidar$1.watch(e,t).on("all",o):fs$1.watch(e,opts,o),r.set(e,this)}return e.prototype.addTask=function(e,t){void 0===t&&(t=!1),t?this.transformDependencyTasks.add(e):this.tasks.add(e)},e.prototype.deleteTask=function(e,t){var r=this.tasks.delete(e);(r=this.transformDependencyTasks.delete(e)||r)&&0===this.tasks.size&&0===this.transformDependencyTasks.size&&(t.delete(this.id),this.close())},e.prototype.close=function(){this.fsWatcher.close()},e.prototype.trigger=function(e){this.tasks.forEach(function(t){t.invalidate(e,!1)}),this.transformDependencyTasks.forEach(function(t){t.invalidate(e,!0)})},e}(),DELAY=200,Watcher=function(e){function t(t){void 0===t&&(t=[]);var r=e.call(this)||this;return r.rerun=!1,r.succeeded=!1,Array.isArray(t)||(t=[t]),r.tasks=t.map(function(e){return new Task(r,e)}),r.running=!0,process.nextTick(function(){return r.run()}),r}return __extends$1(t,e),t.prototype.close=function(){this.buildTimeout&&clearTimeout(this.buildTimeout),this.tasks.forEach(function(e){e.close()}),this.removeAllListeners()},t.prototype.invalidate=function(){var e=this;this.running?this.rerun=!0:(this.buildTimeout&&clearTimeout(this.buildTimeout),this.buildTimeout=setTimeout(function(){e.buildTimeout=void 0,e.run()},DELAY))},t.prototype.run=function(){var e=this;this.running=!0,this.emit("event",{code:"START"});for(var t=Promise.resolve(),r=function(e){t=t.then(function(){return e.run()})},n=0,i=this.tasks;n<i.length;n++){r(i[n])}return t.then(function(){e.succeeded=!0,e.running=!1,e.emit("event",{code:"END"})}).catch(function(t){e.running=!1,e.emit("event",{code:e.succeeded?"ERROR":"FATAL",error:t})}).then(function(){e.rerun&&(e.rerun=!1,e.invalidate())})},t}(events.EventEmitter),Task=function(){function e(e,t){this.invalidated=!0,this.cache=null,this.watcher=e,this.closed=!1,this.watched=new Set;var r=mergeOptions({config:t}),n=r.inputOptions,i=r.outputOptions,s=r.deprecations;this.inputOptions=n,this.outputs=i,this.outputFiles=this.outputs.map(function(e){if(e.file||e.dir)return path__default.resolve(e.file||e.dir)});var o=n.watch||{};"useChokidar"in o&&(o.chokidar=o.useChokidar);var a="chokidar"in o?o.chokidar:!!chokidar$1;if(a&&(a=__assign$1({},!0===a?{}:a,{ignoreInitial:!0})),a&&!chokidar$1)throw new Error("watch.chokidar was provided, but chokidar could not be found. Have you installed it?");this.chokidarOptions=a,this.chokidarOptionsHash=JSON.stringify(a),this.filter=createFilter(o.include,o.exclude),this.deprecations=s.concat(o._deprecations||[])}return e.prototype.close=function(){var e=this;this.closed=!0,this.watched.forEach(function(t){deleteTask(t,e,e.chokidarOptionsHash)})},e.prototype.invalidate=function(e,t){this.watcher.emit("change",e),this.invalidated=!0,t&&this.cache.modules.forEach(function(t){t.transformDependencies&&-1!==t.transformDependencies.indexOf(e)&&(t.originalCode=null)}),this.watcher.invalidate()},e.prototype.run=function(){var e=this;if(this.invalidated){this.invalidated=!1;var t=__assign$1({},this.inputOptions,{cache:this.cache}),r=Date.now();return this.watcher.emit("event",{code:"BUNDLE_START",input:this.inputOptions.input,output:this.outputFiles}),this.deprecations.length&&this.inputOptions.onwarn({code:"DEPRECATED_OPTIONS",deprecations:this.deprecations,message:"The following options have been renamed — please update your config: "+this.deprecations.map(function(e){return e.old+" -> "+e.new}).join(", ")}),setWatcher(this.watcher),rollup(t).then(function(t){if(!e.closed){var r=e.watched=new Set;return e.cache=t.cache,e.watchFiles=t.watchFiles,e.cache.modules.forEach(function(t){t.transformDependencies&&t.transformDependencies.forEach(function(t){r.add(t),e.watchFile(t,!0)})}),e.watchFiles.forEach(function(t){r.add(t),e.watchFile(t)}),e.watched.forEach(function(t){r.has(t)||deleteTask(t,e,e.chokidarOptionsHash)}),Promise.all(e.outputs.map(function(e){return t.write(e)})).then(function(){return t})}}).then(function(t){e.watcher.emit("event",{code:"BUNDLE_END",input:e.inputOptions.input,output:e.outputFiles,duration:Date.now()-r,result:t})}).catch(function(t){if(!e.closed)throw e.cache&&(e.cache.modules&&e.cache.modules.forEach(function(t){t.transformDependencies&&t.transformDependencies.forEach(function(t){e.watchFile(t,!0)})}),e.watchFiles.forEach(function(t){e.watchFile(t)})),t})}},e.prototype.watchFile=function(e,t){if(void 0===t&&(t=!1),this.filter(e)){if(this.outputFiles.some(function(t){return t===e}))throw new Error("Cannot import the generated bundle");addTask(e,this,this.chokidarOptions,this.chokidarOptionsHash,t)}},e}();function walk(e,t){visit(e,null,t.enter,t.leave)}var shouldSkip=!1,context={skip:function(){return shouldSkip=!0}},childKeys={},toString$5=Object.prototype.toString;function isArray$2(e){return"[object Array]"===toString$5.call(e)}function visit(e,t,r,n,i,s){if(e){if(r){var o=shouldSkip;shouldSkip=!1,r.call(context,e,t,i,s);var a=shouldSkip;if(shouldSkip=o,a)return}for(var u=childKeys[e.type]||(childKeys[e.type]=Object.keys(e).filter(function(t){return"object"==typeof e[t]})),c=0;c<u.length;c+=1){var h=u[c],p=e[h];if(isArray$2(p))for(var l=0;l<p.length;l+=1)visit(p[l],e,r,n,h,l);else p&&p.type&&visit(p,e,r,n,h,null)}n&&n(e,t,i,s)}}var filenameRegex$1=function(){return/([^\\\/]+)$/},arrFlatten$1=function(e){return flat$1(e,[])};function flat$1(e,t){for(var r,n=0,i=e.length;n<i;n++)r=e[n],Array.isArray(r)?flat$1(r,t):t.push(r);return t}var slice$2=[].slice;function diff$1(e,t){var r=arguments.length,n=e.length,i=-1,s=[];if(1===r)return e;for(r>2&&(t=arrFlatten$1(slice$2.call(arguments,1)));++i<n;)~t.indexOf(e[i])||s.push(e[i]);return s}var arrDiff$1=diff$1,arrayUnique$1=function(e){if(!Array.isArray(e))throw new TypeError("array-unique expects an array.");for(var t=e.length,r=-1;r++<t;)for(var n=r+1;n<e.length;++n)e[r]===e[n]&&e.splice(n--,1);return e},toString$6={}.toString,isarray$1=Array.isArray||function(e){return"[object Array]"==toString$6.call(e)},isobject$1=function(e){return null!=e&&"object"==typeof e&&!1===isarray$1(e)},isBuffer_1$1=function(e){return null!=e&&(isBuffer$2(e)||isSlowBuffer$1(e)||!!e._isBuffer)};function isBuffer$2(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isSlowBuffer$1(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer$2(e.slice(0,0))}var toString$7=Object.prototype.toString,kindOf$2=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$7.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1$1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isNumber$2=function(e){var t=kindOf$2(e);if("number"!==t&&"string"!==t)return!1;var r=+e;return r-r+1>=0&&""!==e},isNumber$3=function(e){var t=typeof e;if("string"===t||e instanceof String){if(!e.trim())return!1}else if("number"!==t&&!(e instanceof Number))return!1;return e-e+1>=0},toString$8=Object.prototype.toString,kindOf$3=function(e){if(void 0===e)return"undefined";if(null===e)return"null";var t=typeof e;if("boolean"===t)return"boolean";if("string"===t)return"string";if("number"===t)return"number";if("symbol"===t)return"symbol";if("function"===t)return isGeneratorFn$1(e)?"generatorfunction":"function";if(isArray$3(e))return"array";if(isBuffer$3(e))return"buffer";if(isArguments$1(e))return"arguments";if(isDate$1(e))return"date";if(isError$1(e))return"error";if(isRegexp$2(e))return"regexp";switch(ctorName$1(e)){case"Symbol":return"symbol";case"Promise":return"promise";case"WeakMap":return"weakmap";case"WeakSet":return"weakset";case"Map":return"map";case"Set":return"set";case"Int8Array":return"int8array";case"Uint8Array":return"uint8array";case"Uint8ClampedArray":return"uint8clampedarray";case"Int16Array":return"int16array";case"Uint16Array":return"uint16array";case"Int32Array":return"int32array";case"Uint32Array":return"uint32array";case"Float32Array":return"float32array";case"Float64Array":return"float64array"}if(isGeneratorObj$1(e))return"generator";switch(t=toString$8.call(e)){case"[object Object]":return"object";case"[object Map Iterator]":return"mapiterator";case"[object Set Iterator]":return"setiterator";case"[object String Iterator]":return"stringiterator";case"[object Array Iterator]":return"arrayiterator"}return t.slice(8,-1).toLowerCase().replace(/\s/g,"")};function ctorName$1(e){return e.constructor?e.constructor.name:null}function isArray$3(e){return Array.isArray?Array.isArray(e):e instanceof Array}function isError$1(e){return e instanceof Error||"string"==typeof e.message&&e.constructor&&"number"==typeof e.constructor.stackTraceLimit}function isDate$1(e){return e instanceof Date||"function"==typeof e.toDateString&&"function"==typeof e.getDate&&"function"==typeof e.setDate}function isRegexp$2(e){return e instanceof RegExp||"string"==typeof e.flags&&"boolean"==typeof e.ignoreCase&&"boolean"==typeof e.multiline&&"boolean"==typeof e.global}function isGeneratorFn$1(e,t){return"GeneratorFunction"===ctorName$1(e)}function isGeneratorObj$1(e){return"function"==typeof e.throw&&"function"==typeof e.return&&"function"==typeof e.next}function isArguments$1(e){try{if("number"==typeof e.length&&"function"==typeof e.callee)return!0}catch(e){if(-1!==e.message.indexOf("callee"))return!0}return!1}function isBuffer$3(e){return!(!e.constructor||"function"!=typeof e.constructor.isBuffer)&&e.constructor.isBuffer(e)}var max$1=Math.pow(2,32),node$1=random$1,cryptographic$1=!0;function random$1(){var e=crypto__default.randomBytes(4).toString("hex");return parseInt(e,16)/max$1}node$1.cryptographic=cryptographic$1;var randomatic_1$1=randomatic$1,isCrypto$1=!!node$1.cryptographic,type$1={lower:"abcdefghijklmnopqrstuvwxyz",upper:"ABCDEFGHIJKLMNOPQRSTUVWXYZ",number:"0123456789",special:"~!@#$%^&()_+-={}[];',."};function randomatic$1(e,t,r){if(void 0===e)throw new Error("randomatic expects a string or number.");var n=!1;1===arguments.length&&("string"==typeof e?t=e.length:isNumber$3(e)&&(r={},t=e,e="*")),"object"===kindOf$3(t)&&t.hasOwnProperty("chars")&&(t=(e=(r=t).chars).length,n=!0);var i=r||{},s="",o="";if(-1!==e.indexOf("?")&&(s+=i.chars),-1!==e.indexOf("a")&&(s+=type$1.lower),-1!==e.indexOf("A")&&(s+=type$1.upper),-1!==e.indexOf("0")&&(s+=type$1.number),-1!==e.indexOf("!")&&(s+=type$1.special),-1!==e.indexOf("*")&&(s+=type$1.all),n&&(s+=e),i.exclude){var a="string"===kindOf$3(i.exclude)?i.exclude:i.exclude.join("");a=a.replace(new RegExp("[\\]]+","g"),""),s=s.replace(new RegExp("["+a+"]+","g"),""),-1!==i.exclude.indexOf("]")&&(s=s.replace(new RegExp("[\\]]+","g"),""))}for(;t--;)o+=s.charAt(parseInt(node$1()*s.length,10));return o}type$1.all=type$1.lower+type$1.upper+type$1.number+type$1.special,randomatic_1$1.isCrypto=isCrypto$1;var cache$4,res$1="",repeatString$1=repeat$1;function repeat$1(e,t){if("string"!=typeof e)throw new TypeError("expected a string");if(1===t)return e;if(2===t)return e+e;var r=e.length*t;if(cache$4!==e||void 0===cache$4)cache$4=e,res$1="";else if(res$1.length>=r)return res$1.substr(0,r);for(;r>res$1.length&&t>1;)1&t&&(res$1+=e),t>>=1,e+=e;return res$1=(res$1+=e).substr(0,r)}var repeatElement$1=function(e,t){for(var r=new Array(t),n=0;n<t;n++)r[n]=e;return r},fillRange_1$1=fillRange$1;function fillRange$1(e,t,r,n,i){if(null==e||null==t)throw new Error("fill-range expects the first and second args to be strings.");"function"==typeof r&&(i=r,n={},r=null),"function"==typeof n&&(i=n,n={}),isobject$1(r)&&(n=r,r="");var s,o=!1,a="",u=n||{};void 0===u.silent&&(u.silent=!0),r=r||u.step;var c=e,h=t;if(t="-0"===t.toString()?0:t,(u.optimize||u.makeRe)&&(r=r?r+="~":r,s=!0,o=!0,a="~"),"string"==typeof r){var p=stepRe$1().exec(r);if(p){var l=p.index,f=p[0];if("+"===f)return repeatElement$1(e,t);if("?"===f)return[randomatic_1$1(e,t)];">"===f?(r=r.substr(0,l)+r.substr(l+1),s=!0):"|"===f?(r=r.substr(0,l)+r.substr(l+1),s=!0,o=!0,a=f):"~"===f&&(r=r.substr(0,l)+r.substr(l+1),s=!0,o=!0,a=f)}else if(!isNumber$2(r)){if(!u.silent)throw new TypeError("fill-range: invalid step.");return null}}if(/[.&*()[\]^%$#@!]/.test(e)||/[.&*()[\]^%$#@!]/.test(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}if(!noAlphaNum$1(e)||!noAlphaNum$1(t)||hasBoth$1(e)||hasBoth$1(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}var d=isNumber$2(zeros$1(e)),m=isNumber$2(zeros$1(t));if(!d&&m||d&&!m){if(!u.silent)throw new TypeError("fill-range: first range argument is incompatible with second.");return null}var g=d,y=formatStep$1(r);g?(e=+e,t=+t):(e=e.charCodeAt(0),t=t.charCodeAt(0));var v=e>t;(e<0||t<0)&&(s=!1,o=!1);var _,x,b=isPadded$2(c,h),E=[],S=0;if(o&&shouldExpand$1(e,t,y,g,b,u))return"|"!==a&&"~"!==a||(a=detectSeparator$1(e,t,y,g,v)),wrap$3([c,h],a,u);for(;v?e>=t:e<=t;)b&&g&&(x=b(e)),null!==(_="function"==typeof i?i(e,g,x,S++):g?formatPadding$1(e,x):o&&isInvalidChar$1(e)?null:String.fromCharCode(e))&&E.push(_),v?e-=y:e+=y;return!o&&!s||u.noexpand?E:("|"!==a&&"~"!==a||(a=detectSeparator$1(e,t,y,g,v)),1===E.length||e<0||t<0?E:wrap$3(E,a,u))}function wrap$3(e,t,r){"~"===t&&(t="-");var n=e.join(t),i=r&&r.regexPrefix;return"|"===t&&(n="("+(n=i?i+n:n)+")"),"-"===t&&(n="["+(n=i&&"^"===i?i+n:n)+"]"),[n]}function isCharClass$1(e,t,r,n,i){return!i&&(n?e<=9&&t<=9:e<t&&1===r)}function shouldExpand$1(e,t,r,n,i,s){return(!n||!(e>9||t>9))&&(!i&&1===r&&e<t)}function detectSeparator$1(e,t,r,n,i){return isCharClass$1(e,t,r,n,i)?"~":"|"}function formatStep$1(e){return Math.abs(e>>0)||1}function formatPadding$1(e,t){var r=t?t+e:e;return t&&"-"===e.toString().charAt(0)&&(r="-"+t+e.toString().substr(1)),r.toString()}function isInvalidChar$1(e){var t=toStr$1(e);return"\\"===t||"["===t||"]"===t||"^"===t||"("===t||")"===t||"`"===t}function toStr$1(e){return String.fromCharCode(e)}function stepRe$1(){return/\?|>|\||\+|\~/g}function noAlphaNum$1(e){return/[a-z0-9]/i.test(e)}function hasBoth$1(e){return/[a-z][0-9]|[0-9][a-z]/i.test(e)}function zeros$1(e){return/^-*0+$/.test(e.toString())?"0":e}function hasZeros$1(e){return/[^.]\.|^-*0+[0-9]/.test(e)}function isPadded$2(e,t){if(hasZeros$1(e)||hasZeros$1(t)){var r=length$1(e),n=length$1(t),i=r>=n?r:n;return function(e){return repeatString$1("0",i-length$1(e))}}return!1}function length$1(e){return e.toString().length}var expandRange$1=function(e,t,r){if("string"!=typeof e)throw new TypeError("expand-range expects a string.");"function"==typeof t&&(r=t,t={}),"boolean"==typeof t&&((t={}).makeRe=!0);var n=t||{},i=e.split(".."),s=i.length;return s>3?e:1===s?i:("boolean"==typeof r&&!0===r&&(n.makeRe=!0),i.push(n),fillRange_1$1.apply(null,i.concat(r)))},before$1=function(e,t){return e.replace(t,function(e){var t=randomize$1();return cache$5[t]=e,"__ID"+t+"__"})},after$1=function(e){return e.replace(/__ID(.{5})__/g,function(e,t){return cache$5[t]})};function randomize$1(){return Math.random().toString().slice(2,7)}var braceRe$1,patternRe$1,cache$5={},preserve$1={before:before$1,after:after$1},braces_1$1=function(e,t){if("string"!=typeof e)throw new Error("braces expects a string");return braces$1(e,t)};function braces$1(e,t,r){if(""===e)return[];Array.isArray(t)||(r=t,t=[]);var n=r||{};t=t||[],void 0===n.nodupes&&(n.nodupes=!0);var i,s=n.fn;switch("function"==typeof n&&(s=n,n={}),patternRe$1 instanceof RegExp||(patternRe$1=patternRegex$1()),(e.match(patternRe$1)||[])[0]){case"\\,":return escapeCommas$1(e,t,n);case"\\.":return escapeDots$1(e,t,n);case"/.":return escapePaths$1(e,t,n);case" ":return splitWhitespace$1(e);case"{,}":return exponential$1(e,n,braces$1);case"{}":return emptyBraces$1(e,t,n);case"\\{":case"\\}":return escapeBraces$2(e,t,n);case"${":if(!/\{[^{]+\{/.test(e))return t.concat(e);i=!0,e=preserve$1.before(e,es6Regex$1())}braceRe$1 instanceof RegExp||(braceRe$1=braceRegex$1());var o=braceRe$1.exec(e);if(null==o)return[e];var a,u,c=o[1],h=o[2];if(""===h)return[e];if(-1!==h.indexOf(".."))u=(a=expandRange$1(h,n,s)||h.split(",")).length;else{if('"'===h[0]||"'"===h[0])return t.concat(e.split(/['"]/).join(""));if(a=h.split(","),n.makeRe)return braces$1(e.replace(c,wrap$4(a,"|")),n);1===(u=a.length)&&n.bash&&(a[0]=wrap$4(a[0],"\\"))}for(var p,l=a.length,f=0;l--;){var d=a[f++];if(/(\.[^.\/])/.test(d))return u>1?a:[e];if(p=splice$1(e,c,d),/\{[^{}]+?\}/.test(p))t=braces$1(p,t,n);else if(""!==p){if(n.nodupes&&-1!==t.indexOf(p))continue;t.push(i?preserve$1.after(p):p)}}return n.strict?filter$2(t,filterEmpty$1):t}function exponential$1(e,t,r){"function"==typeof t&&(r=t,t=null);var n,i,s=t||{},o="__ESC_EXP__",a=e.split("{,}");if(s.nodupes)return r(a.join(""),s);n=a.length-1;for(var u=(i=r(a.join(o),s)).length,c=[],h=0;u--;){var p=i[h++];if(-1===p.indexOf(o))c.push(p);else if((p=p.split("__ESC_EXP__").join(""))&&!1!==s.nodupes)c.push(p);else{var l=Math.pow(2,n);c.push.apply(c,repeatElement$1(p,l))}}return c}function wrap$4(e,t){return"|"===t?"("+e.join(t)+")":","===t?"{"+e.join(t)+"}":"-"===t?"["+e.join(t)+"]":"\\"===t?"\\{"+e+"\\}":void 0}function emptyBraces$1(e,t,r){return braces$1(e.split("{}").join("\\{\\}"),t,r)}function filterEmpty$1(e){return!!e&&"\\"!==e}function splitWhitespace$1(e){for(var t=e.split(" "),r=t.length,n=[],i=0;r--;)n.push.apply(n,braces$1(t[i++]));return n}function escapeBraces$2(e,t,r){return/\{[^{]+\{/.test(e)?map$1(braces$1(e=(e=e.split("\\{").join("__LT_BRACE__")).split("\\}").join("__RT_BRACE__"),t,r),function(e){return(e=e.split("__LT_BRACE__").join("{")).split("__RT_BRACE__").join("}")}):t.concat(e.split("\\").join(""))}function escapeDots$1(e,t,r){return/[^\\]\..+\\\./.test(e)?map$1(braces$1(e=e.split("\\.").join("__ESC_DOT__"),t,r),function(e){return e.split("__ESC_DOT__").join(".")}):t.concat(e.split("\\").join(""))}function escapePaths$1(e,t,r){return map$1(braces$1(e=e.split("/.").join("__ESC_PATH__"),t,r),function(e){return e.split("__ESC_PATH__").join("/.")})}function escapeCommas$1(e,t,r){return/\w,/.test(e)?map$1(braces$1(e=e.split("\\,").join("__ESC_COMMA__"),t,r),function(e){return e.split("__ESC_COMMA__").join(",")}):t.concat(e.split("\\").join(""))}function patternRegex$1(){return/\${|( (?=[{,}])|(?=[{,}]) )|{}|{,}|\\,(?=.*[{}])|\/\.(?=.*[{}])|\\\.(?={)|\\{|\\}/}function braceRegex$1(){return/.*(\\?\{([^}]+)\})/}function es6Regex$1(){return/\$\{([^}]+)\}/}function splice$1(e,t,r){var n=e.indexOf(t);return e.substr(0,n)+r+e.substr(n+t.length)}function map$1(e,t){if(null==e)return[];for(var r=e.length,n=new Array(r),i=-1;++i<r;)n[i]=t(e[i],i,e);return n}function filter$2(e,t){if(null==e)return[];if("function"!=typeof t)throw new TypeError("braces: filter expects a callback function.");for(var r=e.length,n=e.slice(),i=0;r--;)t(e[r],i++)||n.splice(r,1);return n}var isPosixBracket$1=function(e){return"string"==typeof e&&/\[([:.=+])(?:[^\[\]]|)+\1\]/.test(e)},POSIX$1={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E",punct:"-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"},expandBrackets$1=brackets$1;function brackets$1(e){if(!isPosixBracket$1(e))return e;var t=!1;-1!==e.indexOf("[^")&&(t=!0,e=e.split("[^").join("[")),-1!==e.indexOf("[!")&&(t=!0,e=e.split("[!").join("["));for(var r=e.split("["),n=e.split("]"),i=r.length!==n.length,s=e.split(/(?::\]\[:|\[?\[:|:\]\]?)/),o=s.length,a=0,u="",c="",h=[];o--;){var p=s[a++];"^[!"!==p&&"[!"!==p||(p="",t=!0);var l=t?"^":"",f=POSIX$1[p];f?h.push("["+l+f+"]"):p&&(/^\[?\w-\w\]?$/.test(p)?a===s.length?h.push("["+l+p):1===a?h.push(l+p+"]"):h.push(l+p):1===a?c+=p:a===s.length?u+=p:h.push("["+l+p+"]"))}var d=h.join("|"),m=h.length||1;return m>1&&(d="(?:"+d+")",m=1),c&&(m++,"["===c.charAt(0)&&(i?c="\\["+c.slice(1):c+="]"),d=c+d),u&&(m++,"]"===u.slice(-1)&&(u=i?u.slice(0,u.length-1)+"\\]":"["+u),d+=u),m>1&&(-1===(d=d.split("][").join("]|[")).indexOf("|")||/\(\?/.test(d)||(d="(?:"+d+")")),d=d.replace(/\[+=|=\]+/g,"\\b")}brackets$1.makeRe=function(e){try{return new RegExp(brackets$1(e))}catch(e){}},brackets$1.isMatch=function(e,t){try{return brackets$1.makeRe(t).test(e)}catch(e){return!1}},brackets$1.match=function(e,t){for(var r=e.length,n=0,i=e.slice(),s=brackets$1.makeRe(t);n<r;){var o=e[n++];s.test(o)&&i.splice(n,1)}return i};var re$1,isExtglob$4=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},cache$6={},extglob_1$1=extglob$1;function extglob$1(e,t){t=t||{};var r,n={},i=0,s=(e=(e=e.replace(/!\(([^\w*()])/g,"$1!(")).replace(/([*\/])\.!\([*]\)/g,function(e,t){return escape$1("/"===t?"\\/[^.]+":"[^.]+")}))+String(!!t.regex)+String(!!t.contains)+String(!!t.escape);if(cache$6.hasOwnProperty(s))return cache$6[s];for(re$1 instanceof RegExp||(re$1=regex$1()),t.negate=!1;r=re$1.exec(e);){var o=r[1],a=r[3];"!"===o&&(t.negate=!0);var u="__EXTGLOB_"+i+++"__";n[u]=wrap$5(a,o,t.escape),e=e.split(r[0]).join(u)}for(var c=Object.keys(n),h=c.length;h--;){var p=c[h];e=e.split(p).join(n[p])}var l=t.regex?toRegex$2(e,t.contains,t.negate):e;return l=l.split(".").join("\\."),cache$6[s]=l}function wrap$5(e,t,r){switch(r&&(e=escape$1(e)),t){case"!":return"(?!"+e+")[^/]"+(r?"%%%~":"*?");case"@":return"(?:"+e+")";case"+":return"(?:"+e+")+";case"*":return"(?:"+e+")"+(r?"%%":"*");case"?":return"(?:"+e+"|)";default:return e}}function escape$1(e){return e=(e=e.split("*").join("[^/]%%%~")).split(".").join("\\.")}function regex$1(){return/(\\?[@?!+*$]\\?)(\(([^()]*?)\))/}function negate$1(e){return"(?!^"+e+").*$"}function toRegex$2(e,t,r){var n=t?"^":"";return e="(?:"+e+")"+(t?"$":""),r&&(e=n+negate$1(e)),new RegExp(n+e)}var isGlob$4=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$4(e))},toString$9=Object.prototype.toString,kindOf$4=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$9.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1$1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isWin$1="win32"===process.platform,removeTrailingSeparator$1=function(e){var t=e.length-1;if(t<2)return e;for(;isSeparator$1(e,t);)t--;return e.substr(0,t+1)};function isSeparator$1(e,t){var r=e[t];return t>0&&("/"===r||isWin$1&&"\\"===r)}var normalizePath$2=function(e,t){if("string"!=typeof e)throw new TypeError("expected a string");return e=e.replace(/[\\\/]+/g,"/"),!1!==t&&(e=removeTrailingSeparator$1(e)),e},isExtendable$1=function(e){return null!=e&&("object"==typeof e||"function"==typeof e)},forIn$1=function(e,t,r){for(var n in e)if(!1===t.call(r,e[n],n,e))break},hasOwn$1=Object.prototype.hasOwnProperty,forOwn$1=function(e,t,r){forIn$1(e,function(n,i){if(hasOwn$1.call(e,i))return t.call(r,e[i],i,e)})},object_omit$1=function(e,t){if(!isExtendable$1(e))return{};var r,n=(t=[].concat.apply([],[].slice.call(arguments,1)))[t.length-1],i={};"function"==typeof n&&(r=t.pop());var s="function"==typeof r;return t.length||s?(forOwn$1(e,function(n,o){-1===t.indexOf(o)&&(s?r(n,o,e)&&(i[o]=n):i[o]=n)}),i):e},isExtglob$5=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$5=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$5(e))},isExtglob$6=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$6=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$6(e))},globParent$1=function(e){e+="a";do{e=path__default.dirname(e)}while(isGlob$6(e));return e},globBase$1=function(e){if("string"!=typeof e)throw new TypeError("glob-base expects a string.");var t={};return t.base=globParent$1(e),t.isGlob=isGlob$6(e),"."!==t.base?(t.glob=e.substr(t.base.length),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1))):t.glob=e,t.isGlob||(t.base=dirname(e),t.glob="."!==t.base?e.substr(t.base.length):e),"./"===t.glob.substr(0,2)&&(t.glob=t.glob.substr(2)),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1)),t};function dirname(e){return"/"===e.slice(-1)?e:path__default.dirname(e)}var isDotfile$1=function(e){if(46===e.charCodeAt(0)&&-1===e.indexOf("/",1))return!0;var t=e.lastIndexOf("/");return-1!==t&&46===e.charCodeAt(t+1)},parseGlob$1=createCommonjsModule(function(e){var t=e.exports.cache={};function r(e,t,r){return e&&-1!==t.indexOf(r)}function n(e){return e=(e=e.split("__SLASH__").join("/")).split("__DOT__").join(".")}e.exports=function(e){if(t.hasOwnProperty(e))return t[e];var i={};i.orig=e,i.is={},e=e.replace(/\{([^{}]*?)}|\(([^()]*?)\)|\[([^\[\]]*?)\]/g,function(e,t,r,n){var i=t||r||n;return i?e.split(i).join(i.split("/").join("__SLASH__").split(".").join("__DOT__")):e});var s=globBase$1(e);i.is.glob=s.isGlob,i.glob=s.glob,i.base=s.base;var o=/([^\/]*)$/.exec(e);i.path={},i.path.dirname="",i.path.basename=o[1]||"",i.path.dirname=e.split(i.path.basename).join("")||"";var a=(i.path.basename||"").split(".")||"";i.path.filename=a[0]||"",i.path.extname=a.slice(1).join(".")||"",i.path.ext="",isGlob$5(i.path.dirname)&&!i.path.basename&&(/\/$/.test(i.glob)||(i.path.basename=i.glob),i.path.dirname=i.base),-1!==e.indexOf("/")||i.is.globstar||(i.path.dirname="",i.path.basename=i.orig);var u=i.path.basename.indexOf(".");if(-1!==u&&(i.path.filename=i.path.basename.slice(0,u),i.path.extname=i.path.basename.slice(u)),"."===i.path.extname.charAt(0)){var c=i.path.extname.split(".");i.path.ext=c[c.length-1]}i.glob=n(i.glob),i.path.dirname=n(i.path.dirname),i.path.basename=n(i.path.basename),i.path.filename=n(i.path.filename),i.path.extname=n(i.path.extname);var h=e&&i.is.glob;return i.is.negated=e&&"!"===e.charAt(0),i.is.extglob=e&&isExtglob$5(e),i.is.braces=r(h,e,"{"),i.is.brackets=r(h,e,"[:"),i.is.globstar=r(h,e,"**"),i.is.dotfile=isDotfile$1(i.path.basename)||isDotfile$1(i.path.filename),i.is.dotdir=function(e){if(-1!==e.indexOf("/."))return!0;if("."===e.charAt(0)&&"/"!==e.charAt(1))return!0;return!1}(i.path.dirname),t[e]=i}}),parseGlob_1$1=parseGlob$1.cache,isPrimitive$1=function(e){return null==e||"function"!=typeof e&&"object"!=typeof e},isEqualShallow$1=function(e,t){if(!e&&!t)return!0;if(!e&&t||e&&!t)return!1;var r,n=0,i=0;for(r in t)if(i++,!isPrimitive$1(t[r])||!e.hasOwnProperty(r)||e[r]!==t[r])return!1;for(r in e)n++;return n===i},basic$1={},cache$7={},regexCache_1$1=regexCache$1;function regexCache$1(e,t,r){var n,i,s="_default_";if(!t&&!r)return"function"!=typeof e?e:basic$1[s]||(basic$1[s]=e(t));if("string"==typeof t){if(!r)return basic$1[t]||(basic$1[t]=e(t));s=t}else r=t;return(i=cache$7[s])&&isEqualShallow$1(i.opts,r)?i.regex:(memo$1(s,r,n=e(t,r)),n)}function memo$1(e,t,r){cache$7[e]={regex:r,opts:t}}var cache_1$1=cache$7,basic_1$1=basic$1;regexCache_1$1.cache=cache_1$1,regexCache_1$1.basic=basic_1$1;var unesc$1,temp$1,utils_1$1=createCommonjsModule(function(e){var t=process&&"win32"===process.platform,r=e.exports;r.diff=arrDiff$1,r.unique=arrayUnique$1,r.braces=braces_1$1,r.brackets=expandBrackets$1,r.extglob=extglob_1$1,r.isExtglob=isExtglob$4,r.isGlob=isGlob$4,r.typeOf=kindOf$4,r.normalize=normalizePath$2,r.omit=object_omit$1,r.parseGlob=parseGlob$1,r.cache=regexCache_1$1,r.filename=function(e){var t=e.match(filenameRegex$1());return t&&t[0]},r.isPath=function(e,t){return t=t||{},function(n){var i=r.unixify(n,t);return t.nocase?e.toLowerCase()===i.toLowerCase():e===i}},r.hasPath=function(e,t){return function(n){return-1!==r.unixify(e,t).indexOf(n)}},r.matchPath=function(e,t){return t&&t.contains?r.hasPath(e,t):r.isPath(e,t)},r.hasFilename=function(e){return function(t){var n=r.filename(t);return n&&e.test(n)}},r.arrayify=function(e){return Array.isArray(e)?e:[e]},r.unixify=function(e,n){return n&&!1===n.unixify?e:n&&!0===n.unixify||t||"\\"===path__default.sep?r.normalize(e,!1):n&&!0===n.unescape?e?e.toString().replace(/\\(\w)/g,"$1"):"":e},r.escapePath=function(e){return e.replace(/[\\.]/g,"\\$&")},r.unescapeGlob=function(e){return e.replace(/[\\"']/g,"")},r.escapeRe=function(e){return e.replace(/[-[\\$*+?.#^\s{}(|)\]]/g,"\\$&")},e.exports=r}),chars$3={};function reverse$1(e,t){return Object.keys(e).reduce(function(r,n){var i=t?t+n:n;return r[e[n]]=i,r},{})}chars$3.escapeRegex={"?":/\?/g,"@":/\@/g,"!":/\!/g,"+":/\+/g,"*":/\*/g,"(":/\(/g,")":/\)/g,"[":/\[/g,"]":/\]/g},chars$3.ESC={"?":"__UNESC_QMRK__","@":"__UNESC_AMPE__","!":"__UNESC_EXCL__","+":"__UNESC_PLUS__","*":"__UNESC_STAR__",",":"__UNESC_COMMA__","(":"__UNESC_LTPAREN__",")":"__UNESC_RTPAREN__","[":"__UNESC_LTBRACK__","]":"__UNESC_RTBRACK__"},chars$3.UNESC=unesc$1||(unesc$1=reverse$1(chars$3.ESC,"\\")),chars$3.ESC_TEMP={"?":"__TEMP_QMRK__","@":"__TEMP_AMPE__","!":"__TEMP_EXCL__","*":"__TEMP_STAR__","+":"__TEMP_PLUS__",",":"__TEMP_COMMA__","(":"__TEMP_LTPAREN__",")":"__TEMP_RTPAREN__","[":"__TEMP_LTBRACK__","]":"__TEMP_RTBRACK__"},chars$3.TEMP=temp$1||(temp$1=reverse$1(chars$3.ESC_TEMP));var chars_1$1=chars$3,glob$2=createCommonjsModule(function(e){var t=e.exports=function e(t,r){if(!(this instanceof e))return new e(t,r);this.options=r||{},this.pattern=t,this.history=[],this.tokens={},this.init(t)};t.prototype.init=function(e){this.orig=e,this.negated=this.isNegated(),this.options.track=this.options.track||!1,this.options.makeRe=!0},t.prototype.track=function(e){this.options.track&&this.history.push({msg:e,pattern:this.pattern})},t.prototype.isNegated=function(){return 33===this.pattern.charCodeAt(0)&&(this.pattern=this.pattern.slice(1),!0)},t.prototype.braces=function(){if(!0!==this.options.nobraces&&!0!==this.options.nobrace){var e=this.pattern.match(/[\{\(\[]/g),t=this.pattern.match(/[\}\)\]]/g);e&&t&&e.length!==t.length&&(this.options.makeRe=!1);var r=utils_1$1.braces(this.pattern,this.options);this.pattern=r.join("|")}},t.prototype.brackets=function(){!0!==this.options.nobrackets&&(this.pattern=utils_1$1.brackets(this.pattern))},t.prototype.extglob=function(){!0!==this.options.noextglob&&utils_1$1.isExtglob(this.pattern)&&(this.pattern=utils_1$1.extglob(this.pattern,{escape:!0}))},t.prototype.parse=function(e){return this.tokens=utils_1$1.parseGlob(e||this.pattern,!0),this.tokens},t.prototype._replace=function(e,t,r){this.track('before (find): "'+e+'" (replace with): "'+t+'"'),r&&(t=t.split("?").join("%~").split("*").join("%%")),this.pattern=e&&t&&"string"==typeof e?this.pattern.split(e).join(t):this.pattern.replace(e,t),this.track("after")},t.prototype.escape=function(e){this.track("before escape: ");this.pattern=e.replace(/["\\](['"]?[^"'\\]['"]?)/g,function(e,t){var r=chars_1$1.ESC,n=r&&r[t];return n||(/[a-z]/i.test(e)?e.split("\\").join(""):e)}),this.track("after escape: ")},t.prototype.unescape=function(e){this.pattern=e.replace(/__([A-Z]+)_([A-Z]+)__/g,function(e,t){return chars_1$1[t][e]}),this.pattern=function(e){return e=(e=e.split("%~").join("?")).split("%%").join("*")}(this.pattern)}}),expand_1$1=expand$2;function expand$2(e,t){if("string"!=typeof e)throw new TypeError("micromatch.expand(): argument should be a string.");var r=new glob$2(e,t||{}),n=r.options;if(!utils_1$1.isGlob(e))return r.pattern=r.pattern.replace(/([\/.])/g,"\\$1"),r;if(r.pattern=r.pattern.replace(/(\+)(?!\()/g,"\\$1"),r.pattern=r.pattern.split("$").join("\\$"),"boolean"!=typeof n.braces&&"boolean"!=typeof n.nobraces&&(n.braces=!0),".*"===r.pattern)return{pattern:"\\."+star$2,tokens:i,options:n};if("*"===r.pattern)return{pattern:oneStar$1(n.dot),tokens:i,options:n};r.parse();var i=r.tokens;return i.is.negated=n.negated,!0!==n.dotfiles&&!i.is.dotfile||!1===n.dot||(n.dotfiles=!0,n.dot=!0),!0!==n.dotdirs&&!i.is.dotdir||!1===n.dot||(n.dotdirs=!0,n.dot=!0),/[{,]\./.test(r.pattern)&&(n.makeRe=!1,n.dot=!0),!0!==n.nonegate&&(n.negated=r.negated),"."===r.pattern.charAt(0)&&"/"!==r.pattern.charAt(1)&&(r.pattern="\\"+r.pattern),r.track("before braces"),i.is.braces&&r.braces(),r.track("after braces"),r.track("before extglob"),i.is.extglob&&r.extglob(),r.track("after extglob"),r.track("before brackets"),i.is.brackets&&r.brackets(),r.track("after brackets"),r._replace("[!","[^"),r._replace("(?","(%~"),r._replace(/\[\]/,"\\[\\]"),r._replace("/[","/"+(n.dot?dotfiles$1:nodot$1)+"[",!0),r._replace("/?","/"+(n.dot?dotfiles$1:nodot$1)+"[^/]",!0),r._replace("/.","/(?=.)\\.",!0),r._replace(/^(\w):([\\\/]+?)/gi,"(?=.)$1:$2",!0),-1!==r.pattern.indexOf("[^")&&(r.pattern=negateSlash$1(r.pattern)),!1!==n.globstar&&"**"===r.pattern?r.pattern=globstar$1(n.dot):(r.pattern=balance$1(r.pattern,"[","]"),r.escape(r.pattern),i.is.globstar&&(r.pattern=collapse$1(r.pattern,"/**"),r.pattern=collapse$1(r.pattern,"**/"),r._replace("/**/","(?:/"+globstar$1(n.dot)+"/|/)",!0),r._replace(/\*{2,}/g,"**"),r._replace(/(\w+)\*(?!\/)/g,"$1[^/]*?",!0),r._replace(/\*\*\/\*(\w)/g,globstar$1(n.dot)+"\\/"+(n.dot?dotfiles$1:nodot$1)+"[^/]*?$1",!0),!0!==n.dot&&r._replace(/\*\*\/(.)/g,"(?:**\\/|)$1"),(""!==i.path.dirname||/,\*\*|\*\*,/.test(r.orig))&&r._replace("**",globstar$1(n.dot),!0)),r._replace(/\/\*$/,"\\/"+oneStar$1(n.dot),!0),r._replace(/(?!\/)\*$/,star$2,!0),r._replace(/([^\/]+)\*/,"$1"+oneStar$1(!0),!0),r._replace("*",oneStar$1(n.dot),!0),r._replace("?.","?\\.",!0),r._replace("?:","?:",!0),r._replace(/\?+/g,function(e){var t=e.length;return 1===t?qmark$2:qmark$2+"{"+t+"}"}),r._replace(/\.([*\w]+)/g,"\\.$1"),r._replace(/\[\^[\\\/]+\]/g,qmark$2),r._replace(/\/+/g,"\\/"),r._replace(/\\{2,}/g,"\\")),r.unescape(r.pattern),r._replace("__UNESC_STAR__","*"),r._replace("?.","?\\."),r._replace("[^\\/]",qmark$2),r.pattern.length>1&&/^[\[?*]/.test(r.pattern)&&(r.pattern=(n.dot?dotfiles$1:nodot$1)+r.pattern),r}function collapse$1(e,t){var r=e.split(t),n=""===r[0],i=""===r[r.length-1];return r=r.filter(Boolean),n&&r.unshift(""),i&&r.push(""),r.join(t)}function negateSlash$1(e){return e.replace(/\[\^([^\]]*?)\]/g,function(e,t){return-1===t.indexOf("/")&&(t="\\/"+t),"[^"+t+"]"})}function balance$1(e,t,r){var n=e.split(t);return n.join("").length!==e.split(r).join("").length?(e=n.join("\\"+t)).split(r).join("\\"+r):e}var qmark$2="[^/]",star$2=qmark$2+"*?",nodot$1="(?!\\.)(?=.)",dotfileGlob$1="(?:\\/|^)\\.{1,2}($|\\/)",dotfiles$1="(?!"+dotfileGlob$1+")(?=.)",twoStarDot$2="(?:(?!"+dotfileGlob$1+").)*?";function oneStar$1(e){return e?"(?!"+dotfileGlob$1+")(?=.)"+star$2:nodot$1+star$2}function globstar$1(e){return e?twoStarDot$2:"(?:(?!(?:\\/|^)\\.).)*?"}function micromatch$1(e,t,r){if(!e||!t)return[];if(void 0===(r=r||{}).cache&&(r.cache=!0),!Array.isArray(t))return match$2(e,t,r);for(var n=t.length,i=0,s=[],o=[];n--;){var a=t[i++];"string"==typeof a&&33===a.charCodeAt(0)?s.push.apply(s,match$2(e,a.slice(1),r)):o.push.apply(o,match$2(e,a,r))}return utils_1$1.diff(o,s)}function match$2(e,t,r){if("string"!==utils_1$1.typeOf(e)&&!Array.isArray(e))throw new Error(msg$1("match","files","a string or array"));e=utils_1$1.arrayify(e);var n=(r=r||{}).negate||!1,i=t;"string"==typeof t&&((n="!"===t.charAt(0))&&(t=t.slice(1)),!0===r.nonegate&&(n=!1));for(var s=matcher$1(t,r),o=e.length,a=0,u=[];a<o;){var c=e[a++],h=utils_1$1.unixify(c,r);s(h)&&u.push(h)}if(0===u.length){if(!0===r.failglob)throw new Error('micromatch.match() found no matches for: "'+i+'".');(r.nonull||r.nullglob)&&u.push(utils_1$1.unescapeGlob(i))}return n&&(u=utils_1$1.diff(e,u)),r.ignore&&r.ignore.length&&(t=r.ignore,r=utils_1$1.omit(r,["ignore"]),u=utils_1$1.diff(u,micromatch$1(u,t,r))),r.nodupes?utils_1$1.unique(u):u}function filter$3(e,t){if(!Array.isArray(e)&&"string"!=typeof e)throw new TypeError(msg$1("filter","patterns","a string or array"));for(var r=(e=utils_1$1.arrayify(e)).length,n=0,i=Array(r);n<r;)i[n]=matcher$1(e[n++],t);return function(e){if(null==e)return[];var r=i.length,n=0,s=!0;for(e=utils_1$1.unixify(e,t);n<r;){if(!(0,i[n++])(e)){s=!1;break}}return s}}function isMatch$1(e,t,r){if("string"!=typeof e)throw new TypeError(msg$1("isMatch","filepath","a string"));return e=utils_1$1.unixify(e,r),"object"===utils_1$1.typeOf(t)?matcher$1(e,t):matcher$1(t,r)(e)}function contains$1(e,t,r){if("string"!=typeof e)throw new TypeError(msg$1("contains","pattern","a string"));return(r=r||{}).contains=""!==t,e=utils_1$1.unixify(e,r),r.contains&&!utils_1$1.isGlob(t)?-1!==e.indexOf(t):matcher$1(t,r)(e)}function any$1(e,t,r){if(!Array.isArray(t)&&"string"!=typeof t)throw new TypeError(msg$1("any","patterns","a string or array"));var n=(t=utils_1$1.arrayify(t)).length;for(e=utils_1$1.unixify(e,r);n--;){if(matcher$1(t[n],r)(e))return!0}return!1}function matchKeys$1(e,t,r){if("object"!==utils_1$1.typeOf(e))throw new TypeError(msg$1("matchKeys","first argument","an object"));var n=matcher$1(t,r),i={};for(var s in e)e.hasOwnProperty(s)&&n(s)&&(i[s]=e[s]);return i}function matcher$1(e,t){if("function"==typeof e)return e;if(e instanceof RegExp)return function(t){return e.test(t)};if("string"!=typeof e)throw new TypeError(msg$1("matcher","pattern","a string, regex, or function"));if(e=utils_1$1.unixify(e,t),!utils_1$1.isGlob(e))return utils_1$1.matchPath(e,t);var r=makeRe$2(e,t);return t&&t.matchBase?utils_1$1.hasFilename(r,t):function(e){return e=utils_1$1.unixify(e,t),r.test(e)}}function toRegex$3(e,t){var r=Object.create(t||{}),n=r.flags||"";r.nocase&&-1===n.indexOf("i")&&(n+="i");var i,s=expand_1$1(e,r);r.negated=r.negated||s.negated,r.negate=r.negated,e=wrapGlob$1(s.pattern,r);try{return i=new RegExp(e,n)}catch(e){if(e.reason="micromatch invalid regex: ("+i+")",r.strict)throw new SyntaxError(e)}return/$^/}function wrapGlob$1(e,t){var r=t&&!t.contains?"^":"";return e="(?:"+e+")"+(t&&!t.contains?"$":""),t&&t.negate?r+"(?!^"+e+").*$":r+e}function makeRe$2(e,t){if("string"!==utils_1$1.typeOf(e))throw new Error(msg$1("makeRe","glob","a string"));return utils_1$1.cache(toRegex$3,e,t)}function msg$1(e,t,r){return"micromatch."+e+"(): "+t+" should be "+r+"."}micromatch$1.any=any$1,micromatch$1.braces=micromatch$1.braceExpand=utils_1$1.braces,micromatch$1.contains=contains$1,micromatch$1.expand=expand_1$1,micromatch$1.filter=filter$3,micromatch$1.isMatch=isMatch$1,micromatch$1.makeRe=makeRe$2,micromatch$1.match=match$2,micromatch$1.matcher=matcher$1,micromatch$1.matchKeys=matchKeys$1;var micromatch_1$1=micromatch$1,blockDeclarations={const:!0,let:!0},extractors$1={Literal:function(e,t){e.push(t.value)},Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){"RestElement"===t.type?extractors$1.RestElement(e,t):extractors$1[(t.value||t.key).type](e,t.value||t.key)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors$1[t.type](e,t)})},RestElement:function(e,t){extractors$1[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){return extractors$1[t.left.type](e,t.left)}};function extractNames$1(e){var t=[];return extractors$1[e.type](t,e),t}var Scope$1=function(e){var t=this;e=e||{},this.parent=e.parent,this.isBlockScope=!!e.block,this.declarations=Object.create(null),e.params&&e.params.forEach(function(e){extractNames$1(e).forEach(function(e){t.declarations[e]=!0})})};function attachScopes(e,t){void 0===t&&(t="scope");var r=new Scope$1;return walk(e,{enter:function(e,n){if(/(Function|Class)Declaration/.test(e.type)&&r.addDeclaration(e,!1,!1),"VariableDeclaration"===e.type){var i=blockDeclarations[e.kind];e.declarations.forEach(function(e){r.addDeclaration(e,i,!0)})}var s;/Function/.test(e.type)&&(s=new Scope$1({parent:r,block:!1,params:e.params}),"FunctionExpression"===e.type&&e.id&&s.addDeclaration(e,!1,!1)),"BlockStatement"!==e.type||/Function/.test(n.type)||(s=new Scope$1({parent:r,block:!0})),"CatchClause"===e.type&&(s=new Scope$1({parent:r,params:[e.param],block:!0})),s&&(Object.defineProperty(e,t,{value:s,configurable:!0}),r=s)},leave:function(e){e[t]&&(r=r.parent)}}),r}function ensureArray$1(e){return Array.isArray(e)?e:null==e?[]:[e]}function createFilter$1(e,t){var r=function(e){return isRegexp$3(e)?e:{test:micromatch_1$1.matcher(path.resolve(e).split(path.sep).join("/"))}};return e=ensureArray$1(e).map(r),t=ensureArray$1(t).map(r),function(r){if("string"!=typeof r)return!1;if(/\0/.test(r))return!1;r=r.split(path.sep).join("/");for(var n=0;n<t.length;++n){if(t[n].test(r))return!1}for(var i=0;i<e.length;++i){if(e[i].test(r))return!0}return!e.length}}function isRegexp$3(e){return e instanceof RegExp}Scope$1.prototype.addDeclaration=function(e,t,r){var n=this;!t&&this.isBlockScope?this.parent.addDeclaration(e,t,r):e.id&&extractNames$1(e.id).forEach(function(e){n.declarations[e]=!0})},Scope$1.prototype.contains=function(e){return this.declarations[e]||!!this.parent&&this.parent.contains(e)};var reservedWords$2="break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public".split(" "),builtins$2="arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl".split(" "),blacklisted$1=Object.create(null);function makeLegalIdentifier(e){return e=e.replace(/-(\w)/g,function(e,t){return t.toUpperCase()}).replace(/[^$_a-zA-Z0-9]/g,"_"),(/\d/.test(e[0])||blacklisted$1[e])&&(e="_"+e),e}reservedWords$2.concat(builtins$2).forEach(function(e){return blacklisted$1[e]=!0});var _btoa,integerToChar={};function encode$1(e){var t;if("number"==typeof e)t=encodeInteger$1(e);else{t="";for(var r=0;r<e.length;r+=1)t+=encodeInteger$1(e[r])}return t}function encodeInteger$1(e){var t="";e<0?e=-e<<1|1:e<<=1;do{var r=31&e;(e>>=5)>0&&(r|=32),t+=integerToChar[r]}while(e>0);return t}function Chunk$2(e,t,r){this.start=e,this.end=t,this.original=r,this.intro="",this.outro="",this.content=r,this.storeName=!1,this.edited=!1,Object.defineProperties(this,{previous:{writable:!0,value:null},next:{writable:!0,value:null}})}"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".split("").forEach(function(e,t){integerToChar[t]=e}),Chunk$2.prototype={appendLeft:function(e){this.outro+=e},appendRight:function(e){this.intro=this.intro+e},clone:function(){var e=new Chunk$2(this.start,this.end,this.original);return e.intro=this.intro,e.outro=this.outro,e.content=this.content,e.storeName=this.storeName,e.edited=this.edited,e},contains:function(e){return this.start<e&&e<this.end},eachNext:function(e){for(var t=this;t;)e(t),t=t.next},eachPrevious:function(e){for(var t=this;t;)e(t),t=t.previous},edit:function(e,t,r){return this.content=e,r||(this.intro="",this.outro=""),this.storeName=t,this.edited=!0,this},prependLeft:function(e){this.outro=e+this.outro},prependRight:function(e){this.intro=e+this.intro},split:function(e){var t=e-this.start,r=this.original.slice(0,t),n=this.original.slice(t);this.original=r;var i=new Chunk$2(e,this.end,n);return i.outro=this.outro,this.outro="",this.end=e,this.edited?(i.edit("",!1),this.content=""):this.content=r,i.next=this.next,i.next&&(i.next.previous=i),i.previous=this,this.next=i,i},toString:function(){return this.intro+this.content+this.outro},trimEnd:function(e){if(this.outro=this.outro.replace(e,""),this.outro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&this.split(this.start+t.length).edit("",!1),!0):(this.edit("",!1),this.intro=this.intro.replace(e,""),!!this.intro.length||void 0)},trimStart:function(e){if(this.intro=this.intro.replace(e,""),this.intro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&(this.split(this.end-t.length),this.edit("",!1)),!0):(this.edit("",!1),this.outro=this.outro.replace(e,""),!!this.outro.length||void 0)}};var btoa$1=_btoa="undefined"!=typeof window&&"function"==typeof window.btoa?window.btoa:"function"==typeof Buffer?function(e){return new Buffer(e).toString("base64")}:function(){throw new Error("Unsupported environment: `window.btoa` or `Buffer` should be supported.")};function SourceMap$1(e){this.version=3,this.file=e.file,this.sources=e.sources,this.sourcesContent=e.sourcesContent,this.names=e.names,this.mappings=e.mappings}function guessIndent$1(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getRelativePath$1(e,t){var r=e.split(/[\/\\]/),n=t.split(/[\/\\]/);for(r.pop();r[0]===n[0];)r.shift(),n.shift();if(r.length)for(var i=r.length;i--;)r[i]="..";return r.concat(n).join("/")}SourceMap$1.prototype={toString:function(){return JSON.stringify(this)},toUrl:function(){return"data:application/json;charset=utf-8;base64,"+btoa$1(this.toString())}};var toString$a=Object.prototype.toString;function isObject$1(e){return"[object Object]"===toString$a.call(e)}function getLocator$2(e){var t=e.split("\n"),r=0,n=t.map(function(e,t){var n=r+e.length+1,i={start:r,end:n,line:t};return r=n,i}),i=0;function s(e,t){return e.start<=t&&t<e.end}function o(e,t){return{line:e.line,column:t-e.start}}return function(e){for(var t=n[i],r=e>=t.end?1:-1;t;){if(s(t,e))return o(t,e);t=n[i+=r]}}}function Mappings$1(e){var t=this,r={generatedCodeColumn:0,sourceIndex:0,sourceCodeLine:0,sourceCodeColumn:0,sourceCodeName:0},n=0,i=0;this.raw=[];var s=this.raw[n]=[],o=null;this.addEdit=function(e,r,n,a,u){r.length?s.push([i,e,a.line,a.column,u]):o&&s.push(o),t.advance(r),o=null},this.addUneditedChunk=function(r,a,u,c,h){for(var p=a.start,l=!0;p<a.end;)(e||l||h[p])&&s.push([i,r,c.line,c.column,-1]),"\n"===u[p]?(c.line+=1,c.column=0,n+=1,t.raw[n]=s=[],i=0):(c.column+=1,i+=1),p+=1,l=!1;o=[i,r,c.line,c.column,-1]},this.advance=function(e){if(e){var r=e.split("\n"),o=r.pop();r.length?(n+=r.length,t.raw[n]=s=[],i=o.length):i+=o.length}},this.encode=function(){return t.raw.map(function(e){var t=0;return e.map(function(e){var n=[e[0]-t,e[1]-r.sourceIndex,e[2]-r.sourceCodeLine,e[3]-r.sourceCodeColumn];return t=e[0],r.sourceIndex=e[1],r.sourceCodeLine=e[2],r.sourceCodeColumn=e[3],~e[4]&&(n.push(e[4]-r.sourceCodeName),r.sourceCodeName=e[4]),encode$1(n)}).join(",")}).join(";")}}var warned$1={insertLeft:!1,insertRight:!1,storeName:!1};function MagicString$1(e,t){void 0===t&&(t={});var r=new Chunk$2(0,e.length,e);Object.defineProperties(this,{original:{writable:!0,value:e},outro:{writable:!0,value:""},intro:{writable:!0,value:""},firstChunk:{writable:!0,value:r},lastChunk:{writable:!0,value:r},lastSearchedChunk:{writable:!0,value:r},byStart:{writable:!0,value:{}},byEnd:{writable:!0,value:{}},filename:{writable:!0,value:t.filename},indentExclusionRanges:{writable:!0,value:t.indentExclusionRanges},sourcemapLocations:{writable:!0,value:{}},storedNames:{writable:!0,value:{}},indentStr:{writable:!0,value:guessIndent$1(e)}}),this.byStart[0]=r,this.byEnd[e.length]=r}MagicString$1.prototype={addSourcemapLocation:function(e){this.sourcemapLocations[e]=!0},append:function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.outro+=e,this},appendLeft:function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.appendLeft(t):this.intro+=t,this},appendRight:function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.appendRight(t):this.outro+=t,this},clone:function(){for(var e=new MagicString$1(this.original,{filename:this.filename}),t=this.firstChunk,r=e.firstChunk=e.lastSearchedChunk=t.clone();t;){e.byStart[r.start]=r,e.byEnd[r.end]=r;var n=t.next,i=n&&n.clone();i&&(r.next=i,i.previous=r,r=i),t=n}return e.lastChunk=r,this.indentExclusionRanges&&(e.indentExclusionRanges=this.indentExclusionRanges.slice()),Object.keys(this.sourcemapLocations).forEach(function(t){e.sourcemapLocations[t]=!0}),e},generateMap:function(e){var t=this;e=e||{};var r=Object.keys(this.storedNames),n=new Mappings$1(e.hires),i=getLocator$2(this.original);return this.intro&&n.advance(this.intro),this.firstChunk.eachNext(function(e){var s=i(e.start);e.intro.length&&n.advance(e.intro),e.edited?n.addEdit(0,e.content,e.original,s,e.storeName?r.indexOf(e.original):-1):n.addUneditedChunk(0,e,t.original,s,t.sourcemapLocations),e.outro.length&&n.advance(e.outro)}),new SourceMap$1({file:e.file?e.file.split(/[\/\\]/).pop():null,sources:[e.source?getRelativePath$1(e.file||"",e.source):null],sourcesContent:e.includeContent?[this.original]:[null],names:r,mappings:n.encode()})},getIndentString:function(){return null===this.indentStr?"\t":this.indentStr},indent:function(e,t){var r=/^[^\r\n]/gm;if(isObject$1(e)&&(t=e,e=void 0),""===(e=void 0!==e?e:this.indentStr||"\t"))return this;var n={};(t=t||{}).exclude&&("number"==typeof t.exclude[0]?[t.exclude]:t.exclude).forEach(function(e){for(var t=e[0];t<e[1];t+=1)n[t]=!0});var i=!1!==t.indentStart,s=function(t){return i?""+e+t:(i=!0,t)};this.intro=this.intro.replace(r,s);for(var o=0,a=this.firstChunk;a;){var u=a.end;if(a.edited)n[o]||(a.content=a.content.replace(r,s),a.content.length&&(i="\n"===a.content[a.content.length-1]));else for(o=a.start;o<u;){if(!n[o]){var c=this.original[o];"\n"===c?i=!0:"\r"!==c&&i&&(i=!1,o===a.start?a.prependRight(e):(this._splitChunk(a,o),(a=a.next).prependRight(e)))}o+=1}o=a.end,a=a.next}return this.outro=this.outro.replace(r,s),this},insert:function(){throw new Error("magicString.insert(...) is deprecated. Use prependRight(...) or appendLeft(...)")},insertLeft:function(e,t){return warned$1.insertLeft||(console.warn("magicString.insertLeft(...) is deprecated. Use magicString.appendLeft(...) instead"),warned$1.insertLeft=!0),this.appendLeft(e,t)},insertRight:function(e,t){return warned$1.insertRight||(console.warn("magicString.insertRight(...) is deprecated. Use magicString.prependRight(...) instead"),warned$1.insertRight=!0),this.prependRight(e,t)},move:function(e,t,r){if(r>=e&&r<=t)throw new Error("Cannot move a selection inside itself");this._split(e),this._split(t),this._split(r);var n=this.byStart[e],i=this.byEnd[t],s=n.previous,o=i.next,a=this.byStart[r];if(!a&&i===this.lastChunk)return this;var u=a?a.previous:this.lastChunk;return s&&(s.next=o),o&&(o.previous=s),u&&(u.next=n),a&&(a.previous=i),n.previous||(this.firstChunk=i.next),i.next||(this.lastChunk=n.previous,this.lastChunk.next=null),n.previous=u,i.next=a||null,u||(this.firstChunk=n),a||(this.lastChunk=i),this},overwrite:function(e,t,r,n){if("string"!=typeof r)throw new TypeError("replacement content must be a string");for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(t>this.original.length)throw new Error("end is out of bounds");if(e===t)throw new Error("Cannot overwrite a zero-length range – use appendLeft or prependRight instead");this._split(e),this._split(t),!0===n&&(warned$1.storeName||(console.warn("The final argument to magicString.overwrite(...) should be an options object. See https://github.com/rich-harris/magic-string"),warned$1.storeName=!0),n={storeName:!0});var i=void 0!==n&&n.storeName,s=void 0!==n&&n.contentOnly;if(i){var o=this.original.slice(e,t);this.storedNames[o]=!0}var a=this.byStart[e],u=this.byEnd[t];if(a){if(t>a.end&&a.next!==this.byStart[a.end])throw new Error("Cannot overwrite across a split point");if(a.edit(r,i,s),a!==u){for(var c=a.next;c!==u;)c.edit("",!1),c=c.next;c.edit("",!1)}}else{var h=new Chunk$2(e,t,"").edit(r,i);u.next=h,h.previous=u}return this},prepend:function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.intro=e+this.intro,this},prependLeft:function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.prependLeft(t):this.intro=t+this.intro,this},prependRight:function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.prependRight(t):this.outro=t+this.outro,this},remove:function(e,t){for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(e===t)return this;if(e<0||t>this.original.length)throw new Error("Character is out of bounds");if(e>t)throw new Error("end must be greater than start");this._split(e),this._split(t);for(var r=this.byStart[e];r;)r.intro="",r.outro="",r.edit(""),r=t>r.end?this.byStart[r.end]:null;return this},slice:function(e,t){for(void 0===e&&(e=0),void 0===t&&(t=this.original.length);e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;for(var r="",n=this.firstChunk;n&&(n.start>e||n.end<=e);){if(n.start<t&&n.end>=t)return r;n=n.next}if(n&&n.edited&&n.start!==e)throw new Error("Cannot use replaced character "+e+" as slice start anchor.");for(var i=n;n;){!n.intro||i===n&&n.start!==e||(r+=n.intro);var s=n.start<t&&n.end>=t;if(s&&n.edited&&n.end!==t)throw new Error("Cannot use replaced character "+t+" as slice end anchor.");var o=i===n?e-n.start:0,a=s?n.content.length+t-n.end:n.content.length;if(r+=n.content.slice(o,a),!n.outro||s&&n.end!==t||(r+=n.outro),s)break;n=n.next}return r},snip:function(e,t){var r=this.clone();return r.remove(0,e),r.remove(t,r.original.length),r},_split:function(e){if(!this.byStart[e]&&!this.byEnd[e])for(var t=this.lastSearchedChunk,r=e>t.end;;){if(t.contains(e))return this._splitChunk(t,e);t=r?this.byStart[t.end]:this.byEnd[t.start]}},_splitChunk:function(e,t){if(e.edited&&e.content.length){var r=getLocator$2(this.original)(t);throw new Error("Cannot split a chunk that has already been edited ("+r.line+":"+r.column+' – "'+e.original+'")')}var n=e.split(t);return this.byEnd[t]=e,this.byStart[t]=n,this.byEnd[n.end]=n,e===this.lastChunk&&(this.lastChunk=n),this.lastSearchedChunk=e,!0},toString:function(){for(var e=this.intro,t=this.firstChunk;t;)e+=t.toString(),t=t.next;return e+this.outro},trimLines:function(){return this.trim("[\\r\\n]")},trim:function(e){return this.trimStart(e).trimEnd(e)},trimEnd:function(e){var t=new RegExp((e||"\\s")+"+$");if(this.outro=this.outro.replace(t,""),this.outro.length)return this;var r=this.lastChunk;do{var n=r.end,i=r.trimEnd(t);if(r.end!==n&&(this.lastChunk===r&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return this;r=r.previous}while(r);return this},trimStart:function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),this.intro.length)return this;var r=this.firstChunk;do{var n=r.end,i=r.trimStart(t);if(r.end!==n&&(r===this.lastChunk&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return this;r=r.next}while(r);return this}};var core=["assert","buffer_ieee754","buffer","child_process","cluster","console","constants","crypto","_debugger","dgram","dns","domain","events","freelist","fs","http","https","_linklist","module","net","os","path","punycode","querystring","readline","repl","stream","string_decoder","sys","timers","tls","tty","url","util","vm","zlib"],core$1=Object.freeze({default:core}),require$$0=core$1&&core||core$1,core$2=require$$0.reduce(function(e,t){return e[t]=!0,e},{}),caller=function(){var e=Error.prepareStackTrace;Error.prepareStackTrace=function(e,t){return t};var t=(new Error).stack;return Error.prepareStackTrace=e,t[2].getFileName()},nodeModulesPaths=function(e,t){var r=t.moduleDirectory?[].concat(t.moduleDirectory):["node_modules"];e=path__default.resolve(e);var n="/";/^([A-Za-z]:)/.test(e)?n="":/^\\\\/.test(e)&&(n="\\\\");for(var i="win32"===process.platform?/[\/\\]/:/\/+/,s=e.split(i),o=[],a=s.length-1;a>=0;a--)-1===r.indexOf(s[a])&&(o=o.concat(r.map(function(e){return n+path__default.join(path__default.join.apply(path__default,s.slice(0,a+1)),e)})));return"win32"===process.platform&&(o[o.length-1]=o[o.length-1].replace(":",":\\")),o.concat(t.paths)},splitRe="win32"===process.platform?/[\/\\]/:/\//,async=function(e,t,r){if("function"==typeof t&&(r=t,t={}),t||(t={}),"string"!=typeof e)return process.nextTick(function(){r(new Error("path must be a string"))});var n=t.isFile||function(e,t){fs$1__default.stat(e,function(e,r){e&&"ENOENT"===e.code?t(null,!1):e?t(e):t(null,r.isFile()||r.isFIFO())})},i=t.readFile||fs$1__default.readFile,s=t.extensions||[".js"],o=t.basedir||path__default.dirname(caller());if(t.paths=t.paths||[],/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[\\\/])/.test(e)){var a=path__default.resolve(o,e);".."===e&&(a+="/"),/\/$/.test(e)&&a===o?h(a,t.package,u):c(a,t.package,u)}else!function(e,r,n){!function t(r){if(0===r.length)return n(null,void 0);var i=r[0],s=path__default.join(i,"/",e);function o(e,i,s){return e?n(e):i?n(null,i,s):void t(r.slice(1))}c(s,void 0,function(t,r,s){if(t)return n(t);if(r)return n(null,r,s);h(path__default.join(i,"/",e),void 0,o)})}(nodeModulesPaths(r,t))}(e,o,function(t,n,i){if(t)r(t);else if(n)r(null,n,i);else{if(core$2[e])return r(null,e);r(new Error("Cannot find module '"+e+"' from '"+o+"'"))}});function u(t,n,i){t?r(t):n?r(null,n,i):h(a,function(t,n,i){t?r(t):n?r(null,n,i):r(new Error("Cannot find module '"+e+"' from '"+o+"'"))})}function c(e,r,o){"function"==typeof r&&(o=r,r=void 0),function e(r,a,u){if(0===r.length)return o(null,void 0,u);var c=a+r[0];u?h(null,u):function e(r,s){if(""===r||"/"===r)return s(null);if("win32"===process.platform&&/^\w:[\\\/]*$/.test(r))return s(null);if(/[\\\/]node_modules[\\\/]*$/.test(r))return s(null);var o=path__default.join(r,"package.json");n(o,function(n,a){if(!a)return e(path__default.dirname(r),s);i(o,function(e,n){e&&s(e);try{var i=JSON.parse(n)}catch(e){}i&&t.packageFilter&&(i=t.packageFilter(i,o)),s(null,i,r)})})}(path__default.dirname(c),h);function h(i,h,l){if(u=h,i)return o(i);if(l&&u&&t.pathFilter){var f=path__default.relative(l,c),d=f.slice(0,f.length-r[0].length),m=t.pathFilter(u,a,d);if(m)return e([""].concat(s.slice()),path__default.resolve(l,m),u)}n(c,p)}function p(t,n){t?o(t):n?o(null,c,u):e(r.slice(1),a,u)}}([""].concat(s),e,r)}function h(e,r,s){"function"==typeof r&&(s=r,r=t.package);var o=path__default.join(e,"/package.json");n(o,function(n,a){return n?s(n):a?void i(o,function(r,n){if(r)return s(r);try{var i=JSON.parse(n)}catch(r){}if(t.packageFilter&&(i=t.packageFilter(i,o)),i.main)return"."!==i.main&&"./"!==i.main||(i.main="index"),void c(path__default.resolve(e,i.main),i,function(t,r,n){return t?s(t):r?s(null,r,n):n?void h(path__default.resolve(e,n.main),n,function(t,r,n){return t?s(t):r?s(null,r,n):void c(path__default.join(e,"/index"),n,s)}):c(path__default.join(e,"/index"),n,s)});c(path__default.join(e,"/index"),i,s)}):c(path__default.join(e,"/index"),r,s)})}},sync$1=function(e,t){t||(t={});var r=t.isFile||function(e){try{var t=fs$1__default.statSync(e)}catch(e){if(e&&"ENOENT"===e.code)return!1}return t.isFile()||t.isFIFO()},n=t.readFileSync||fs$1__default.readFileSync,i=t.extensions||[".js"],s=t.basedir||path__default.dirname(caller());if(t.paths=t.paths||[],/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[\\\/])/.test(e)){var o=path__default.resolve(s,e);".."===e&&(o+="/");var a=c(o)||h(o);if(a)return a}else{var u=function(e,r){for(var n=nodeModulesPaths(r,t),i=0;i<n.length;i++){var s=n[i],o=c(path__default.join(s,"/",e));if(o)return o;var a=h(path__default.join(s,"/",e));if(a)return a}}(e,s);if(u)return u}if(core$2[e])return e;throw new Error("Cannot find module '"+e+"' from '"+s+"'");function c(e){if(r(e))return e;for(var t=0;t<i.length;t++){var n=e+i[t];if(r(n))return n}}function h(e){var i=path__default.join(e,"/package.json");if(r(i)){var s=n(i,"utf8");try{var o=JSON.parse(s);if(t.packageFilter&&(o=t.packageFilter(o,e)),o.main){var a=c(path__default.resolve(e,o.main));if(a)return a;var u=h(path__default.resolve(e,o.main));if(u)return u}}catch(e){}}return c(path__default.join(e,"/index"))}},resolve=createCommonjsModule(function(e,t){(t=e.exports=async).core=core$2,t.isCore=function(e){return core$2[e]},t.sync=sync$1}),resolve_1=resolve.core,resolve_2=resolve.isCore,resolve_3=resolve.sync,HELPERS_ID="\0commonjsHelpers",HELPERS="\nexport var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};\n\nexport function commonjsRequire () {\n\tthrow new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');\n}\n\nexport function unwrapExports (x) {\n\treturn x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;\n}\n\nexport function createCommonjsModule(fn, module) {\n\treturn module = { exports: {} }, fn(module, module.exports), module.exports;\n}",PREFIX="\0commonjs-proxy:",EXTERNAL="\0commonjs-external:";function isFile(e){try{return fs$1.statSync(e).isFile()}catch(e){return!1}}function addJsExtensionIfNecessary$1(e){return isFile(e)?e:isFile(e+=".js")?e:null}var absolutePath$1=/^(?:\/|(?:[A-Za-z]:)?[\\|\/])/;function isAbsolute$1(e){return absolutePath$1.test(e)}function defaultResolver(e,t){return isAbsolute$1(e)?addJsExtensionIfNecessary$1(path.resolve(e)):void 0===t?addJsExtensionIfNecessary$1(path.resolve(process.cwd(),e)):"."!==e[0]?null:addJsExtensionIfNecessary$1(path.resolve(path.dirname(t),e))}function isReference$1(e,t){return"MemberExpression"===t.type?t.computed||e===t.object:("Property"!==t.type||e===t.value)&&("MethodDefinition"!==t.type&&("ExportSpecifier"!==t.type||e===t.local))}function flatten(e){for(var t=[];"MemberExpression"===e.type;){if(e.computed)return null;t.unshift(e.property.name),e=e.object}if("Identifier"!==e.type)return null;var r=e.name;return t.unshift(r),{name:r,keypath:t.join(".")}}function extractNames$2(e){var t=[];return extractors$2[e.type](t,e),t}var extractors$2={Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){extractors$2[t.value.type](e,t.value)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors$2[t.type](e,t)})},RestElement:function(e,t){extractors$2[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){extractors$2[t.left.type](e,t.left)}};function isTruthy(e){return"Literal"===e.type?!!e.value:"ParenthesizedExpression"===e.type?isTruthy(e.expression):e.operator in operators?operators[e.operator](e):void 0}function isFalsy(e){return not(isTruthy(e))}function not(e){return void 0===e?e:!e}function equals(e,t,r){if(e.type===t.type)return"Literal"===e.type?r?e.value===t.value:e.value==t.value:void 0}var operators={"==":function(e){return equals(e.left,e.right,!1)},"!=":function(e){return not(operators["=="](e))},"===":function(e){return equals(e.left,e.right,!0)},"!==":function(e){return not(operators["==="](e))},"!":function(e){return isFalsy(e.argument)},"&&":function(e){return isTruthy(e.left)&&isTruthy(e.right)},"||":function(e){return isTruthy(e.left)||isTruthy(e.right)}};function getName(e){var t=makeLegalIdentifier(path.basename(e,path.extname(e)));if("index"!==t)return t;var r=path.dirname(e).split(path.sep);return makeLegalIdentifier(r[r.length-1])}var reserved="process location abstract arguments boolean break byte case catch char class const continue debugger default delete do double else enum eval export extends false final finally float for from function goto if implements import in instanceof int interface let long native new null package private protected public return short static super switch synchronized this throw throws transient true try typeof var void volatile while with yield".split(" "),blacklist={__esModule:!0};reserved.forEach(function(e){return blacklist[e]=!0});var exportsPattern=/^(?:module\.)?exports(?:\.([a-zA-Z_$][a-zA-Z_$0-9]*))?$/,firstpassGlobal=/\b(?:require|module|exports|global)\b/,firstpassNoGlobal=/\b(?:require|module|exports)\b/,importExportDeclaration=/^(?:Import|Export(?:Named|Default))Declaration/,functionType=/^(?:FunctionDeclaration|FunctionExpression|ArrowFunctionExpression)$/;function deconflict(e,t,r){for(var n=1,i=r;e.contains(i)||t.has(i)||i in blacklist;)i=r+"_"+n++;return e.declarations[i]=!0,i}function tryParse$1(e,t,r){try{return e(t,{allowReturnOutsideFunction:!0})}catch(e){throw e.message+=" in "+r,e}}function checkFirstpass(e,t){return(t?firstpassNoGlobal:firstpassGlobal).test(e)}function checkEsModule(e,t,r){for(var n=tryParse$1(e,t,r),i=!1,s=!1,o=0,a=n.body;o<a.length;o+=1){var u=a[o];"ExportDefaultDeclaration"===u.type&&(i=!0),importExportDeclaration.test(u.type)&&(s=!0)}return{isEsModule:s,hasDefaultExport:i,ast:n}}function transformCommonjs(e,t,r,n,i,s,o,a,u,c){var h=c||tryParse$1(e,t,r),p=new MagicString$1(t),l={},f=[],d=0,m=attachScopes(h,"scope"),g={module:!1,exports:!1,global:!1,require:!1},y=0,v=0,_=new Set,x=deconflict(m,_,"commonjsHelpers"),b={},E=/__esModule/.test(t);function S(e){if(e&&"CallExpression"===e.type&&"require"===e.callee.name&&!m.contains("require")&&!(1!==e.arguments.length||"Literal"!==e.arguments[0].type&&("TemplateLiteral"!==e.arguments[0].type||e.arguments[0].expressions.length>0)||s(e.arguments[0].value)))return!0}function A(e,t){var r="Literal"===e.arguments[0].type?e.arguments[0].value:e.arguments[0].quasis[0].value.cooked;if(void 0===l[r]){if(f.push(r),!t)do{t="require$$"+d++}while(m.contains(t));l[r]={source:r,name:t,importsDefault:!1}}return l[r]}var w=new Set;if(walk(h,{enter:function(e){"AssignmentExpression"===e.type&&"MemberExpression"!==e.left.type&&extractNames$2(e.left).forEach(function(e){w.add(e)})}}),walk(h,{enter:function(e,t){if(a&&(p.addSourcemapLocation(e.start),p.addSourcemapLocation(e.end)),t&&("IfStatement"===t.type||"ConditionalExpression"===t.type)){if(e===t.consequent&&isFalsy(t.test))return this.skip();if(e===t.alternate&&isTruthy(t.test))return this.skip()}if(e._skip)return this.skip();if(v+=1,e.scope&&(m=e.scope),functionType.test(e.type)&&(y+=1),"ReturnStatement"===e.type&&0===y&&(E=!0),"ThisExpression"===e.type&&0===y)return g.global=!0,void(i||p.overwrite(e.start,e.end,x+".commonjsGlobal",{storeName:!0}));if("UnaryExpression"===e.type&&"typeof"===e.operator){var r=flatten(e.argument);if(!r)return;if(m.contains(r.name))return;"module.exports"!==r.keypath&&"module"!==r.keypath&&"exports"!==r.keypath||p.overwrite(e.start,e.end,"'object'",{storeName:!1})}if("Identifier"!==e.type){if("AssignmentExpression"===e.type){if("MemberExpression"!==e.left.type)return;var n=flatten(e.left);if(!n)return;if(m.contains(n.name))return;var s=exportsPattern.exec(n.keypath);if(!s||"exports"===n.keypath)return;return g[n.name]=!0,v>3&&(E=!0),e.left._skip=!0,"module.exports"===n.keypath&&"ObjectExpression"===e.right.type?e.right.properties.forEach(function(e){if(!e.computed&&"Identifier"===e.key.type){var t=e.key.name;t===makeLegalIdentifier(t)&&(b[t]=!0)}}):void(s[1]&&(b[s[1]]=!0))}if("VariableDeclarator"===e.type&&"Identifier"===e.id.type&&S(e.init)){if(m.parent)return;if(w.has(e.id.name))return;var o=A(e.init,e.id.name);o.importsDefault=!0,o.name===e.id.name&&(e._shouldRemove=!0)}if(S(e)){var c=A(e);"ExpressionStatement"===t.type?p.remove(t.start,t.end):(c.importsDefault=!0,p.overwrite(e.start,e.end,c.name)),e.callee._skip=!0}}else if(isReference$1(e,t)&&!m.contains(e.name)){if(e.name in g){if("require"===e.name){if(u)return;p.overwrite(e.start,e.end,x+".commonjsRequire",{storeName:!0})}g[e.name]=!0,"global"!==e.name||i||p.overwrite(e.start,e.end,x+".commonjsGlobal",{storeName:!0}),"module"!==e.name&&"exports"!==e.name||(E=!0)}"define"===e.name&&p.overwrite(e.start,e.end,"undefined",{storeName:!0}),_.add(e.name)}},leave:function(e){if(v-=1,e.scope&&(m=m.parent),functionType.test(e.type)&&(y-=1),"VariableDeclaration"===e.type){for(var t=!1,r=e.declarations[0].start,n=0;n<e.declarations.length;n+=1){var i=e.declarations[n];i._shouldRemove?p.remove(r,i.end):(t||(p.remove(r,i.start),t=!0),r=i.end)}t||p.remove(e.start,e.end)}}}),!f.length&&!g.module&&!g.exports&&!g.require&&(i||!g.global)){if(Object.keys(b).length)throw new Error("Custom named exports were specified for "+r+" but it does not appear to be a CommonJS module");return null}var k=(E||g.global||g.require?["import * as "+x+" from '"+HELPERS_ID+"';"]:[]).concat(f.map(function(e){return"import '"+e+"';"}),f.map(function(e){var t=l[e],r=t.name;return"import "+(t.importsDefault?r+" from ":"")+"'"+PREFIX+e+"';"})).join("\n")+"\n\n",N=[],P="",$="",C=deconflict(m,_,getName(r));if(!n){var I={str:"export { "+C+" as __moduleExports };",name:"__moduleExports"};N.push(I)}var O=getName(r);function R(e){var t=deconflict(m,_,O),r=t===O?"export var "+e+" = "+C+"."+e+";":"var "+t+" = "+C+"."+e+";\nexport { "+t+" as "+e+" };";N.push({str:r,name:e})}o&&o.forEach(R);var T=[],M=!1;if(E){var L="module"+(g.exports?", exports":"");P="var "+C+" = "+x+".createCommonjsModule(function ("+L+") {\n",$="\n});"}else{var D=[];h.body.forEach(function(e){if("ExpressionStatement"===e.type&&"AssignmentExpression"===e.expression.type){var t=e.expression.left,r=flatten(t);if(!r)return;var n=exportsPattern.exec(r.keypath);if(!n)return;if("module.exports"===r.keypath)M=!0,p.overwrite(t.start,t.end,"var "+C);else{var i=n[1],s=deconflict(m,_,i);D.push({name:i,deconflicted:s}),p.overwrite(e.start,t.end,"var "+s);var o=i===s?"export { "+i+" };":"export { "+s+" as "+i+" };";"default"!==i&&(N.push({str:o,name:i}),delete b[i]),T.push(C+"."+i+" = "+s+";")}}}),M||($="\n\nvar "+C+" = {\n"+D.map(function(e){return"\t"+e.name+": "+e.deconflicted}).join(",\n")+"\n};")}Object.keys(b).filter(function(e){return!blacklist[e]}).forEach(R);var j=/__esModule/.test(t)?"export default "+x+".unwrapExports("+C+");":"export default "+C+";",B=N.filter(function(e){return"default"!==e.name||!M}).map(function(e){return e.str}),U="\n\n"+[j].concat(B).concat(M?T:[]).join("\n");return p.trim().prepend(k+P).trim().append($+U),{code:t=p.toString(),map:a?p.generateMap():null}}function getCandidatesForExtension(e,t){return[e+t,e+path.sep+"index"+t]}function getCandidates(e,t){return t.reduce(function(t,r){return t.concat(getCandidatesForExtension(e,r))},[e])}function first(e){return function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return e.reduce(function(e,r){return e.then(function(e){return null!=e?e:Promise.resolve(r.apply(void 0,t))})},Promise.resolve())}}function startsWith(e,t){return e.slice(0,t.length)===t}var isCjsPromises=Object.create(null);function commonjs(e){void 0===e&&(e={});var t=e.extensions||[".js"],r=createFilter$1(e.include,e.exclude),n=e.ignoreGlobal,i={};e.namedExports&&Object.keys(e.namedExports).forEach(function(t){var r;try{r=resolve_3(t,{basedir:process.cwd()})}catch(e){r=path.resolve(t)}i[r]=e.namedExports[t]});var s=[],o=!!e.ignore,a="function"==typeof e.ignore?e.ignore:Array.isArray(e.ignore)?function(t){return~e.ignore.indexOf(t)}:function(){return!1},u=null;function c(e,t){var r=startsWith(e,PREFIX);if(r)e=e.slice(PREFIX.length);else if(startsWith(e,"\0"))return e;return t&&startsWith(t,PREFIX)&&(t=t.slice(PREFIX.length)),h(e,t).then(function(n){return n?r?PREFIX+n:n:(n=defaultResolver(e,t),r?n?PREFIX+n:EXTERNAL+e:n)})}var h,p=!1!==e.sourceMap;return{name:"commonjs",options:function(e){var r=(e.plugins||[]).map(function(e){return e.resolveId===c?function(e,r){if("."===e[0]&&r)for(var n=getCandidates(path.resolve(path.dirname(r),e),t),i=0;i<n.length;i+=1)try{if(fs$1.statSync(n[i]).isFile())return n[i]}catch(e){}}:e.resolveId}).filter(Boolean);r.unshift(function(t){return!function(t){return!!e.external&&(Array.isArray(e.external)?~e.external.indexOf(t):e.external(t))}(t)&&null}),h=first(r);var n=e.input||e.entry,i=Array.isArray(n)?n:"object"==typeof n&&null!==n?Object.values(n):[n];u=Promise.all(i.map(function(e){return c(e)}))},resolveId:c,load:function(e){if(e===HELPERS_ID)return HELPERS;if(startsWith(e,EXTERNAL)){var r=e.slice(EXTERNAL.length),n=getName(r);return"import "+n+" from "+JSON.stringify(r)+"; export default "+n+";"}if(startsWith(e,PREFIX)){var i=e.slice(PREFIX.length),o=getName(i);return(-1===t.indexOf(path.extname(e))?Promise.resolve(!1):function(e){var t=isCjsPromises[e];if(t)return t.promise;var r=new Promise(function(r){isCjsPromises[e]=t={resolve:r,promise:void 0}});return t.promise=r,r}(i)).then(function(e){return e?"import { __moduleExports } from "+JSON.stringify(i)+"; export default __moduleExports;":-1!==s.indexOf(i)?"import * as "+o+" from "+JSON.stringify(i)+"; export default "+o+";":"import * as "+o+" from "+JSON.stringify(i)+"; export default ( "+o+" && "+o+"['default'] ) || "+o+";"})}},transform:function(e,c){var h=this;if(!r(c))return null;if(-1===t.indexOf(path.extname(c)))return null;var l=u.then(function(t){var r=checkEsModule(h.parse,e,c),u=r.isEsModule,l=r.hasDefaultExport,f=r.ast;if(u)l||s.push(c);else if(checkFirstpass(e,n)){var d=transformCommonjs(h.parse,e,c,-1!==t.indexOf(c),n,a,i[c],p,o,f);if(d)return d;s.push(c)}else s.push(c)}).catch(function(e){h.error(e,e.loc)});return function(e,t){var r=isCjsPromises[e];r?r.resolve&&(r.resolve(t),r.resolve=void 0):isCjsPromises[e]={promise:t,resolve:void 0}}(c,l.then(function(e){return!!e},function(){return!0})),l}}}const blacklist$1=["freelist","sys"];var builtinModules=Object.keys(process.binding("natives")).filter(e=>!/^_|^internal|\//.test(e)&&-1===blacklist$1.indexOf(e)).sort(),ES6ImportExportRegExp=/(?:^\s*|[}{\(\);,\n]\s*)(import\s+['"]|(import|module)\s+[^"'\(\)\n;]+\s+from\s+['"]|export\s+(\*|\{|default|function|var|const|let|[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*))/,ES6AliasRegExp=/(?:^\s*|[}{\(\);,\n]\s*)(export\s*\*\s*from\s*(?:'([^']+)'|"([^"]+)"))/,isModule=function(e){return ES6ImportExportRegExp.test(e)||ES6AliasRegExp.test(e)},ES6_BROWSER_EMPTY=path.resolve(__dirname,"../src/empty.js"),CONSOLE_WARN=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return console.warn.apply(console,e)},DEFAULT_EXTS=[".mjs",".js",".json",".node"],readFileCache={},readFileAsync=function(e){return new Promise(function(t,r){return fs$1__default.readFile(e,function(e,n){return e?r(e):t(n)})})},statAsync=function(e){return new Promise(function(t,r){return fs$1__default.stat(e,function(e,n){return e?r(e):t(n)})})};function cachedReadFile(e,t){e in readFileCache==!1&&(readFileCache[e]=readFileAsync(e).catch(function(t){throw delete readFileCache[e],t})),readFileCache[e].then(function(e){return t(null,e)},t)}var isFileCache={};function cachedIsFile(e,t){e in isFileCache==!1&&(isFileCache[e]=statAsync(e).then(function(e){return e.isFile()},function(t){if("ENOENT"==t.code)return!1;throw delete isFileCache[e],t})),isFileCache[e].then(function(e){return t(null,e)},t)}var resolveIdAsync=function(e,t){return new Promise(function(r,n){return resolve(e,t,function(e,t){return e?n(e):r(t)})})};function nodeResolve(e){void 0===e&&(e={});var t,r=!1!==e.module,n=!1!==e.main,i=!0===e.jsnext,s=!0===e.preferBuiltins||!1===e.preferBuiltins,o=!s||e.preferBuiltins,a=e.customResolveOptions||{},u=e.jail,c=Array.isArray(e.only)?e.only.map(function(e){return e instanceof RegExp?e:new RegExp("^"+String(e).replace(/[\\^$*+?.()|[\]{}]/g,"\\$&")+"$")}):null,h={},p=e.onwarn||CONSOLE_WARN;if(e.skip)throw new Error("options.skip is no longer supported — you should use the main Rollup `external` option instead");if(!r&&!n&&!i)throw new Error("At least one of options.module, options.main or options.jsnext must be true");return{name:"node-resolve",options:function(e){t=e.preserveSymlinks},onwrite:function(){isFileCache={},readFileCache={}},resolveId:function(l,f){if(/\0/.test(l))return null;if(!f)return null;if(e.browser&&h[f]){var d=path.resolve(path.dirname(f),l),m=h[f];if(!1===m[l]||!1===m[d])return ES6_BROWSER_EMPTY;(m[l]||m[d]||m[d+".js"]||m[d+".json"])&&(l=m[l]||m[d]||m[d+".js"]||m[d+".json"])}var g=l.split(/[\/\\]/),y=g.shift();if("@"===y[0]&&g.length?y+="/"+g.shift():"."===y[0]&&(y=path.resolve(f,"..",l)),c&&!c.some(function(e){return e.test(y)}))return null;var v=!1,_=!1,x=e.extensions||DEFAULT_EXTS,b={basedir:path.dirname(f),packageFilter:function(t,s){var o=path.dirname(s);return e.browser&&"object"==typeof t.browser&&(_=Object.keys(t.browser).reduce(function(e,r){var n=!1!==t.browser[r]&&path.resolve(o,t.browser[r]);if(e[r]=n,"."===r[0]){var i=path.resolve(o,r);e[i]=n,path.extname(r)||x.reduce(function(e,t){return e[i+t]=e[r],e},e)}return e},{})),e.browser&&"string"==typeof t.browser?t.main=t.browser:r&&t.module?t.main=t.module:i&&t["jsnext:main"]?t.main=t["jsnext:main"]:!i&&!r||n||(v=!0),t},readFile:cachedReadFile,isFile:cachedIsFile,extensions:x};return void 0!==t&&(b.preserveSymlinks=t),resolveIdAsync(l,Object.assign(b,a)).catch(function(){return!1}).then(function(r){if(e.browser&&_&&(_[r]&&(r=_[r]),h[r]=_),!v&&!1!==r){if(!t&&r&&fs$1__default.existsSync(r)&&(r=fs$1__default.realpathSync(r)),~builtinModules.indexOf(r))return null;if(~builtinModules.indexOf(l)&&o)return s||p("preferring built-in module '"+l+"' over local alternative at '"+r+"', pass 'preferBuiltins: false' to disable this behavior or 'preferBuiltins: true' to disable this warning"),null;if(u&&0!==r.indexOf(path.normalize(u.trim(path.sep))))return null}return r&&e.modulesOnly?readFileAsync(r,"utf-8").then(function(e){return isModule(e)?r:null}):!1===r?null:r})}}}const NodeRollup={rollup:rollup,plugins:{commonjs:commonjs,nodeResolve:nodeResolve,emptyJsResolver:()=>({load:e=>e.endsWith("empty.js")&&e.endsWith(path__default.join(__dirname,"../src/empty.js"))?"export default {};":null})}};class NodeStorage{constructor(e){this.fs=e;const t=`stencil-storage-${crypto.createHash("md5").update(__dirname).digest("base64").replace(/\W/g,"")}.json`;this.storagePath=path.join(os.tmpdir(),t)}get(e){return __awaiter(this,void 0,void 0,function*(){return(yield this.readData())[e]})}set(e,t){return __awaiter(this,void 0,void 0,function*(){(yield this.readData())[e]=t,this.writeData()})}readData(){return __awaiter(this,void 0,void 0,function*(){if(!this.data)try{const e=yield this.fs.readFile(this.storagePath);this.data=JSON.parse(e)}catch(e){this.data={}}return this.data})}writeData(){try{const e=JSON.stringify(this.data,null,2);this.fs.writeFileSync(this.storagePath,e)}catch(e){}}}var isWsl_1=createCommonjsModule(function(e){const t=()=>{if("linux"!==process.platform)return!1;if(os__default.release().includes("Microsoft"))return!0;try{return fs$1__default.readFileSync("/proc/version","utf8").includes("Microsoft")}catch(e){return!1}};process.env.__IS_WSL_TEST__?e.exports=t:e.exports=t()}),opn=(e,t)=>{if("string"!=typeof e)return Promise.reject(new Error("Expected a `target`"));let r;t=Object.assign({wait:!0},t);let n=[],i=[];const s={};Array.isArray(t.app)&&(n=t.app.slice(1),t.app=t.app[0]),"darwin"===process.platform?(r="open",t.wait&&i.push("-W"),t.app&&i.push("-a",t.app)):"win32"===process.platform||isWsl_1?(r="cmd"+(isWsl_1?".exe":""),i.push("/c","start",'""',"/b"),e=e.replace(/&/g,"^&"),t.wait&&i.push("/wait"),t.app&&i.push(t.app),n.length>0&&(i=i.concat(n))):(r=t.app?t.app:"android"===process.platform?"xdg-open":path__default.join(__dirname,"xdg-open"),n.length>0&&(i=i.concat(n)),t.wait||(s.stdio="ignore",s.detached=!0)),i.push(e),"darwin"===process.platform&&n.length>0&&(i.push("--args"),i=i.concat(n));const o=cp__default.spawn(r,i,s);return t.wait?new Promise((e,t)=>{o.once("error",t),o.once("close",r=>{r>0?t(new Error("Exited with code "+r)):e(o)})}):(o.unref(),Promise.resolve(o))},semver=createCommonjsModule(function(e,t){var r;t=e.exports=G,r="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?function(){var e=Array.prototype.slice.call(arguments,0);e.unshift("SEMVER"),console.log.apply(console,e)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var n=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,s=t.re=[],o=t.src=[],a=0,u=a++;o[u]="0|[1-9]\\d*";var c=a++;o[c]="[0-9]+";var h=a++;o[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;o[p]="("+o[u]+")\\.("+o[u]+")\\.("+o[u]+")";var l=a++;o[l]="("+o[c]+")\\.("+o[c]+")\\.("+o[c]+")";var f=a++;o[f]="(?:"+o[u]+"|"+o[h]+")";var d=a++;o[d]="(?:"+o[c]+"|"+o[h]+")";var m=a++;o[m]="(?:-("+o[f]+"(?:\\."+o[f]+")*))";var g=a++;o[g]="(?:-?("+o[d]+"(?:\\."+o[d]+")*))";var y=a++;o[y]="[0-9A-Za-z-]+";var v=a++;o[v]="(?:\\+("+o[y]+"(?:\\."+o[y]+")*))";var _=a++,x="v?"+o[p]+o[m]+"?"+o[v]+"?";o[_]="^"+x+"$";var b="[v=\\s]*"+o[l]+o[g]+"?"+o[v]+"?",E=a++;o[E]="^"+b+"$";var S=a++;o[S]="((?:<|>)?=?)";var A=a++;o[A]=o[c]+"|x|X|\\*";var w=a++;o[w]=o[u]+"|x|X|\\*";var k=a++;o[k]="[v=\\s]*("+o[w]+")(?:\\.("+o[w]+")(?:\\.("+o[w]+")(?:"+o[m]+")?"+o[v]+"?)?)?";var N=a++;o[N]="[v=\\s]*("+o[A]+")(?:\\.("+o[A]+")(?:\\.("+o[A]+")(?:"+o[g]+")?"+o[v]+"?)?)?";var P=a++;o[P]="^"+o[S]+"\\s*"+o[k]+"$";var $=a++;o[$]="^"+o[S]+"\\s*"+o[N]+"$";var C=a++;o[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=a++;o[I]="(?:~>?)";var O=a++;o[O]="(\\s*)"+o[I]+"\\s+",s[O]=new RegExp(o[O],"g");var R=a++;o[R]="^"+o[I]+o[k]+"$";var T=a++;o[T]="^"+o[I]+o[N]+"$";var M=a++;o[M]="(?:\\^)";var L=a++;o[L]="(\\s*)"+o[M]+"\\s+",s[L]=new RegExp(o[L],"g");var D=a++;o[D]="^"+o[M]+o[k]+"$";var j=a++;o[j]="^"+o[M]+o[N]+"$";var B=a++;o[B]="^"+o[S]+"\\s*("+b+")$|^$";var U=a++;o[U]="^"+o[S]+"\\s*("+x+")$|^$";var W=a++;o[W]="(\\s*)"+o[S]+"\\s*("+b+"|"+o[k]+")",s[W]=new RegExp(o[W],"g");var V=a++;o[V]="^\\s*("+o[k]+")\\s+-\\s+("+o[k]+")\\s*$";var F=a++;o[F]="^\\s*("+o[N]+")\\s+-\\s+("+o[N]+")\\s*$";var z=a++;o[z]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)r(q,o[q]),s[q]||(s[q]=new RegExp(o[q]));function K(e,t){if(e instanceof G)return e;if("string"!=typeof e)return null;if(e.length>n)return null;if(!(t?s[E]:s[_]).test(e))return null;try{return new G(e,t)}catch(e){return null}}function G(e,t){if(e instanceof G){if(e.loose===t)return e;e=e.version}else if("string"!=typeof e)throw new TypeError("Invalid Version: "+e);if(e.length>n)throw new TypeError("version is longer than "+n+" characters");if(!(this instanceof G))return new G(e,t);r("SemVer",e,t),this.loose=t;var o=e.trim().match(t?s[E]:s[_]);if(!o)throw new TypeError("Invalid Version: "+e);if(this.raw=e,this.major=+o[1],this.minor=+o[2],this.patch=+o[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");o[4]?this.prerelease=o[4].split(".").map(function(e){if(/^[0-9]+$/.test(e)){var t=+e;if(t>=0&&t<i)return t}return e}):this.prerelease=[],this.build=o[5]?o[5].split("."):[],this.format()}t.parse=K,t.valid=function(e,t){var r=K(e,t);return r?r.version:null},t.clean=function(e,t){var r=K(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null},t.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(e){return r("SemVer.compare",this.version,this.loose,e),e instanceof G||(e=new G(e,this.loose)),this.compareMain(e)||this.comparePre(e)},G.prototype.compareMain=function(e){return e instanceof G||(e=new G(e,this.loose)),X(this.major,e.major)||X(this.minor,e.minor)||X(this.patch,e.patch)},G.prototype.comparePre=function(e){if(e instanceof G||(e=new G(e,this.loose)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;var t=0;do{var n=this.prerelease[t],i=e.prerelease[t];if(r("prerelease compare",t,n,i),void 0===n&&void 0===i)return 0;if(void 0===i)return 1;if(void 0===n)return-1;if(n!==i)return X(n,i)}while(++t)},G.prototype.inc=function(e,t){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t),this.inc("pre",t);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t),this.inc("pre",t);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var r=this.prerelease.length;--r>=0;)"number"==typeof this.prerelease[r]&&(this.prerelease[r]++,r=-2);-1===r&&this.prerelease.push(0)}t&&(this.prerelease[0]===t?isNaN(this.prerelease[1])&&(this.prerelease=[t,0]):this.prerelease=[t,0]);break;default:throw new Error("invalid increment argument: "+e)}return this.format(),this.raw=this.version,this},t.inc=function(e,t,r,n){"string"==typeof r&&(n=r,r=void 0);try{return new G(e,r).inc(t,n).version}catch(e){return null}},t.diff=function(e,t){if(Z(e,t))return null;var r=K(e),n=K(t);if(r.prerelease.length||n.prerelease.length){for(var i in r)if(("major"===i||"minor"===i||"patch"===i)&&r[i]!==n[i])return"pre"+i;return"prerelease"}for(var i in r)if(("major"===i||"minor"===i||"patch"===i)&&r[i]!==n[i])return i},t.compareIdentifiers=X;var H=/^[0-9]+$/;function X(e,t){var r=H.test(e),n=H.test(t);return r&&n&&(e=+e,t=+t),r&&!n?-1:n&&!r?1:e<t?-1:e>t?1:0}function Y(e,t,r){return new G(e,r).compare(new G(t,r))}function J(e,t,r){return Y(e,t,r)>0}function Q(e,t,r){return Y(e,t,r)<0}function Z(e,t,r){return 0===Y(e,t,r)}function ee(e,t,r){return 0!==Y(e,t,r)}function te(e,t,r){return Y(e,t,r)>=0}function re(e,t,r){return Y(e,t,r)<=0}function ne(e,t,r,n){var i;switch(t){case"===":"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),i=e===r;break;case"!==":"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),i=e!==r;break;case"":case"=":case"==":i=Z(e,r,n);break;case"!=":i=ee(e,r,n);break;case">":i=J(e,r,n);break;case">=":i=te(e,r,n);break;case"<":i=Q(e,r,n);break;case"<=":i=re(e,r,n);break;default:throw new TypeError("Invalid operator: "+t)}return i}function ie(e,t){if(e instanceof ie){if(e.loose===t)return e;e=e.value}if(!(this instanceof ie))return new ie(e,t);r("comparator",e,t),this.loose=t,this.parse(e),this.semver===se?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}t.rcompareIdentifiers=function(e,t){return X(t,e)},t.major=function(e,t){return new G(e,t).major},t.minor=function(e,t){return new G(e,t).minor},t.patch=function(e,t){return new G(e,t).patch},t.compare=Y,t.compareLoose=function(e,t){return Y(e,t,!0)},t.rcompare=function(e,t,r){return Y(t,e,r)},t.sort=function(e,r){return e.sort(function(e,n){return t.compare(e,n,r)})},t.rsort=function(e,r){return e.sort(function(e,n){return t.rcompare(e,n,r)})},t.gt=J,t.lt=Q,t.eq=Z,t.neq=ee,t.gte=te,t.lte=re,t.cmp=ne,t.Comparator=ie;var se={};function oe(e,t){if(e instanceof oe)return e.loose===t?e:new oe(e.raw,t);if(e instanceof ie)return new oe(e.value,t);if(!(this instanceof oe))return new oe(e,t);if(this.loose=t,this.raw=e,this.set=e.split(/\s*\|\|\s*/).map(function(e){return this.parseRange(e.trim())},this).filter(function(e){return e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+e);this.format()}function ae(e){return!e||"x"===e.toLowerCase()||"*"===e}function ue(e,t,r,n,i,s,o,a,u,c,h,p,l){return((t=ae(r)?"":ae(n)?">="+r+".0.0":ae(i)?">="+r+"."+n+".0":">="+t)+" "+(a=ae(u)?"":ae(c)?"<"+(+u+1)+".0.0":ae(h)?"<"+u+"."+(+c+1)+".0":p?"<="+u+"."+c+"."+h+"-"+p:"<="+a)).trim()}function ce(e,t){for(var n=0;n<e.length;n++)if(!e[n].test(t))return!1;if(t.prerelease.length){for(n=0;n<e.length;n++)if(r(e[n].semver),e[n].semver!==se&&e[n].semver.prerelease.length>0){var i=e[n].semver;if(i.major===t.major&&i.minor===t.minor&&i.patch===t.patch)return!0}return!1}return!0}function he(e,t,r){try{t=new oe(t,r)}catch(e){return!1}return t.test(e)}function pe(e,t,r,n){var i,s,o,a,u;switch(e=new G(e,n),t=new oe(t,n),r){case">":i=J,s=re,o=Q,a=">",u=">=";break;case"<":i=Q,s=te,o=J,a="<",u="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(e,t,n))return!1;for(var c=0;c<t.set.length;++c){var h=t.set[c],p=null,l=null;if(h.forEach(function(e){e.semver===se&&(e=new ie(">=0.0.0")),p=p||e,l=l||e,i(e.semver,p.semver,n)?p=e:o(e.semver,l.semver,n)&&(l=e)}),p.operator===a||p.operator===u)return!1;if((!l.operator||l.operator===a)&&s(e,l.semver))return!1;if(l.operator===u&&o(e,l.semver))return!1}return!0}ie.prototype.parse=function(e){var t=this.loose?s[B]:s[U],r=e.match(t);if(!r)throw new TypeError("Invalid comparator: "+e);this.operator=r[1],"="===this.operator&&(this.operator=""),r[2]?this.semver=new G(r[2],this.loose):this.semver=se},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(e){return r("Comparator.test",e,this.loose),this.semver===se||("string"==typeof e&&(e=new G(e,this.loose)),ne(e,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(e,t){if(!(e instanceof ie))throw new TypeError("a Comparator is required");var r;if(""===this.operator)return r=new oe(e.value,t),he(this.value,r,t);if(""===e.operator)return r=new oe(this.value,t),he(e.semver,r,t);var n=!(">="!==this.operator&&">"!==this.operator||">="!==e.operator&&">"!==e.operator),i=!("<="!==this.operator&&"<"!==this.operator||"<="!==e.operator&&"<"!==e.operator),s=this.semver.version===e.semver.version,o=!(">="!==this.operator&&"<="!==this.operator||">="!==e.operator&&"<="!==e.operator),a=ne(this.semver,"<",e.semver,t)&&(">="===this.operator||">"===this.operator)&&("<="===e.operator||"<"===e.operator),u=ne(this.semver,">",e.semver,t)&&("<="===this.operator||"<"===this.operator)&&(">="===e.operator||">"===e.operator);return n||i||s&&o||a||u},t.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(e){return e.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(e){var t=this.loose;e=e.trim(),r("range",e,t);var n=t?s[F]:s[V];e=e.replace(n,ue),r("hyphen replace",e),e=e.replace(s[W],"$1$2$3"),r("comparator trim",e,s[W]),e=(e=(e=e.replace(s[O],"$1~")).replace(s[L],"$1^")).split(/\s+/).join(" ");var i=t?s[B]:s[U],o=e.split(" ").map(function(e){return function(e,t){return r("comp",e),e=function(e,t){return e.trim().split(/\s+/).map(function(e){return function(e,t){r("caret",e,t);var n=t?s[j]:s[D];return e.replace(n,function(t,n,i,s,o){var a;return r("caret",e,t,n,i,s,o),ae(n)?a="":ae(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ae(s)?a="0"===n?">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":">="+n+"."+i+".0 <"+(+n+1)+".0.0":o?(r("replaceCaret pr",o),"-"!==o.charAt(0)&&(o="-"+o),a="0"===n?"0"===i?">="+n+"."+i+"."+s+o+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+o+" <"+(+n+1)+".0.0"):(r("no pr"),a="0"===n?"0"===i?">="+n+"."+i+"."+s+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+" <"+(+n+1)+".0.0"),r("caret return",a),a})}(e,t)}).join(" ")}(e,t),r("caret",e),e=function(e,t){return e.trim().split(/\s+/).map(function(e){return function(e,t){var n=t?s[T]:s[R];return e.replace(n,function(t,n,i,s,o){var a;return r("tilde",e,t,n,i,s,o),ae(n)?a="":ae(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ae(s)?a=">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":o?(r("replaceTilde pr",o),"-"!==o.charAt(0)&&(o="-"+o),a=">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0"):a=">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0",r("tilde return",a),a})}(e,t)}).join(" ")}(e,t),r("tildes",e),e=function(e,t){return r("replaceXRanges",e,t),e.split(/\s+/).map(function(e){return function(e,t){e=e.trim();var n=t?s[$]:s[P];return e.replace(n,function(t,n,i,s,o,a){r("xRange",e,t,n,i,s,o,a);var u=ae(i),c=u||ae(s),h=c||ae(o),p=h;return"="===n&&p&&(n=""),u?t=">"===n||"<"===n?"<0.0.0":"*":n&&p?(c&&(s=0),h&&(o=0),">"===n?(n=">=",c?(i=+i+1,s=0,o=0):h&&(s=+s+1,o=0)):"<="===n&&(n="<",c?i=+i+1:s=+s+1),t=n+i+"."+s+"."+o):c?t=">="+i+".0.0 <"+(+i+1)+".0.0":h&&(t=">="+i+"."+s+".0 <"+i+"."+(+s+1)+".0"),r("xRange return",t),t})}(e,t)}).join(" ")}(e,t),r("xrange",e),e=function(e,t){return r("replaceStars",e,t),e.trim().replace(s[z],"")}(e,t),r("stars",e),e}(e,t)}).join(" ").split(/\s+/);return this.loose&&(o=o.filter(function(e){return!!e.match(i)})),o=o.map(function(e){return new ie(e,t)})},oe.prototype.intersects=function(e,t){if(!(e instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(r){return r.every(function(r){return e.set.some(function(e){return e.every(function(e){return r.intersects(e,t)})})})})},t.toComparators=function(e,t){return new oe(e,t).set.map(function(e){return e.map(function(e){return e.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(e){if(!e)return!1;"string"==typeof e&&(e=new G(e,this.loose));for(var t=0;t<this.set.length;t++)if(ce(this.set[t],e))return!0;return!1},t.satisfies=he,t.maxSatisfying=function(e,t,r){var n=null,i=null;try{var s=new oe(t,r)}catch(e){return null}return e.forEach(function(e){s.test(e)&&(n&&-1!==i.compare(e)||(i=new G(n=e,r)))}),n},t.minSatisfying=function(e,t,r){var n=null,i=null;try{var s=new oe(t,r)}catch(e){return null}return e.forEach(function(e){s.test(e)&&(n&&1!==i.compare(e)||(i=new G(n=e,r)))}),n},t.validRange=function(e,t){try{return new oe(e,t).range||"*"}catch(e){return null}},t.ltr=function(e,t,r){return pe(e,t,"<",r)},t.gtr=function(e,t,r){return pe(e,t,">",r)},t.outside=pe,t.prerelease=function(e,t){var r=K(e,t);return r&&r.prerelease.length?r.prerelease:null},t.intersects=function(e,t,r){return e=new oe(e,r),t=new oe(t,r),e.intersects(t)},t.coerce=function(e){if(e instanceof G)return e;if("string"!=typeof e)return null;var t=e.match(s[C]);return null==t?null:K((t[1]||"0")+"."+(t[2]||"0")+"."+(t[3]||"0"))}}),semver_1=semver.SEMVER_SPEC_VERSION,semver_2=semver.re,semver_3=semver.src,semver_4=semver.parse,semver_5=semver.valid,semver_6=semver.clean,semver_7=semver.SemVer,semver_8=semver.inc,semver_9=semver.diff,semver_10=semver.compareIdentifiers,semver_11=semver.rcompareIdentifiers,semver_12=semver.major,semver_13=semver.minor,semver_14=semver.patch,semver_15=semver.compare,semver_16=semver.compareLoose,semver_17=semver.rcompare,semver_18=semver.sort,semver_19=semver.rsort,semver_20=semver.gt,semver_21=semver.lt,semver_22=semver.eq,semver_23=semver.neq,semver_24=semver.gte,semver_25=semver.lte,semver_26=semver.cmp,semver_27=semver.Comparator,semver_28=semver.Range,semver_29=semver.toComparators,semver_30=semver.satisfies,semver_31=semver.maxSatisfying,semver_32=semver.minSatisfying,semver_33=semver.validRange,semver_34=semver.ltr,semver_35=semver.gtr,semver_36=semver.outside,semver_37=semver.prerelease,semver_38=semver.intersects,semver_39=semver.coerce;class WorkerMain extends events.EventEmitter{constructor(e,t){super(),this.id=e,this.tasks=[],this.exitCode=null,this.processQueue=!0,this.sendQueue=[],this.stopped=!1,this.successfulMessage=!1,this.totalTasksAssigned=0,this.workerKeys=[],this.fork(t)}fork(e){const t={execArgv:process.execArgv.filter(e=>!/^--(debug|inspect)/.test(e)),env:process.env,cwd:process.cwd()};this.childProcess=cp.fork(e,["--start-worker"],t),this.childProcess.on("message",this.receiveFromWorker.bind(this)),this.childProcess.once("exit",e=>{this.exitCode=e,this.emit("exit",e)}),this.childProcess.on("error",e=>{this.emit("error",e)})}run(e){this.totalTasksAssigned++,this.tasks.push(e),this.sendToWorker({taskId:e.taskId,method:e.method,args:e.args})}sendToWorker(e){if(!this.processQueue)return void this.sendQueue.push(e);this.childProcess.send(e,e=>{if(!(e&&e instanceof Error)&&(this.processQueue=!0,this.sendQueue.length>0)){const e=this.sendQueue.slice();this.sendQueue=[],e.forEach(e=>this.sendToWorker(e))}})&&!/^win/.test(process.platform)||(this.processQueue=!1)}receiveFromWorker(e){if(this.successfulMessage=!0,this.stopped)return;const t=this.tasks.find(t=>t.taskId===e.taskId);if(!t)return;e.error?t.reject(e.error):t.resolve(e.value);const r=this.tasks.indexOf(t);r>-1&&this.tasks.splice(r,1),this.emit("response",e)}stop(){this.stopped=!0;for(const e of this.tasks)e.reject(TASK_CANCELED_MSG);this.tasks.length=0,this.successfulMessage?(this.childProcess.send({exit:!0}),setTimeout(()=>{null===this.exitCode&&this.childProcess.kill("SIGKILL")},100)):this.childProcess.kill("SIGKILL")}}class WorkerManager extends events.EventEmitter{constructor(e,t){super(),this.modulePath=e,this.options=t,this.workerIds=0,this.taskIds=0,this.isEnding=!1,this.taskQueue=[],this.workers=[],this.useForkedWorkers=!1,this.useForkedWorkers=this.options.maxConcurrentWorkers>1,this.useForkedWorkers&&this.startWorkers()}onError(e,t){if("ERR_IPC_CHANNEL_CLOSED"===e.code)return this.stopWorker(t)}onExit(e){setTimeout(()=>{let t=!1;const r=this.workers.find(t=>t.id===e);if(r&&r.tasks.length>0){for(const e of r.tasks)e.retries++,this.taskQueue.unshift(e),t=!0;r.tasks.length=0}this.stopWorker(e),t&&this.processTaskQueue()},10)}startWorkers(){for(;this.workers.length<this.options.maxConcurrentWorkers;)this.startWorker()}startWorker(){const e=this.workerIds++,t=new WorkerMain(e,this.modulePath);t.on("response",this.processTaskQueue.bind(this)),t.once("exit",()=>{this.onExit(e)}),t.on("error",t=>{this.onError(t,e)}),this.workers.push(t)}stopWorker(e){const t=this.workers.find(t=>t.id===e);if(t){t.successfulMessage||(this.useForkedWorkers=!1),t.stop();const e=this.workers.indexOf(t);e>-1&&this.workers.splice(e,1)}}processTaskQueue(){if(!this.isEnding&&0!==this.taskQueue.length)for(this.startWorkers();this.taskQueue.length>0;){const e=getWorker(this.taskQueue[0],this.workers,this.options.maxConcurrentTasksPerWorker);if(!e)break;e.run(this.taskQueue.shift())}}run(e,t,r={}){if(this.isEnding)return Promise.reject(TASK_CANCELED_MSG);if(this.useForkedWorkers)return new Promise((n,i)=>{const s={taskId:this.taskIds++,method:e,args:t,retries:0,resolve:n,reject:i,isLongRunningTask:!!r.isLongRunningTask,workerKey:r.workerKey};this.taskQueue.push(s),this.processTaskQueue()});if(!this.mainThreadRunner){const e=require(this.modulePath);this.mainThreadRunner=new e.createRunner}return this.mainThreadRunner(e,t)}cancelTasks(){for(const e of this.workers){for(const t of e.tasks)t.reject(TASK_CANCELED_MSG);e.tasks.length=0}this.taskQueue.length=0,this.taskIds=0}destroy(){if(!this.isEnding){this.isEnding=!0;for(const e of this.taskQueue)e.reject(TASK_CANCELED_MSG);this.taskQueue.length=0;const e=this.workers.map(e=>e.id);for(const t of e)this.stopWorker(t)}}}function getWorker(e,t,r){return e.workerKey?getWorkerFromKey(t,r,e.workerKey):getNextWorker(t,r)}function getWorkerFromKey(e,t,r){let n=e.find(e=>e.workerKeys.includes(r));return n||((n=getNextWorker(e,t))||(n=e.find(e=>0===e.workerKeys.length))||(n=e[0]),n.workerKeys.push(r),n)}function getNextWorker(e,t){const r=e.filter(e=>!e.stopped&&(!(e.tasks.length>=t)&&!e.tasks.some(e=>e.isLongRunningTask)));return 0===r.length?null:r.sort((e,t)=>e.tasks.length<t.tasks.length?-1:e.tasks.length>t.tasks.length?1:e.totalTasksAssigned<t.totalTasksAssigned?-1:e.totalTasksAssigned>t.totalTasksAssigned?1:0)[0]}class NodeSystem{constructor(e){this.destroys=[],this.semver={lt:semver.lt,lte:semver.lte,gt:semver.gt,gte:semver.gte,prerelease:semver.prerelease,satisfies:semver.satisfies},this.fs=e||new NodeFs,this.path=path,this.nodeResolveModule=new NodeResolveModule,this.storage=new NodeStorage(this.fs),this.packageDir=path.join(__dirname,"..","..",".."),this.distDir=path.join(this.packageDir,"dist");try{this.packageJsonData=require(path.join(this.packageDir,"package.json"))}catch(e){throw new Error(`unable to resolve "package.json" from: ${this.packageDir}`)}try{this.typescriptPackageJson=require(this.resolveModule(this.packageDir,"typescript"))}catch(e){throw new Error(`unable to resolve "typescript" from: ${this.packageDir}`)}}initWorkers(e,t){if(this.sysWorker)return this.sysWorker.options;const r=require.resolve(path.join(this.distDir,"sys","node","sys-worker.js")),n=os.cpus().length;return e="number"==typeof e?Math.max(1,Math.min(n,e)):n,this.sysWorker=new WorkerManager(r,{maxConcurrentWorkers:e,maxConcurrentTasksPerWorker:t}),this.addDestroy(()=>{this.sysWorker&&this.sysWorker.destroy()}),this.sysWorker.options}cancelWorkerTasks(){this.sysWorker&&this.sysWorker.cancelTasks()}destroy(){this.destroys.forEach(e=>{e()}),this.destroys.length=0}addDestroy(e){this.destroys.push(e)}get compiler(){return{name:this.packageJsonData.name,version:this.packageJsonData.version,runtime:path.join(this.distDir,"compiler","index.js"),packageDir:this.packageDir,typescriptVersion:this.typescriptPackageJson.version}}copy(e){return __awaiter(this,void 0,void 0,function*(){return this.sysWorker.run("copy",[e],{isLongRunningTask:!0})})}get createDom(){return this._existingDom?this._existingDom:createDom}set createDom(e){this._existingDom=e}createFsWatcher(e,t,r){const n=createFsWatcher(e,t,r);return this.addDestroy(()=>{n.close()}),n}generateContentHash(e,t){let r=crypto.createHash("md5").update(e).digest("base64");return"number"==typeof t&&(r=r.replace(/\W/g,"").substr(0,t).toLowerCase()),r}getClientCoreFile(e){const t=normalizePath(path.join(this.distDir,"client",e.staticName));return this.fs.readFile(t)}glob(e,t){return new Promise((r,n)=>{glob_1(e,t,(e,t)=>{e?n(e):r(t)})})}loadConfigFile(e,t){const r=loadConfigFile(this.fs,e,t);return r.sys||(r.sys=this),r}get lazyRequire(){return this.nodeLazyRequire||(this.nodeLazyRequire=new NodeLazyRequire(this.semver,this.nodeResolveModule,this.packageJsonData)),this.nodeLazyRequire}optimizeCss(e){return this.sysWorker.run("optimizeCss",[e])}minifyJs(e,t){return this.sysWorker.run("minifyJs",[e,t])}open(e,t){return opn(e,t)}get details(){const e={cpuModel:"",cpus:-1,platform:"",release:"",runtime:"node",runtimeVersion:"",tmpDir:os.tmpdir()};try{const t=os.cpus();e.cpuModel=t[0].model,e.cpus=os.cpus.length,e.platform=os.platform(),e.release=os.release(),e.runtimeVersion=process.version}catch(e){}return e}requestLatestCompilerVersion(){return this.sysWorker.run("requestLatestCompilerVersion")}resolveModule(e,t){return this.nodeResolveModule.resolveModule(e,t)}get rollup(){return NodeRollup}scopeCss(e,t,r,n){return this.sysWorker.run("scopeCss",[e,t,r,n])}get color(){return ansiColors}transpileToEs5(e,t,r){return __awaiter(this,void 0,void 0,function*(){return this.sysWorker.run("transpileToEs5",[e,t,r])})}get url(){return url}validateTypes(e,t,r,n,i){return this.sysWorker.run("validateTypes",[e,t,r,n,i],{isLongRunningTask:!0,workerKey:"validateTypes"})}get vm(){return{createContext:createContext,runInContext:runInContext}}}exports.NodeLogger=NodeLogger,exports.NodeSystem=NodeSystem;